#!/usr/bin/perl

use strict;
use warnings;
use Data::Dumper;
use Date::Parse;
use Xorux_lib;

my $storage_name       = "";
my $basedir            = "";
my $bindir             = "";
my $webdir             = "";
my $health_status_html = "";
my $inputdir           = "";
my $wrkdir             = "";
my $configuration      = "";
my $config_directory   = "";
my $ip_address         = "";
my $ip_address_a         = "";
my $ip_address_b         = "";
my $user               = "";
my $key                = "";
my $data_directory     = "";
my $connection         = "";
my $path               = "";
my $summary_health     = "";
my $error_datadomain   = "";
my $eternus_enviroment = 1;
my $err_tmp = "";


my %inventory_data;
my %header_section;
my %data_structure;
my $time_start = "";
my $time_end = "";
my $ssh_cmd = $ENV{SSH};
if ( !defined($ssh_cmd) || $ssh_cmd eq '' ) {
  $ssh_cmd = "ssh -q -o ConnectTimeout=15 -o StrictHostKeyChecking=no -o PreferredAuthentications=publickey -o SendEnv=no ";
}

$ssh_cmd = $ssh_cmd . "-tt ";


my $interval       = 300;    ## time collecting statistics
my $timeout_config = 120;
my $timeout_perf   = 60;
my $timeout_perf2 = 600;

set_variable();
data_structure();
run_eternus();
my $version = test_version();
get_performance_statistics();

if ($version == 1){
  set_data_volume();
  set_data_drive();
  set_data_rg();
  set_data_host();
  set_data_pool();
  set_data_port();

}
else{
  set_data_volume_old();
  set_data_drive_old();
  set_data_rg_old();
  set_data_port();
  set_data_host_old();
  set_data_pool_old();

}


set_header();
write_data();
`touch "$data_directory/config-$storage_name.touch"`;
#print Dumper \%inventory_data;


sub set_data_pool_old{

  my $section = "RG Level Configuration";
  my $section_pool = "Pool Level Configuration";

  foreach my $id (keys %{$inventory_data{$section}}){
    $inventory_data{$section_pool}{$id} = $inventory_data{$section}{$id};
  }

}

sub set_data_host_old{


  my $section = "Host Level Configuration";
  my $file = "$data_directory/host.txt";
  my @data = get_array_data($file);
  my $active = 0;
  my $name_property = "";
  my $name_property2 = "";
  my %hash_position;
  my $line_parse = "";
  my %luns;
  my $act_volume;
  my $wwn = 0;
  my $host_group = "";
  my %host_group;

  foreach my $line (@data){
    chomp $line;
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/Host Group/ && $line =~ m/Host Response/){
      $active = 1;
      $wwn = 0;
      $host_group = "";
      next;
    }
    if ($line =~ m/<Host List/){
      $active++;
      $wwn++;
      next;
    }
    if ($active == 1 && $line =~ m/Name/){
      $active++;
      next;
    }
    if ($line =~ m/Name/ && $wwn == 2){
      next;
    }
    if ($line =~ m/WWN/){
      $wwn++;
    }
    if ($wwn == 2){
      my ($id_host, $name_host, $wwn) = split (" ",$line);
      if (!defined $wwn || $wwn eq ""){next;}
      $wwn = remove_whitespace($wwn);
      $inventory_data{$section}{$wwn}{"host_id"} = $wwn;
      $inventory_data{$section}{$wwn}{"wwn"} = $wwn;
      if (defined $id_host && $id_host ne ""){
        $id_host = remove_whitespace($id_host);
        $inventory_data{$section}{$wwn}{"id"} = $id_host;
      }
      if (defined $name_host && $name_host ne "" && $name_host ne "-"){
        $name_host = remove_whitespace($name_host);
        $inventory_data{$section}{$wwn}{"name"} = $name_host;
      }
      if (defined $host_group && $host_group ne "" ){
        $host_group{$host_group}{id} = $host_group;
        $host_group{$host_group}{host}{$wwn}{id} = $wwn;
      }
      next;
    }
    if ($active == 2 && $wwn != 2){
      my ($id_host, $name_host) = split (" ",$line);
      if (!defined $id_host || $id_host eq ""){next;}
      $id_host = remove_whitespace($id_host);
      $host_group = $id_host;
      $inventory_data{$section}{$id_host}{"host_id"} = $id_host;
      $inventory_data{$section}{$id_host}{"id"} = $id_host;
      if (defined $name_host && $name_host ne "" && $name_host ne "-"){
        $name_host = remove_whitespace($name_host);
        $inventory_data{$section}{$id_host}{"name"} = $name_host;
      }
    }
  }
  $file = "$data_directory/volume_mapping.txt";
  @data = get_array_data($file);
  $active = 0;
  $name_property = "";
  $name_property2 = "";
  $line_parse = "";
  my $vol_id = "";

  foreach my $line (@data){
    chomp $line;
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/\<Mapping\>/ && $vol_id ne ""){
      $active = 5;
      next;
    }
    if ($line =~ m/Volume/ && $line =~ m/UID/){
      $vol_id = "";
      $active = 1;
      next;
    }
    if ($vol_id ne "" && $active == 5){
      if ($line =~ m/LUN  Affinity|No\./){next;}
      my (undef, $lun_id, $lun_name) = split(" ",$line);
      if ( !defined $lun_id || $lun_id eq ""){next;}
      $lun_id = remove_whitespace($lun_id);
      $luns{$lun_id}{id} = $lun_id;
      $luns{$lun_id}{volume}{$vol_id}{id} = $vol_id;
    }
    if ($active == 1 && $line =~ m/Name/ && $line =~ m/No\./){
      $active++;
      next;
    }
    if ($active == 2){
      my (undef, $name_vol, undef, $id_vol) = split (" ",$line);
      if (!defined $id_vol || $id_vol eq ""){next;}
      $vol_id = $id_vol;
      next;
    }
  }
  #print Dumper \$inventory_data{$section};

  $file = "$data_directory/host_affinity.txt";
  @data = get_array_data($file);
  $active = 0;
  $name_property = "";
  $name_property2 = "";
  $line_parse = "";
  my $host_only = 0;

  foreach my $index (keys %hash_position){
    delete $hash_position{$index};
  }
  foreach my $line (@data){
    chomp $line;
    if ( $line eq "" || $line =~ m/^CLI>/ || $line =~ m/\<Connection List/ ) {
      $active = 0;
      $host_only = 0;
      next;
    }
    my $test_line = $line;
    $test_line = remove_whitespace($test_line);
    if ($test_line eq ""){
      $active = 0;
      $host_only = 0;
      next;
    }

    if ( $line =~ m/Port Group/  && $line =~ m/Host Group/ && $line =~ m/Affinity/ ){
      $active++;
      $host_only = 0;
      next;
    }
    #only hosts
    if ($line !~ m/Port Group/ && $line =~ m/Host/ && $line =~ m/LUN Group/){
      $active = 0;
      $host_only = 1;
      next;
    }
    if ($active == 1 && $line =~ m/Name/ && $line =~ m/No\./){
      $active++;
      next;
    }
    if ($host_only == 1 && $line =~ m/Name/ && $line =~ m/No\./){
      $host_only++;
      next;
    }
    if ($host_only == 2){
      my ($host_id, $host_name, $lun_id, $lun_name) = split(" ",$line);
      if (defined $host_id && $host_id ne "" && defined $host_name && $host_name ne "" && defined $lun_id && $lun_id ne ""){
        $host_id = remove_whitespace($host_id);
        $host_name = remove_whitespace($host_name);
        $lun_id = remove_whitespace($lun_id);
        $inventory_data{$section}{$host_id}{"host_id"} = $host_id;
        $inventory_data{$section}{$host_id}{"id"} = $host_id;
        $inventory_data{$section}{$host_id}{"name"} = $host_name;
        $inventory_data{$section}{$host_id}{"lun_group"}{$lun_id}{id} = $lun_id;
      }
    }
    if ($active == 2){
      my (undef, undef, $host_id, $host_name, $lun_id, $lun_name) = split(" ",$line);
      if (defined $host_id && $host_id ne "" && defined $host_name && $host_name ne "" && defined $lun_id && $lun_id ne ""){
        $host_id = remove_whitespace($host_id);
        $host_name = remove_whitespace($host_name);
        $lun_id = remove_whitespace($lun_id);
        $inventory_data{$section}{$host_id}{"host_id"} = $host_id;
        $inventory_data{$section}{$host_id}{"id"} = $host_id;
        $inventory_data{$section}{$host_id}{"name"} = $host_name;
        $inventory_data{$section}{$host_id}{"lun_group"}{$lun_id}{id} = $lun_id;
      }
    }
  }
  foreach my $host_group (keys %host_group){
    my @lun_group = ();
    if (defined $inventory_data{$section}{$host_group} && defined $inventory_data{$section}{$host_group}{id}){
      #$inventory_data{$section}{$host_group}{"type"} = "group";
      my $name_host_group = $inventory_data{$section}{$host_group}{"name"};
      if (defined $name_host_group && $name_host_group ne ""){
        my $pom = "Group-$name_host_group";
        $inventory_data{$section}{$host_group}{"name"} = $pom;
      }
      foreach my $lun_group (keys %{$inventory_data{$section}{$host_group}{"lun_group"}}){
        push(@lun_group,"$lun_group");
      }
    }
    foreach my $host (keys %{$host_group{$host_group}{host}}){
      foreach my $lun (@lun_group){
        if (defined $inventory_data{$section}{$host} && defined $inventory_data{$section}{$host}{id}){
          $inventory_data{$section}{$host}{"lun_group"}{$lun}{id} = $lun;
          #$inventory_data{$section}{$host}{"type"} = "host";
        }
      }
    }
  }
  #print Dumper \$inventory_data{$section};

  ### delete duplicite host
  foreach my $host (keys %{$inventory_data{$section}}){
    my $id = $inventory_data{$section}{$host}{"id"};
    my $name = $inventory_data{$section}{$host}{"name"};
    if (!defined $name || $name eq ""){next;}
    if (!defined $id || $id eq ""){next;}
    if ($host ne $id && defined $inventory_data{$section}{$id}){
       my $name_act = $inventory_data{$section}{$id}{"name"};
      if (defined $name_act && $name_act eq $name){
        delete $inventory_data{$section}{$id};
      }
    }
  }



  foreach my $host (keys %{$inventory_data{$section}}){
    my $volume_ids = "";
    if (!defined $inventory_data{$section}{$host}{lun_group}){next;}
    foreach my $lun (keys %{$inventory_data{$section}{$host}{lun_group}}){
      if (!defined $luns{$lun}{volume}){next;}
      foreach my $volume (keys %{$luns{$lun}{volume}}){
        if ($volume_ids eq ""){
          $volume_ids = $volume;
        }
        else{
          if ($volume_ids !~ m/$volume/){
            $volume_ids = $volume_ids ." " . "$volume";
          }
        }
      }
    }
    if ($volume_ids ne ""){
      $inventory_data{$section}{$host}{"Volume IDs"} = $volume_ids;
    }
  }
  #print Dumper \$inventory_data{$section};
}



sub set_data_port{

  my $section = "Port Level Configuration";
  my $id_port = "";
  my $id_port2 = "";
  my @files = ();
  push (@files,"$data_directory/fc-port.txt");
  push (@files,"$data_directory/sas-port.txt");
  push (@files,"$data_directory/fcoe-port.txt");
  push (@files,"$data_directory/iscsi-port.txt");
  my @port_id = ();

  my $index_file = 0;
  foreach my $file (@files){
    $index_file++;
    my @data = get_array_data($file);

    if ($index_file == 4){
      my $name_port = "";
      foreach my $line (@data){
        my $active = 0;
        chomp $line;
        if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
        $line =~ s/ {2,}/  /g;
        $line = remove_whitespace($line);
        if ($line eq ""){next;}
        my ($property, $value) = split("  ",$line);
        if (!defined $property || $property eq ""){next;}
        if ($property =~ m/Port#/ && $property =~ m/CM#/ && $property =~ m/CA#/){
          $property =~ s/#//g;
          $name_port = $property;
          $inventory_data{$section}{$name_port}{id} = $name_port;
          $inventory_data{$section}{$name_port}{name} = $name_port;
          $inventory_data{$section}{$name_port}{Protocol} = "ISCSI";
          next;
        }
        if (defined $name_port && $name_port ne ""){
          if (defined $value){
            $value = remove_whitespace($value);
            $inventory_data{$section}{$name_port}{$property} = $value;
            next;
          }
        }
      }

    }
    else{

      foreach my $line (@data){
        my $name_property = "";
        my $active = 0;
        chomp $line;
        if ( $line eq "" || $line =~ m/^CLI>/ ) { @port_id = (); next; }
        $line =~ s/ {2,}/  /g;
        $line = remove_whitespace($line);
        if ($line eq ""){@port_id = (); next;}
        my @data_line = split("  ",$line);
        #print Dumper \@data_line;
        foreach my $element (@data_line){
          $element = remove_whitespace($element);
          if ($active == 0 ){
            $name_property = $element;
            $active++;
            next;
          }
          if (defined $name_property && $name_property eq "Port"){
            if ($active > 0){
              $id_port = "";
              $element =~ s/#//g;
              $id_port = $element;
              $inventory_data{$section}{$element}{id} = $element;
              $inventory_data{$section}{$element}{name} = $element;
              push(@port_id,"$element");
              if ($index_file == 1){
                $inventory_data{$section}{$element}{Protocol} = "FC";
              }
              if ($index_file == 2){
                $inventory_data{$section}{$element}{Protocol} = "SAS";
              }
              if ($index_file == 3){
                $inventory_data{$section}{$element}{Protocol} = "FCOE";
              }
              $active++;
              next;
            }
          }
          if (defined $name_property && $name_property ne "Port" && $active > 0 && defined $port_id[$active-1] && defined $inventory_data{$section}{$port_id[$active-1]}){
            $inventory_data{$section}{$port_id[$active-1]}{$name_property} = $element;
            $active++;
            next;
          }

        }
      }
    }
  }
  #print Dumper \$inventory_data{$section};

}


sub set_data_rg_old{


  my $section = "RG Level Configuration";
  my $file = "$data_directory/rg.txt";
  my @data = get_array_data($file);
  my $active = 0;

  foreach my $line (@data){
    chomp $line;
    $line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/^CLI>/) { next; }
    if ($line =~ m/No\./ && $line =~ m/Name/){
      $active++;
      next;
    }
    if ($active == 1){
      my ($id, $name, $raid_level, $assigned, $status, $cap, $free_cap) = split(" ",$line);
      if (!defined $id || $id eq ""){next;}
      if (!defined $name){
        $name =  "";
      }
      if (!defined $raid_level){
        $raid_level =  "";
      }
      if (!defined $assigned){
        $assigned =  "";
      }
      if (!defined $cap){
        $cap =  "";
      }
      if (!defined $free_cap){
        $free_cap =  "";
      }
      $id = remove_whitespace($id);
      $name = remove_whitespace($name);
      $raid_level = remove_whitespace($raid_level);
      $assigned = remove_whitespace($assigned);
      $status = remove_whitespace($status);
      $cap = remove_whitespace($cap);
      $free_cap = remove_whitespace($free_cap);
      if ($id eq ""){next;}
      $inventory_data{$section}{$id}{id} = $id;
      if ($name ne ""){
        $inventory_data{$section}{$id}{name} = $name;
      }
      if ($status ne ""){
        $inventory_data{$section}{$id}{health_status} = $status;
      }
      if ($raid_level ne ""){
        $inventory_data{$section}{$id}{"RAID Level"} = $raid_level;
      }
      if ($assigned ne ""){
        $inventory_data{$section}{$id}{"Assigned CM"} = $assigned;
      }
      if (isdigit($cap)){
        my $pom = $cap / 1024;
        $inventory_data{$section}{$id}{"capacity (GB)"} = round($pom,1);
      }
      if (isdigit($free_cap)){
        my $pom = $free_cap / 1024;
        $inventory_data{$section}{$id}{"free_capacity (GB)"} = round($pom,1);
      }
      if (isdigit($free_cap) && isdigit($cap)){
        my $pom = ($cap - $free_cap) / 1024;
        $inventory_data{$section}{$id}{"used_capacity (GB)"} = round($pom,1);
      }
    }
  }
  #print Dumper \$inventory_data{$section};
}

sub set_data_drive_old{

  my $section = "Drive Level Configuration";
  my $file = "$data_directory/disk.txt";
  my @data = get_array_data($file);
  my $active = 0;
  my $property = "";
  my %hash_position;
  foreach my $line (@data){
    chomp $line;
    $line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/Location/ && $line =~ m/Status/){
      $active++;
      $property = $line;
      next;
    }
    if ($active == 1 && $property ne ""){
      my @data_line = split("",$property);
      my @data_property = split(" ",$property);
      my $index = -1;
      my $num_property = 0;
      foreach my $char (@data_line){
        $index++;
        if ($char eq " " && defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{END} = $index - 1;
          $num_property++;
          next;
        }
        if ($char ne " " && !defined $hash_position{$num_property}{START} &&  $index != 0 && defined $hash_position{$num_property-1}{END}){
          $hash_position{$num_property-1}{END} = $index - 1;
        }
        if ($char ne " " && !defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{START} = $index;
          if (defined $data_property[$num_property]){
            $hash_position{$num_property}{NAME} = $data_property[$num_property];
          }
        }
      }
      $active++;
      #print Dumper \%hash_position;
      next;
    }
    if ($active == 2){
      my $id = "";
      my $status = "";
      my $size = "";
      my $usage = "";
      foreach my $index (keys %hash_position){
        my $name = $hash_position{$index}{NAME};
        my $start = $hash_position{$index}{START};
        my $end = $hash_position{$index}{END};
        if (!defined $name || $name eq ""){next;}
        if (!isdigit($start)){next;}
        if (!isdigit($end)){
          $end = length($line);
        }
        my $length = $end - $start;
        $length++;
        my $value = substr($line,$start,$length);
        if (!defined $value && $value eq ""){next;}
        $value = remove_whitespace($value);
        if ($name eq "Location"){
          $id = $value;
        }
        if ($name eq "Status"){
          $status = $value;
        }
        if ($name eq "Usage"){
          $usage = $value;
        }
        if ($name eq "Size"){
          $size = $value;
        }
      }
      if ($id eq ""){next;}
      $id =~ s/#//g;
      $inventory_data{$section}{$id}{id} = $id;
      $inventory_data{$section}{$id}{name} = $id;
      $inventory_data{$section}{$id}{"health_status"} = $status;
      $inventory_data{$section}{$id}{"usage"} = $usage;
      if (defined $size && $size ne ""){
        if ($size =~ /TB/){
          $size =~ s/TB//g;
          $size = remove_whitespace($size);
          if (isdigit($size)){
            my $pom = $size * 1024;
            $size = round($pom,2);
          }
        }
        if ($size =~ /GB/){
          $size =~ s/GB//g;
          $size = remove_whitespace($size);
        }
        if ($size =~ /MB/){
          $size =~ s/MB//g;
          $size = remove_whitespace($size);
          if (isdigit($size)){
            my $pom = $size / 1024;
            $size = round($pom,2);
          }
        }
        if (isdigit($size)){
          $inventory_data{$section}{$id}{"Capacity(GB)"} = $size;
        }
      }
    }
  }
  #print Dumper \$inventory_data{$section};
}


sub set_data_volume_old{

  my $section = "Volume Level Configuration";
  my $file = "$data_directory/volume.txt";
  my @data = get_array_data($file);
  my $active = 0;
  foreach my $line (@data){
    chomp $line;
    $line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/No\./ && $line =~ m/Name/){
      $active++;
      next;
    }
    if ($active == 1){
      my ($id, $name, $status, undef, undef, undef, $rg_id, $rg_name, $cap) = split (" ",$line);
      if (!defined $id || $id eq ""){next;}
      if (!defined $rg_id){
        $rg_id = "";
      }
      if (!defined $name){
        $name = "";
      }
      if (!defined $rg_name){
        $rg_name = "";
      }
      if (!defined $cap){
        $cap = "";
      }
      if (!defined $status){
        $status = "";
      }
      $id = remove_whitespace($id);
      $name = remove_whitespace($name);
      $rg_id = remove_whitespace($rg_id);
      $rg_name = remove_whitespace($rg_name);
      $cap = remove_whitespace($cap);
      $status = remove_whitespace($status);
      if (defined $id && $id ne ""){
        $inventory_data{$section}{$id}{"volume_id"} = $id;
        if (isdigit($cap)){
          $inventory_data{$section}{$id}{"capacity (MB)"} = $cap;
        }
        if (defined $name && $name ne ""){
          $inventory_data{$section}{$id}{"name"} = $name;
        }
        if (defined $status && $status ne ""){
          $inventory_data{$section}{$id}{"health_status"} = $status;
        }
        if (defined $rg_id && $rg_id ne ""){
          $inventory_data{$section}{$id}{"pool_id"} = $rg_id;
          if (defined $rg_name && $rg_name ne ""){
            $inventory_data{$section}{$id}{"pool_name"} = $rg_name;
          }
        }
      }
    }
  }
  # volume uid
  $file = "$data_directory/volume_mapping.txt";
  @data = get_array_data($file);
  $active = 0;
  foreach my $line (@data){
    chomp $line;
    $line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/\<Mapping/){
      $active = 0;
      next;
    }
    if ($line =~ m/Volume/ && $line =~ m/UID/){
      $active++;
      next;
    }
    if ($active == 1 && $line =~ m/No\./ && $line =~ m/Name/){
      $active++;
      next;
    }
    if ($active == 2){
      my ($no, $name, undef, $uid) = split (" ",$line);
      if (defined $no && $no ne "" && defined $uid && $uid ne ""){
        $no = remove_whitespace($no);
        $uid = remove_whitespace($uid);
        if (defined $inventory_data{$section}{$no} && defined $inventory_data{$section}{$no}{volume_id}){
          $inventory_data{$section}{$no}{volume_id} = $uid;
        }
      }
    }
  }
  #print Dumper \$inventory_data{$section};
}


sub test_version{
  my $file = "$wrkdir/ETERNUS_NEW";
  if (-f "$data_directory/version_old.txt"){
    unlink("$data_directory/version_old.txt");
  }
  if (-f $file){

    my $mtime = ( stat("$file") )[9];
    my $last_update = time() - $mtime;
    if ($last_update >= 86400){
      my $cmd = "show volumes -mode detail";
      my $file = "$data_directory/test_version.txt";
      cmd_to_file($cmd,$file, $timeout_perf);
      if (-f "$data_directory/version_old.txt"){
        `touch $wrkdir/ETERNUS_OLD`;
        return 0;
      }
      else{
        `touch $wrkdir/ETERNUS_NEW`;
        return 1;
      }
    }
    else{
      return 1;
    }
  }
  else{
    my $file = "$wrkdir/ETERNUS_OLD";
    if (-f $file){
      my $mtime = ( stat("$file") )[9];
      my $last_update = time() - $mtime;
      if ($last_update >= 86400){
        my $cmd = "show volumes -mode detail";
        my $file = "$data_directory/test_version.txt";
        cmd_to_file($cmd,$file, $timeout_perf);
        if (-f "$data_directory/version_old.txt"){
          `touch $wrkdir/ETERNUS_OLD`;
          return 0;
        }
        else{
          `touch $wrkdir/ETERNUS_NEW`;
          return 1;
        }
      }
      else{
        return 0;
      }
    }
    else{
      my $cmd = "show volumes -mode detail";
      my $file = "$data_directory/test_version.txt";
      cmd_to_file($cmd,$file, $timeout_perf);
      if (-f "$data_directory/version_old.txt"){
        `touch $wrkdir/ETERNUS_OLD`;
        return 0;
      }
      else{
        `touch $wrkdir/ETERNUS_NEW`;
        return 1;
      }
    }
  }
}



sub test_connection {
  my $cmd     = shift;
  my $file    = shift;
  my $timeout = shift;
  my $connection = shift;
  my $save = shift;
  my $pid     = fork();
  if ( !defined $pid ) {
    error_die( "no fork $!" . __FILE__ . ":" . __LINE__ );
  }
  elsif ( $pid == 0 ) {
    setpgrp( 0, 0 );
    if (defined $save && $save eq "save"){
      #`$connection '$cmd' >> "$file" 2>>\$ERRLOG_ETERNUS`;
      #`$connection '$cmd' >> "$file" 2>\$err_tmp`;
      `echo '$cmd' | $connection >> "$file" 2>\$err_tmp`
    }
    else{
      #`$connection '$cmd' > "$file" 2>>\$ERRLOG_ETERNUS`;
      #`$connection '$cmd' > "$file" 2>\$err_tmp`;
      `echo '$cmd' | $connection > "$file" 2>\$err_tmp`
    }
    if ( $? != 0 ) {
      error( "command failed: $cmd " . __FILE__ . ":" . __LINE__ );
    }
    exit(0);
  } ## end elsif ( $pid == 0 )
  eval {
    local $SIG{ALRM} = sub { die "die in SIGALRM"; };
    alarm($timeout);
    waitpid( $pid, 0 );
    alarm(0);
  };
  if ( $@ =~ /die in SIGALRM/ ) {
    my $act_time = localtime();
    error( "$act_time command: $cmd timed out after: $timeout seconds " . __FILE__ . ":" . __LINE__ );
    kill -15, $pid;
    waitpid( $pid, 0 );
  } ## end if ( $@ =~ /die in SIGALRM/)
  error_wraper($err_tmp);
  return;
} ## end sub cmd_to_file


sub error_wraper{

  my $file = shift;
  if (-f "$file" && !-z "$file"){
    my @data = get_array_data($file);

    foreach my $line (@data){
      chomp $line;
      if ($line eq "" || $line =~ m/closed by remote host/ || $line =~ m/tcgetattr: Inappropriate ioctl for device/){
        next;
      }
      print STDERR "$line\n";
    }
  }

}


sub run_eternus{

  my $file = "$data_directory/config-$storage_name.touch";
  my $test_file = test_file_exist($file,"run");
  if ($test_file){
    my $mtime = ( stat("$file") )[9];
    my $last_update = time() - $mtime;
    if ($last_update >= 3600){
      return;
    }
    else{
      exit (1);
    }
  }
  else{
    return;
  }


}


sub set_data_port_old{
  ### function is not used missing ISCSI port type.
  my $section = "Port Level Configuration";
  my $id_port = "";
  my $id_port2 = "";
  my @files = ();
  push (@files,"$data_directory/fc-port.txt");
  push (@files,"$data_directory/sas-port.txt");
  push (@files,"$data_directory/fcoe-port.txt");
  my @port_id = ();

  my $index_file = 0;
  foreach my $file (@files){
    $index_file++;
    my @data = get_array_data($file);

  foreach my $line (@data){
    my $name_property = "";
    my $active = 0;
    chomp $line;
    if ( $line eq "" || $line =~ m/^CLI>/ ) { @port_id = (); next; }
    $line =~ s/ {2,}/  /g;
    $line = remove_whitespace($line);
    if ($line eq ""){@port_id = (); next;}
    my @data_line = split("  ",$line);
    #print Dumper \@data_line;
    foreach my $element (@data_line){
      $element = remove_whitespace($element);
      if ($active == 0 ){
        $name_property = $element;
        $active++;
        next;
      }
      if (defined $name_property && $name_property eq "Port"){
        if ($active > 1){
          $id_port = "";
          $element =~ s/#//g;
          $id_port = $element;
          $inventory_data{$section}{$element}{id} = $element;
          $inventory_data{$section}{$element}{name} = $element;
          push(@port_id,"$element");
          if ($index_file == 1){
            $inventory_data{$section}{$element}{Protocol} = "FC";
          }
          if ($index_file == 2){
            $inventory_data{$section}{$element}{Protocol} = "SAS";
          }
          if ($index_file == 3){
            $inventory_data{$section}{$element}{Protocol} = "FCOE";
          }
          $active++;
          next;
        }
      }
      if (defined $name_property && $name_property ne "Port" && $active > 0 && defined $port_id[$active-1] && defined $inventory_data{$section}{$port_id[$active-1]}){
        $inventory_data{$section}{$port_id[$active-1]}{$name_property} = $element;
        $active++;
        next;
      }
    }
  }
  #print Dumper \$inventory_data{$section};
  }
}

sub set_data_pool{
  my $section = "Pool Level Configuration";
  my $file = "$data_directory/pool.txt";
  my @data = get_array_data($file);
  my $active = 0;
  my $name_property = "";
  my $name_property2 = "";
  my %hash_position;
  my $line_parse = "";

  foreach my $line (@data){
    chomp $line;
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/Name/ && $line =~ m/No\./){
      $name_property = $line;
      $active++;
    }
    if ($line =~ m/----/ && ( $active == 1 || $active == 5)){
      $line_parse = $line;
      my @chars = split("",$line);
      my $index = -1;
      my $num_property = 1;
      foreach my $char (@chars){
        $index++;
        if ($char eq " " && defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{END} = $index - 1;
          $num_property++;
          next;
        }
        if ($char eq "-" && !defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{START} = $index;
        }
      }
      $active++;
      next;
    }
    if ($active == 2 && $name_property ne ""){
      my $id = "";
      my $name = "";
      my $total = "";
      my $used = "";
      my $free = "";
      my $status = "";
      my $raid = "";
      my $used_status = "";
      foreach my $index (sort {$a<=>$b} keys %hash_position){
        my $start = $hash_position{$index}{START};
        my $end = $hash_position{$index}{END};
        if (isdigit($start) && !isdigit($end)){
          $end = length($line_parse);
        }
        if (!isdigit($start) || !isdigit($end)){next;}
        my $length = ($end - $start);
        $length++;
        if ($index == 1){
          $id = substr($line,$start,$length);
          $id = remove_whitespace($id);
          if (defined $id && $id ne ""){
            $inventory_data{$section}{$id}{id} = $id;
          }
        }
        if ($index == 2){
          $name = substr($line,$start,$length);
          $name = remove_whitespace($name);
          if (defined $id && $id ne "" && defined $name && $name ne ""){
            $inventory_data{$section}{$id}{name} = $name;
          }
        }
        if ($index == 4){
          $raid = substr($line,$start,$length);
          $raid = remove_whitespace($raid);
          if (defined $id && $id ne "" && defined $raid && $raid ne ""){
            $inventory_data{$section}{$id}{"RAID Level"} = $raid;
          }
        }
        if ($index == 5){
          $status = substr($line,$start,$length);
          $status = remove_whitespace($status);
          if (defined $id && $id ne "" && defined $status && $status ne ""){
            $inventory_data{$section}{$id}{"health_status"} = $status;
          }
        }
        if ($index == 6){
          $total = substr($line,$start,$length);
          $total = remove_whitespace($total);
          if (defined $total){
            my ($value, $unit) = split(" ",$total);
            if (isdigit($value) && defined $unit){
              my $pom = convert_capacity($unit,"GB",$value);
              if (isdigit($pom)){
                $total = $pom;
              }
            }
          }
          if (defined $id && $id ne "" && isdigit($total)){
            $inventory_data{$section}{$id}{"capacity (GB)"} = $total;
          }
        }
        if ($index == 9){
          $used = substr($line,$start,$length);
          $used = remove_whitespace($used);
          if (defined $used){
            my ($value, $unit) = split(" ",$used);
            if (isdigit($value) && defined $unit){
              my $pom = convert_capacity($unit,"GB",$value);
              if (isdigit($pom)){
                $used = $pom;
              }
            }
          }
          if (defined $id && $id ne "" && isdigit($used)){
            $inventory_data{$section}{$id}{"used_capacity (GB)"} = $used;
          }
        }
        if ($index == 10){
          $used_status = substr($line,$start,$length);
          $used_status = remove_whitespace($used_status);
          if (defined $id && $id ne "" && defined $used_status && $used_status ne ""){
            $inventory_data{$section}{$id}{"used_status"} = $used_status;
          }
        }
        if (isdigit($total) && isdigit($used)){
          $free = $total - $used;
          if (defined $id && $id ne "" && isdigit($free)){
            $inventory_data{$section}{$id}{"free_capacity (GB)"} = round($free,2);
          }
        }
      }
    }
  }
  #print Dumper \%inventory_data;
  #print Dumper \$inventory_data{$section};
  $file = "$data_directory/pool_mapping.txt";
  @data = get_array_data($file);
  $active = 0;
  $name_property = "";
  $name_property2 = "";
  $line_parse = "";
  my $pool_index = -1;
  my @pool_id = get_id_pool("$data_directory/pool.txt");
  my %pool_mapping;

  foreach my $line (@data){
    chomp $line;
    if ( $line eq "") { next; }
    if ($line =~ m/^CLI>/ && $name_property ne ""){
      $active = 0;
      $name_property = "";
      $name_property2 = "";
      $line_parse = "";
      foreach my $index (keys %hash_position){
        delete $hash_position{$index};
      }
      next;
    }
    if ($line =~ m/^CLI>/){next;}
    if ($line =~ m/Raid Group List/){
      $active = 1;
      $name_property = "";
      $name_property2 = "";
      $line_parse = "";
      if ($line =~ m/Raid Group List/){
        $pool_index++;
      }
      foreach my $index (keys %hash_position){
        delete $hash_position{$index};
      }
      next;
    }
    if ($line =~ m/Name/ && $line =~ m/No\./ && $active == 1){
      $name_property = $line;
      $active++;
      next;
    }
    if ($line =~ m/----/ && ( $active == 2 || $active == 5)){
      $line_parse = $line;
      my @chars = split("",$line);
      my $index = -1;
      my $num_property = 1;
      foreach my $char (@chars){
        $index++;
        if ($char eq " " && defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{END} = $index - 1;
          $num_property++;
          next;
        }
        if ($char eq "-" && !defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{START} = $index;
        }
      }
      $active++;
      next;
    }
    if ($active == 3 && $name_property ne ""){
      my $id = "";
      my $name = "";
      foreach my $index (sort {$a<=>$b} keys %hash_position){
        my $start = $hash_position{$index}{START};
        my $end = $hash_position{$index}{END};
        if (isdigit($start) && !isdigit($end)){
          $end = length($line_parse);
        }
        if (!isdigit($start) || !isdigit($end)){next;}
        my $length = ($end - $start);
        $length++;
        if ($index == 1){
          $id = substr($line,$start,$length);
          $id = remove_whitespace($id);
          if (defined $id && $id ne "" && defined $pool_id[$pool_index] && $pool_id[$pool_index] ne ""){
            $pool_mapping{$pool_id[$pool_index]}{id} = $pool_id[$pool_index];
            $pool_mapping{$pool_id[$pool_index]}{RAID}{$id}{id} = $id;
          }
        }
        if ($index == 2){
          $name = substr($line,$start,$length);
          $name = remove_whitespace($name);
          if (defined $id && $id ne "" && defined $name && $name ne "" && defined $pool_id[$pool_index] && $pool_id[$pool_index] ne ""){
            $pool_mapping{$pool_id[$pool_index]}{RAID}{$id}{name} = $name;
          }
        }
      }
    }
  }
  foreach my $pool_id (keys %pool_mapping){
    my $pool_name = $inventory_data{$section}{$pool_id}{name};
    foreach my $rg_id (keys %{$pool_mapping{$pool_id}{RAID}}){
      my $name = $pool_mapping{$pool_id}{RAID}{$rg_id}{name};
      if (defined $inventory_data{"RG Level Configuration"}{$rg_id}){
        if (defined $pool_name){
          $inventory_data{"RG Level Configuration"}{$rg_id}{pool_name} = $pool_name;
        }
        $inventory_data{"RG Level Configuration"}{$rg_id}{pool_id} = $pool_id;
      }
    }
  }
  #print Dumper \$inventory_data{"RG Level Configuration"};
  #print Dumper \%pool_mapping;
  #foreach my $id_rg (keys %{$inventory_data{"RG Level Configuration"}}){
  #  foreach my $id_pool (keys %pool_mapping){
  #    if (!defined $pool_mapping{$id_pool}{RAID}{$id_rg}){
  #      $inventory_data{$section}{$id_rg} = $inventory_data{"RG Level Configuration"}{$id_rg};
  #    }
  #    else{
  #      $inventory_data{"RG Level Configuration"}{$id_rg}{pool_id} = $id_pool;
  #      if (defined $inventory_data{$section}{$id_pool}{name}){
  #        $inventory_data{"RG Level Configuration"}{$id_rg}{pool_name} = $inventory_data{$section}{$id_pool}{name};
  #      }
  #    }
  #  }
  #}
  #print Dumper \$inventory_data{$section};

  #### flex tier pool ###
  $active = 0;
  #my $tier_mode = "$data_directory/tier_mode.txt";
  my $tier_pool = "$data_directory/tier_pool.txt";

  #my $test_tier = test_tier_pool($tier_mode);
  my $test_tier = 1;
  if ($test_tier == 1){
    my @data = get_array_data($tier_pool);
    foreach my $line (@data){
      chomp $line;
      if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
      if ($line =~ m/Name/ && $line =~ m/No\./){
        $name_property = $line;
        $active++;
      }
      if ($line =~ m/----/ &&  $active == 1 ){
        $line_parse = $line;
        my @chars = split("",$line);
        my $index = -1;
        my $num_property = 1;
        foreach my $char (@chars){
          $index++;
          if ($char eq " " && defined $hash_position{$num_property}{START}){
            $hash_position{$num_property}{END} = $index - 1;
            $num_property++;
            next;
          }
          if ($char eq "-" && !defined $hash_position{$num_property}{START}){
            $hash_position{$num_property}{START} = $index;
          }
        }
        $active++;
        next;
      }
      if ($active == 2 && $name_property ne ""){
        my $id = "";
        my $name = "";
        my $total = "";
        my $used = "";
        my $free = "";
        my $status = "";
        my $raid = "";
        my $used_status = "";
        foreach my $index (sort {$a<=>$b} keys %hash_position){
          my $start = $hash_position{$index}{START};
          my $end = $hash_position{$index}{END};
          if (isdigit($start) && !isdigit($end)){
            $end = length($line_parse);
          }
          if (!isdigit($start) || !isdigit($end)){next;}
          my $length = ($end - $start);
          $length++;
          if ($index == 1){
            $id = substr($line,$start,$length);
            $id = remove_whitespace($id);
            if (defined $id && $id ne ""){
              $inventory_data{$section}{$id}{id} = $id;
            }
          }
          if ($index == 2){
            $name = substr($line,$start,$length);
            $name = remove_whitespace($name);
            if (defined $id && $id ne "" && defined $name && $name ne ""){
              $inventory_data{$section}{$id}{name} = $name;
            }
          }
          if ($index == 8){
            $used_status = substr($line,$start,$length);
            $used_status = remove_whitespace($used_status);
            if (defined $id && $id ne "" && defined $used_status && $used_status ne ""){
              $inventory_data{$section}{$id}{"used_status"} = $used_status;
            }
          }
          if ($index == 3){
            $status = substr($line,$start,$length);
            $status = remove_whitespace($status);
            if (defined $id && $id ne "" && defined $status && $status ne ""){
              $inventory_data{$section}{$id}{"health_status"} = $status;
            }
          }
          if ($index == 4){
            $total = substr($line,$start,$length);
            $total = remove_whitespace($total);
            if (defined $total){
              my ($value, $unit) = split(" ",$total);
              if (isdigit($value) && defined $unit){
                my $pom = convert_capacity($unit,"GB",$value);
                if (isdigit($pom)){
                  $total = $pom;
                }
              }
            }
            if (defined $id && $id ne "" && isdigit($total)){
              $inventory_data{$section}{$id}{"capacity (GB)"} = $total;
            }
          }
          if ($index == 7){
            $used = substr($line,$start,$length);
            $used = remove_whitespace($used);
            if (defined $used){
              my ($value, $unit) = split(" ",$used);
              if (isdigit($value) && defined $unit){
                my $pom = convert_capacity($unit,"GB",$value);
                if (isdigit($pom)){
                  $used = $pom;
                }
              }
            }
            if (defined $id && $id ne "" && isdigit($used)){
              $inventory_data{$section}{$id}{"used_capacity (GB)"} = $used;
            }
          }
          if (isdigit($total) && isdigit($used)){
            $free = $total - $used;
            if (defined $id && $id ne "" && isdigit($free)){
              $inventory_data{$section}{$id}{"free_capacity (GB)"} = $free;
            }
          }
        }
      }
    }
  }


  ### rg copy to pool
  foreach my $id (keys %{$inventory_data{"RG Level Configuration"}}){
    if (!defined $inventory_data{$section}{$id} && test_file_exist("$wrkdir/POOL/$id.rrd")){
      $inventory_data{$section}{$id} = $inventory_data{"RG Level Configuration"}{$id};
    }
  }
}

sub convert_capacity {
  my $unit_input  = shift;
  my $unit_output = shift;
  my $value       = shift;
  $unit_input = uc($unit_input);

  if ( $unit_input eq $unit_output ) {
    return $value;
  }
  if ( $unit_input eq "MB" && $unit_output eq "GB" ) {
    return round( $value / 1024 );
  }
  if ( $unit_input eq "MB" && $unit_output eq "TB" ) {
    return round( $value / ( 1024 * 1024 ) );
  }
  if ( $unit_input eq "MB" && $unit_output eq "PB" ) {
    return round( $value / ( 1024 * 1024 * 1024 ) );
  }
  if ( $unit_input eq "GB" && $unit_output eq "TB" ) {
    return round( $value / (1024) );
  }
  if ( $unit_input eq "GB" && $unit_output eq "PB" ) {
    return round( $value / ( 1024 * 1024 ) );
  }
  if ( $unit_input eq "TB" && $unit_output eq "PB" ) {
    return round( $value / (1024) );
  }
  if ( $unit_input eq "GB" && $unit_output eq "MB" ) {
    return round( $value * 1024 );
  }
  if ( $unit_input eq "TB" && $unit_output eq "MB" ) {
    return round( $value * ( 1024 * 1024 ) );
  }
  if ( $unit_input eq "TB" && $unit_output eq "GB" ) {
    return round( $value * (1024) );
  }
  if ( $unit_input eq "PB" && $unit_output eq "MB" ) {
    return round( $value * ( 1024 * 1024 * 1024 ) );
  }
  if ( $unit_input eq "PB" && $unit_output eq "GB" ) {
    return round( $value * ( 1024 * 1024 ) );
  }
  if ( $unit_input eq "PB" && $unit_output eq "TB" ) {
    return round( $value * (1024) );
  }
  return "";

} ## end sub convert_capacity

sub set_data_host{

  my $section = "Host Level Configuration";
  my $file = "$data_directory/host.txt";
  my @data = get_array_data($file);
  my $active = 0;
  my $name_property = "";
  my $name_property2 = "";
  my %hash_position;
  my $line_parse = "";
  my %luns;
  my $act_volume;
  my $wwn = 0;
  my $host_group = "";
  my %host_group;

  foreach my $line (@data){
    chomp $line;
    my $test_line = $line;
    $test_line = remove_whitespace ($test_line);
    if ( $line eq "" || $line =~ m/^CLI>/ ||  $test_line eq "" ) { next; }
    if ($line =~ m/Host Group/ && $line =~ m/Host Response/){
      $host_group = "";
      $active++;
      $wwn = 0;
      foreach my $index (keys %hash_position){
        delete $hash_position{$index};
      }
      next;
    }
    if ($line =~ m/<Host List/){
      $name_property = "";
      $line_parse = "";
      $active = 0;
      $wwn = 1;
      foreach my $index (keys %hash_position){
        delete $hash_position{$index};
      }
      next;
    }
    if ($wwn == 1 && $active == 0 && $line =~ m/WWN/){
      $wwn++;
      $name_property = $line;
      next
    }
    if ($active == 1 && $line =~ m/Name/){
      $name_property = $line;
      $active++;
      next;
    }

    if ($line =~ m/----/ && ( $active == 2 || $wwn == 2)){
      $line_parse = $line;
      my @chars = split("",$line);
      my $index = -1;
      my $num_property = 1;
      foreach my $char (@chars){
        $index++;
        if ($char eq " " && defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{END} = $index - 1;
          $num_property++;
          next;
        }
        if ($char eq "-" && !defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{START} = $index;
        }
      }
      if ($wwn == 2){
        $wwn++;
      }
      else{
        $active++;
      }
      next;
    }
    if (($active == 3 || $wwn == 3) && $name_property ne ""){
      my $id_host = "";
      my $name_host = "";
      my $host_wwn = "";
      foreach my $index (sort {$a<=>$b} keys %hash_position){
        my $start = $hash_position{$index}{START};
        my $end = $hash_position{$index}{END};
        if (isdigit($start) && !isdigit($end)){
          $end = length($line_parse);
        }
        if (!isdigit($start) || !isdigit($end)){next;}
        my $length = ($end - $start);
        $length++;
        if ($index == 1 && $active == 3){
          $id_host = substr($line,$start,$length);
          $id_host = remove_whitespace($id_host);
          if (defined $id_host && $id_host ne ""){
            $host_group = $id_host;
          }
        }
        if ($index == 2 && $active == 3){
          $name_host = substr($line,$start,$length);
          $name_host = remove_whitespace($name_host);
        }
        if ($index == 1 && $wwn == 3){
          $id_host = substr($line,$start,$length);
          $id_host = remove_whitespace($id_host);
        }
        if ($index == 2 && $wwn == 3){
          $name_host = substr($line,$start,$length);
          $name_host = remove_whitespace($name_host);
        }
        if ($index == 3 && $wwn == 3){
          $host_wwn = substr($line,$start,$length);
          $host_wwn = remove_whitespace($host_wwn);
        }
      }
      if (defined $name_host && $name_host && defined $id_host && $id_host ne ""){
        my $id = "";
        if (defined $host_wwn && $host_wwn ne "" && $wwn == 3){
          $id = $id_host;
          $id_host = $host_wwn;
        }
        $inventory_data{$section}{$id_host}{"host_id"} = $id_host;
        $inventory_data{$section}{$id_host}{"id"} = $id_host;
        $inventory_data{$section}{$id_host}{"name"} = $name_host;
        if (defined $id && $id ne ""){
          $inventory_data{$section}{$id_host}{"id"} = $id;
        }
        if (defined $host_wwn && $host_wwn ne ""){
          $inventory_data{$section}{$id_host}{"wwn"} = $host_wwn;
        }
        if ($wwn == 3 && defined $host_group && $host_group ne ""){
          $host_group{$host_group}{id} = $host_group;
          $host_group{$host_group}{host}{$id_host}{id} = $id_host;
          $host_group{$host_group}{name} = $name_host;
        }
      }
    }
  }
  #print Dumper \$inventory_data{$section};
  #print Dumper \%host_group;


  foreach my $index (keys %hash_position){
    delete $hash_position{$index};
  }

  $file = "$data_directory/volume_mapping.txt";
  @data = get_array_data($file);
  $active = 0;
  $name_property = "";
  $name_property2 = "";
  $line_parse = "";

  foreach my $line (@data){
    chomp $line;
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/\<Mapping\>/){
      $name_property = "";
      $name_property2 = "";
      $active = 5;
      $line_parse = "";
      foreach my $index (keys %hash_position){
        delete $hash_position{$index};
      }
      next;
    }
    if ($line =~ m/Volume/ && $line =~ m/UID/){
      $act_volume = "";
      $name_property = "";
      $name_property2 = "";
      $active = 0;
      $line_parse = "";
      foreach my $index (keys %hash_position){
        delete $hash_position{$index};
      }
      $name_property = $line;
      $active++;
      next;
    }


    if ($line =~ m/Name/ && $line =~ m/No\./){
      $name_property2 = $line;
      next;
    }

    if ($line =~ m/----/ && ( $active == 1 || $active == 5)){
      $line_parse = $line;
      my @chars = split("",$line);
      my $index = -1;
      my $num_property = 1;
      foreach my $char (@chars){
        $index++;
        if ($char eq " " && defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{END} = $index - 1;
          $num_property++;
          next;
        }
        if ($char eq "-" && !defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{START} = $index;
        }
      }
      $active++;
      next;
    }
    if ($active == 2 && $name_property ne ""){
      my $id_element = "";
      my $name_element = "";
      my $lun_id = "";
      my $size = "";
      my $type = "";
      my $status = "";
      foreach my $index (sort {$a<=>$b} keys %hash_position){
        my $start = $hash_position{$index}{START};
        my $end = $hash_position{$index}{END};
        if (isdigit($start) && !isdigit($end)){
          $end = length($line_parse);
        }
        if (!isdigit($start) || !isdigit($end)){next;}
        my $length = ($end - $start);
        $length++;
        my $len = length($name_property);
        my $name = substr($name_property,$start,$length);
        $name = remove_whitespace($name);
        if (!defined $name){next;}
        if (defined $name && $name eq "UID"){
          $lun_id = substr($line,$start,$length);
          $lun_id = remove_whitespace($lun_id);
          if (defined $lun_id){
            $act_volume = $lun_id;
          }
        }
      }
    }
    if ($active == 6 && $name_property2 ne ""){
      foreach my $index (sort {$a<=>$b} keys %hash_position){
        my $start = $hash_position{$index}{START};
        my $end = $hash_position{$index}{END};
        if (isdigit($start) && !isdigit($end)){
          $end = length($line_parse);
        }
        if (!isdigit($start) || !isdigit($end)){next;}
        my $length = ($end - $start);
        $length++;
        my $len = length($name_property2);
        if ($len < $start){next;}
        my $name = substr($name_property2,$start,$length);
        $name = remove_whitespace($name);
        if (!defined $name){next;}
        if ($name eq "Name" ){
          my $len = length($line);
          if ($len < $start ){next;}
          my $lun = substr($line,$start,$length);
          $lun = remove_whitespace($lun);
          if (defined $lun && $lun ne ""){
            $luns{$lun}{id} = $lun;
            if (defined $act_volume && $act_volume ne ""){
              $luns{$lun}{volume}{$act_volume}{id} = $act_volume;
            }
          }
        }
      }
    }
  }
  #print Dumper \%luns;
  $file = "$data_directory/host_affinity.txt";
  @data = get_array_data($file);
  $active = -1;
  $name_property = "";
  $name_property2 = "";
  $line_parse = "";
  my $host_only = 0;

  foreach my $index (keys %hash_position){
    delete $hash_position{$index};
  }
  foreach my $line (@data){
    chomp $line;
    my $size_line  = $line;
    $size_line = remove_whitespace($size_line);
    if ( $line eq "" || $line =~ m/^CLI>/ || $size_line eq "" ) {
      $active = -1;
      $host_only = 0;
      foreach my $index (keys %hash_position){
        delete $hash_position{$index};
      }
      next;
    }
    if ($line =~ m/<Connection List/){
      $active = -1;
      next;
    }
    if ($line =~ m/Port Group/ && $line =~ m/Host Group/ && $line =~ m/LUN Group/){
      $active = 0;
      next;
    }
    #only hosts
    if ($line !~ m/Port Group/ && $line =~ m/Host/ && $line =~ m/LUN Group/){
      $active = 0;
      $host_only = 1;
      next;
    }
    if ($active == 0 && $line =~ m/Name/ && $line =~ m/No\./){
      $name_property = $line;
      $active++;
      next;
    }
    #if ($line =~ m/^</){
    #  last;
    #}
    if ($line =~ m/----/ && ( $active == 1 || $active == 5)){
      $line_parse = $line;
      my @chars = split("",$line);
      my $index = -1;
      my $num_property = 1;
      foreach my $char (@chars){
        $index++;
        if ($char eq " " && defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{END} = $index - 1;
          $num_property++;
          next;
        }
        if ($char eq "-" && !defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{START} = $index;
        }
      }
      $active++;
      next;
    }
    if ($active == 2 && $name_property ne ""){
      my $lun_group = "";
      my $host = "";
      my $host_id = "";
      foreach my $index (sort {$a<=>$b} keys %hash_position){
        my $start = $hash_position{$index}{START};
        my $end = $hash_position{$index}{END};
        if (isdigit($start) && !isdigit($end)){
          $end = length($line_parse);
        }
        if (!isdigit($start) || !isdigit($end)){next;}
        my $length = ($end - $start);
        $length++;
        my $name = substr($name_property,$start,$length);
        $name = remove_whitespace($name);
        if (!defined $name){next;}
        if (defined $name && $name eq "Name" && $host_only == 0){
          if ($index == 4){
            $host = substr($line,$start,$length);
            $host = remove_whitespace($host);
          }
          if ($index == 6){
            $lun_group = substr($line,$start,$length);
            $lun_group = remove_whitespace($lun_group);
          }
        }
        if (defined $name && $name eq "No." && $index == 3 && $host_only == 0){
          $host_id = substr($line,$start,$length);
          $host_id = remove_whitespace($host_id);
        }
        if (defined $name && $name eq "Name" && $host_only == 1){
          if ($index == 2){
            $host = substr($line,$start,$length);
            $host = remove_whitespace($host);
          }
          if ($index == 4 ){
            $lun_group = substr($line,$start,$length);
            $lun_group = remove_whitespace($lun_group);
          }
        }
        if (defined $name && $name eq "No." && $index == 1 && $host_only == 1){
          $host_id = substr($line,$start,$length);
          $host_id = remove_whitespace($host_id);
        }
        if (defined $lun_group && $lun_group ne "" && defined $host && $host ne "" && defined $host_id && $host_id ne ""){
          $inventory_data{$section}{$host_id}{"host_id"} = $host_id;
          $inventory_data{$section}{$host_id}{"id"} = $host_id;
          $inventory_data{$section}{$host_id}{"name"} = $host;
          $inventory_data{$section}{$host_id}{"lun_group"}{$lun_group}{id} = $lun_group;
          foreach my $host_wwn (keys %{$inventory_data{$section}}){
            if ($host_wwn eq $host_id){next;}
            my $name = $inventory_data{$section}{$host_wwn}{"name"};
            my $wwn = $inventory_data{$section}{$host_wwn}{"id"};
            if (defined $name && $name ne "" && defined $wwn && $wwn ne "" && $name eq $host && $host_id eq $wwn){
              $inventory_data{$section}{$host_wwn}{"lun_group"}{$lun_group}{id} = $lun_group;
            }
          }

        }
      }
    }
  }
  #print Dumper \$inventory_data{$section};
  #print Dumper \%host_group;
  foreach my $host_group (keys %host_group){
    my @lun_group = ();
    if (defined $inventory_data{$section}{$host_group} && defined $inventory_data{$section}{$host_group}{id}){
      my $name_host_group = $inventory_data{$section}{$host_group}{"name"};
      my $name_host_group2 = $host_group{$host_group}{name};
      if (defined $name_host_group && $name_host_group ne "" && defined $name_host_group2 && $name_host_group eq $name_host_group2){
        print "$name_host_group\n";
        my $pom = "Group-$name_host_group";
        $inventory_data{$section}{$host_group}{"name"} = $pom;
      }
      #print "host group $host_group\n";
      #print Dumper \$inventory_data{$section}{$host_group}{"lun_group"};
      foreach my $lun_group (keys %{$inventory_data{$section}{$host_group}{"lun_group"}}){
        push(@lun_group,"$lun_group");
      }
    }
    #print "$host_group\n";
    #print Dumper \@lun_group;
    foreach my $host (keys %{$host_group{$host_group}{host}}){
      foreach my $lun (@lun_group){
        if (defined $inventory_data{$section}{$host} && defined $inventory_data{$section}{$host}{id} && !defined $inventory_data{$section}{$host}{"lun_group"}){
          $inventory_data{$section}{$host}{"lun_group"}{$lun}{id} = $lun;
        }
      }
    }
  }
  #print Dumper \$inventory_data{$section};

  ### delete duplicite host
  foreach my $host (keys %{$inventory_data{$section}}){
    my $id = $inventory_data{$section}{$host}{"id"};
    my $name = $inventory_data{$section}{$host}{"name"};
    if (!defined $id || $id eq ""){next;}
    if (!defined $name || $name eq ""){next;}
    if ($host ne $id && defined $inventory_data{$section}{$id}){
      my $name_act = $inventory_data{$section}{$id}{"name"};
      if (defined $name_act && $name_act eq $name){
        delete $inventory_data{$section}{$id};
      }
    }
  }

  foreach my $host (keys %{$inventory_data{$section}}){
    my $volume_ids = "";
    if (!defined $inventory_data{$section}{$host}{lun_group}){next;}
    foreach my $lun (keys %{$inventory_data{$section}{$host}{lun_group}}){
      if (!defined $luns{$lun}{volume}){next;}
      foreach my $volume (keys %{$luns{$lun}{volume}}){
        if ($volume_ids eq ""){
          $volume_ids = $volume;
        }
        else{
          if ($volume_ids !~ m/$volume/){
            $volume_ids = $volume_ids ." " . "$volume";
          }
        }
      }
    }
    if ($volume_ids ne ""){
      $inventory_data{$section}{$host}{"Volume IDs"} = $volume_ids;
    }
  }
  #print Dumper \$inventory_data{$section};

}

sub get_configuration_storage{

  my @configuration = ();

  my $file = "$data_directory/enclosure_status.txt";
  my @data = get_array_data($file);
  my $storage_name = "";
  my $model_name = "";
  my $serial_number = "";
  my $firmware = "";
  my $status = "";
  my $cache_mode = "";
  my $remote_support = "";
  my $operation_mode = "";
  my $connection_module = "";

  foreach my $line (@data){
    chomp $line;
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    $line = remove_whitespace($line);
    if ($line =~ m/Storage System Name/){
      $line =~ s/Storage System Name//g;
      $line =~ s/\[//g;
      $line =~ s/\]//g;
      $line = remove_whitespace($line);
      if (defined $line ){
        $storage_name = $line;
      }
    }
    if ($line =~ m/Model Name/){
      $line =~ s/Model Name//g;
      $line =~ s/\[//g;
      $line =~ s/\]//g;
      $line = remove_whitespace($line);
      if (defined $line ){
        $model_name = $line;
      }
    }
    if ($line =~ m/Serial Number/){
      $line =~ s/Serial Number//g;
      $line =~ s/\[//g;
      $line =~ s/\]//g;
      $line = remove_whitespace($line);
      if (defined $line ){
        $serial_number = $line;
      }
    }
    if ($line =~ m/Firmware Version/){
      $line =~ s/Firmware Version//g;
      $line =~ s/\[//g;
      $line =~ s/\]//g;
      $line = remove_whitespace($line);
      if (defined $line ){
        $firmware = $line;
      }
    }
    if ($line =~ m/Status/){
      $line =~ s/Status//g;
      $line =~ s/\[//g;
      $line =~ s/\]//g;
      $line = remove_whitespace($line);
      if (defined $line ){
        $status = $line;
      }
    }
    if ($line =~ m/Cache Mode/){
      $line =~ s/Cache Mode//g;
      $line =~ s/\[//g;
      $line =~ s/\]//g;
      $line = remove_whitespace($line);
      if (defined $line ){
        $cache_mode = $line;
      }
    }
    if ($line =~ m/Remote Support/){
      $line =~ s/Remote Support//g;
      $line =~ s/\[//g;
      $line =~ s/\]//g;
      $line = remove_whitespace($line);
      if (defined $line ){
        $remote_support = $line;
      }
    }
    if ($line =~ m/CLI Connecting Controller Module/){
      $line =~ s/CLI Connecting Controller Module//g;
      $line =~ s/\[//g;
      $line =~ s/\]//g;
      $line = remove_whitespace($line);
      if (defined $line ){
        $connection_module = $line;
      }
    }
    if ($line =~ m/Operation Mode/){
      $line =~ s/Operation Mode//g;
      $line =~ s/\[//g;
      $line =~ s/\]//g;
      $line = remove_whitespace($line);
      if (defined $line ){
        $operation_mode = $line;
      }
    }

  }
  push(@configuration,"Storage System Name   : $storage_name\n");
  push(@configuration,"Model Name            : $model_name\n");
  push(@configuration,"Serial Number         : $serial_number\n");
  push(@configuration,"Firmware Version      : $firmware\n");
  push(@configuration,"Status                : $status\n");
  push(@configuration,"Cache Mode            : $cache_mode\n");
  push(@configuration,"Remote Support        : $remote_support\n");
  push(@configuration,"Operation Mode        : $operation_mode\n");
  push(@configuration,"Connecting Module     : $connection_module\n\n\n");


  $file = "$data_directory/performance.txt";
  @data = get_array_data($file);
  my $perf_status = "";
  my $sample_rate = "";

  foreach my $line (@data){
    chomp $line;
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    $line = remove_whitespace($line);
    if ($line =~ m/Status/){
      $line =~ s/Status//g;
      $line =~ s/\[//g;
      $line =~ s/\]//g;
      $line = remove_whitespace($line);
      if (defined $line){
        $perf_status = $line;
      }
    }
    if ($line =~ m/Interval/){
      $line =~ s/Interval//g;
      $line =~ s/\[//g;
      $line =~ s/\]//g;
      $line = remove_whitespace($line);
      if (defined $line){
        $sample_rate = $line;
      }
    }

  }
  push(@configuration,"Performance settings\n");
  push(@configuration, "  Status   : $perf_status\n");
  push(@configuration, "  Interval : $sample_rate\n");

  return @configuration;
}


sub write_data{

 (my $file, my $file_tmp) = split(",",get_name_file("conf"));
  my @config_data = get_configuration_storage();
  #my $version = get_version();
  open(DATA, ">>$file_tmp") or error_die ("Cannot open file: $file_tmp : $!");
    print DATA "Configuration Data\n";
    print DATA "------------------\n\n";
    #print DATA "Version : $version\n\n";
    print DATA @config_data;
    print DATA "\n\n";
  close DATA;
  foreach my $section (reverse sort keys %header_section){
    open(DATA, ">>$file_tmp") or error_die ("Cannot open file: $file_tmp : $!");
    my @values = get_data_configuration("$section","$header_section{$section}");
    print DATA "$section\n";
    print DATA "------------------------------------------\n";
    print DATA $header_section{$section};
    print DATA @values;
    print DATA "\n\n";

    close DATA;
  }
  rename ("$file_tmp", "$file");


}

sub get_data_configuration{
  my $section = shift;
  my $section_contents = shift;
  my @values = "";
  my $active = 0;
  my @header = split (",",$section_contents);
  foreach my $id (keys %{$inventory_data{$section}}){
    if ( ($header[0] ne "" && !defined $inventory_data{$section}{$id}{$header[0]}) || ($header[1] ne "" && !defined $inventory_data{$section}{$id}{$header[1]} && $section ne "Port-Mapping Level Configuration")){next;}
    if ( defined $inventory_data{$section}{$id}{$header[0]} && $inventory_data{$section}{$id}{$header[0]} eq "-"){next;}
    #if ($section eq "Tier Level Configuration" && $id ne "/data: post-comp"){next;}
    if (!@values eq ""){
      my $last = pop(@values);
      $last =~ s/,//g;
      push(@values,$last);
    }
    #if ($active > 0 && $section eq "Pool Level Configuration"){
    #  push(@values,",,,,,,,,");  ### add blank properties end
    #}
    $active++;
    push(@values,"\n");
    foreach my $element (@header){
      chomp $element;
      $element = remove_whitespace($element);
      if ($element eq ""){
        push (@values,",");
        next;
      }
      if (defined $inventory_data{$section}{$id}{$element} && $inventory_data{$section}{$id}{$element} ne "" && $inventory_data{$section}{$id}{$element} ne "-"){
        push (@values,"$inventory_data{$section}{$id}{$element},");
      }
      else{
        push (@values,",");
      }
    }
  }
  my $last = pop(@values);
  $last =~ s/,//g;
  push(@values,$last);
  #if ( $section eq "Pool Level Configuration"){
  #  push(@values,",,,,,,,,");  ### add blank properties end
  #}
  return @values;
}


sub get_name_file {
  my $type       = shift;
  my @time       = localtime();
  my $time_human = localtime();
  my $sec        = $time[0];
  my $minute     = $time[1];
  my $hour       = $time[2];
  my $day        = $time[3];
  my $month      = $time[4] + 1;
  my ( undef, undef, undef, undef, $year ) = split( " ", $time_human );
  chomp $year;

  if ( $minute < 10 ) { $minute = "0$minute"; }
  if ( $hour < 10 )   { $hour   = "0$hour"; }
  if ( $day < 10 )    { $day    = "0$day"; }
  if ( $month < 10 )  { $month  = "0$month"; }
  if ( $sec < 10 )    { $sec    = "0$sec"; }
  my $name_file     = "$wrkdir/$storage_name" . "_eternus$type" . "_" . "$year$month$day" . "_" . "$hour$minute" . ".out";
  my $name_file_tmp = "$wrkdir/$storage_name" . "_eternus$type" . "_" . "$year$month$day" . "_" . "$hour$minute" . ".out-tmp";
  return "$name_file,$name_file_tmp";

} ## end sub get_name_file

sub set_time{

  my $end_timestamp = time;
  my $start_timestamp = $end_timestamp - 300;
  my $end_time = get_time($end_timestamp);
  my $start_time = get_time($start_timestamp);

  foreach my $section (keys %inventory_data){
    $inventory_data{$section}{TIME}{END} = $end_time;
    $inventory_data{$section}{TIME}{START} = $start_time;
    $inventory_data{$section}{TIME}{STEP} = 300;
  }

}


sub set_header{

  ### VOLUME
  my $section = "Volume Level Configuration";
  my $metric  = "volume_id,name,serial,,,,pool_id,pool_name,capacity (MB),Used(MB),Free(MB),,,,,,,,,,interface_type,raid_group_id,raid_group_name,health_status";
  $header_section{$section} = $metric;

  ### RG
  $section                  = "RG Level Configuration";
  $metric                   = "name,id,health_status,,,capacity (GB),,free_capacity (GB),,used_capacity (GB),,,,,,,RAID Level,Assigned CM,pool_id,pool_name";
  $header_section{$section} = $metric;

  ### DRIVE
  $metric                   = "id,name,health_status,status,raid_group_id,raid_group_name,motor_status,Capacity(GB),Used(GB),Free(GB),Vendor ID,Product ID,Serial Number,WWN,type,Firmware,usage";
  $section                  = "Drive Level Configuration";
  $header_section{$section} = $metric;

  ### HOST
  $section                  = "Host Level Configuration";
  $metric                   = "host_id,id,name,wwn,,,,Volume IDs,";
  $header_section{$section} = $metric;

  ### POOL
  $section                  = "Pool Level Configuration";
  $metric                   = "name,id,health_status,used_status,,capacity (GB),,free_capacity (GB),,used_capacity (GB),,,,,,,RAID Level,Assigned CM";
  $header_section{$section} = $metric;

  ### PORT
  $metric  = "id,name,,,,Transfer Rate,,,,,status,Protocol,Port Mode,WWPN,Connection";
  $section = "Port Level Configuration";
  $header_section{$section} = $metric;


}

sub set_data_rg{

  my $section = "RG Level Configuration";
  my $file = "$data_directory/rg.txt";
  my @data = get_array_data($file);

  foreach my $line (@data){
    chomp $line;
    $line = remove_whitespace($line);
    if ( $line eq "" || $line =~ /Status|RAID Group No/ ) { next; }
    if ($line =~ m/CLI\>/){next;}
    my ($id, $name, $raid_level, $assigned_cm, $status, $total, $free) = split(",", $line);
    if (!defined $id){next;}
    $inventory_data{$section}{$id}{"id"} = $id;
    $inventory_data{$section}{$id}{"name"} = $name;
    if (isdigit($total)){
      if (defined $inventory_data{$section}{$id}{"id"}){
        my $pom = $total / 1024;
        $inventory_data{$section}{$id}{"capacity (GB)"} = round($pom,2);
      }
    }
    if (isdigit($free)){
      if (defined $inventory_data{$section}{$id}{"id"}){
        my $pom = $free / 1024;
        $inventory_data{$section}{$id}{"free_capacity (GB)"} = round($pom,2);
      }
    }
    if (isdigit($total) && isdigit($free)){
      my $used = $total - $free;
      if (isdigit ($used)){
        my $pom = $used / 1024;
        $inventory_data{$section}{$id}{"used_capacity (GB)"} = round($pom,2);
      }
    }
    if (defined $raid_level){
      $inventory_data{$section}{$id}{"RAID Level"} = $raid_level;
    }
    if (defined $assigned_cm){
      $inventory_data{$section}{$id}{"Assigned CM"} = $assigned_cm;
    }
    if (defined $status){
      $inventory_data{$section}{$id}{"health_status"} = $status;
    }

  }

}





sub set_data_drive{

  ### location - substr


  my $file = "$data_directory/disk.txt";
  my $section = "Drive Level Configuration";
  my @data = get_array_data($file);
  my $active = 0;
  my %hash_position;
  my $name_property = "";
  my $line_parse = "";


  foreach my $line (@data){
    chomp $line;
    $line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/Status|Location/ ) { next; }
    if ($line =~ m/^CLI/){next;}
    my ($location, $status, $size, $type, $speed, $usage, $health, $rg, $motor_status, undef, $vendor, $product, $serial, $wwn, $firmware) = split(",",$line);
    if (!defined $location){next;}
    $location =~ s/#//g;
    $inventory_data{$section}{$location}{id} = $location;
    $inventory_data{$section}{$location}{name} = $location;
    if (defined $status){
      $inventory_data{$section}{$location}{"status"} = $status;
    }
    if (defined $size){
      if ($size =~ /TB/){
        $size =~ s/TB//g;
        $size = remove_whitespace($size);
        if (isdigit($size)){
          my $pom = $size * 1024;
          $size = round($pom,2);
        }
      }
      if ($size =~ /GB/){
        $size =~ s/GB//g;
        $size = remove_whitespace($size);
      }
      if ($size =~ /MB/){
        $size =~ s/MB//g;
        $size = remove_whitespace($size);
        if (isdigit($size)){
          my $pom = $size / 1024;
          $size = round($pom,2);
        }
      }
      if (isdigit($size)){
        $inventory_data{$section}{$location}{"Capacity(GB)"} = $size;
      }
    }
    if (defined $type){
      $inventory_data{$section}{$location}{"type"} = $type;
    }
    if (defined $rg){
      my ($id, $name ) = split(" : ",$rg);
      $id = remove_whitespace($id);
      $name = remove_whitespace($name);
      if (defined $id && $id ne ""){
        $inventory_data{$section}{$location}{"raid_group_id"} = $id;
      }
      if (defined $name && $name ne ""){
        $inventory_data{$section}{$location}{"raid_group_name"} = $name;
      }
    }
    if (defined $health){
      $inventory_data{$section}{$location}{"health_status"} = $health;
    }
    if (defined $speed){
      $inventory_data{$section}{$location}{"speed"} = $speed;
    }
    if (defined $usage){
      $inventory_data{$section}{$location}{"usage"} = $usage;
    }
    if (defined $motor_status){
      $inventory_data{$section}{$location}{"motor_status"} = $motor_status;
    }
    if (defined $firmware){
      $inventory_data{$section}{$location}{"Firmware"} = $firmware;
    }
    if (defined $vendor){
      $inventory_data{$section}{$location}{"Vendor ID"} = $vendor;
    }
    if (defined $product){
      $inventory_data{$section}{$location}{"Product ID"} = $product;
    }
    if (defined $wwn){
      $inventory_data{$section}{$location}{"WWN"} = $wwn;
    }
    if (defined $serial){
      $inventory_data{$section}{$location}{"Serial Number"} = $serial;
    }

  }

}


sub set_data_volume{

  my $section = "Volume Level Configuration";
  my $file = "$data_directory/volume.txt";
  my @data = get_array_data($file);
  my $active = 0;
  my $name_property = "";
  my $name_property2 = "";
  my %hash_position;


  foreach my $line (@data){
    chomp $line;
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/No\./ && $line =~ m/Name/){
      $name_property = $line;
      $active++;
      next;
    }
    if ($line =~ m/Status/ && $line =~ m/Volume/){
      $name_property2 = $line;
    }

    if ($line =~ m/^----/ && $active == 1){
      my @chars = split("",$line);
      my $index = -1;
      my $num_property = 1;
      foreach my $char (@chars){
        $index++;
        if ($char eq " " && defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{END} = $index - 1;
          $num_property++;
          next;
        }
        if ($char eq "-" && !defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{START} = $index;
        }
      }
      $active++;
      next;
    }
    if ($active == 2 && $name_property ne ""){
      my $id_element = "";
      my $name_element = "";
      my $rg_name = "";
      my $rg_id = "";
      my $size = "";
      my $type = "";
      my $status = "";
      foreach my $index (sort {$a<=>$b} keys %hash_position){
        my $start = $hash_position{$index}{START};
        my $end = $hash_position{$index}{END};
        if (!isdigit($start) || !isdigit($end)){next;}
        my $length = ($end - $start);
        $length++;
        my $name = substr($name_property,$start,$length);
        $name = remove_whitespace($name);

        ### status and type
        if ($name_property2 ne "" && $index == 3 ){
          my $name2 = substr($name_property2,$start,$length);
          $name2 = remove_whitespace($name2);
          if (defined $name2 && $name2 eq "Status"){
            $status = substr($line,$start,$length);
            $status = remove_whitespace($status);
          }
        }
        if ($name_property2 ne "" && $index == 4 ){
          my $name2 = substr($name_property2,$start,$length);
          $name2 = remove_whitespace($name2);
          if (defined $name2 && $name2 eq "Type"){
            $type = substr($line,$start,$length);
            $type = remove_whitespace($type);
          }
        }
        if ($name_property2 ne "" && $index == 12 ){
          my $name2 = substr($name_property2,$start,$length);
          $name2 = remove_whitespace($name2);
          if (defined $name2 && $name2 eq "Size(MB)"){
            $size = substr($line,$start,$length);
            $size = remove_whitespace($size);
          }
        }

        ###

        if (!defined $name || $name eq ""){
          next;
        }
        if ($name eq "Name" && $index == 2){
          $name_element = substr($line,$start,$length);
          $name_element = remove_whitespace($name_element);
        }
        if ($name eq "ID"){
          $id_element = substr($line,$start,$length);
          $id_element = remove_whitespace($id_element);
        }
        if ($name eq "No." && $index == 8){
          $rg_id = substr($line,$start,$length);
          $rg_id = remove_whitespace($rg_id);
        }
        if ($name eq "Name" && $index == 9){
          $rg_name = substr($line,$start,$length);
          $rg_name = remove_whitespace($rg_name);
        }
        if (defined $name_element && $name_element ne "" && defined $id_element && $id_element ne "" ){
          $inventory_data{$section}{$id_element}{"volume_id"} = $id_element;
          $inventory_data{$section}{$id_element}{"name"} = $name_element;

          if (isdigit($size)){
            $inventory_data{$section}{$id_element}{"capacity (MB)"} = $size;
          }
          if (defined $status){
            $inventory_data{$section}{$id_element}{"health_status"} = $status;
          }
          if (defined $type){
            $inventory_data{$section}{$id_element}{"type"} = $type;
          }


          if (defined $rg_id && $rg_id ne "" && defined $rg_name && $rg_name ne ""){
            $inventory_data{$section}{$id_element}{"pool_id"} = $rg_id;
            $inventory_data{$section}{$id_element}{"pool_name"} = $rg_name;
          }
        }
      }
    }
  }
  #print Dumper \%inventory_data;
  #print Dumper \%hash_position;

}



sub cmd_to_file {
  my $cmd     = shift;
  my $file    = shift;
  my $timeout = shift;
  my $save = shift;
  my $pid     = fork();
  if ( !defined $pid ) {
    error_die( "no fork $!" . __FILE__ . ":" . __LINE__ );
  }
  elsif ( $pid == 0 ) {
    setpgrp( 0, 0 );
    if (defined $save && $save eq "save"){
      #`$connection '$cmd' >> "$file" 2>>\$ERRLOG_ETERNUS`;
      #`$connection '$cmd' >> "$file" 2>\$err_tmp`;
      `echo '$cmd' | $connection >> "$file" 2>\$err_tmp`
    }
    else{
      #`$connection '$cmd' > "$file" 2>>\$ERRLOG_ETERNUS`;
      #`$connection '$cmd' > "$file" 2>\$err_tmp`;
      `echo '$cmd' | $connection > "$file" 2>\$err_tmp`
    }
    if ( $? != 0 ) {
      error( "command failed: $cmd " . __FILE__ . ":" . __LINE__ );
      if ($file =~ m/test_version\.txt/){
        `touch $data_directory/version_old.txt`;
      }
    }
    exit(0);
  } ## end elsif ( $pid == 0 )
  eval {
    local $SIG{ALRM} = sub { die "die in SIGALRM"; };
    alarm($timeout);
    waitpid( $pid, 0 );
    alarm(0);
  };
  if ( $@ =~ /die in SIGALRM/ ) {
    my $act_time = localtime();
    error( "$act_time command: $cmd timed out after: $timeout seconds " . __FILE__ . ":" . __LINE__ );
    kill -15, $pid;
    waitpid( $pid, 0 );
  } ## end if ( $@ =~ /die in SIGALRM/)
  error_wraper($err_tmp);
  return;
} ## end sub cmd_to_file


sub get_performance_statistics{

  my $cmd = "";
  my $file = "";

  if ($version == 1){

    $cmd = "show disks -csv";
    $file = "$data_directory/disk.txt";
    cmd_to_file($cmd,$file, $timeout_perf);

    $cmd = "show volumes -mode detail";
    $file = "$data_directory/volume.txt";
    cmd_to_file($cmd,$file, $timeout_perf);

    $cmd = "show raid-groups -csv";
    $file = "$data_directory/rg.txt";
    cmd_to_file($cmd,$file, $timeout_perf);

    $cmd = "show thin-pro-pools";
    $file = "$data_directory/pool.txt";
    cmd_to_file($cmd,$file, $timeout_perf);

    my @pool = get_id_pool($file);
    if ( -e "$data_directory/pool_mapping.txt" ) {
      unlink "$data_directory/pool_mapping.txt" or  error ("Unable to unlink $data_directory/pool_mapping.txt: $!");
    }

    foreach my $id (@pool){
      my $cmd = "show thin-pro-pools -pool-number $id";
      $file = "$data_directory/pool_mapping.txt";
      cmd_to_file($cmd,$file, $timeout_perf,"save");
    }

    #$cmd = "show flexible-tier-mode";
    #$file = "$data_directory/tier_mode.txt";
    #cmd_to_file($cmd,$file, $timeout_perf);

    #my $test_tier = test_tier_pool($file);
    my $test_tier = 1;

    if ($test_tier == 1){

      $cmd = "show flexible-tier-pools";
      $file = "$data_directory/tier_pool.txt";
      cmd_to_file($cmd,$file, $timeout_perf);
    }

  }
  if ($version == 0){
    $cmd = "show disks";
    $file = "$data_directory/disk.txt";
    cmd_to_file($cmd,$file, $timeout_perf);

    $cmd = "show raid-groups";
    $file = "$data_directory/rg.txt";
    cmd_to_file($cmd,$file, $timeout_perf);

    $cmd = "show volumes";
    $file = "$data_directory/volume.txt";
    cmd_to_file($cmd,$file, $timeout_perf);

  }

  $cmd = "show port-groups";
  $file = "$data_directory/port_group.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show lun-groups";
  $file = "$data_directory/lun_group.txt";  ### parallel with system show stats view cifs
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show host-groups -all";
  $file = "$data_directory/host.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show volume-mapping";
  $file = "$data_directory/volume_mapping.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show host-affinity";
  $file = "$data_directory/host_affinity.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show fc-parameters";
  $file = "$data_directory/fc-port.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show sas-parameters";
  $file = "$data_directory/sas-port.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show fcoe-parameters";
  $file = "$data_directory/fcoe-port.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show iscsi-parameters";
  $file = "$data_directory/iscsi-port.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show enclosure-status";
  $file = "$data_directory/enclosure_status.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show performance";
  $file = "$data_directory/performance.txt";
  cmd_to_file($cmd,$file, $timeout_perf);



}

sub test_tier_pool{
  my $file = shift;
  my @data = get_array_data($file);

  foreach my $line (@data){
    chomp $line;
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    $line = remove_whitespace($line);
    if ( $line eq ""){next;}
    if ($line =~ m/Enable/){return 1;}

  }

  return 0;

}

sub get_id_pool {

  my $file = shift;
  my @data = get_array_data($file);
  my $active = 0;
  my @pool = ();

  foreach my $line (@data){
    chomp $line;
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    $line = remove_whitespace($line);
    if ( $line eq "" ) {next;}
    if ($line =~ m/----------------/){
      $active++;
      next;
    }
    if ($active == 1){
      my ($id) = split (" ",$line);
      $id = remove_whitespace($id);
      if (isdigit($id)){
        push(@pool,$id);
      }
    }

  }
  return @pool;

}


sub set_variable{

  if ($eternus_enviroment){
    my $act_directory = localtime();
    my @entry_time = split( " ", $act_directory );
    ( undef, my $active_minute, undef ) = split( ":", $entry_time[3] );
    $storage_name = $ENV{STORAGE_NAME};
    $basedir      = $ENV{INPUTDIR};
    $bindir       = $ENV{BINDIR};
    $webdir       = $ENV{WEBDIR};
    $error_datadomain  = $ENV{ERRLOG_ETERNUS};
    if ( defined $webdir && $webdir ne "" && defined $storage_name && $storage_name ne "" ) {
      $health_status_html = "$webdir/$storage_name/health_status.html";
      $wrkdir             = "$basedir/data/$storage_name";
      $data_directory     = "$wrkdir/IOSTATS/configuration";
      if ( !-d "$wrkdir/IOSTATS" ) {
        mkdir "$wrkdir/IOSTATS" || error_die( "Cannot read $wrkdir/IOSTATS: $!" . __FILE__ . ":" . __LINE__ );
      }
      $summary_health = "$basedir/tmp/health_status_summary";
      if ( !-d "$data_directory" ) {
        mkdir "$data_directory" || error_die( "Cannot read $data_directory: $!" . __FILE__ . ":" . __LINE__ );
      }
      if ( defined $basedir && $basedir ne "" ) {
        $summary_health = "$basedir/tmp/health_status_summary";
      }
      else {
        error_die("BASEDIR is not defined!");
      }
    } ## end if ( defined $webdir &&...)
    else {
      error_die("WEBDIR or STORAGE NAME is not defined!");
    }
    $ENV{err_tmp} = "$basedir/tmp/error.log-tmp-$storage_name";
    $err_tmp = "$basedir/tmp/error.log-tmp-$storage_name";
    $user   = $ENV{ETERNUS_USER};
    $ip_address_a  = $ENV{ETERNUS_IP_SPA};
    $ip_address_b  = $ENV{ETERNUS_IP_SPB};
    if ( !defined $user || $user eq "" ) {
      error_die("USER is not defined!");
    }
    if (!defined $ip_address_a || $ip_address_a eq ""){
      if (!defined $ip_address_b || $ip_address_b eq ""){
        error_die("IP ADDRESS is not defined!");
      }
      else{
        my $cmd = "show enclosure-status";
        my $file = "$data_directory/test.txt";
        my $connection = "$ssh_cmd $user" . "@" . "$ip_address_b";
        test_conection($cmd,$file, $timeout_perf,$connection);
        if (test_file_exist($file)){
          $ip_address = $ip_address_b;
        }
        else{
          error_die("IP connection failed!");
        }
      }
    }
    else{
      my $cmd = "show enclosure-status";
      my $file = "$data_directory/test.txt";
      my $connection = "$ssh_cmd $user" . "@" . "$ip_address_a";
      test_connection($cmd,$file, $timeout_perf,$connection);
      if (test_file_exist($file)){
        $ip_address = $ip_address_a;
      }
      else{
        if (defined $ip_address_b || $ip_address_b eq ""){
          my $cmd = "show enclosure-status";
          my $file = "$data_directory/test.txt";
          my $connection = "$ssh_cmd $user" . "@" . "$ip_address_b";
          test_connection($cmd,$file, $timeout_perf,$connection);
          if (test_file_exist($file)){
            $ip_address = $ip_address_b;
          }
          else{
            error_die("IP connection failed!");
          }
        }
      }
    }
    if ( !defined $key || $key eq "" || !test_file_exist($key) ) {
      $connection = "$ssh_cmd $user" . "@" . "$ip_address";
    }
    else {
      $connection = "$ssh_cmd -i $key $user" . "@" . "$ip_address";
    }
  }

  else {
    my $act_directory = localtime();
    my @entry_time = split( " ", $act_directory );
    ( undef, my $active_minute, undef ) = split( ":", $entry_time[3] );
    #$active_minute = "10";
    #$storage_name       = "DX200S4_main";
    #$storage_name       = "Eternus_AF650_De";
    #$storage_name       = "CC_DX200_PRD_BDC";
    $basedir            = "/home/luzajic/STOR/ETERNUS";
    $bindir             = $ENV{BINDIR};
    $inputdir           = $ENV{INPUTDIR};
    $wrkdir             = "$basedir/data/$storage_name";
    $webdir             = "$basedir/www";
    $health_status_html = "$webdir/$storage_name/health_status.html";
    $summary_health     = "$basedir/tmp/health_status_summary";
    $configuration      = "";
    $config_directory   = "";
    $data_directory     = "$wrkdir/IOSTATS/configuration";
    $ip_address          = "192.168.0.251";
    $user               = "stor2rrd";
    $path               = "";
    $connection = "$ssh_cmd $user" . "@" . "$ip_address";
    $ENV{ERRLOG_ETERNUS} = "$basedir/error.log";
    #$err_tmp = "$ENV{INPUTDIR}/tmp/error.log-tmp-$storage_name";
    #$ENV{err_tmp} = "$ENV{INPUTDIR}/tmp/error.log-tmp-$storage_name";
    $ENV{err_tmp} = "$basedir/tmp/error.log-tmp-$storage_name";
    $err_tmp = "$basedir/tmp/error.log-tmp-$storage_name";

  } ## end else [ if ($vnx_enviroment) ]

}




sub data_structure {
  my $directory = "$wrkdir/IOSTATS";
  if ( !-d $directory ) {
    mkdir $directory || error_die( "Cannot read $directory: $!" . __FILE__ . ":" . __LINE__ );
  }
  if ( !-d "$directory/configuration" ) {
    mkdir "$directory/configuration" || error_die( "Cannot read $directory: $!" . __FILE__ . ":" . __LINE__ );
  }

  for ( my $i = 0; $i < 60; $i = $i + 1 ) {
    if ( $i < 10 ) {
      if ( !-d "$directory/0$i" ) {
        mkdir "$directory/0$i" || error_die( "Cannot read $directory: $!" . __FILE__ . ":" . __LINE__ );
      }
    }
    else {
      if ( !-d "$directory/$i" ) {
        mkdir "$directory/$i" || error_die( "Cannot read $directory: $!" . __FILE__ . ":" . __LINE__ );
      }
    }
  } ## end for ( my $i = 0; $i < 60...)
} ## end sub data_structure


sub error {

  my $text     = shift;
  my $act_time = localtime();
  chomp($text);
  print STDERR "$act_time: $text : $!\n";
  return 1;

} ## end sub error

sub error_die {
  my $message  = shift;
  my $act_time = localtime();
  print STDERR "$act_time: $message : $!\n";
  exit(1);
} ## end sub error_die

sub get_array_data {
  my $file = shift;
  my $test = test_file_exist($file);
  if ($test) {
    open( FH, "< $file" ) || error_die( "Cannot read $file: $!" . __FILE__ . ":" . __LINE__ );
    my @file_all = <FH>;
    close(FH);
    return @file_all;
  } ## end if ($test)
  else {
    if ($file !~  m/pool_mapping\.txt/ ){
      error( "File not exist $file: $!" . __FILE__ . ":" . __LINE__ );
    }
    my @file_empty = "";
    return @file_empty;
  }
} ## end sub get_array_data

sub test_file_exist{
  my $file = shift;
  my $run = shift;
  if (!defined $file || $file eq ""){
    error("File does not defined !");
    return 0;
  }
  if (!-e $file || -z $file){
    if (defined $run && -z $file){return 1;}
    else{
      return 0;
    }
  }
  else{
    return 1;
  }
}


sub remove_whitespace {
  my $value = shift;
  if (!defined $value){
    return "";
  }
  $value =~ s/^\s+|\s+$//g;
  return $value;

} ## end sub remove_whitespace


sub isdigit {
  my $digit = shift;
  my $text  = shift;

  if ( !defined($digit) ) {
    return 0;
  }
  if ( $digit eq '' ) {
    return 0;
  }
  if ($digit eq "-"){
    return 0;
  }

  my $digit_work = $digit;
  $digit_work =~ s/[0-9]//g;
  $digit_work =~ s/\.//;
  $digit_work =~ s/^-//;
  $digit_work =~ s/e//;
  $digit_work =~ s/\+//;
  $digit_work =~ s/\-//;

  if ( length($digit_work) == 0 ) {

    # is a number
    return 1;
  }

  #if (($digit * 1) eq $digit){
  #  # is a number
  #  return 1;
  #}

  # NOT a number
  return 0;
} ## end sub isdigit

sub round {
  my $number         = shift;
  my $decimal_plates = shift;
  if ( !defined $decimal_plates ) {
    $decimal_plates = 3;
  }
  my $num = $number;
  if ( $number =~ /\./ ) {
    $number =~ s/.*\.//g;
    my $length = length($number);
    if ( $length > $decimal_plates ) {
      my $rounded = sprintf( "%.$decimal_plates" . "f", $num );
      return $rounded;
    }
    else {
      return $num;
    }
  } ## end if ( $number =~ /\./ )
  else {
    return $num;
  }
} ## end sub round

sub get_time {
  my $timestamp_end = shift;
  my @time          = localtime($timestamp_end);
  my $time_human    = localtime($timestamp_end);
  my $sec           = $time[0];
  my $minute        = $time[1];
  my $hour          = $time[2];
  my $day           = $time[3];
  my $month         = $time[4] + 1;
  my ( undef, undef, undef, undef, $year ) = split( " ", $time_human );
  chomp $year;
  if ( $minute < 10 ) { $minute = "0$minute"; }
  if ( $hour < 10 )   { $hour   = "0$hour"; }
  if ( $day < 10 )    { $day    = "0$day"; }
  if ( $month < 10 )  { $month  = "0$month"; }
  if ( $sec < 10 )    { $sec    = "0$sec"; }
  my $time_end = "$year:$month:$day" . "T" . "$hour:$minute:$sec";
  return $time_end;
}
