#!/usr/bin/perl

use strict;
use warnings;
use Data::Dumper;
use Date::Parse;
use Xorux_lib;

my $storage_name       = "";
my $basedir            = "";
my $bindir             = "";
my $webdir             = "";
my $health_status_html = "";
my $inputdir           = "";
my $wrkdir             = "";
my $configuration      = "";
my $config_directory   = "";
my $ip_address_a       = "";
my $ip_address_b       = "";
my $ip_address         = "";
my $user               = "";
my $key                = "";
my $data_directory     = "";
my $connection         = "";
my $path               = "";
my $summary_health     = "";
my $error_datadomain   = "";
my $eternus_enviroment = 1;
my $err_tmp = "";


my %inventory_data;
my %header_section;
my %data_structure;
my $time_start = "";
my $time_end = "";
my $ssh_cmd = $ENV{SSH};
if ( !defined($ssh_cmd) || $ssh_cmd eq '' ) {
  $ssh_cmd = "ssh -q -o ConnectTimeout=15 -o StrictHostKeyChecking=no -o PreferredAuthentications=publickey -o SendEnv=no ";
}
$ssh_cmd = $ssh_cmd . "-tt ";


my $interval       = 300;    ## time collecting statistics
my $timeout_config = 120;
my $timeout_perf   = 60;
my $timeout_perf2 = 600;

set_variable();
data_structure();

### version new = 1 , version old = 0;

my $version = test_version();
get_performance_statistics();

if ($version == 1){
  set_data_volume();
  set_data_drive();
  set_data_rg();
  set_data_port();
  set_data_node();

}
else{
  set_data_volume_old();
  set_data_drive_old();
  set_data_rg_old();
  set_data_port_old();
  set_data_node_old();

}

set_time();

set_header();
write_data();
set_health_status();
#print Dumper \%inventory_data;

sub set_data_volume_old {

  my $file = "$data_directory/volume_stat.txt";
  my $section = "Volume Level Statistics";
  my @data = get_array_data($file);
  my $active = 0;
  foreach my $line (@data){
    chomp $line;
    $line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/No\./ && $line =~ m/Name/){
      $active++;
      next;
    }
    if ($active == 1){
      my ($id, $name, $read_io, $write_io, $read, $write, $resp_t_r, $resp_t_w, $r_cache_hit, $w_cache_hit) = split(" ",$line);
      my $data_rate = "";
      my $io_rate = "";
      my $resp_t = "";
      if (!defined $id){
        $id = "";
      }
      if (!defined $read_io){
        $read_io = "";
      }
      if (!defined $write_io){
        $write_io = "";
      }
      if (!defined $read){
        $read = "";
      }
      if (!defined $write){
        $write = "";
      }
      if (!defined $resp_t_r){
        $resp_t_r = "";
      }
      if (!defined $resp_t_w){
        $resp_t_w = "";
      }
      if (!defined $r_cache_hit){
        $r_cache_hit = "";
      }
      if (!defined $w_cache_hit){
        $w_cache_hit = "";
      }
      $id = remove_whitespace($id);
      $read_io = remove_whitespace($read_io);
      $write_io = remove_whitespace($write_io);
      $read = remove_whitespace($read);
      $write = remove_whitespace($write);
      $resp_t_r = remove_whitespace($resp_t_r);
      $resp_t_w = remove_whitespace($resp_t_w);
      $r_cache_hit = remove_whitespace($r_cache_hit);
      $w_cache_hit = remove_whitespace($w_cache_hit);
      if (!defined $id || $id eq ""){
        next;
      }
      $inventory_data{$section}{$id}{id} = $id;
      if (isdigit($read_io)){
        $inventory_data{$section}{$id}{read_io} = $read_io;
        $io_rate = $read_io;
      }
      if (isdigit($write_io)){
        $inventory_data{$section}{$id}{write_io} = $write_io;
        if (isdigit($io_rate)){
          $io_rate = $io_rate + $write_io;
        }
        else{
          $io_rate = $write_io;
        }
      }
      if (isdigit($r_cache_hit)){
        $inventory_data{$section}{$id}{r_cache_hit} = $r_cache_hit;
      }
      if (isdigit($w_cache_hit)){
        $inventory_data{$section}{$id}{w_cache_hit} = $w_cache_hit;
      }
      if (isdigit($read)){
        $inventory_data{$section}{$id}{read} = round($read * 1024,0);
        $data_rate = $read;
      }
      if (isdigit($write)){
        $inventory_data{$section}{$id}{write} = round($write * 1024,0);
        if (isdigit($data_rate)){
          $data_rate = $data_rate + $write;
        }
        else{
          $data_rate = $write;
        }
      }
      if (isdigit($resp_t_r)){
        $inventory_data{$section}{$id}{resp_t_r} = $resp_t_r;
        if (isdigit($read_io)){
          $resp_t = $resp_t_r * $read_io;
        }
      }
      if (isdigit($resp_t_w)){
        $inventory_data{$section}{$id}{resp_t_w} = $resp_t_w;
        if (isdigit($resp_t_w)){
          if (isdigit($write_io)){
            $resp_t = $resp_t + ($resp_t_w * $write_io);
          }
        }
        else{
          $resp_t = $resp_t_w * $write_io;
        }
      }
      if (isdigit($io_rate)){
        $inventory_data{$section}{$id}{io_rate} = $io_rate;
      }
      if (isdigit($data_rate)){
        $inventory_data{$section}{$id}{data_rate} = round($data_rate * 1024,0);
      }
      if (isdigit($resp_t) && isdigit($io_rate) && $io_rate != 0){
        $inventory_data{$section}{$id}{resp_t} = round($resp_t / $io_rate,2);
      }
    }
  }
  $file = "$data_directory/volume.txt";
  @data = get_array_data($file);
  $active = 0;
  foreach my $line (@data){
    chomp $line;
    $line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/No\./ && $line =~ m/Name/){
      $active++;
      next;
    }
    if ($active == 1){
      my ($id, undef, undef, undef, undef, undef, $rg_id, $rg_name, $cap) = split (" ",$line);
      if (!defined $id || $id eq ""){next;}
      if (!defined $rg_id){
        $rg_id = "";
      }
      if (!defined $rg_name){
        $rg_name = "";
      }
      if (!defined $cap){
        $cap = "";
      }
      $id = remove_whitespace($id);
      $rg_id = remove_whitespace($rg_id);
      $rg_name = remove_whitespace($rg_name);
      $cap = remove_whitespace($cap);
      if (defined $inventory_data{$section}{$id} && $inventory_data{$section}{$id}{id} ne ""){
        if (isdigit($cap)){
          $inventory_data{$section}{$id}{"Capacity(MB)"} = $cap;
        }
        if (defined $rg_id && $rg_id ne ""){
          $inventory_data{$section}{$id}{"rg_id"} = $rg_id;
          if (!defined $inventory_data{"Pool Level Statistics"}{$rg_id}{"id"}){
            $inventory_data{"Pool Level Statistics"}{$rg_id}{"id"} = $rg_id;
          }

          if (defined $rg_name && $rg_name ne ""){
            $inventory_data{$section}{$id}{"rg_name"} = $rg_name;
            $inventory_data{"Pool Level Statistics"}{$rg_id}{"name"} = $rg_name;
          }
        }
      }

    }
  }
  $file = "$data_directory/advanced_copy_stat.txt";
  @data = get_array_data($file);
  $active = 0;

  foreach my $line (@data){
    chomp $line;
    $line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/No\./ && $line =~ m/Name/){
      $active++;
      next;
    }
    if ($active == 1){
      my ($id, $name, $read_io, $write_io, $read, $write, $r_cache_hit, $w_cache_hit) = split(" ",$line);
      my $data_rate = "";
      my $io_rate = "";
      my $resp_t = "";
      if (!defined $id){
        $id = "";
      }
      if (!defined $read_io){
        $read_io = "";
      }
      if (!defined $write_io){
        $write_io = "";
      }
      if (!defined $read){
        $read = "";
      }
      if (!defined $write){
        $write = "";
      }
      if (!defined $w_cache_hit){
        $w_cache_hit = "";
      }
      if (!defined $r_cache_hit){
        $r_cache_hit = "";
      }
      $id = remove_whitespace($id);
      $read_io = remove_whitespace($read_io);
      $write_io = remove_whitespace($write_io);
      $read = remove_whitespace($read);
      $write = remove_whitespace($write);
      $r_cache_hit = remove_whitespace($r_cache_hit);
      $w_cache_hit = remove_whitespace($w_cache_hit);
      if (!defined $id || $id eq ""){
        next;
      }
      $inventory_data{$section}{$id}{id} = $id;
      if (isdigit($read_io)){
        $inventory_data{$section}{$id}{read_io_advance_copy} = $read_io;
        $io_rate = $read_io;
      }
      if (isdigit($write_io)){
        $inventory_data{$section}{$id}{write_io_advance_copy} = $write_io;
        if (isdigit($io_rate)){
          $io_rate = $io_rate + $write_io;
        }
        else{
          $io_rate = $write_io;
        }
      }
      if (isdigit($r_cache_hit)){
        $inventory_data{$section}{$id}{r_cache_hit_advance_copy} = $r_cache_hit;
      }
      if (isdigit($w_cache_hit)){
        $inventory_data{$section}{$id}{w_cache_hit_advance_copy} = $w_cache_hit;
      }
      if (isdigit($read)){
        $inventory_data{$section}{$id}{read_advance_copy} = round($read * 1024,0);
        $data_rate = $read;
      }
      if (isdigit($write)){
        $inventory_data{$section}{$id}{write_advance_copy} = round($write * 1024,0);
        if (isdigit($data_rate)){
          $data_rate = $data_rate + $write;
        }
        else{
          $data_rate = $write;
        }
      }
      if (isdigit($io_rate)){
        $inventory_data{$section}{$id}{io_rate_advance_copy} = $io_rate;
      }
      if (isdigit($data_rate)){
        $inventory_data{$section}{$id}{data_rate_advance_copy} = round($data_rate * 1024,0);
      }
    }
  }

  # volume uid
  $file = "$data_directory/volume_mapping.txt";
  @data = get_array_data($file);
  $active = 0;
  foreach my $line (@data){
    chomp $line;
    $line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/\<Mapping/){
      $active = 0;
      next;
    }
    if ($line =~ m/Volume/ && $line =~ m/UID/){
      $active++;
      next;
    }
    if ($active == 1 && $line =~ m/No\./ && $line =~ m/Name/){
      $active++;
      next;
    }
    if ($active == 2){
      my ($no, $name, undef, $uid) = split (" ",$line);
      if (defined $no && $no ne "" && defined $uid && $uid ne ""){
        $no = remove_whitespace($no);
        $uid = remove_whitespace($uid);
        if (defined $inventory_data{$section}{$no} && defined $inventory_data{$section}{$no}{id}){
          $inventory_data{$section}{$no}{id} = $uid;
        }
      }
    }
  }

  #print Dumper \$inventory_data{$section};
}

sub set_data_drive_old{

  my $file = "$data_directory/disk_stat.txt";
  my $section = "Drive Level Statistics";
  my @data = get_array_data($file);
  my $active = 0;
  my %hash_position;
  my $name_property = "";
  my $name_property2 = "";


  foreach my $line (@data){
    chomp $line;
    $line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/Location/){
      $active++;
      next;
    }
    if ($active == 1){
      my $line_parse = $line;
      $line_parse =~ s/ {2,}/  /g;
      my ($localtion, $busy) = split("  ",$line_parse);
       if (!defined $localtion){
        $localtion = "";
      }
      if (!defined $busy){
        $busy = "";
      }
      $localtion = remove_whitespace($localtion);
      $busy = remove_whitespace($busy);
      if (!defined $localtion || $localtion eq ""){next;}
      $inventory_data{$section}{$localtion}{id} = $localtion;
      if (isdigit($busy)){
        $inventory_data{$section}{$localtion}{busy} = $busy;
      }
    }
  }
  #print Dumper \$inventory_data{$section};

}

sub set_data_rg_old{


  ### Pool = POOL

  my $section = "Pool Level Statistics";
  my $section_vol = "Volume Level Statistics";

  foreach my $rg (keys %{$inventory_data{$section}}){
    my $sum_read_io = "";
    my $sum_write_io = "";
    my $sum_io_rate = "";
    my $sum_read = "";
    my $sum_write = "";
    my $sum_data_rate = "";
    my $sum_resp_t_r = "";
    my $sum_resp_t_w = "";
    my $sum_resp_t = "";
    my $sum_r_cache_hit = "";
    my $sum_w_cache_hit = "";


    my $rg_id = $inventory_data{$section}{$rg}{id};
    if (!defined $rg_id){next;}

    foreach my $volume (keys %{$inventory_data{$section_vol}}){
      my $rg_id_vol = $inventory_data{$section_vol}{$volume}{"rg_id"};
      if (!defined $rg_id_vol || $rg_id_vol eq ""){next;}
      if ($rg_id eq $rg_id_vol){

        my $read_io = $inventory_data{$section_vol}{$volume}{"read_io"};
        my $write_io = $inventory_data{$section_vol}{$volume}{"write_io"};
        my $io_rate = $inventory_data{$section_vol}{$volume}{"io_rate"};

        my $read = $inventory_data{$section_vol}{$volume}{"read"};
        my $write = $inventory_data{$section_vol}{$volume}{"write"};
        my $data_rate = $inventory_data{$section_vol}{$volume}{"data_rate"};

        my $resp_t_r = $inventory_data{$section_vol}{$volume}{"resp_t_r"};
        my $resp_t_w = $inventory_data{$section_vol}{$volume}{"resp_t_w"};
        my $resp_t = $inventory_data{$section_vol}{$volume}{"resp_t"};

        my $r_cache_hit = $inventory_data{$section_vol}{$volume}{"r_cache_hit"};
        my $w_cache_hit = $inventory_data{$section_vol}{$volume}{"w_cache_hit"};

        if (isdigit($sum_read_io)){
          if (isdigit($read_io)){
            $sum_read_io = $sum_read_io + $read_io;
          }
        }
        else{
          if (isdigit($read_io)){
            $sum_read_io = $read_io;
          }
        }

        if (isdigit($sum_write_io)){
          if (isdigit($write_io)){
            $sum_write_io = $sum_write_io + $write_io;
          }
        }
        else{
          if (isdigit($write_io)){
            $sum_write_io = $write_io;
          }
        }

        if (isdigit($sum_io_rate)){
          if (isdigit($io_rate)){
            $sum_io_rate = $sum_io_rate + $io_rate;
          }
        }
        else{
          if (isdigit($io_rate)){
            $sum_io_rate = $io_rate;
          }
        }


        ### data
        if (isdigit($sum_read)){
          if (isdigit($read)){
            $sum_read = $sum_read + $read;
          }
        }
        else{
          if (isdigit($read)){
            $sum_read = $read;
          }
        }

        if (isdigit($sum_write)){
          if (isdigit($write)){
            $sum_write = $sum_write + $write;
          }
        }
        else{
          if (isdigit($write_io)){
            $sum_write = $write;
          }
        }

        if (isdigit($sum_data_rate)){
          if (isdigit($data_rate)){
            $sum_data_rate = $sum_data_rate + $data_rate;
          }
        }
        else{
          if (isdigit($data_rate)){
            $sum_data_rate = $data_rate;
          }
        }

        ###

        ### resp
        if (isdigit($sum_resp_t_r) &&  isdigit($sum_read_io)){
          if (isdigit($read_io) && isdigit($resp_t_r)){
            $sum_resp_t_r = $sum_resp_t_r + ($read_io * $resp_t_r);
          }
        }
        else{
          if (isdigit($read_io) && isdigit($resp_t_r)){
            $sum_resp_t_r = $read_io * $resp_t_r;
          }
        }

        if (isdigit($sum_resp_t_w) &&  isdigit($sum_write_io)){
          if (isdigit($write_io) && isdigit($resp_t_w)){
            $sum_resp_t_w = $sum_resp_t_w + ($write_io * $resp_t_w);
          }
        }
        else{
          if (isdigit($write_io) && isdigit($resp_t_w)){
            $sum_resp_t_w = $write_io * $resp_t_w;
          }
        }

        if (isdigit($sum_resp_t) &&  isdigit($sum_io_rate)){
          if (isdigit($io_rate) && isdigit($resp_t)){
            $sum_resp_t = $sum_resp_t + ($io_rate * $resp_t);
          }
        }
        else{
          if (isdigit($io_rate) && isdigit($resp_t)){
            $sum_resp_t = $io_rate * $resp_t;
          }
        }


        ###

        ### cache
        if (isdigit($sum_r_cache_hit) &&  isdigit($sum_read_io)){
          if (isdigit($read_io) && isdigit($r_cache_hit)){
            $sum_r_cache_hit = $sum_r_cache_hit + ($read_io * $r_cache_hit);
          }
        }
        else{
          if (isdigit($read_io) && isdigit($r_cache_hit)){
            $sum_r_cache_hit = $read_io * $r_cache_hit;
          }
        }

        if (isdigit($sum_w_cache_hit) &&  isdigit($sum_write_io)){
          if (isdigit($write_io) && isdigit($w_cache_hit)){
            $sum_w_cache_hit = $sum_w_cache_hit + ($write_io * $w_cache_hit);
          }
        }
        else{
          if (isdigit($write_io) && isdigit($w_cache_hit)){
            $sum_w_cache_hit = $write_io * $w_cache_hit;
          }
        }


        ###

      }
    }
    if (isdigit($sum_read_io)){
      $inventory_data{$section}{$rg}{"read_io"} = $sum_read_io;

      if (isdigit($sum_resp_t_r) && $sum_read_io != 0){
        my $pom = $sum_resp_t_r / $sum_read_io;
        $inventory_data{$section}{$rg}{"resp_t_r"} = round($pom,3);
      }
      if (isdigit($sum_r_cache_hit) && $sum_read_io != 0){
        my $pom = $sum_r_cache_hit / $sum_read_io;
        $inventory_data{$section}{$rg}{"r_cache_hit"} = round($pom,1);
      }

    }
    if (isdigit($sum_write_io)){
      $inventory_data{$section}{$rg}{"write_io"} = $sum_write_io;

      if (isdigit($sum_resp_t_w) && $sum_write_io != 0){
        my $pom = $sum_resp_t_w / $sum_write_io;
        $inventory_data{$section}{$rg}{"resp_t_w"} = round($pom,3);
      }

      if (isdigit($sum_w_cache_hit) && $sum_write_io != 0){
        my $pom = $sum_w_cache_hit / $sum_write_io;
        $inventory_data{$section}{$rg}{"w_cache_hit"} = round($pom,1);
      }

    }
    if (isdigit($sum_io_rate)){
      $inventory_data{$section}{$rg}{"io_rate"} = $sum_io_rate;

      if (isdigit($sum_resp_t) && $sum_io_rate != 0){
        my $pom = $sum_resp_t / $sum_io_rate;
        $inventory_data{$section}{$rg}{"resp_t"} = round($pom,3);
      }
    }
    if (isdigit($sum_read)){
      $inventory_data{$section}{$rg}{"read"} = $sum_read;
    }
    if (isdigit($sum_write)){
      $inventory_data{$section}{$rg}{"write"} = $sum_write;
    }
    if (isdigit($sum_data_rate)){
      $inventory_data{$section}{$rg}{"data_rate"} = $sum_data_rate;
    }


  }

  ### capacity
  my $file = "$data_directory/rg.txt";
  my @data = get_array_data($file);
  my $active = 0;

  foreach my $line (@data){
    chomp $line;
    $line = remove_whitespace($line);
    if ( $line eq "" ) { next; }
    if ($line =~ m/CLI\>/){next;}
    if ($line =~ m/No\./ && $line =~ m/Name/){
      $active++;
      next;
    }
    if ($active == 1){
      my ($id, $name, undef, undef, undef, $cap, $free_cap) = split(" ",$line);
      if (!defined $id ){
        next;
      }
      if (!defined $name){
        $name = "";
      }
      if (!defined $cap){
        $cap = "";
      }
      if (!defined $free_cap){
        $free_cap = "";
      }
      $id = remove_whitespace($id);
      $name = remove_whitespace($name);
      $cap = remove_whitespace($cap);
      $free_cap = remove_whitespace($free_cap);
      if ($id eq "" || $id eq "-"){
        next;
      }
      $inventory_data{$section}{$id}{id} = $id;
      if (defined $name && $name ne ""){
        $inventory_data{$section}{$id}{name} = $name;
      }
      if (isdigit($cap)){
        my $pom = $cap / (1024 * 1024);
        $inventory_data{$section}{$id}{"Capacity(TB)"} = round($pom,3);
      }
      if (isdigit($free_cap)){
        my $pom = $free_cap / (1024 * 1024);
        $inventory_data{$section}{$id}{"Free(TB)"} = round($pom,3);
      }
      if (isdigit($cap) && isdigit($free_cap)){
        my $pom = ($cap - $free_cap) / (1024 * 1024);
        $inventory_data{$section}{$id}{"Used(TB)"} = round($pom,3);
      }
    }
  }
  #print Dumper \$inventory_data{$section};

}

sub set_data_port_old{


  my $file = "$data_directory/port_stat.txt";
  my $section = "Port Level Statistics";
  my @data = get_array_data($file);
  my $active = 0;
  my %hash_position;
  my $name_property = "";
  my $name_property2 = "";


  foreach my $line (@data){
    chomp $line;
    $line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/^CLI>/ ) {
      $active = 0;
      $name_property = "";
      $name_property2 = "";
      next;
    }
    if ($line =~ m/Location/){
      $active++;
      next;
    }
    if ($line =~ m/Read/ && $line =~ m/Write/ && $active == 1){
      $active++;
      next;
    }
    if ($active == 2){
      my $line_parse = $line;
      $line_parse =~ s/ {2,}/  /g;
      my ($localtion, $read_io, $write_io, $read, $write) = split("  ",$line_parse);
       if (!defined $localtion){
        $localtion = "";
      }
      if (!defined $read_io){
        $read_io = "";
      }
      if (!defined $write_io){
        $write_io = "";
      }
      if (!defined $read){
        $read = "";
      }
      if (!defined $write){
        $write = "";
      }
      $localtion = remove_whitespace($localtion);
      $read_io   = remove_whitespace($read_io);
      $write_io = remove_whitespace($write_io);
      $read = remove_whitespace($read_io);
      $write = remove_whitespace($write);
      my $io_rate = "";
      my $data_rate = "";
      if (!defined $localtion || $localtion eq ""){next;}
      $inventory_data{$section}{$localtion}{id} = $localtion;
      if (isdigit($read_io)){
        $inventory_data{$section}{$localtion}{read_io} = $read_io;
        $io_rate = $read_io;
      }
      if (isdigit($write_io)){
        $inventory_data{$section}{$localtion}{write_io} = $write_io;
        if (isdigit($io_rate)){
          $io_rate = $io_rate + $write_io;
        }
        else{
          $io_rate = $write_io;
        }
      }
      if (isdigit($read)){
        $inventory_data{$section}{$localtion}{read} = round($read * 1024,0);
        $data_rate = $read;
      }
      if (isdigit($write)){
        $inventory_data{$section}{$localtion}{write} = round($write * 1024,0);
        if (isdigit($data_rate)){
          $data_rate = $data_rate + $write;
        }
        else{
          $data_rate = $write;
        }
      }
      if (isdigit($io_rate)){
        $inventory_data{$section}{$localtion}{io_rate} = $io_rate;
      }
      if (isdigit($data_rate)){
        $inventory_data{$section}{$localtion}{data_rate} = round($data_rate * 1024);
      }
    }
  }
  my $id_port = "";
  my $id_port2 = "";
  my @files = ();
  push (@files,"$data_directory/fc-port.txt");
  push (@files,"$data_directory/sas-port.txt");
  push (@files,"$data_directory/fcoe-port.txt");
  push (@files,"$data_directory/iscsi-port.txt");

  my $index_file = 0;
  foreach my $file (@files){
    $index_file++;
    my @data = get_array_data($file);

    foreach my $line (@data){
      my $name_property = "";
      my $active = 0;
      chomp $line;
      if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
      $line =~ s/ {2,}/  /g;
      $line = remove_whitespace($line);
      if ($line eq ""){next;}
      my @data_line = split("  ",$line);
      #print Dumper \@data_line;
      foreach my $element (@data_line){
        $element = remove_whitespace($element);
        if ($active == 0 && $index_file != 4 ){
          $name_property = $element;
          $active++;
          next;
        }
        if ($index_file == 4){
          my $first = 0;
          foreach my $element (@data_line){
            $first++;
            if ($first != 1){
              last;
            }
            $element = remove_whitespace($element);
            if (defined $inventory_data{$section}{$element}{id}){
              $inventory_data{$section}{$element}{Protocol} = "ISCSI";
              last;
            }
            else{
              delete $inventory_data{$section}{$element};
            }
          }
        }
        if ((defined $name_property && $name_property eq "Port" && $index_file != 4)){
          if ($active > 0){
            $id_port = "";
            $id_port = $element;
            #$element =~ s/#//g;
            if (defined $inventory_data{$section}{$element}{id}){
              if ($index_file == 1){
                $inventory_data{$section}{$element}{Protocol} = "FC";
              }
              if ($index_file == 2){
                $inventory_data{$section}{$element}{Protocol} = "SAS";
              }
              if ($index_file == 3){
                $inventory_data{$section}{$element}{Protocol} = "FCOE";
              }
              if ($index_file == 4){
                $inventory_data{$section}{$element}{Protocol} = "ISCSI";
              }
              $active++;
              next;
            }
          }
        }
      }
    }
  }
  #print Dumper \$inventory_data{$section};
  #print Dumper \$inventory_data{$section};
  #print Dumper \%inventory_data;
  #print Dumper \%hash_position;

}


sub set_data_node_old{

  my $file = "$data_directory/controller_stat.txt";
  my $section = "Node Level Statistics";
  my @data = get_array_data($file);
  my $active = 0;
  my %hash_position;
  my $name_property = "";
  my $name_property2 = "";


  foreach my $line (@data){
    chomp $line;
    $line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/Location/){
      $active++;
      next;
    }
    if ($active == 1){
      my $line_parse = $line;
      $line_parse =~ s/ {2,}/  /g;
      my ($localtion, $busy) = split("  ",$line_parse);
       if (!defined $localtion){
        $localtion = "";
      }
      if (!defined $busy){
        $busy = "";
      }
      $localtion = remove_whitespace($localtion);
      $busy = remove_whitespace($busy);
      if (!defined $localtion || $localtion eq ""){next;}
      $inventory_data{$section}{$localtion}{id} = $localtion;
      if (isdigit($busy)){
        $inventory_data{$section}{$localtion}{busy} = $busy;
      }
    }
  }
  #print Dumper \$inventory_data{$section};
}

sub test_version{
  my $file = "$wrkdir/ETERNUS_NEW";
  if (-f "$data_directory/version_old.txt"){
    unlink("$data_directory/version_old.txt");
  }
  if (-f $file){

    my $mtime = ( stat("$file") )[9];
    my $last_update = time() - $mtime;
    if ($last_update >= 86400){
      my $cmd = "show volumes -mode detail";
      my $file = "$data_directory/test_version.txt";
      cmd_to_file($cmd,$file, $timeout_perf);
      if (-f "$data_directory/version_old.txt"){
        `touch $wrkdir/ETERNUS_OLD`;
        return 0;
      }
      else{
        `touch $wrkdir/ETERNUS_NEW`;
        return 1;
      }
    }
    else{
      return 1;
    }
  }
  else{
    my $file = "$wrkdir/ETERNUS_OLD";
    if (-f $file){
      my $mtime = ( stat("$file") )[9];
      my $last_update = time() - $mtime;
      if ($last_update >= 86400){
        my $cmd = "show volumes -mode detail";
        my $file = "$data_directory/test_version.txt";
        cmd_to_file($cmd,$file, $timeout_perf);
        if (-f "$data_directory/version_old.txt"){
          `touch $wrkdir/ETERNUS_OLD`;
          return 0;
        }
        else{
          `touch $wrkdir/ETERNUS_NEW`;
          return 1;
        }
      }
      else{
        return 0;
      }
    }
    else{
      my $cmd = "show volumes -mode detail";
      my $file = "$data_directory/test_version.txt";
      cmd_to_file($cmd,$file, $timeout_perf);
      if (-f "$data_directory/version_old.txt"){
        `touch $wrkdir/ETERNUS_OLD`;
        return 0;
      }
      else{
        `touch $wrkdir/ETERNUS_NEW`;
        return 1;
      }
    }
  }
}


sub set_health_status{


  my $file = "$data_directory/enclosure_status.txt";
  my @data = get_array_data($file);
  my $type = "";
  my $name = "";
  my $status = "";
  my $error_code = "";
  my @component = ();

  foreach my $line (@data){
    chomp $line;
    #$line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/^CLI>/ ) {
      $type = "";
      $name = "";
      $status = "";
      $error_code = "";
      next;
    }
    $line = remove_whitespace($line);
    if ($line =~ m/Controller Module Status|Power Supply Unit Status|Disk Status|Location/){
      $type = $line;
      next;
    }
    if ($type ne ""){
      $line =~ s/ {2,}/  /g;
      $line = remove_whitespace($line);
      if ($line eq ""){next;}
      my @data_line = split("  ",$line);
      $name = "";
      $status = "";
      $error_code = "";
      foreach my $element (@data_line){
        $element = remove_whitespace($element);
        if (!defined $element || $element eq "" ){next;}
        if ($element eq "]"){
          if (defined $name && $name ne "" && defined $status && $status ne ""){
            $status =~ s/\[//g;
            $status =~ s/\]//g;
            $status =~ s/\///g;
            $status = remove_whitespace($status);
            $error_code =~ s/\[//g;
            $error_code =~ s/\]//g;
            $error_code =~ s/\///g;
            $error_code = remove_whitespace($error_code);
            if (defined $status && $status ne ""){
              if (defined $error_code && $error_code ne ""){
                push(@component,"$name : $status : $error_code");
              }
              else{
                push(@component,"$name : $status");
              }
            }
          }
          $name = "";
          $status = "";
          $error_code = "";
          next;
        }
        if ($name eq ""){
          $name = $element;
          next;
        }
        if ($status eq ""){
          $status = $element;
          next;
        }
        if ($error_code eq "" && $type !~ m/Disk Status/){
          $error_code = $element;
          next;
        }
      }
      if (defined $name && $name ne "" && defined $status && $status ne ""){
        $status =~ s/\[//g;
        $status =~ s/\]//g;
        $status =~ s/\///g;
        $status = remove_whitespace($status);
        $error_code =~ s/\[//g;
        $error_code =~ s/\]//g;
        $error_code =~ s/\///g;
        $error_code = remove_whitespace($error_code);
        if (defined $status && $status ne ""){
          if (defined $error_code && $error_code ne ""){
            push(@component,"$name : $status : $error_code");
          }
          else{
            push(@component,"$name : $status");
          }
        }
      }
    }
  }

  my $table = "<table class =\"tabcfgsum tablesorter tablesortercfgsum\">\n";
  my $thead = "<thead><tr><th class = \"sortable\" title=\"Component\" nowrap=\"\">Component</th>\n";
  $thead = $thead . "<th class = \"sortable\" title=\"Status\" nowrap=\"\">Status</th>\n";
  $thead = $thead . "<th class = \"sortable\" title=\"Error Code\" nowrap=\"\">Error Code</th>\n";
  $thead = $thead . "</tr>\n</thead>\n";
  my $tbody = "<tbody>\n";
  my $tr    = "";

  my $error_health = 0;
  my @error_message = ();

  foreach my $line (@component){
    chomp $line;
    my ($component, $status, $error_code) = split (" : ",$line);
    if (!defined $component && $component eq ""){next;}
    if (!defined $status){$status = "";}
    if (!defined $error_code){$error_code = "";}
    if ( $status eq "Error" ) {
      $error_health++;
      my $line = "$component  $status  $error_code";
      push (@error_message,"$line\n");
    }
    $tr = $tr . "<tr><td>$component</td><td>$status</td><td>$error_code</td></tr>\n";

  }

  ### summary status
  my $summary_status = "";
  $file = "$data_directory/summary_status.txt";
  @data = get_array_data($file);

  foreach my $line (@data){
    chomp $line;
    $line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/^CLI>/ ) {
      next;
    }
    $line =~ s/Summary Status//g;
    $line =~ s/\[//g;
    $line =~ s/\]//g;
    $line = remove_whitespace($line);
    if (defined $line && $line eq "Error"){
      $error_health++;
      my $line_error = "Summary Status  $line";
      push (@error_message,"$line_error\n");
    }
    if (defined $line){
      $summary_status = $line;
    }
  }



  my $time = localtime();
  $time = $time . "<br><br>\n";
  my $report = "";
  $tbody = $tbody . $tr . "</tbody>\n";
  if ( $error_health == 0 ) {
    $report = "Storage $storage_name health status = $summary_status\n";
  }
  else {
    $report = "Storage $storage_name health status = $summary_status\n";
  }
  $table = $time . $report ."<br><br>". $table . $thead . $tbody . "</table>\n";
  write_health_status_html( $health_status_html, $table );
  summary_health_status($error_health, \@error_message);
}

sub write_health_status_html {
  my $file  = shift;
  my $table = shift;
  open( DATA, ">$file" ) or error("Cannot open file: $file : $!") && return 0;
  print DATA $table;
  close(DATA);
} ## end sub write_health_status_html

sub summary_health_status {
  my ($error_status, $error_message_tmp) = @_;
  my @error_message = @{$error_message_tmp};
  my $timestamp    = time();
  my $time         = localtime();
  my $alert_status = 0;

  if ( !-d "$summary_health" ) {
    mkdir( "$summary_health", 0755 ) || error( "$time: Cannot mkdir $summary_health: $!" . __FILE__ . ":" . __LINE__ );
  }

  if ( !-f "$summary_health/$storage_name.ok" && !-f "$summary_health/$storage_name.nok" ) {
    $alert_status = 1;
  }

  if ( -f "$summary_health/$storage_name.ok" ) {
    unlink("$summary_health/$storage_name.ok");
    $alert_status = 1;
  }
  if ( -f "$summary_health/$storage_name.nok" ) { unlink("$summary_health/$storage_name.nok"); }

  if ( $error_status == 0 ) {
    my $report = "STORAGE : $storage_name : OK : $timestamp";
    write_health_status_html( "$summary_health/$storage_name.ok", $report );
    return;
  }
  else {
    my $report = "STORAGE : $storage_name : NOT_OK : $timestamp";
    write_health_status_html( "$summary_health/$storage_name.nok", $report );
    if ( $alert_status == 1 ) {
      ### alert health status
      if ( exists &Xorux_lib::health_status_alerting ) {
        Xorux_lib::health_status_alerting($storage_name,\@error_message);
      }
    } ## end if ( $alert_status == ...)
    return;
  } ## end else [ if ( $error_status == ...)]

} ## end sub summary_health_status

sub write_data {
  ( my $file, my $file_tmp ) = split( ",", get_name_file("perf") );

  foreach my $title ( keys %header_section ) {
    open( DATA, ">>$file_tmp" ) or error_die("Cannot open file: $file_tmp : $!");
    my ($values_tmp) = get_data( "$title", "$header_section{$title}" );
    my @values = @{$values_tmp};
    if ( !defined $inventory_data{$title}{TIME}{START} || !defined $inventory_data{$title}{TIME}{END} || !defined $inventory_data{$title}{TIME}{STEP} ) {
      close DATA;
      next;
    }
    print DATA "$title\n";
    my $interval_start  = " Interval Start:  " . $inventory_data{$title}{TIME}{START};
    my $interval_end    = " Interval End:    " . $inventory_data{$title}{TIME}{END};
    my $interval_length = " Interval Length: " . $inventory_data{$title}{TIME}{STEP};
    print DATA" $interval_start";
    print DATA"\n";
    print DATA" $interval_end";
    print DATA"\n";
    print DATA" $interval_length";
    print DATA"\n";
    print DATA "-----------------------------------\n";
    print DATA $header_section{$title};
    print DATA @values;
    print DATA "\n\n";
    close DATA;
  } ## end foreach my $title ( keys %header_section)
  rename( "$file_tmp", "$file" );

} ## end sub write_data

sub get_data {
  my $section          = shift;
  my $section_contents = shift;
  my @values           = "";
  my @headers          = split( ",", $section_contents );
  my $index_section    = 1;
  foreach my $property ( keys %{ $inventory_data{$section} } ) {
    if ( !defined $inventory_data{$section}{$property}{ $headers[0] } || $inventory_data{$section}{$property}{ $headers[0] } eq "" || $inventory_data{$section}{$property}{ $headers[0]} eq "-" ) { next; }
    if ($section eq "Port Level Statistics" && (!defined $inventory_data{$section}{$property}{"Protocol"} || $inventory_data{$section}{$property}{"Protocol"} eq "")){next;}
    if ( !@values eq "" ) {
      my $last = pop(@values);
      $last =~ s/,//g;
      push( @values, $last );
    }
    push( @values, "\n" );
    my $index = 1;
    foreach my $element (@headers) {
      chomp $element;
      $element =~ s/^\s+|\s+$//g;
      if ( defined $inventory_data{$section}{$property}{$element} && $inventory_data{$section}{$property}{$element} ne "" ) {

        if ( $index == 1 ) {
          my $id = $inventory_data{$section}{$property}{$element};
          $id =~ s/#//g;
          push( @values, "$id," );
          $index++;
          next;
        }
        if (defined $inventory_data{$section}{$property}{$element} && $element eq "Protocol" && $section eq "Port Level Statistics"){
          push( @values, "$inventory_data{$section}{$property}{$element}," );
          $index++;
          next;
        }

        if ( $index > 1 && isdigit( $inventory_data{$section}{$property}{$element} ) && $inventory_data{$section}{$property}{$element} !~ m/-/ ) {
          push( @values, "$inventory_data{$section}{$property}{$element}," );
          $index++;
          next;
        }
        else {
          push( @values, "," );
          $index++;
          next;
        }
      } ## end if ( defined $inventory_data...)
      else {
        push( @values, "," );
        $index++;
      }
    } ## end foreach my $element (@headers)
  } ## end foreach my $property ( keys...)
  my $last = pop(@values);
  $last =~ s/,//g;
  push( @values, $last );
  return \@values;
} ## end sub get_data

sub get_name_file {
  my $type       = shift;
  my @time       = localtime();
  my $time_human = localtime();
  my $sec        = $time[0];
  my $minute     = $time[1];
  my $hour       = $time[2];
  my $day        = $time[3];
  my $month      = $time[4] + 1;
  my ( undef, undef, undef, undef, $year ) = split( " ", $time_human );
  chomp $year;

  if ( $minute < 10 ) { $minute = "0$minute"; }
  if ( $hour < 10 )   { $hour   = "0$hour"; }
  if ( $day < 10 )    { $day    = "0$day"; }
  if ( $month < 10 )  { $month  = "0$month"; }
  if ( $sec < 10 )    { $sec    = "0$sec"; }
  my $name_file     = "$wrkdir/$storage_name" . "_eternus$type" . "_" . "$year$month$day" . "_" . "$hour$minute" . ".out";
  my $name_file_tmp = "$wrkdir/$storage_name" . "_eternus$type" . "_" . "$year$month$day" . "_" . "$hour$minute" . ".out-tmp";
  return "$name_file,$name_file_tmp";

} ## end sub get_name_file

sub set_time{

  my $file = "$data_directory/date.txt";
  my @data = get_array_data($file);


  foreach my $line (@data){
    chomp $line;
    #$line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    my $year = get_year();
    if (!defined $year || $year eq ""){
      next;
    }
    if ($line =~ m/^$year/){
      my ($date, $time) = split(" ",$line);
      if (defined $date && $date ne "" && defined $time && $time ne ""){
        $date =~ s/-/:/g;
        my $time_end = "$date" . "T" . "$time";
        my $timestamp = str2time($time_end);
        $timestamp = $timestamp - 300;
        my $time_start = get_time($timestamp);
        foreach my $section (keys %inventory_data){
          $inventory_data{$section}{TIME}{START} = $time_start;
          $inventory_data{$section}{TIME}{END} = $time_end;
          $inventory_data{$section}{TIME}{STEP} = 300;
        }
      }
    }
  }
}

sub get_year{
  my $time = time();
  my $time_human    = localtime($time);
  my ( undef, undef, undef, undef, $year ) = split( " ", $time_human );
  chomp $year;
  return $year;

}


sub set_header{

  ### VOLUME
  my $section = "Volume Level Statistics";
  my $metric  = "id,read_io,write_io,io_rate,read,write,data_rate,resp_t_r,resp_t_w,resp_t,r_cache_hit,w_cache_hit,Capacity(MB),read_io_advance_copy,write_io_advance_copy,io_rate_advance_copy,read_advance_copy,write_advance_copy,data_rate_advance_copy,r_cache_hit_advance_copy,w_cache_hit_advance_copy";
  $header_section{$section} = $metric;

  ### PORT
  $section                  = "Port Level Statistics";
  $metric                   = "id,read_io,write_io,io_rate,read,write,data_rate,Protocol";
  $header_section{$section} = $metric;

  ### RG
  $section                  = "Pool Level Statistics";
  $metric                   = "id,read_io,write_io,io_rate,read,write,data_rate,resp_t_r,resp_t_w,resp_t,r_cache_hit,w_cache_hit,Capacity(TB),Used(TB),Free(TB)";
  $header_section{$section} = $metric;

  ### DRIVE
  $metric                   = "id,busy";
  $section                  = "Drive Level Statistics";
  $header_section{$section} = $metric;

  ### NODE
  $metric                   = "id,busy";
  $section                  = "Node Level Statistics";
  $header_section{$section} = $metric;


}

sub set_data_rg{

  ### Pool = POOL

  my $section = "Pool Level Statistics";
  my $section_vol = "Volume Level Statistics";

  foreach my $rg (keys %{$inventory_data{$section}}){
    my $sum_read_io = "";
    my $sum_write_io = "";
    my $sum_io_rate = "";
    my $sum_read = "";
    my $sum_write = "";
    my $sum_data_rate = "";
    my $sum_resp_t_r = "";
    my $sum_resp_t_w = "";
    my $sum_resp_t = "";
    my $sum_r_cache_hit = "";
    my $sum_w_cache_hit = "";


    my $rg_id = $inventory_data{$section}{$rg}{id};
    if (!defined $rg_id){next;}

    foreach my $volume (keys %{$inventory_data{$section_vol}}){
      my $rg_id_vol = $inventory_data{$section_vol}{$volume}{"rg_id"};
      if (!defined $rg_id_vol || $rg_id_vol eq ""){next;}
      if ($rg_id eq $rg_id_vol){

        my $read_io = $inventory_data{$section_vol}{$volume}{"read_io"};
        my $write_io = $inventory_data{$section_vol}{$volume}{"write_io"};
        my $io_rate = $inventory_data{$section_vol}{$volume}{"io_rate"};

        my $read = $inventory_data{$section_vol}{$volume}{"read"};
        my $write = $inventory_data{$section_vol}{$volume}{"write"};
        my $data_rate = $inventory_data{$section_vol}{$volume}{"data_rate"};

        my $resp_t_r = $inventory_data{$section_vol}{$volume}{"resp_t_r"};
        my $resp_t_w = $inventory_data{$section_vol}{$volume}{"resp_t_w"};
        my $resp_t = $inventory_data{$section_vol}{$volume}{"resp_t"};

        my $r_cache_hit = $inventory_data{$section_vol}{$volume}{"r_cache_hit"};
        my $w_cache_hit = $inventory_data{$section_vol}{$volume}{"w_cache_hit"};

        if (isdigit($sum_read_io)){
          if (isdigit($read_io)){
            $sum_read_io = $sum_read_io + $read_io;
          }
        }
        else{
          if (isdigit($read_io)){
            $sum_read_io = $read_io;
          }
        }

        if (isdigit($sum_write_io)){
          if (isdigit($write_io)){
            $sum_write_io = $sum_write_io + $write_io;
          }
        }
        else{
          if (isdigit($write_io)){
            $sum_write_io = $write_io;
          }
        }

        if (isdigit($sum_io_rate)){
          if (isdigit($io_rate)){
            $sum_io_rate = $sum_io_rate + $io_rate;
          }
        }
        else{
          if (isdigit($io_rate)){
            $sum_io_rate = $io_rate;
          }
        }




        ### data
        if (isdigit($sum_read)){
          if (isdigit($read)){
            $sum_read = $sum_read + $read;
          }
        }
        else{
          if (isdigit($read)){
            $sum_read = $read;
          }
        }

        if (isdigit($sum_write)){
          if (isdigit($write)){
            $sum_write = $sum_write + $write;
          }
        }
        else{
          if (isdigit($write_io)){
            $sum_write = $write;
          }
        }

        if (isdigit($sum_data_rate)){
          if (isdigit($data_rate)){
            $sum_data_rate = $sum_data_rate + $data_rate;
          }
        }
        else{
          if (isdigit($data_rate)){
            $sum_data_rate = $data_rate;
          }
        }

        ###

        ### resp
        if (isdigit($sum_resp_t_r) &&  isdigit($sum_read_io)){
          if (isdigit($read_io) && isdigit($resp_t_r)){
            $sum_resp_t_r = $sum_resp_t_r + ($read_io * $resp_t_r);
          }
        }
        else{
          if (isdigit($read_io) && isdigit($resp_t_r)){
            $sum_resp_t_r = $read_io * $resp_t_r;
          }
        }

        if (isdigit($sum_resp_t_w) &&  isdigit($sum_write_io)){
          if (isdigit($write_io) && isdigit($resp_t_w)){
            $sum_resp_t_w = $sum_resp_t_w + ($write_io * $resp_t_w);
          }
        }
        else{
          if (isdigit($write_io) && isdigit($resp_t_w)){
            $sum_resp_t_w = $write_io * $resp_t_w;
          }
        }

        if (isdigit($sum_resp_t) &&  isdigit($sum_io_rate)){
          if (isdigit($io_rate) && isdigit($resp_t)){
            $sum_resp_t = $sum_resp_t + ($io_rate * $resp_t);
          }
        }
        else{
          if (isdigit($io_rate) && isdigit($resp_t)){
            $sum_resp_t = $io_rate * $resp_t;
          }
        }


        ###

        ### cache
        if (isdigit($sum_r_cache_hit) &&  isdigit($sum_read_io)){
          if (isdigit($read_io) && isdigit($r_cache_hit)){
            $sum_r_cache_hit = $sum_r_cache_hit + ($read_io * $r_cache_hit);
          }
        }
        else{
          if (isdigit($read_io) && isdigit($r_cache_hit)){
            $sum_r_cache_hit = $read_io * $r_cache_hit;
          }
        }

        if (isdigit($sum_w_cache_hit) &&  isdigit($sum_write_io)){
          if (isdigit($write_io) && isdigit($w_cache_hit)){
            $sum_w_cache_hit = $sum_w_cache_hit + ($write_io * $w_cache_hit);
          }
        }
        else{
          if (isdigit($write_io) && isdigit($w_cache_hit)){
            $sum_w_cache_hit = $write_io * $w_cache_hit;
          }
        }




        ###

      }
    }
    if (isdigit($sum_read_io)){
      $inventory_data{$section}{$rg}{"read_io"} = $sum_read_io;

      if (isdigit($sum_resp_t_r) && $sum_read_io != 0){
        my $pom = $sum_resp_t_r / $sum_read_io;
        $inventory_data{$section}{$rg}{"resp_t_r"} = round($pom,3);
      }
      if (isdigit($sum_r_cache_hit) && $sum_read_io != 0){
        my $pom = $sum_r_cache_hit / $sum_read_io;
        $inventory_data{$section}{$rg}{"r_cache_hit"} = round($pom,1);
      }

    }
    if (isdigit($sum_write_io)){
      $inventory_data{$section}{$rg}{"write_io"} = $sum_write_io;

      if (isdigit($sum_resp_t_w) && $sum_write_io != 0){
        my $pom = $sum_resp_t_w / $sum_write_io;
        $inventory_data{$section}{$rg}{"resp_t_w"} = round($pom,3);
      }

      if (isdigit($sum_w_cache_hit) && $sum_write_io != 0){
        my $pom = $sum_w_cache_hit / $sum_write_io;
        $inventory_data{$section}{$rg}{"w_cache_hit"} = round($pom,1);
      }

    }
    if (isdigit($sum_io_rate)){
      $inventory_data{$section}{$rg}{"io_rate"} = $sum_io_rate;

      if (isdigit($sum_resp_t) && $sum_io_rate != 0){
        my $pom = $sum_resp_t / $sum_io_rate;
        $inventory_data{$section}{$rg}{"resp_t"} = round($pom,3);
      }
    }
    if (isdigit($sum_read)){
      $inventory_data{$section}{$rg}{"read"} = $sum_read;
    }
    if (isdigit($sum_write)){
      $inventory_data{$section}{$rg}{"write"} = $sum_write;
    }
    if (isdigit($sum_data_rate)){
      $inventory_data{$section}{$rg}{"data_rate"} = $sum_data_rate;
    }


  }

  ### capacity
  my $file = "$data_directory/rg.txt";
  my @data = get_array_data($file);
  my @pool_data = ();
  my $pool_activity = 0;

  foreach my $line (@data){
    chomp $line;
    $line = remove_whitespace($line);
    if ( $line eq "" || $line =~ /Status|RAID Group No/ ) { next; }
    if ($line =~ m/CLI\>/){next;}
    my ($id, $name, undef, undef, undef, $total, $free) = split(",", $line);
    if (!defined $id){next;}
    if (!defined $inventory_data{$section}{$id}{"id"}){
      my $total_c = "";
      my $used_c = "";
      my $free_c = "";
      if (isdigit($total)){
        $total_c = $total;
        $total_c = round($total_c / (1024 * 1024),3);
      }
      if (isdigit($free)){
        $free_c = $free;
        $free_c = round($free_c / (1024 * 1024),3);
      }
      if (isdigit($total_c) && isdigit($free_c)){
        my $pom = $total_c - $free_c;
        $used_c = round($pom,3);
      }
      push(@pool_data,"$id,$total_c,$used_c,$free_c");
    }
    if (isdigit($total)){
      if (defined $inventory_data{$section}{$id}{"id"}){
        my $pom = $total / (1024 * 1024);
        $inventory_data{$section}{$id}{"Capacity(TB)"} = round($pom,3);
      }
    }
    if (isdigit($free)){
      if (defined $inventory_data{$section}{$id}{"id"}){
        my $pom = $free / (1024 * 1024);
        $inventory_data{$section}{$id}{"Free(TB)"} = round($pom,3);
      }
    }
    if (isdigit($total) && isdigit($free)){
      my $used = $total - $free;
      if (isdigit ($used)){
        my $pom = $used / (1024 * 1024);
        $inventory_data{$section}{$id}{"Used(TB)"} = round($pom,3);
      }
    }

  }

  ### pool capacity
  $file = "$data_directory/pool.txt";
  @data = get_array_data($file);
  my $active = 0;
  my $name_property = "";
  my $name_property2 = "";
  my $line_parse = "";
  my %hash_position;

  foreach my $line (@data){
    chomp $line;
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/Name/ && $line =~ m/No\./){
      $name_property = $line;
      $active++;
      $pool_activity++;
    }
    if ($line =~ m/----/ && ( $active == 1 || $active == 5)){
      $line_parse = $line;
      my @chars = split("",$line);
      my $index = -1;
      my $num_property = 1;
      foreach my $char (@chars){
        $index++;
        if ($char eq " " && defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{END} = $index - 1;
          $num_property++;
          next;
        }
        if ($char eq "-" && !defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{START} = $index;
        }
      }
      $active++;
      next;
    }
    if ($active == 2 && $name_property ne ""){
      my $id = "";
      my $name = "";
      my $total = "";
      my $used = "";
      my $free = "";
      my $status = "";
      my $raid = "";
      my $used_status = "";
      foreach my $index (sort {$a<=>$b} keys %hash_position){
        my $start = $hash_position{$index}{START};
        my $end = $hash_position{$index}{END};
        if (isdigit($start) && !isdigit($end)){
          $end = length($line_parse);
        }
        if (!isdigit($start) || !isdigit($end)){next;}
        my $length = ($end - $start);
        $length++;
        if ($index == 1){
          $id = substr($line,$start,$length);
          $id = remove_whitespace($id);
          if (defined $id && $id ne ""){
            $inventory_data{$section}{$id}{id} = $id;
          }
        }
        if ($index == 2){
          $name = substr($line,$start,$length);
          $name = remove_whitespace($name);
          if (defined $id && $id ne "" && defined $name && $name ne ""){
            $inventory_data{$section}{$id}{name} = $name;
          }
        }
        if ($index == 6){
          $total = substr($line,$start,$length);
          $total = remove_whitespace($total);
          if (defined $total){
            my ($value, $unit) = split(" ",$total);
            if (isdigit($value) && defined $unit){
              my $pom = convert_capacity($unit,"TB",$value);
              if (isdigit($pom)){
                $total = $pom;
              }
            }
          }
          if (defined $id && $id ne "" && isdigit($total)){
            $inventory_data{$section}{$id}{"Capacity(TB)"} = $total;
          }
        }
        if ($index == 9){
          $used = substr($line,$start,$length);
          $used = remove_whitespace($used);
          if (defined $used){
            my ($value, $unit) = split(" ",$used);
            if (isdigit($value) && defined $unit){
              my $pom = convert_capacity($unit,"TB",$value);
              if (isdigit($pom)){
                $used = $pom;
              }
            }
          }
          if (defined $id && $id ne "" && isdigit($used)){
            $inventory_data{$section}{$id}{"Used(TB)"} = $used;
          }
        }
        if (isdigit($total) && isdigit($used)){
          $free = $total - $used;
          if (defined $id && $id ne "" && isdigit($free)){
            $inventory_data{$section}{$id}{"Free(TB)"} = $free;
          }
        }
      }
    }
  }
  #### flex tier pool ###
  $active = 0;
  #my $tier_mode = "$data_directory/tier_mode.txt";
  my $tier_pool = "$data_directory/tier_pool.txt";

  #my $test_tier = test_tier_pool($tier_mode);
  my $test_tier = 1;
  if ($test_tier == 1){
    my @data = get_array_data($tier_pool);
    foreach my $line (@data){
      chomp $line;
      if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
      if ($line =~ m/Name/ && $line =~ m/No\./){
        $name_property = $line;
        $active++;
        $pool_activity++;
      }
      if ($line =~ m/----/ &&  $active == 1 ){
        $line_parse = $line;
        my @chars = split("",$line);
        my $index = -1;
        my $num_property = 1;
        foreach my $char (@chars){
          $index++;
          if ($char eq " " && defined $hash_position{$num_property}{START}){
            $hash_position{$num_property}{END} = $index - 1;
            $num_property++;
            next;
          }
          if ($char eq "-" && !defined $hash_position{$num_property}{START}){
            $hash_position{$num_property}{START} = $index;
          }
        }
        $active++;
        next;
      }
      if ($active == 2 && $name_property ne ""){
        my $id = "";
        my $name = "";
        my $total = "";
        my $used = "";
        my $free = "";
        my $status = "";
        my $raid = "";
        my $used_status = "";
        foreach my $index (sort {$a<=>$b} keys %hash_position){
          my $start = $hash_position{$index}{START};
          my $end = $hash_position{$index}{END};
          if (isdigit($start) && !isdigit($end)){
            $end = length($line_parse);
          }
          if (!isdigit($start) || !isdigit($end)){next;}
          my $length = ($end - $start);
          $length++;
          if ($index == 1){
            $id = substr($line,$start,$length);
            $id = remove_whitespace($id);
            if (defined $id && $id ne ""){
              $inventory_data{$section}{$id}{id} = $id;
            }
          }
          if ($index == 2){
            $name = substr($line,$start,$length);
            $name = remove_whitespace($name);
            if (defined $id && $id ne "" && defined $name && $name ne ""){
              $inventory_data{$section}{$id}{name} = $name;
            }
          }
          if ($index == 4){
            $total = substr($line,$start,$length);
            $total = remove_whitespace($total);
            if (defined $total){
              my ($value, $unit) = split(" ",$total);
              if (isdigit($value) && defined $unit){
                my $pom = convert_capacity($unit,"TB",$value);
                if (isdigit($pom)){
                  $total = $pom;
                }
              }
            }
            if (defined $id && $id ne "" && isdigit($total)){
              $inventory_data{$section}{$id}{"Capacity(TB)"} = $total;
            }
          }
          if ($index == 7){
            $used = substr($line,$start,$length);
            $used = remove_whitespace($used);
            if (defined $used){
              my ($value, $unit) = split(" ",$used);
              if (isdigit($value) && defined $unit){
                my $pom = convert_capacity($unit,"TB",$value);
                if (isdigit($pom)){
                  $used = $pom;
                }
              }
            }
            if (defined $id && $id ne "" && isdigit($used)){
              $inventory_data{$section}{$id}{"Used(TB)"} = $used;
            }
          }
          if (isdigit($total) && isdigit($used)){
            $free = $total - $used;
            if (defined $id && $id ne "" && isdigit($free)){
              $inventory_data{$section}{$id}{"Free(TB)"} = $free;
            }
          }
        }
      }
    }
  }
  if ($pool_activity == 0){
    foreach my $line (@pool_data){
      my ($id, $total, $used, $free) = split (",",$line);
      $inventory_data{$section}{$id}{"Used(TB)"} = $used;
      $inventory_data{$section}{$id}{"Free(TB)"} = $free;
      $inventory_data{$section}{$id}{"Capacity(TB)"} = $total;
      $inventory_data{$section}{$id}{"id"} = $id;
    }
  }
  #print Dumper \$inventory_data{$section};

}

sub convert_capacity {
  my $unit_input  = shift;
  my $unit_output = shift;
  my $value       = shift;
  $unit_input = uc($unit_input);

  if ( $unit_input eq $unit_output ) {
    return $value;
  }
  if ( $unit_input eq "MB" && $unit_output eq "GB" ) {
    return round( $value / 1024 );
  }
  if ( $unit_input eq "MB" && $unit_output eq "TB" ) {
    return round( $value / ( 1024 * 1024 ) );
  }
  if ( $unit_input eq "MB" && $unit_output eq "PB" ) {
    return round( $value / ( 1024 * 1024 * 1024 ) );
  }
  if ( $unit_input eq "GB" && $unit_output eq "TB" ) {
    return round( $value / (1024) );
  }
  if ( $unit_input eq "GB" && $unit_output eq "PB" ) {
    return round( $value / ( 1024 * 1024 ) );
  }
  if ( $unit_input eq "TB" && $unit_output eq "PB" ) {
    return round( $value / (1024) );
  }
  if ( $unit_input eq "GB" && $unit_output eq "MB" ) {
    return round( $value * 1024 );
  }
  if ( $unit_input eq "TB" && $unit_output eq "MB" ) {
    return round( $value * ( 1024 * 1024 ) );
  }
  if ( $unit_input eq "TB" && $unit_output eq "GB" ) {
    return round( $value * (1024) );
  }
  if ( $unit_input eq "PB" && $unit_output eq "MB" ) {
    return round( $value * ( 1024 * 1024 * 1024 ) );
  }
  if ( $unit_input eq "PB" && $unit_output eq "GB" ) {
    return round( $value * ( 1024 * 1024 ) );
  }
  if ( $unit_input eq "PB" && $unit_output eq "TB" ) {
    return round( $value * (1024) );
  }
  return "";

} ## end sub convert_capacity


sub set_data_node{

  my $file = "$data_directory/controller_stat.txt";
  my $section = "Node Level Statistics";
  my @data = get_array_data($file);
  my $active = 0;
  my %hash_position;
  my $name_property = "";
  my $line_parse = "";


  foreach my $line (@data){
    chomp $line;
    #$line = remove_whitespace($line);
    my $pom_line = $line;
    $pom_line = remove_whitespace($pom_line);
    if ( $line eq "" || $line =~ m/^CLI>/ || $pom_line eq "" ) {
      $active = 0;
      next;
    }
    if ($line =~ m/^Location/){
      $name_property = $line;
      $active++;
      next;
    }
    if ($line =~ m/------/ && $active == 1){
      $line_parse = $line;
      my @chars = split("",$line);
      my $index = -1;
      my $num_property = 1;
      foreach my $char (@chars){
        $index++;
        if ($char eq " " && defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{END} = $index - 1;
          $num_property++;
          next;
        }
        if ($char eq "-" && !defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{START} = $index;
        }
      }
      $active++;
      next;
    }
    if ($name_property ne "" && $active == 2){
      my $location = "";
      foreach my $index (sort {$a<=>$b} keys %hash_position){
        my $start = $hash_position{$index}{START};
        my $end = $hash_position{$index}{END};
        if (isdigit($start) && !isdigit($end)){
          my $len = length($line_parse);
          $end = $len;
        }
        if (!isdigit($start) || !isdigit($end)){next;}
        my $length = ($end - $start);
        $length++;
        my $property = substr($name_property,$start,$length);
        $property = remove_whitespace($property);
        my $value = substr($line,$start,$length);
        $value = remove_whitespace($value);
        if (!defined $property || $property eq "" || !defined $value){next;}
        if ($property eq "Location"){
          $inventory_data{$section}{$value}{"id"} = $value;
          $location = $value;
        }
        if ($property eq "Busy Rate(%)" && defined $location && isdigit($value)){
          $inventory_data{$section}{$location}{"busy"} = $value;
        }

      }

    }
  }

}



sub set_data_drive{

  ### location - substr


  my $file = "$data_directory/disk_stat.txt";
  my $section = "Drive Level Statistics";
  my @data = get_array_data($file);
  my $active = 0;
  my %hash_position;
  my $name_property = "";
  my $line_parse = "";


  foreach my $line (@data){
    chomp $line;
    #$line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/^Location/){
      $name_property = $line;
      $active++;
      next;
    }
    if ($line =~ m/------/ && $active == 1){
      $line_parse = $line;
      my @chars = split("",$line);
      my $index = -1;
      my $num_property = 1;
      foreach my $char (@chars){
        $index++;
        if ($char eq " " && defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{END} = $index - 1;
          $num_property++;
          next;
        }
        if ($char eq "-" && !defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{START} = $index;
        }
      }
      $active++;
      next;
    }
    if ($name_property ne "" && $active == 2){
      my $location = "";
      foreach my $index (sort {$a<=>$b} keys %hash_position){
        my $start = $hash_position{$index}{START};
        my $end = $hash_position{$index}{END};
        if (isdigit($start) && !isdigit($end)){
          my $len = length($line_parse);
          $end = $len;
        }
        if (!isdigit($start) || !isdigit($end)){next;}
        my $length = ($end - $start);
        $length++;
        my $property = substr($name_property,$start,$length);
        $property = remove_whitespace($property);
        my $value = substr($line,$start,$length);
        $value = remove_whitespace($value);
        if (!defined $property || $property eq "" || !defined $value){next;}
        if ($property eq "Location"){
          $inventory_data{$section}{$value}{"id"} = $value;
          $location = $value;
        }
        if ($property eq "Busy Rate(%)" && defined $location && isdigit($value)){
          $inventory_data{$section}{$location}{"busy"} = $value;
        }

      }

    }
  }
  #print Dumper \%inventory_data;

  $file = "$data_directory/disk.txt";
  @data = get_array_data($file);

  foreach my $line (@data){
    chomp $line;
    $line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/Status|Location/ ) { next; }
    if ($line =~ m/^CLI/){next;}
    my ($location, $status, $size, $type, $speed, $usage, $health, $rg, $motor_status, undef, $vendor, $product, $serial, $wwn, $firmware) = split(",",$line);
    if (!defined $location){next;}
    #$location =~ s/#//g;
    $inventory_data{$section}{$location}{id} = $location;
    $inventory_data{$section}{$location}{name} = $location;

    if (defined $rg){
      my ($id, $name ) = split(" : ",$rg);
      $id = remove_whitespace($id);
      $name = remove_whitespace($name);
      if (defined $id && $id ne ""){
        $inventory_data{$section}{$location}{"raid_group_id"} = $id;
      }
      #if (defined $name && $name ne ""){
      #  $inventory_data{$section}{$location}{"raid_group_name"} = $name;
      #}
    }

  }

}

sub set_data_port{

  my $file = "$data_directory/port_stat.txt";
  my $section = "Port Level Statistics";
  my @data = get_array_data($file);
  my $active = 0;
  my %hash_position;
  my $name_property = "";
  my $name_property2 = "";
  my $line_parse = "";


  foreach my $line (@data){
    chomp $line;
    my $size_line = $line;
    $size_line = remove_whitespace($size_line);
    #$line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/^CLI>/ || $size_line eq "") {
      $active = 0;
      $name_property = "";
      $name_property2 = "";
      $line_parse = "";
      foreach my $index (keys %hash_position){
        delete $hash_position{$index};
      }
      next;
    }
    if ($line =~ m/Location/){
      $name_property = $line;
      $active++;
      next;
    }
    if (($line =~ m/Read/ && $line =~ m/Write/ ) || ($line =~ m/Transmitted/ && $line =~ m/Received/)){
      $name_property2 = $line;
      $active++;
      next;
    }

    if ($line =~ m/----/ && $active == 2){
      my @chars = split("",$line);
      my $index = -1;
      my $num_property = 1;
      $line_parse = $line;
      foreach my $char (@chars){
        $index++;
        if ($char eq " " && defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{END} = $index - 1;
          $num_property++;
          next;
        }
        if ($char eq "-" && !defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{START} = $index;
        }
      }
      $active++;
      next;
    }
    if ($active == 3 && $name_property ne "" && $name_property2 ne ""){
      my $read_io = "";
      my $write_io = "";
      my $read = "";
      my $write = "";
      my $localtion = "";
      foreach my $index (sort {$a<=>$b} keys %hash_position){
        my $start = $hash_position{$index}{START};
        my $end = $hash_position{$index}{END};
        if (isdigit($start) && !isdigit($end)){
          my $len = length($line_parse);
          $end = $len;
        }
        if (!isdigit($start) || !isdigit($end)){next;}
        my $length = ($end - $start);
        $length++;
        my $property = substr($name_property,$start,$length);
        $property = remove_whitespace($property);

        if (!defined $property  || $property eq "" || $property ne "Location" ){
          $property = substr($name_property2,$start,$length);
          $property = remove_whitespace($property);
        }
        if (!defined $property ){next;}
        if ($property eq "Location"){
          $localtion = substr($line,$start,$length);
          $localtion = remove_whitespace($localtion);
        }
        if (($property eq "Read" || $property eq "Transmitted") && $index == 2){
          $read_io = substr($line,$start,$length);
          $read_io = remove_whitespace($read_io);
        }
        if (($property eq "Write" || $property eq "Received") && $index == 3){
          $write_io = substr($line,$start,$length);
          $write_io = remove_whitespace($write_io);
        }
        if (($property eq "Read" || $property eq "Transmitted") && $index == 4){
          $read = substr($line,$start,$length);
          $read = remove_whitespace($read);
        }
        if (($property eq "Write" || $property eq "Received") && $index == 5){
          $write = substr($line,$start,$length);
          $write = remove_whitespace($write);
        }
      }
      if (defined $localtion && $localtion ne ""){
        $inventory_data{$section}{$localtion}{"id"} = $localtion;
        if (isdigit($read_io)){
          $inventory_data{$section}{$localtion}{"read_io"} = $read_io;
        }
        if (isdigit($write_io)){
          $inventory_data{$section}{$localtion}{"write_io"} = $write_io;
        }
        if (isdigit($read)){
          $inventory_data{$section}{$localtion}{"read"} = round($read * 1024,0);
        }
        if (isdigit($write)){
          $inventory_data{$section}{$localtion}{"write"} = round($write * 1024,0);
        }
        my $io_rate = "";
        my $data_rate = "";
        if (isdigit($read_io)){
          $io_rate = $read_io;
        }
        if (isdigit($write_io)){
          if (isdigit($io_rate)){
            $io_rate = $io_rate + $write_io;
          }
          else{
            $io_rate = $write_io;
          }
        }
        if (isdigit($io_rate)){
          $inventory_data{$section}{$localtion}{"io_rate"} = $io_rate;
        }

        if (isdigit($read)){
          $data_rate = $read;
        }
        if (isdigit($write)){
          if (isdigit($data_rate)){
            $data_rate = $data_rate + $write;
          }
          else{
            $data_rate = $write;
          }
        }
        if (isdigit($data_rate)){
          $inventory_data{$section}{$localtion}{"data_rate"} = round($data_rate * 1024,0);
        }

      }
    }
  }
  my $id_port = "";
  my $id_port2 = "";
  my @files = ();
  push (@files,"$data_directory/fc-port.txt");
  push (@files,"$data_directory/sas-port.txt");
  push (@files,"$data_directory/fcoe-port.txt");
  push (@files,"$data_directory/iscsi-port.txt");

  my $index_file = 0;
  foreach my $file (@files){
    $index_file++;
    my @data = get_array_data($file);

    if ($index_file == 4){
      my $name_port = "";
      foreach my $line (@data){
        my $active = 0;
        chomp $line;
        if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
        $line =~ s/ {2,}/  /g;
        $line = remove_whitespace($line);
        if ($line eq ""){next;}
        my ($property, $value) = split("  ",$line);
        if (!defined $property || $property eq ""){next;}
        if ($property =~ m/Port#/ && $property =~ m/CM#/ && $property =~ m/CA#/){
          #$property =~ s/#//g;
          $name_port = $property;
          if (defined $inventory_data{$section}{$name_port}{id} ){
            $inventory_data{$section}{$name_port}{Protocol} = "ISCSI";
            next;
          }
        }
      }

    }
    else{

      foreach my $line (@data){
        my $name_property = "";
        my $active = 0;
        chomp $line;
        if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
        $line =~ s/ {2,}/  /g;
        $line = remove_whitespace($line);
        if ($line eq ""){next;}
        my @data_line = split("  ",$line);
        foreach my $element (@data_line){
          $element = remove_whitespace($element);
          if ($active == 0 ){
            $name_property = $element;
            $active++;
            next;
          }
          if (defined $name_property && $name_property eq "Port"){
            if ($active > 0){
              $id_port = "";
              $id_port = $element;
              #$element =~ s/#//g;
              if (defined $inventory_data{$section}{$element}{id}){
                if ($index_file == 1){
                  $inventory_data{$section}{$element}{Protocol} = "FC";
                }
                if ($index_file == 2){
                  $inventory_data{$section}{$element}{Protocol} = "SAS";
                }
                if ($index_file == 3){
                  $inventory_data{$section}{$element}{Protocol} = "FCOE";
                }
                $active++;
                next;
              }
            }
          }
        }
      }
    }
  }
  #print Dumper \$inventory_data{$section};
  #print Dumper \%inventory_data;
  #print Dumper \%hash_position;

}


sub set_data_volume{

  my $file = "$data_directory/volume_stat.txt";
  my $section = "Volume Level Statistics";
  my @data = get_array_data($file);
  my $active = 0;
  my %hash_position;
  my $name_property = "";


  foreach my $line (@data){
    chomp $line;
    #$line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/No\./ && $line =~ m/Name/){
      $name_property = $line;
      $active++;
      next;
    }

    if ($line =~ m/^----/ && $active == 1){
      my @chars = split("",$line);
      my $index = -1;
      my $num_property = 1;
      foreach my $char (@chars){
        $index++;
        if ($char eq " " && defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{END} = $index - 1;
          $num_property++;
          next;
        }
        if ($char eq "-" && !defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{START} = $index;
        }
      }
      $active++;
      next;
    }
    if ($active == 2 && $name_property ne ""){
      my $name_volume = "";
      my $read_io = "";
      my $write_io = "";
      my $resp_t_r = "";
      my $resp_t_w = "";
      my $read = "";
      my $write = "";
      my $r_cache_hit = "";
      my $w_cache_hit = "";
      foreach my $index (sort {$a<=>$b} keys %hash_position){
        my $start = $hash_position{$index}{START};
        my $end = $hash_position{$index}{END};
        if (!isdigit($start) || !isdigit($end)){next;}
        my $length = ($end - $start);
        $length++;
        my $name = substr($name_property,$start,$length);
        $name = remove_whitespace($name);
        if (!defined $name || $name eq "" ){next;}
        my $value = substr($line,$start,$length);
        $value = remove_whitespace($value);
        if (!defined $value || $value eq ""){next;}
        #print "$line : $start : $length : $value\n";

        if ($name eq "Name"){
          $inventory_data{$section}{$value}{"name"} = $value;
          $name_volume = $value;
        }
        if ($name eq "Read" && $index == 3 && isdigit($value) && $name_volume ne "" ){
          $read_io = $value;
        }
        if ($name eq "Read" && $index == 5 && isdigit($value) && $name_volume ne "" ){
          $read = $value;
        }
        if ($name eq "Read" && $index == 7 && isdigit($value) && $name_volume ne "" ){
          $resp_t_r = $value;
        }
        if ($name eq "Read" && $index == 11 && isdigit($value) && $name_volume ne "" ){
          $r_cache_hit = $value;
        }

        if ($name eq "Write" && $index == 4 && isdigit($value) && $name_volume ne "" ){
          $write_io = $value;
        }
        if ($name eq "Write" && $index == 6 && isdigit($value) && $name_volume ne "" ){
          $write = $value;
        }
        if ($name eq "Write" && $index == 8 && isdigit($value) && $name_volume ne "" ){
          $resp_t_w = $value;
        }
        if ($name eq "Write" && $index == 12 && isdigit($value) && $name_volume ne "" ){
          $w_cache_hit = $value;
        }


        #my (undef, undef, $read_io, $write_io, $read, $write, $resp_t_r, $resp_t_w, undef, undef, $r_cache_hit, $w_cache_hit) = split (" ",$line);
        if (isdigit ($read_io)){
          $inventory_data{$section}{$name_volume}{"read_io"} = $read_io;
        }
        if (isdigit ($write_io)){
          $inventory_data{$section}{$name_volume}{"write_io"} = $write_io;
        }
        if (isdigit ($read)){
          $inventory_data{$section}{$name_volume}{"read"} = round($read * 1024,0);
        }
        if (isdigit ($write)){
          $inventory_data{$section}{$name_volume}{"write"} = round($write * 1024,0);
        }
        if (isdigit ($resp_t_r)){
          $inventory_data{$section}{$name_volume}{"resp_t_r"} = $resp_t_r;
        }
        if (isdigit ($resp_t_w)){
          $inventory_data{$section}{$name_volume}{"resp_t_w"} = $resp_t_w;
        }
        if (isdigit ($r_cache_hit)){
          $inventory_data{$section}{$name_volume}{"r_cache_hit"} = $r_cache_hit;
        }
        if (isdigit ($w_cache_hit)){
          $inventory_data{$section}{$name_volume}{"w_cache_hit"} = $w_cache_hit;
        }
        ### sum io data resp
        my $io_rate = "";
        if (isdigit($read_io) ){
          $io_rate = $read_io;
        }
        if (isdigit($write_io) ){
          if (isdigit($io_rate)){
            $io_rate = $io_rate + $write_io;
          }
          else{
            $io_rate = $write_io;
          }
        }

        my $data_rate = "";
        if (isdigit($read) ){
          $data_rate = $read;
        }
        if (isdigit($write) ){
          if (isdigit($data_rate)){
            $data_rate = $data_rate + $write;
          }
          else{
            $data_rate = $write;
          }
        }

        my $resp_t = "";
        if (isdigit($read_io) && isdigit($resp_t_r) ){
          $resp_t = $read_io * $resp_t_r;
        }
        if (isdigit($write_io) && isdigit($resp_t_w) ){
          if (isdigit($resp_t)){
            $resp_t = $resp_t + ($write_io * $resp_t_w);
          }
          else{
            $resp_t = $write_io * $resp_t_w;
          }
        }

        if (isdigit($io_rate)){
          $inventory_data{$section}{$name_volume}{"io_rate"} = round($io_rate,0);
        }
        if (isdigit($data_rate)){
          $inventory_data{$section}{$name_volume}{"data_rate"} = round($data_rate * 1024,0);
        }
        if (isdigit($io_rate) && $io_rate != 0 && isdigit($resp_t)){
          my $pom = $resp_t / $io_rate;
          $inventory_data{$section}{$name_volume}{"resp_t"} = round($pom,3);
        }

      }
    }
  }
  #print Dumper \%hash_position;
  #print Dumper \%inventory_data;

  $file = "$data_directory/volume.txt";
  @data = get_array_data($file);
  $active = 0;
  $name_property = "";
  my $name_property2 = "";

  foreach my $index (keys %hash_position){
    delete $hash_position{$index};
  }


  foreach my $line (@data){
    chomp $line;
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/No\./ && $line =~ m/Name/){
      $name_property = $line;
      $active++;
      next;
    }
    if ($line =~ m/Status/ && $line =~ m/Volume/){
      $name_property2 = $line;
    }

    if ($line =~ m/^----/ && $active == 1){
      my @chars = split("",$line);
      my $index = -1;
      my $num_property = 1;
      foreach my $char (@chars){
        $index++;
        if ($char eq " " && defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{END} = $index - 1;
          $num_property++;
          next;
        }
        if ($char eq "-" && !defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{START} = $index;
        }
      }
      $active++;
      next;
    }
    if ($active == 2 && $name_property ne ""){
      my $id_element = "";
      my $name_element = "";
      my $rg_name = "";
      my $rg_id = "";
      my $size = "";
      foreach my $index (sort {$a<=>$b} keys %hash_position){
        my $start = $hash_position{$index}{START};
        my $end = $hash_position{$index}{END};
        if (!isdigit($start) || !isdigit($end)){next;}
        my $length = ($end - $start);
        $length++;
        my $name = substr($name_property,$start,$length);
        $name = remove_whitespace($name);
        if ($name_property2 ne "" && $index == 12 ){
          my $name2 = substr($name_property2,$start,$length);
          $name2 = remove_whitespace($name2);
          if (defined $name2 && $name2 eq "Size(MB)"){
            $size = substr($line,$start,$length);
            $size = remove_whitespace($size);
          }
        }
        if (!defined $name || $name eq ""){
          next;
        }
        if ($name eq "Name" && $index == 2){
          $name_element = substr($line,$start,$length);
          $name_element = remove_whitespace($name_element);
        }
        if ($name eq "ID"){
          $id_element = substr($line,$start,$length);
          $id_element = remove_whitespace($id_element);
        }
        if ($name eq "No." && $index == 8){
          $rg_id = substr($line,$start,$length);
          $rg_id = remove_whitespace($rg_id);
        }
        if ($name eq "Name" && $index == 9){
          $rg_name = substr($line,$start,$length);
          $rg_name = remove_whitespace($rg_name);
        }
        if (defined $name_element && $name_element ne "" && defined $id_element && $id_element ne "" && defined $inventory_data{$section}{$name_element}){
          $inventory_data{$section}{$name_element}{"id"} = $id_element;

          if (isdigit($size)){
            $inventory_data{$section}{$name_element}{"Capacity(MB)"} = $size;
          }


          if (defined $rg_id && $rg_id ne "" && defined $rg_name && $rg_name ne ""){
            $inventory_data{$section}{$name_element}{"rg_id"} = $rg_id;
            $inventory_data{$section}{$name_element}{"rg_name"} = $rg_name;
            if (!defined $inventory_data{"Pool Level Statistics"}{$rg_id}{"id"}){
              $inventory_data{"Pool Level Statistics"}{$rg_id}{"id"} = $rg_id;
              $inventory_data{"Pool Level Statistics"}{$rg_id}{"name"} = $rg_name;
            }
          }
        }
      }
    }
  }

  #advance copy stats
  $file = "$data_directory/advanced_copy_stat.txt";
  @data = get_array_data($file);
  $active = 0;
  $name_property = "";
   foreach my $index (keys %hash_position){
    delete $hash_position{$index};
  }


  foreach my $line (@data){
    chomp $line;
    #$line = remove_whitespace($line);
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    if ($line =~ m/No\./ && $line =~ m/Name/){
      $name_property = $line;
      $active++;
      next;
    }

    if ($line =~ m/^----/ && $active == 1){
      my @chars = split("",$line);
      my $index = -1;
      my $num_property = 1;
      foreach my $char (@chars){
        $index++;
        if ($char eq " " && defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{END} = $index - 1;
          $num_property++;
          next;
        }
        if ($char eq "-" && !defined $hash_position{$num_property}{START}){
          $hash_position{$num_property}{START} = $index;
        }
      }
      $active++;
      next;
    }
    if ($active == 2 && $name_property ne ""){
      my $name_volume = "";
      my $read_io = "";
      my $write_io = "";
      my $resp_t_r = "";
      my $resp_t_w = "";
      my $read = "";
      my $write = "";
      my $r_cache_hit = "";
      my $w_cache_hit = "";
      foreach my $index (sort {$a<=>$b} keys %hash_position){
        my $start = $hash_position{$index}{START};
        my $end = $hash_position{$index}{END};
        if (!isdigit($start) || !isdigit($end)){next;}
        my $length = ($end - $start);
        $length++;
        my $name = substr($name_property,$start,$length);
        $name = remove_whitespace($name);
        if (!defined $name || $name eq "" ){next;}
        my $value = substr($line,$start,$length);
        $value = remove_whitespace($value);
        if (!defined $value || $value eq ""){next;}
        #print "$line : $start : $length : $value\n";

        if ($name eq "Name"){
          $inventory_data{$section}{$value}{"name"} = $value;
          $name_volume = $value;
        }
        if ($name eq "Read" && $index == 3 && isdigit($value) && $name_volume ne "" ){
          $read_io = $value;
        }
        if ($name eq "Read" && $index == 5 && isdigit($value) && $name_volume ne "" ){
          $read = $value;
        }
        if ($name eq "Read" && $index == 7 && isdigit($value) && $name_volume ne "" ){
          $r_cache_hit = $value;
        }

        if ($name eq "Write" && $index == 4 && isdigit($value) && $name_volume ne "" ){
          $write_io = $value;
        }
        if ($name eq "Write" && $index == 6 && isdigit($value) && $name_volume ne "" ){
          $write = $value;
        }
        if ($name eq "Write" && $index == 8 && isdigit($value) && $name_volume ne "" ){
          $w_cache_hit = $value;
        }


        #my (undef, undef, $read_io, $write_io, $read, $write, $resp_t_r, $resp_t_w, undef, undef, $r_cache_hit, $w_cache_hit) = split (" ",$line);
        if (isdigit ($read_io)){
          $inventory_data{$section}{$name_volume}{"read_io_advance_copy"} = $read_io;
        }
        if (isdigit ($write_io)){
          $inventory_data{$section}{$name_volume}{"write_io_advance_copy"} = $write_io;
        }
        if (isdigit ($read)){
          $inventory_data{$section}{$name_volume}{"read_advance_copy"} = round($read * 1024,0);
        }
        if (isdigit ($write)){
          $inventory_data{$section}{$name_volume}{"write_advance_copy"} = round($write * 1024,0);
        }
        if (isdigit ($r_cache_hit)){
          $inventory_data{$section}{$name_volume}{"r_cache_hit_advance_copy"} = $r_cache_hit;
        }
        if (isdigit ($w_cache_hit)){
          $inventory_data{$section}{$name_volume}{"w_cache_hit_advance_copy"} = $w_cache_hit;
        }
        ### sum io data resp
        my $io_rate = "";
        if (isdigit($read_io) ){
          $io_rate = $read_io;
        }
        if (isdigit($write_io) ){
          if (isdigit($io_rate)){
            $io_rate = $io_rate + $write_io;
          }
          else{
            $io_rate = $write_io;
          }
        }
        my $data_rate = "";
        if (isdigit($read) ){
          $data_rate = $read;
        }
        if (isdigit($write) ){
          if (isdigit($data_rate)){
            $data_rate = $data_rate + $write;
          }
          else{
            $data_rate = $write;
          }
        }

        if (isdigit($io_rate)){
          $inventory_data{$section}{$name_volume}{"io_rate_advance_copy"} = round($io_rate,0);
        }
        if (isdigit($data_rate)){
          $inventory_data{$section}{$name_volume}{"data_rate_advance_copy"} = round($data_rate * 1024,0);
        }

      }
    }
  }


  #print Dumper \%inventory_data;
  #print Dumper \%hash_position;

}


sub test_connection {
  my $cmd     = shift;
  my $file    = shift;
  my $timeout = shift;
  my $connection = shift;
  my $save = shift;
  my $pid     = fork();
  if ( !defined $pid ) {
    error_die( "no fork $!" . __FILE__ . ":" . __LINE__ );
  }
  elsif ( $pid == 0 ) {
    setpgrp( 0, 0 );
    if (defined $save && $save eq "save"){
      #`$connection '$cmd' >> "$file" 2>>\$ERRLOG_ETERNUS`;
      `echo '$cmd' | $connection >> "$file" 2>\$err_tmp`;
    }
    else{
      #`$connection '$cmd' > "$file" 2>>\$ERRLOG_ETERNUS`;
      `echo '$cmd' | $connection > "$file" 2>\$err_tmp`;
    }
    if ( $? != 0 ) {
      error( "command failed: $cmd " . __FILE__ . ":" . __LINE__ );
    }
    exit(0);
  } ## end elsif ( $pid == 0 )
  eval {
    local $SIG{ALRM} = sub { die "die in SIGALRM"; };
    alarm($timeout);
    waitpid( $pid, 0 );
    alarm(0);
  };
  if ( $@ =~ /die in SIGALRM/ ) {
    my $act_time = localtime();
    error( "$act_time command: $cmd timed out after: $timeout seconds " . __FILE__ . ":" . __LINE__ );
    kill -15, $pid;
    waitpid( $pid, 0 );
  } ## end if ( $@ =~ /die in SIGALRM/)
  error_wraper($err_tmp);
  return;
} ## end sub cmd_to_file

sub error_wraper{

  my $file = shift;

  if (-f "$file" && !-z "$file"){

    my @data = get_array_data($file);

    foreach my $line (@data){
      chomp $line;
      if ($line eq "" || $line =~ m/closed by remote host/ || $line =~ m/tcgetattr: Inappropriate ioctl for device/){
        next;
      }
      print STDERR "$line\n";
    }
  }

}


sub cmd_to_file {
  my $cmd     = shift;
  my $file    = shift;
  my $timeout = shift;
  my $save = shift;
  my $pid     = fork();
  if ( !defined $pid ) {
    error_die( "no fork $!" . __FILE__ . ":" . __LINE__ );
  }
  elsif ( $pid == 0 ) {
    setpgrp( 0, 0 );
    if (defined $save && $save eq "save"){
      #`$connection '$cmd' >> "$file" 2>>\$ERRLOG_ETERNUS`;
      `echo '$cmd' | $connection >> "$file" 2>\$err_tmp`;
    }
    else{
      #`$connection '$cmd' > "$file" 2>>\$ERRLOG_ETERNUS`;
      `echo '$cmd' | $connection > "$file" 2>\$err_tmp`;
    }
    if ( $? != 0 ) {
      error( "command failed: $cmd " . __FILE__ . ":" . __LINE__ );
      if ($file =~ m/test_version\.txt/){
        `touch $data_directory/version_old.txt`;
      }
    }
    exit(0);
  } ## end elsif ( $pid == 0 )
  eval {
    local $SIG{ALRM} = sub { die "die in SIGALRM"; };
    alarm($timeout);
    waitpid( $pid, 0 );
    alarm(0);
  };
  if ( $@ =~ /die in SIGALRM/ ) {
    my $act_time = localtime();
    error( "$act_time command: $cmd timed out after: $timeout seconds " . __FILE__ . ":" . __LINE__ );
    kill -15, $pid;
    waitpid( $pid, 0 );
  } ## end if ( $@ =~ /die in SIGALRM/)
  error_wraper($err_tmp);
  return;
} ## end sub cmd_to_file


sub get_performance_statistics{

  my $cmd = "show date";
  my $file = "$data_directory/date.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show performance -type host-io";
  $file = "$data_directory/volume_stat.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show performance -type disks";
  $file = "$data_directory/disk_stat.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show performance -type cm";
  $file = "$data_directory/controller_stat.txt";  ### parallel with system show stats view cifs
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show performance -type port";
  $file = "$data_directory/port_stat.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show performance -type advanced-copy";
  $file = "$data_directory/advanced_copy_stat.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  if ($version == 1){

    $cmd = "show volumes -mode detail";
    $file = "$data_directory/volume.txt";
    cmd_to_file($cmd,$file, $timeout_perf);

    $cmd = "show raid-groups -csv";
    $file = "$data_directory/rg.txt";
    cmd_to_file($cmd,$file, $timeout_perf);

    $cmd = "show thin-pro-pools";
    $file = "$data_directory/pool.txt";
    cmd_to_file($cmd,$file, $timeout_perf);

    $cmd = "show disks -csv";
    $file = "$data_directory/disk.txt";
    cmd_to_file($cmd,$file, $timeout_perf);

    #$cmd = "show performance -type pfm";
    #$file = "$data_directory/pfm_stat.txt";
    #cmd_to_file($cmd,$file, $timeout_perf);

    #$cmd = "show flexible-tier-mode";
    #$file = "$data_directory/tier_mode.txt";
    #cmd_to_file($cmd,$file, $timeout_perf);

    #my $test_tier = test_tier_pool($file);
    my $test_tier = 1;
    if ($test_tier == 1){

      $cmd = "show flexible-tier-pools";
      $file = "$data_directory/tier_pool.txt";
      cmd_to_file($cmd,$file, $timeout_perf);
    }
  }
  if ($version == 0){
    $cmd = "show volumes";
    $file = "$data_directory/volume.txt";
    cmd_to_file($cmd,$file, $timeout_perf);

    $cmd = "show raid-groups";
    $file = "$data_directory/rg.txt";
    cmd_to_file($cmd,$file, $timeout_perf);

    $cmd = "show disks";
    $file = "$data_directory/disk.txt";
    cmd_to_file($cmd,$file, $timeout_perf);

    $cmd = "show volume-mapping";
    $file = "$data_directory/volume_mapping.txt";
    cmd_to_file($cmd,$file, $timeout_perf);
  }

  $cmd = "show fc-parameters";
  $file = "$data_directory/fc-port.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show sas-parameters";
  $file = "$data_directory/sas-port.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show fcoe-parameters";
  $file = "$data_directory/fcoe-port.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show iscsi-parameters";
  $file = "$data_directory/iscsi-port.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  #$cmd = "show volume-mapping";
  #$file = "$data_directory/volume_mapping.txt";
  #cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show enclosure-status -type all";
  $file = "$data_directory/enclosure_status.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show hardware-information";
  $file = "$data_directory/hardware.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show fru-ce";
  $file = "$data_directory/component_status.txt";
  cmd_to_file($cmd,$file, $timeout_perf);

  $cmd = "show status";
  $file = "$data_directory/summary_status.txt";
  cmd_to_file($cmd,$file, $timeout_perf);


}

sub test_tier_pool{
  my $file = shift;
  my @data = get_array_data($file);

  foreach my $line (@data){
    chomp $line;
    if ( $line eq "" || $line =~ m/^CLI>/ ) { next; }
    $line = remove_whitespace($line);
    if ( $line eq ""){next;}
    if ($line =~ m/Enable/){return 1;}

  }

  return 0;

}


sub set_variable{

  if ($eternus_enviroment){
    my $act_directory = localtime();
    my @entry_time = split( " ", $act_directory );
    ( undef, my $active_minute, undef ) = split( ":", $entry_time[3] );
    $storage_name = $ENV{STORAGE_NAME};
    $basedir      = $ENV{INPUTDIR};
    $bindir       = $ENV{BINDIR};
    $webdir       = $ENV{WEBDIR};
    $error_datadomain  = $ENV{ERRLOG_ETERNUS};
    if ( defined $webdir && $webdir ne "" && defined $storage_name && $storage_name ne "" ) {
      $health_status_html = "$webdir/$storage_name/health_status.html";
      $wrkdir             = "$basedir/data/$storage_name";
      $data_directory     = "$wrkdir/IOSTATS/$active_minute";
      if ( !-d "$wrkdir/IOSTATS" ) {
        mkdir "$wrkdir/IOSTATS" || error_die( "Cannot read $wrkdir/IOSTATS: $!" . __FILE__ . ":" . __LINE__ );
      }
      $summary_health = "$basedir/tmp/health_status_summary";
      if ( !-d "$data_directory" ) {
        mkdir "$data_directory" || error_die( "Cannot read $data_directory: $!" . __FILE__ . ":" . __LINE__ );
      }
      if ( defined $basedir && $basedir ne "" ) {
        $summary_health = "$basedir/tmp/health_status_summary";
      }
      else {
        error_die("BASEDIR is not defined!");
      }
    } ## end if ( defined $webdir &&...)
    else {
      error_die("WEBDIR or STORAGE NAME is not defined!");
    }
    $ENV{err_tmp} = "$basedir/tmp/error.log-tmp-$storage_name";
    $err_tmp = "$basedir/tmp/error.log-tmp-$storage_name";
    $user   = $ENV{ETERNUS_USER};
    $ip_address_a  = $ENV{ETERNUS_IP_SPA};
    $ip_address_b  = $ENV{ETERNUS_IP_SPB};
    if ( !defined $user || $user eq "" ) {
      error_die("USER is not defined!");
    }
    if (!defined $ip_address_a || $ip_address_a eq ""){
      if (!defined $ip_address_b || $ip_address_b eq ""){
        error_die("IP ADDRESS is not defined!");
      }
      else{
        my $cmd = "show enclosure-status";
        my $file = "$data_directory/test.txt";
        my $connection = "$ssh_cmd $user" . "@" . "$ip_address_b";
        test_conection($cmd,$file, $timeout_perf,$connection);
        if (test_file_exist($file)){
          $ip_address = $ip_address_b;
        }
        else{
          error_die("IP connection failed!");
        }
      }
    }
    else{
      my $cmd = "show enclosure-status";
      my $file = "$data_directory/test.txt";
      my $connection = "$ssh_cmd $user" . "@" . "$ip_address_a";
      test_connection($cmd,$file, $timeout_perf,$connection);
      if (test_file_exist($file)){
        $ip_address = $ip_address_a;
      }
      else{
        if (defined $ip_address_b || $ip_address_b eq ""){
          my $cmd = "show enclosure-status";
          my $file = "$data_directory/test.txt";
          my $connection = "$ssh_cmd $user" . "@" . "$ip_address_b";
          test_connection($cmd,$file, $timeout_perf,$connection);
          if (test_file_exist($file)){
            $ip_address = $ip_address_b;
          }
          else{
            error_die("IP connection failed!");
          }
        }
      }
    }
    if ( !defined $key || $key eq "" || !test_file_exist($key) ) {
      $connection = "$ssh_cmd $user" . "@" . "$ip_address";
    }
    else {
      $connection = "$ssh_cmd -i $key $user" . "@" . "$ip_address";
    }
  }

  else {
    my $act_directory = localtime();
    my @entry_time = split( " ", $act_directory );
    ( undef, my $active_minute, undef ) = split( ":", $entry_time[3] );
    $active_minute = "00";
    #$storage_name       = "DX200S4_main";
    #$storage_name = "Eternus_AF650_De";
    #$storage_name  = "CC_DX200_PRD_BDC";
    $basedir            = "/home/luzajic/STOR/ETERNUS";
    $bindir             = $ENV{BINDIR};
    $inputdir           = $ENV{INPUTDIR};
    $wrkdir             = "$basedir/data/$storage_name";
    $webdir             = "$basedir/www";
    $health_status_html = "$webdir/$storage_name/health_status.html";
    $summary_health     = "$basedir/tmp/health_status_summary";
    $configuration      = "";
    $config_directory   = "";
    $data_directory     = "$wrkdir/IOSTATS/$active_minute";
    $ip_address          = "192.168.0.251";
    $user               = "stor2rrd";
    $path               = "";
    $connection = "$ssh_cmd $user" . "@" . "$ip_address";
    $ENV{ERRLOG_ETERNUS} = "$basedir/error.log";
    #$err_tmp = "$ENV{INPUTDIR}/tmp/error.log-tmp-$storage_name";
    #$ENV{err_tmp} = "$ENV{INPUTDIR}/tmp/error.log-tmp-$storage_name";
    $ENV{err_tmp} = "$basedir/tmp/error.log-tmp-$storage_name";
    $err_tmp = "$basedir/tmp/error.log-tmp-$storage_name";

  } ## end else [ if ($vnx_enviroment) ]

}






sub data_structure {
  my $directory = "$wrkdir/IOSTATS";
  if ( !-d $directory ) {
    mkdir $directory || error_die( "Cannot read $directory: $!" . __FILE__ . ":" . __LINE__ );
  }
  if ( !-d "$directory/configuration" ) {
    mkdir "$directory/configuration" || error_die( "Cannot read $directory: $!" . __FILE__ . ":" . __LINE__ );
  }

  for ( my $i = 0; $i < 60; $i = $i + 1 ) {
    if ( $i < 10 ) {
      if ( !-d "$directory/0$i" ) {
        mkdir "$directory/0$i" || error_die( "Cannot read $directory: $!" . __FILE__ . ":" . __LINE__ );
      }
    }
    else {
      if ( !-d "$directory/$i" ) {
        mkdir "$directory/$i" || error_die( "Cannot read $directory: $!" . __FILE__ . ":" . __LINE__ );
      }
    }
  } ## end for ( my $i = 0; $i < 60...)
} ## end sub data_structure


sub error {

  my $text     = shift;
  my $act_time = localtime();
  chomp($text);
  print STDERR "$act_time: $text : $!\n";
  return 1;

} ## end sub error

sub error_die {
  my $message  = shift;
  my $act_time = localtime();
  print STDERR "$act_time: $message : $!\n";
  exit(1);
} ## end sub error_die

sub get_array_data {
  my $file = shift;
  my $test = test_file_exist($file);
  if ($test) {
    open( FH, "< $file" ) || error_die( "Cannot read $file: $!" . __FILE__ . ":" . __LINE__ );
    my @file_all = <FH>;
    close(FH);
    return @file_all;
  } ## end if ($test)
  else {
    error( "File not exist $file: $!" . __FILE__ . ":" . __LINE__ );
    my @file_empty = "";
    return @file_empty;
  }
} ## end sub get_array_data

sub test_file_exist {
  my $file = shift;
  if ( !-e $file || -z $file ) {
    return 0;
  }
  else {
    return 1;
  }
} ## end sub test_file_exist

sub remove_whitespace {
  my $value = shift;
  if (!defined $value){
    return "";
  }
  $value =~ s/^\s+|\s+$//g;
  return $value;

} ## end sub remove_whitespace


sub isdigit {
  my $digit = shift;
  my $text  = shift;

  if ( !defined($digit) ) {
    return 0;
  }
  if ( $digit eq '' ) {
    return 0;
  }
  if ($digit eq "-"){
    return 0;
  }

  my $digit_work = $digit;
  $digit_work =~ s/[0-9]//g;
  $digit_work =~ s/\.//;
  $digit_work =~ s/^-//;
  $digit_work =~ s/e//;
  $digit_work =~ s/\+//;
  $digit_work =~ s/\-//;

  if ( length($digit_work) == 0 ) {

    # is a number
    return 1;
  }

  #if (($digit * 1) eq $digit){
  #  # is a number
  #  return 1;
  #}

  # NOT a number
  return 0;
} ## end sub isdigit

sub round {
  my $number         = shift;
  my $decimal_plates = shift;
  if ( !defined $decimal_plates ) {
    $decimal_plates = 3;
  }
  my $num = $number;
  if ( $number =~ /\./ ) {
    $number =~ s/.*\.//g;
    my $length = length($number);
    if ( $length > $decimal_plates ) {
      my $rounded = sprintf( "%.$decimal_plates" . "f", $num );
      return $rounded;
    }
    else {
      return $num;
    }
  } ## end if ( $number =~ /\./ )
  else {
    return $num;
  }
} ## end sub round

sub get_time {
  my $timestamp_end = shift;
  my @time          = localtime($timestamp_end);
  my $time_human    = localtime($timestamp_end);
  my $sec           = $time[0];
  my $minute        = $time[1];
  my $hour          = $time[2];
  my $day           = $time[3];
  my $month         = $time[4] + 1;
  my ( undef, undef, undef, undef, $year ) = split( " ", $time_human );
  chomp $year;
  if ( $minute < 10 ) { $minute = "0$minute"; }
  if ( $hour < 10 )   { $hour   = "0$hour"; }
  if ( $day < 10 )    { $day    = "0$day"; }
  if ( $month < 10 )  { $month  = "0$month"; }
  if ( $sec < 10 )    { $sec    = "0$sec"; }
  my $time_end = "$year:$month:$day" . "T" . "$hour:$minute:$sec";
  return $time_end;
}
