#!/bin/sh

. ./fix.cfg

DEBUG_UPD=0
ID=`id -un`

os_aix=`uname -a|grep AIX|wc -l`
if [ $os_aix -eq 0 ]; then
  ECHO_OPT="-e"
else
  ECHO_OPT=""
fi

umask 022

if [ -d $HOME/$PRODUCT ]; then
  HOME1=$HOME/$PRODUCT
fi

if [ -f "$HOME/.${PRODUCT}_home" ]; then
  HOME1=`cat "$HOME/.${PRODUCT}_home"`
fi

if [ ! "$HOME1"x = "x" -a -d "$HOME1" ]; then
  echo $ECHO_OPT "Where is $UPRODUCT actually located [$HOME1]: \c"
else
  if [ x"$HOME1" = "x" ]; then
    echo $ECHO_OPT "Where is $UPRODUCT actually located: \c"
  else
    echo $ECHO_OPT "Where is $UPRODUCT actually located [$HOME1]: \c"
  fi
fi
read HOMELPAR

if [ x"$HOMELPAR" = "x" ]; then
  HOMELPAR=$HOME1
fi

# Check if it runs under the right user
check_file="$HOMELPAR/bin/$PRODUCT.pl"
if [ ! -f "$check_file" ]; then
  check_file="$HOMELPAR/bin/$PRODUCT-cgi.pl"
  if [ ! -f "$check_file" ]; then
    echo "$UPRODUCT product has not been found in: $HOMELPAR"
    exit 1
  fi
fi

install_user=`ls -l "$check_file"|awk '{print $3}'`
running_user=`id |awk -F\( '{print $2}'|awk -F\) '{print $1}'`
if [ ! "$install_user" = "$running_user" ]; then
  echo "You probably trying to run it under wrong user"
  echo "$UPRODUCT files are owned by : $install_user"
  echo "You are : $running_user"
  echo "$UPRODUCT fix should run only under user which owns installed package"
  echo "Do you want to really continue? [n]:"
  read answer
  if [ "$answer"x = "x" -o "$answer" = "n" -o "$answer" = "N" ]; then
    exit
  fi
fi

CFG=$HOMELPAR/etc/$PRODUCT.cfg

if [ ! -f "$CFG" ]; then
  CFG=$HOMELPAR/$PRODUCT.cfg
  if [ ! -f "$CFG" ]; then
    CFG=$HOMELPAR/load.sh
    if [ ! -f "$CFG" ]; then
      echo "Could not find config file $CFG, $UPRODUCT is not installed there, exiting"
      exit
    fi
	SHEBANG=`head -n 1 $CFG`
  fi
fi

. "$CFG"

if [ -d "files" ]; then
  os_linux=`uname -a|grep Linux|wc -l`
  if [ $os_linux -eq 1 ]; then
    #echo "Adjusting shell for Linux..."
    find files/ -name "*.sh" -exec sed -i 's/#!\/bin\/ksh/#!\/bin\/bash/' {} \;
  fi
  echo "Applying fix..."
  cp -r files/* $HOMELPAR
  if [ -d "files/html" ]; then
    echo "Copying files to WEBDIR ($WEBDIR)..."
    cp -r files/html/* $WEBDIR
  fi
  chmod 755 $HOMELPAR/bin
  chmod -R 755 $HOMELPAR/html  # must be due tue subdirs jquery, images ...
  chmod -R 755 $HOMELPAR/$PRODUCT-cgi
  # excluded, not really necessary, some users might have many files there historically
  #chmod -R o+r $HOMELPAR/www  2>/dev/null
  #chmod -R o+x $HOMELPAR/www 2>/dev/null
  chmod 755 $HOMELPAR/bin/*.pl
  chmod 755 $HOMELPAR/bin/*.pm
  chmod 755 $HOMELPAR/bin/*.sh
  rm -f $HOMELPAR/tmp/[2-9]* 2>/dev/null # remove version number
  #touch $HOMELPAR/tmp/$TAG
fi

# stop the agent daemon
if [ -f "$HOMELPAR/tmp/lpar2rrd-daemon.pid" ]; then
    PID=`cat "$HOMELPAR/tmp/lpar2rrd-daemon.pid"|sed 's/ //g'`
  if [ ! "$PID"x = "x" ]; then
    echo ""
    echo "Stopping LPAR2RRD daemon"
    kill `cat "$HOMELPAR/tmp/lpar2rrd-daemon.pid"` 2>/dev/null
  fi
fi
run=`ps -ef|grep lpar2rrd-daemon.pl| egrep -v "grep |vi | vim "|wc -l`
if [ $run -gt 0 ]; then
  # just to make sure ....
  kill `ps -ef|grep lpar2rrd-daemon.pl| egrep -v "grep |vi | vim "|awk '{print $2}'` 2>/dev/null
fi


echo "$VERSION-$PATCHNAME" >> $HOMELPAR/etc/version.txt

echo "Patch installation is done"
echo "run this to apply it"
echo ""
echo "cd $HOMELPAR"
echo "./load.sh"
echo "refresh the GUI when it finishes by Ctrl-F5"

