var hashTable = {},
sysInfo = {},
curLoad,
curNode,
curTab,
lastTabName = "",
jumpTo,
browserNavButton = false,
emailRegex = /^[a-zA-Z0-9.!#$%&'*+\/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/,
fleet = {},
metrics = {},
cgroups = {},
itemList = [],
mailGroups = {},
lessVars = {},
alrtCfg = {},
storedUrl,
zoomedUrl,
storedObj,
timeoutHandle,
backendSupportsPDF = false,
backendSupportsZIP = false,
loaded = 0,
prodName = "STOR2RRD";
var tiersList, poolsTiers;
var repRuleStr = "FREQ=MONTHLY";
var repRuleObj;

var urlItems = {
	resp: [ "response time total", "xa" ],
	resp_t: [ "response time total", "xb", "response time" ],
	resp_t_r: [ "response time read", "xc" ],
	resp_t_w: [ "response time write", "xd" ],
	resp_t_r_b: [ "response time read - back", "xe" ],
	resp_t_w_b: [ "response time write - back", "xf" ],
	sum_io: [ "IO total", "xg" ],
	sum_data: [ "data total", "xh" ],
	io: [ "IO total", "xi" ],
	io_rate: [ "IO total", "xj", "IO aggregated" ],
	data: [ "data total", "xk" ],
	data_rate: [ "data total", "xl", "data aggregated" ],
	read_io: [ "read IO", "xm" ],
	write_io: [ "write IO", "xn" ],
	read_io_b: [ "read IO - back", "xo" ],
	write_io_b: [ "write IO - back", "xp" ],
	read: [ "read data", "xq" ],
	write: [ "write data", "xr" ],
	read_b: [ "read data - back", "xs" ],
	write_b: [ "write data - back", "xt" ],
	sys: [ "CPU system", "xu" ],
	compress: [ "CPU compress", "xv" ],
	sum_capacity: [ "capacity", "xw" ],
	used: [ "capacity used", "xx" ],
	real: [ "capacity real", "xy" ],
	r_cache_usage: [ "read cache usage", "xz" ],
	w_cache_usage: [ "write cache usage", "xA" ],
	r_cache_hit: [ "read cache hit", "xB" ],
	w_cache_hit: [ "write cache hit", "xC" ],
	pprc_rio: [ "PPRC read IO", "xD" ],
	pprc_wio: [ "PPRC write IO", "xE" ],
	pprc_data_r: [ "PPRC read data", "xF" ],
	pprc_data_w: [ "PPRC write data", "xG" ],
	pprc_rt_r: [ "PPRC response time read", "xH" ],
	pprc_rt_w: [ "PPRC response time write", "xI" ],
	io_cntl: [ "controller", "xJ" ],
	ssd_r_cache_hit: [ "SSD read cache hit", "xK" ],
	cache_hit: [ "cache hit", "xL" ],
	data_cntl: [ "controller", "xM" ],
	read_pct: [ "read percent", "xN" ],
	sum_io_total: [ "agg IO total", "xO" ],
	san_data_sum_in: ["IN", "xQ", "Data IN" ],
	san_data_sum_out: ["OUT", "xR", "Data OUT" ],
	san_io_sum_credits: ["credits", "xS" ],
	san_io_sum_crc_errors: ["CRC errors", "xT" ],
	san_io_sum_encoding_errors: ["encoding errors", "xU" ],
	san_io_sum_in: ["IN", "xV", "Frame IN" ],
	san_io_sum_out: ["OUT", "xW", "Frame OUT" ],
	san_data: ["data", "xX" ],
	san_io: ["frames", "xY" ],
	san_credits: ["credits", "xZ" ],
	san_errors: ["errors", "x0" ],
	"custom-group-io_rate": ["IO rate", "x1" ],
	"custom-group-data_rate": ["data rate", "x2" ],
	"custom-group-read_io": ["read IO", "x3" ],
	"custom-group-write_io": ["write IO", "x4" ],
	"custom-group-read": ["read", "x5" ],
	"custom-group-write": ["write", "x6" ], // end of short dashboard hashes
	san_data_sum_tot_in: ["IN", "aa", "Data IN" ],
	san_data_sum_tot_out: ["OUT", "ab", "DataOUT" ],
	san_io_sum_tot_credits: ["Credits", "ac" ],
	san_io_sum_tot_crc_errors: ["CRC errors", "ad" ],
	san_io_sum_tot_encoding_errors: ["Encoding errors", "ae" ],
	san_io_sum_tot_in: ["IN", "af", "Frame IN" ],
	san_io_sum_tot_out: ["OUT", "ag", "Frame OUT" ],
	san_fabric_data_in: ["Data in", "ah" ],
	san_fabric_frames_in: ["Frames in", "ai" ],
	san_fabric_credits: ["Credits", "aj" ],
	san_fabric_crc_errors: ["CRC errors", "ak" ],
	san_fabric_encoding_errors: ["Encoding errors", "al" ],
	san_fabric_conf: ["Configuration", "am" ],
	tier0: ["Tier 0", "an" ],
	tier1: ["Tier 1", "ao" ],
	tier2: ["Tier 2", "ap" ],
	"custom-group-data_in": ["Data IN", "aq" ],
	"custom-group-data_out": ["Data OUT", "ar" ],
	"custom-group-frames_in": ["Frames IN", "as" ],
	"custom-group-frames_out": ["Frames OUT", "at" ],
	"custom-group-credits": ["Credits", "au" ],
	"custom-group-errors": ["Errors", "av" ],
	"san_isl_data_in": ["Data in", "aw" ],
	"san_isl_data_out": ["Data out", "ax" ],
	"san_isl_frames_in": ["Frames in", "ay" ],
	"san_isl_frames_out": ["Frames out", "az" ],
	"san_isl_credits": ["BBCredits", "ba" ],
	"san_isl_crc_errors": ["CRC errors", "bb" ],
	"write_pend": ["Write pending", "bc" ],
	"clean_usage": ["Clean queue", "bd" ],
	"middle_usage": ["Middle queue", "be" ],
	"phys_usage": ["Physical queue", "bf" ],
	"operating_rate": ["Operating rate", "bg" ],
	"busy": ["CPU busy", "bh" ],
	"cifs_io_rate-3_io_rate-4_io_rate-iscsi_io_rate-fcp_io_rate": ["IO rate by protocol", "bi" ],
	"cifs_read_io-3_read_io-4_read_io-iscsi_read_io-fcp_read_io": ["IO read by protocol", "bj" ],
	"cifs_write_io-3_write_io-4_write_io-iscsi_write_io-fcp_write_io": ["IO write by protocol", "bk" ],
	"cifs_data_rate-3_data_rate-4_data_rate-iscsi_data_rate-fcp_data_rate": ["Data rate by protocol", "bl" ],
	"cifs_read-3_read-4_read-iscsi_read-fcp_read": ["Data read by protocol", "bm" ],
	"cifs_write-3_write-4_write-iscsi_write-fcp_write": ["Data write by protocol", "bn" ],
	"cifs_resp_t-3_resp_t-4_resp_t-iscsi_resp_t": ["Response time by protocol", "bo" ],
	"io_rate_b": ["IO back", "bp" ],
	"wafl_exempt-kahuna-exempt-hostOS-nwk_legacy": ["CPU domain busy", "bq" ],
	"custom-group-resp_t": ["Response time", "br" ],
	"custom-group-resp_t_r": ["Response time read", "bs" ],
	"custom-group-resp_t_w": ["Response time write", "bt" ],
	"qdepth": ["Queue depth", "bu" ],
	"calls_rate": ["Calls rate", "bv" ],
	"read_calls": ["Read calls", "bw" ],
	"write_calls": ["Write calls", "bx" ],
	"dirty_cache_pages": ["Dirty cache pages", "by" ],
	"packet_rate": ["Packet rate", "bz" ],
	"read_packet": ["Read packet", "b1" ],
	"write_packet": ["Write packet", "b2" ],
	"read_error": ["Read error", "b3" ],
	"write_error": ["Write error", "b4" ],
	"dnlc_hit": ["DNLC hit", "b5" ],
	"buffer_hit": ["Buffer hit", "b6" ],
	"sum_data_total": ["sum data total", "b7" ],
	"data_rate-subsys": ["data rate subsys", "b8" ],
	"read-subsys": ["read subsys", "b9" ],
	"write-subsys": ["write subsys", "b0" ],
	"io_rate-subsys": ["IO rate subsys", "ca" ],
	"read_io-subsys": ["read IO subsys", "cb" ],
	"write_io-subsys": ["write IO subsys", "cc" ],
	"b2b": ["B2B", "cd" ],
	"crc": ["CRC", "ce" ],
	"io_rate_frontend": ["IO rate frontend", "cf"],
	"read_io_frontend": ["IO read frontend", "cg"],
	"write_io_frontend": ["IO write frontend", "ch"],
	"io_rate_backend": ["IO rate backend", "ci"],
	"read_io_backend": ["IO read backend", "cj"],
	"write_io_backend": ["IO writw backend", "ck"],
	"io_rate_rdf": ["IO rate RDF", "cl"],
	"read_io_rdf": ["IO read RDF", "cm"],
	"write_io_rdf": ["IO write RDF", "cn"],
	"data_rate_b": ["data rate backend", "co"],
	"resp_t_b": ["response time backend", "cp"],
	"WP": ["Write Pending", "cq"],
	"sum_resp_t": ["response time sum", "cr"],
	"alloc": ["allocated", "cs"],
	"data_rate_frontend": ["data rate frontend", "ct"],
	"read_frontend": ["read frontend", "cu"],
	"write_frontend": ["write frontend", "cv"],
	"data_rate_backend": ["data rate backend", "cw"],
	"read_backend": ["read backend", "cx"],
	"write_backend": ["write backend", "cy"],
	"data_rate_rdf": ["data rate_rdf", "cz"],
	"read_rdf": ["read rdf", "c0"],
	"write_rdf": ["write rdf", "c1"],
	"sum_busy_frontend": ["sum busy frontend", "c2"],
	"sum_busy_backend": ["sum busy backend", "c3"],
	"sum_busy_rdf": ["sum busy rdf", "c4"],
	"busy_frontend": ["busy frontend", "c5"],
	"busy_backend": ["busy backend", "c6"],
	"busy_rdf": ["busy rdf", "c7"],
	"io_pending": ["IO pending", "c8"],
	"sum_capacity_aggregated": ["Capacity", "c9"],
	san_data_sum_tot_in_bna: ["IN", "da", "Data IN" ],
	san_data_sum_tot_out_bna: ["OUT", "db", "Data OUT" ],
	san_io_sum_tot_credits_bna: ["Credits", "dc" ],
	san_io_sum_tot_crc_errors_bna: ["CRC errors", "dd" ],
	san_io_sum_tot_encoding_errors_bna: ["Encoding errors", "de" ],
	san_io_sum_tot_in_bna: ["IN", "df", "Frame IN" ],
	san_io_sum_tot_out_bna: ["OUT", "dg", "Frame OUT" ],
	san_fabric_data_in_bna: ["Data in", "dh" ],
	san_fabric_frames_in_bna: ["Frames in", "di" ],
	san_fabric_credits_bna: ["Credits", "dj" ],
	san_fabric_crc_errors_bna: ["CRC errors", "dk" ],
	san_fabric_encoding_errors_bna: ["Encoding errors", "dl" ],
	san_fabric_conf_bna: ["Configuration", "dm" ],
	"sum_busy": ["sum busy", "dn"],
	"transfer_size": ["transfer size", "do"],
	"r_transfer_size": ["read transfer size", "dp"],
	"w_transfer_size": ["write transfer size", "dq"],
	"total_usage": ["total usage", "dr"],
	"san_isl_data_in_bna": ["Data in", "ds" ],
	"san_isl_data_out_bna": ["Data out", "dt" ],
	"san_isl_frames_in_bna": ["Frames in", "du" ],
	"san_isl_frames_out_bna": ["Frames out", "dv" ],
	"san_isl_credits_bna": ["BBCredits", "dw" ],
	"san_isl_crc_errors_bna": ["CRC errors", "dx" ],
	"san_isl_frame_size_in_bna": ["Frame size in", "dy" ],
	"san_isl_frame_size_out_bna": ["Frame size out", "dz" ],
	"san_isl_frame_size_in": ["Frame size in", "d0" ],
	"san_isl_frame_size_out": ["Frame size out", "d1" ],
	"tier0-nl": ["Tier0 Near Line", "d2"],
	"san_cpu": ["CPU", "d3" ],
	"san_mem": ["Memory", "d4" ],
	"san_cpu_tot": ["CPU", "d5" ],
	"san_mem_tot": ["Memory", "d6" ],
	"san_io_size": ["Frame size", "d7" ],
	"compress_cap": ["Compressed capacity", "d8" ],
	"compress_virt_cap": ["Compressed virtual capacity", "d9" ],
	"uncompress_cap": ["Uncompressed capacity", "d0" ],
	"io_rate-FC": ["IO rate", "ea" ],
	"read_io-FC": ["IO read", "eb" ],
	"write_io-FC": ["IO write", "ec" ],
	"data_rate-FC": ["data rate", "ed" ],
	"read-FC": ["read", "ee" ],
	"write-FC": ["write", "ef" ],
	"cifs_ops": ["CIFS ops", "eg" ],
	"nfs_ops": ["NFS ops", "eh" ],
	"resp_t_r_frontend": ["Response time read", "ei" ],
	"resp_t_w_frontend": ["Response time read", "ej" ],
	"queue": ["Queue", "ek" ],
	"ops_rate": ["OPS", "el" ],
	"cfc_dirty": ["cfc dirty", "em" ],
	"cfc_max": ["cfc max", "en" ],
	"del_ack": ["del ack", "eo" ],
	"sum_repl": ["sum replication", "ep" ],
	"repl_rate": ["Replication rate", "eq" ],
	"read_repl": ["read replication", "er" ],
	"write_repl": ["write replication", "es" ],
	"read_ops": ["read ops", "et" ],
	"write_ops": ["write ops", "eu" ],
	"phase": ["Cleaning phase", "ev" ],
	"sum_net": ["sum net", "ew" ],
	"sum_bound_pre_comp": ["sum bound pre comp", "ex" ],
	"sum_bound_net": ["sum bound net", "ey" ],
	"net_rate": ["Network rate", "ez" ],
	"write_net": ["write network", "f0" ],
	"read_net": ["read network", "f1" ],
	"outbound_pre_comp": ["outbound pre comp", "f2" ],
	"inbound_pre_comp": ["inbound pre comp", "f3" ],
	"outbound_net": ["outbound network", "f4" ],
	"inbound_net": ["inbound network", "f5" ],
	"hit_ratio": ["hit ratio", "f6" ],
	"ssd_hit_ratio": ["ssd hit ratio", "f7" ],
	"queue_full_count": ["disk queue full count", "f8"],
	"nfs_ops_rate": ["nfs rate", "f9"],
	"nfsv4_ops_rate": ["nsf4 rate", "ga"],
	"smb1_rate": ["smb1 rate", "gb"],
	"smb2_rate": ["smb2 rate", "gc"],
	"local_capacity": ["local capacity", "gd"],
	"total_comp_factor": ["compression", "ge"],
	"disk_busy": ["busy", "gf"],
	"usage_rate": ["usage rate", "gg"],
	r_cache_miss: [ "read cache miss", "gh" ],
	w_cache_miss: [ "write cache miss", "gi" ],
	read_data_job: [ "read data job", "gj" ],
	write_data_job: [ "write data job", "gk" ],
	read_copy_job: [ "read copy job", "gl" ],
	write_copy_job: [ "write copy job", "gm" ],
	dedupe_ratio: [ "dedupe ratio", "gn" ],
	lan_sum_data_in: ["IN", "go" ],
	lan_sum_data_out: ["OUT", "gp" ],
	lan_sum_pkts_Ucast_in: ["Unicast IN", "gq" ],
	lan_sum_pkts_Ucast_out: ["Unicast OUT", "gr" ],
	lan_sum_pkts_Mcast_in: ["Multicast IN", "gs" ],
	lan_sum_pkts_Mcast_out: ["Multicast OUT", "gt" ],
	lan_sum_pkts_Bcast_in: ["Broadcast IN", "gu" ],
	lan_sum_pkts_Bcast_out: ["Broadcast OUT", "gv" ],
	lan_sum_pkts_errors_in: ["Errors IN", "gw" ],
	lan_sum_pkts_errors_out: ["Errors OUT", "gx" ],
	lan_sum_data_tot_in: ["IN", "gy" ],
	lan_sum_data_tot_out: ["OUT", "gz" ],
	lan_sum_pkts_tot_Ucast_in: ["Unicast IN", "ha" ],
	lan_sum_pkts_tot_Ucast_out: ["Unicast OUT", "hb" ],
	lan_sum_pkts_tot_Mcast_in: ["Multicast IN", "hc" ],
	lan_sum_pkts_tot_Mcast_out: ["Multicast OUT", "hd" ],
	lan_sum_pkts_tot_Bcast_in: ["Broadcast IN", "he" ],
	lan_sum_pkts_tot_Bcast_out: ["Broadcast OUT", "hf" ],
	lan_sum_pkts_tot_errors_in: ["Errors IN", "hg" ],
	lan_sum_pkts_tot_errors_out: ["Errors OUT", "hh" ],
	lan_data: ["Data", "hi" ],
	lan_Ucast_pkts: ["Unicast pkts", "hj" ],
	lan_Mcast_pkts: ["Multicast pkts", "hk" ],
	lan_Bcast_pkts: ["Broadcast pkts", "hl" ],
	lan_errors: ["Errors", "hm" ],
	memory: ["Memory", "hn" ],
	apply_lat: [ "Apply latency", "ho" ],
	commit_lat: [ "Commit latency", "hp" ],
	virt: [ "capacity virtual", "hq" ],
	"tier_ENT": [ "ENT", "hr" ],
	"tier_SSD": [ "SSD", "hs" ],
	"tier_Flash": [ "Flash", "ht" ],
	"tier_HighCapFlash": [ "HighCapFlash", "hu" ],
	"tier_SATA": [ "SATA", "hv" ],
	"tier_NL": [ "NL", "hw" ],
	"san_enc_out": [ "Encoding errors", "hx" ],
	"san_disc_c3": [ "discarded Class 3 frames", "hy" ],
	"san_link_fail": [ "link failures", "hz" ],
	"san_loss_sync": [ "synchronization loss", "ia" ],
	"san_io_sum_enc_out": [ "Encoding errors", "ib" ],
	"san_io_sum_disc_c3": [ "discarded Class 3 frames", "ic" ],
	"san_io_sum_link_fail": [ "link failures", "id" ],
	"san_io_sum_loss_sync": [ "synchronization loss", "ie" ],
	"san_io_sum_tot_enc_out": [ "Encoding errors", "if" ],
	"san_io_sum_tot_disc_c3": [ "discarded Class 3 frames", "ig" ],
	"san_io_sum_tot_link_fail": [ "link failures", "ih" ],
	"san_io_sum_tot_loss_sync": [ "synchronization loss", "ii" ],
	"san_fabric_enc_out": [ "Encoding errors", "ij" ],
	"san_fabric_disc_c3": [ "discarded Class 3 frames", "ik" ],
	"san_fabric_link_fail": [ "link failures", "il" ],
	"san_fabric_loss_sync": [ "synchronization loss", "im" ],
	"san_isl_enc_out": [ "Encoding errors", "in" ],
	"san_isl_disc_c3": [ "discarded Class 3 frames", "io" ],
	"san_isl_link_fail": [ "link failures", "ip" ],
	"san_isl_loss_sync": [ "synchronization loss", "iq" ],
	"san_io_sum_tot_enc_out_bna": [ "Encoding errors", "ir" ],
	"san_io_sum_tot_disc_c3_bna": [ "discarded Class 3 frames", "is" ],
	"san_io_sum_tot_link_fail_bna": [ "link failures", "it" ],
	"san_io_sum_tot_loss_sync_bna": [ "synchronization loss", "iu" ],
	"san_fabric_enc_out_bna": [ "Encoding errors", "iv" ],
	"san_fabric_disc_c3_bna": [ "discarded Class 3 frames", "iw" ],
	"san_fabric_link_fail_bna": [ "link failures", "ix" ],
	"san_fabric_loss_sync_bna": [ "synchronization loss", "iy" ],
	"san_isl_enc_out_bna": [ "Encoding errors", "iz" ],
	"san_isl_disc_c3_bna": [ "discarded Class 3 frames", "ja" ],
	"san_isl_link_fail_bna": [ "link failures", "jb" ],
	"san_isl_loss_sync_bna": [ "synchronization loss", "jc" ],
	"custom-group-enc_out": ["Encoding errors", "jd" ],
	"custom-group-disc_c3": ["discarded Class 3 frames", "je" ],
	"custom-group-link_fail": ["link failures", "jf" ],
	"custom-group-loss_sync": ["synchronization loss", "jg" ],
	"lan_cpu": [ "CPU", "jh" ],
	"lan_mem": [ "Memory", "ji" ],
        "lan_sum_vlan_data_in": [ "IN", "jj" ],
	"lan_sum_vlan_data_out": [ "OUT", "jk" ],
        "lan_sum_vlan_unrouted_data_in": [ "IN", "jl" ],
	"lan_sum_vlan_unrouted_data_out": [ "OUT", "jm" ],
        "lan_sum_vlan_routed_data_in": [ "IN", "jn" ],
	"lan_sum_vlan_routed_data_out": [ "OUT", "jo" ],
        "lan_sum_fexport_data_in": [ "IN", "jp" ],
        "lan_sum_fexport_data_out": [ "OUT", "jq" ],
        "lan_sum_port_channel_data_in": [ "IN", "jr" ],
        "lan_sum_port_channel_data_out": [ "OUT", "js" ]
},

alrtMetrics = {
	io_rate:  'IO rate',
	read_io:  'IO read',
	write_io: 'IO write',
	data_rate:'data rate',
	read:     'data read',
	write:    'data write',
	resp_t:   'resp time',
	resp_t_r: 'resp time read',
	resp_t_w: 'resp time write',
	'data total': 'Data total',
	'data in': 'Data in',
	'data out': 'Data out',
	'frames total': 'Frames total',
	'frames in': 'Frames in',
	'frames out': 'Frames out',
	'CRC errors': 'CRC errors',
	'BBCredits': 'BB credits',
	'cpu': 'CPU',
	'Ucast pkts total': 'Ucast pkts total',
	'Ucast pkts in':    'Ucast pkts in',
	'Ucast pkts out':   'Ucast pkts out',
	'Mcast pkts total': 'Mcast pkts total',
	'Mcast pkts in':    'Mcast pkts in',
	'Mcast pkts out':   'Mcast pkts out',
	'Bcast pkts total': 'Bcast pkts total',
	'Bcast pkts in':    'Bcast pkts in',
	'Bcast pkts out':   'Bcast pkts out',
	'errors total':     'Errors total',
	'errors in':        'Errors in',
	'errors out':       'Errors out',
	'Enc out':          'Enc out',
	'Disc c3':          'Disc c3',
	'Link fail':        'Link fail',
	'Loss sync':        'Loss sync'
},
usercfg = {},
repcfg = {},
repcfgusr = {},
userName = "",
aclAdminGroup = "admins",
isAdmin = false;
/*
if (!Object.keys) { // IE8 hack
	Object.keys = function(obj) {
		var keys = [];

		for (var i in obj) {
			if (obj.hasOwnProperty(i)) {
				keys.push(i);
			}
		}

		return keys;
	};
}

var urlItems = Object.keys(urlItem);
*/

jQuery.extend({ alert: function (message, title, status) {
	title += (status ? " - SUCCESS" : " - FAILURE");
	$("<div></div>").dialog( {
		buttons: { "OK": function () { $(this).dialog("close"); } },
		close: function (event, ui) { $(this).remove(); },
		resizable: false,
		title: title,
		minWidth: 700,
		modal: true
	}).html("<pre>" + message + "</pre>");
	}
});

// Create a jquery style modal confirm dialog
// Usage:
//    $.confirm(
//        "message",
//        "title",
//        function() { /* Ok action here*/
//        });
jQuery.extend({ confirm: function(message, title, okAction) {
	$("<div></div>").dialog({
		// Remove the closing 'X' from the dialog
		open: function(event, ui) { $(".ui-dialog-titlebar-close").hide(); },
		buttons: {
			"OK": function() {
				$(this).dialog("close");
				okAction();
			},
			"Cancel": function() {
				$(this).dialog("close");
			}
		},
		close: function(event, ui) { $(this).remove(); },
		resizable: false,
		minWidth: 700,
		title: title,
		modal: true
	}).text(message);
}
});

var intervals = {
	d: "Last day",
	w: "Last week",
	m: "Last month",
	y: "Last year"
};

jQuery.when( jQuery.ready, jQuery.Deferred( function() {
	$.getJSON(cgiPath + "/genjson.sh?jsontype=env", function(data) {
		$.each(data, function(key, val) {
			sysInfo[key] = val;
		});
		if (sysInfo.sideMenuWidth) {
			lessVars.sideBarWidth = sysInfo.sideMenuWidth + 'px';
			less.modifyVars( lessVars );
		}
		if ($.cookie('sideBarWidth')) {
			lessVars.sideBarWidth = $.cookie('sideBarWidth') + 'px';
			less.modifyVars( lessVars );
		}
		if (sysInfo.guidebug == 1) {
			$("#savecontent input:submit").button();
			$("#savecontent").show();
		}
		var logo = "<a href='http://www.stor2rrd.com/' target='_blank'><img src='css/images/logo-stor2rrd.png' alt='STOR2RRD HOME' title='STOR2RRD HOME' style='float: left; margin-top: 13px; margin-left:0px; border: 0; opacity: 0.7;'></a>";

		// white labeling
		if (sysInfo.wlabel) {
			prodName = sysInfo.wlabel;
			switch(prodName) {
				case "7eysight":
					logo = "<a href='http://www.7eysight.com/' target='_blank'><img src='css/images/7eysight_logo.png' alt='7eysight HOME' title='7eysight HOME' style='float: left; margin-top: 4px; margin-left:22px; border: 0; opacity: 0.8;'></a>";
				$( "#header" ).css("background", "#23A0E5");
				break;
				case "CIRO":
					logo = "<a href='https://www.cutaway.it/documentation-ciro' target='_blank'><img src='css/images/logo_ciro.png' style='float: left; margin-top: 8px; margin-left:22px; width: 144px; border: 0; opacity: 0.8;'></a>";
					lessVars.headerBg = "#262626";
					lessVars.headerFg = "#fff";
					lessVars.sideBarBg = "#8a8a8a";
					lessVars.paneSepLine = "#262626";
					lessVars.dialogTitleBarBg = "#262626";
					$( "#footer" ).hide();
					$( "#menusw" ).css("bottom", 0);
					lessVars.sideBarBottom = "29px";
					less.modifyVars( lessVars );
				break;
				case "Dark":
					prodName = "STOR2RDD";
					logo = "<a href='http://www.stor2rrd.com/' target='_blank'><img src='css/images/logo_stor_dark.png' alt='STOR2RRD website' title='STOR2RRD website' style='float: left; margin-top: 12px; margin-left:27px; width: 164px; border: 0; opacity: 0.8;'></a>";
					lessVars.headerBg = "#262626";
					lessVars.headerFg = "#fff";
					lessVars.sideBarBg = "#6a6a6a";
					lessVars.paneSepLine = "#666";
					lessVars.dialogTitleBarBg = "#262626";
					lessVars.contentBg = "#" + sysInfo.picture_color;
					lessVars.switchbg = "#666";
					lessVars.switchfg = "#fff";
					// $( "#footer" ).hide();
					// $( "#menusw" ).css("bottom", 0);
					// lessVars.sideBarBottom = "29px";
					less.modifyVars( lessVars );
				break;
			}
			$(document).attr("title", prodName);
		}
		$( logo ).insertBefore( "#subheader" );
		if (sysInfo.useACL > 0) {
			var lhtml = '<span id="loggedin" title="' + sysInfo.gid + '"><b>' + sysInfo.uid + '</b></span><a href="#"><img src="css/images/logout-20.png" style="vertical-align: middle; margin-top: -2px; margin-left: 0.5em;" title="Click to log out" alt="Click to log out"></a>';
			$( "#uid" ).html(lhtml);
			$('#uid a').on('click', function(e){
				e.preventDefault();
				if (navigator.userAgent.indexOf('Chrome') >= 0) {
					document.location = document.location.protocol + "//reset:reset@" + document.location.hostname + document.location.pathname;
				}
				// HTTPAuth Logout code based on: http://tom-mcgee.com/blog/archives/4435
				try {
					// This is for Firefox
					$.ajax({
						// This can be any path on your same domain which requires HTTPAuth
						url: document.location.origin + document.location.pathname,
						username: 'reset',
						password: 'reset',
						// If the return is 401, refresh the page to request new details.
						statusCode: { 401: function() {
							document.location = document.location;
						}
						}
					});
				} catch (exception) {
					// Firefox throws an exception since we didn't handle anything but a 401 above
					// This line works only in IE
					if (!document.execCommand("ClearAuthenticationCache")) {
						// exeCommand returns false if it didn't work (which happens in Chrome) so as a last
						// resort refresh the page providing new, invalid details.
						document.location = document.location.protocol + "//reset:reset@" + document.location.hostname + document.location.pathname;
					}
				}
			});

			$( "#loggedin" ).tooltip ({
				position: {
					my: "left top",
					at: "left bottom+5"
				},
				open: function(event, ui) {
					if (typeof(event.originalEvent) === 'undefined') {
						return false;
					}
					var $id = $(ui.tooltip).attr('id');
					// close any lingering tooltips
					$('div.ui-tooltip').not('#' + $id).remove();
					// ajax function to pull in data and add it to the tooltip goes here
				},
				close: function(event, ui) {
					ui.tooltip.on("mouseenter mouseleave", function() {
						$(this).stop(true).fadeTo(400, 1);
					},
					function() {
						$(this).fadeOut('400', function() {
							$(this).remove();
						});
					});
				},
				content: function () {
					return $(this).prop('title');
				}
			});
		}
		if (sysInfo.isAdmin == 1) {
			isAdmin = true;
		}
		if (sysInfo.aclAdminGroup) {
			aclAdminGroup = sysInfo.aclAdminGroup;
		}
		if (sysInfo.useACL > 0 && sysInfo.showSAN != 1) {
			$(".sansrch").hide();
		}
	});
}))

$(document).ready(function() {
	$window = $(window),
	d = new Date(),
	n = d.getFullYear();
	if (typeof $.cookie('sansrch') !== 'undefined') {
		$("#sansrch").prop('checked', $.cookie('sansrch'));
	}
	if (typeof $.cookie('volsrch') !== 'undefined') {
		$("#volsrch").prop('checked', $.cookie('volsrch'));
	}
	$("#copyright").hide().html('&copy; ' + n + ' <a href="http://www.xorux.com" target="_blank">XORUX</a>').show(1000);
	$.ajaxSetup({
		traditional: true,
		cache: false
	});

	// Bind to StateChange Event
	History.Adapter.bind(window, 'statechange', function() { // Note: We are using statechange instead of popstate
		var state = History.getState(); // Note: We are using History.getState() instead of event.state
		var menuTree = $("#side-menu").fancytree("getTree");
		if (state.data.menu && state.internal) {
			curTab = state.data.tab;
			browserNavButton = true;
			if (state.data.form) {
				var data = restoreData(state.data.form);
				$("#content").html(data.html);
				myreadyFunc();
				$("#content").scrollTop(data.scroll);
				$("#title").html(data.title);
			} else if (state.data.menu == menuTree.getActiveNode().key) {
				menuTree.reactivate();
			} else {
				menuTree.activateKey(state.data.menu);
			}
		}
	});



	$("#data-src-info").dialog({
		dialogClass: "info",
		minWidth: 400,
		modal: true,
		autoOpen: false,
		show: {
			effect: "fadeIn",
			duration: 500
		},
		hide: {
			effect: "fadeOut",
			duration: 200
		},
		position: {
			my: "right top",
			at: "right top",
			of: $("#content")
		},
		buttons: {
			OK: function() {
				$(this).dialog("close");
			}
		}
	});
	$("#rperf-notice").dialog({
		dialogClass: "info",
		minWidth: 500,
		modal: true,
		autoOpen: false,
		show: {
			effect: "fadeIn",
			duration: 500
		},
		hide: {
			effect: "fadeOut",
			duration: 200
		},
		buttons: {
			OK: function() {
				$(this).dialog("close");
			}
		}
	});
	var groupMenuByStorageType = $.cookie('groupMenuByStorageType');
	var mUrl = groupMenuByStorageType ? '/genjson.sh?jsontype=gmenu' : '/genjson.sh?jsontype=menuh';
	$("#side-menu").fancytree({
		extensions: ["filter", "persist"],
		source: {
			url: cgiPath + mUrl
		},
		filter: {
			mode: "hide"
		},
		icon: false,
		selectMode: 1,
		clickFolderMode: 2,
		activate: function(event, data) {
			if (curNode != data.node) {
				if (curNode && !browserNavButton) {
					curTab = 0;
				}
				curNode = data.node;
			}
			if (curNode.data.href) {
				autoRefresh();
				var url = curNode.data.href;
				if (curLoad) {
					curLoad.ajaxStop(); //cancel previous load
				}
				$('#content').empty();
				$('#content').append("<div style='width: 100%; height: 100%; text-align: center'><img src='css/images/sloading.gif' style='margin-top: 200px'></div>");
				$('#subheader fieldset').hide();
				if (curNode.title == "Capacity") {
					setTitle(curNode);
					if (curNode.data.hash) {
						urlMenu = curNode.data.hash;
					} else {
						urlMenu = curNode.key.substring(1);
					}
					History.pushState({
						menu: curNode.key,
						tab: 0
					}, prodName + " - " + $('#title').text(), '?menu=' + urlMenu + "&tab=" + 0);
					browserNavButton = false;
					if (url.indexOf("capacity.html") >= 0) {
						genCapacity();
						return;
					} else if (curNode.data.altname != "cap") {
						genPoolCapacity(curNode.parent.title, curNode.data.href);
						return;
					}
				}
				if (/name=fast_sg/i.test(curNode.data.href)) {
					setTitle(curNode);
					if (curNode.data.hash) {
						urlMenu = curNode.data.hash;
					} else {
						urlMenu = curNode.key.substring(1);
					}
					History.pushState({
						menu: curNode.key,
						tab: 0
					}, prodName + " - " + $('#title').text(), '?menu=' + urlMenu + "&tab=" + 0);
					browserNavButton = false;

					fastSG(curNode.parent.title, curNode.data.href);
					return;
				}
				curLoad = $('#content').load(url, function() {
					imgPaths();
					setTimeout(function() {
						myreadyFunc();
						setTitle(curNode);
						var tabName = "";
						if ($('#tabs').length) {
							tabName = " [" + $('#tabs li.ui-tabs-active').text() + "]";
						}
						if (curNode.data.hash) {
							urlMenu = curNode.data.hash;
						} else {
							urlMenu = curNode.key.substring(1);
						}
						History.pushState({
							menu: curNode.key,
							tab: curTab
						}, prodName + " - " + $('#title').text() + tabName, '?menu=' + urlMenu + "&tab=" + curTab);
						browserNavButton = false;
					}, 10);
				});
			}
		},
		click: function(event, data) { // allow re-loads
			var node = data.node;
			if (!node.isExpanded()) {  // jump directly to POOL/IO when opening storage
				if ((node.getLevel() == 2 && ! groupMenuByStorageType) || (node.getLevel() == 3 && groupMenuByStorageType)) {
					if (node.data.type == "SAN" || node.data.type == "LAN") {
						node.visit(function(pNode) {
							if (pNode.title == "Data") {
								event.preventDefault();
								pNode.setActive();
								pNode.makeVisible({
									noAnimation: true,
									noEvents: true,
									scrollIntoView: true
								});
								// chNode.setExpanded()
								return false;
							}
						});
					} else {
						var leaveMe = false;
						node.visit(function(chNode) {
							if ( ( sysInfo.jump_to_rank && chNode.data.bl == "RANK") || (!sysInfo.jump_to_rank && chNode.data.bl == "POOL") ) {
								chNode.visit(function(pNode) {
									if (pNode.title == "IO" || pNode.title == "Data") {
										event.preventDefault();
										pNode.setActive();
										pNode.makeVisible({
											noAnimation: true,
											noEvents: true,
											scrollIntoView: true
										});
										// chNode.setExpanded()
										leaveMe = true;
										return false;
									}
								});
							}
							if (leaveMe) {
								return false;
							}
						});
					}
				}
				else if (node.getLevel() == 3) {
					node.visit(function(chNode) {
						if ( chNode.title == "IO" || chNode.title == "Data" || chNode.title == "Total") {
							event.preventDefault();
							chNode.setActive();
							chNode.makeVisible({
								noAnimation: true,
								noEvents: true,
								scrollIntoView: true
							});
							// chNode.setExpanded()
							return false;
						}
					});
				}
			}
			if (node.isActive() && node.data.href) {
				data.tree.reactivate();
			}
		},
		init: function() {
			var $tree = $(this).fancytree("getTree");
			var menuPos = getUrlParameter('menu');
			var tabPos = getUrlParameter('tab');
			var serverPos = getUrlParameter('server');
			var lparPos = getUrlParameter('lpar');
			var fakeUrl = "";
			checkStatus();
			checkCopyServices();
			checkSnapshot();
			hashTable = [];
			$tree.visit(function(node) {
				if (sysInfo.guidebug == 1) {
					node.tooltip = node.data.href;
					node.renderTitle();
				}
				node.data.noalias = node.title.replace(/ \[.*\]/g, "");
				if (node.data.hash && node.data.hmc) {
					var type = node.data.href.match(/type=([^&]*)/i);
					if (type) {
						type = type[1];
					}
					if (node.data.agg) {
						hashTable[node.data.hash] = {
							"hmc": node.data.hmc,
							"srv": node.data.srv,
							"lpar": "sum",
							"type": type
						};
					} else if (node.data.altname) {
						hashTable[node.data.hash] = {
							"hmc": node.data.hmc,
							"srv": node.data.srv,
							"lpar": node.data.altname,
							"longname": node.title,
							"type": type
						};
					} else {
						hashTable[node.data.hash] = {
							"hmc": node.data.hmc,
							"srv": node.data.srv,
							"lpar": node.title,
							"type": type
						};
					}
				}
			});
			if (tabPos) {
				curTab = tabPos;
			}
			if (serverPos) {
				if (lparPos) {
					fakeUrl = "?item=lpar&server=" + serverPos + "&lpar=" + lparPos;
				} else {
					fakeUrl = "?item=pool&server=" + serverPos + "&lpar=pool";
				}
				backLink(fakeUrl);
				return false;
			}
			if (menuPos) {
				if (menuPos == "extnmon") {
					var href = window.location.href;
					var qstr = href.slice(href.indexOf('&start-hour') + 1);
					var hashes = qstr.split('&');
					// var txt = hashes[13].split("=")[1];
					var txt = decodeURIComponent(hashes[14].split("=")[1]);

					txt = txt.replace("--unknown","");
					txt = txt.replace("--NMON--","");
					$("#content").load("/lpar2rrd-cgi/lpar2rrd-external-cgi.sh?" + qstr, function(){
						imgPaths();
						$('#title').text(txt);
						$('#title').show();
						myreadyFunc();
						// loadImages('#content img.lazy');
						if (timeoutHandle) {
							clearTimeout(timeoutHandle);
						}
					});
				} else {
					$tree.visit(function(node) {
						if (node.data.hash == menuPos) {
							node.setExpanded(true);
							node.setActive();
							return false;
						}
					});
				}
			} else if (!$tree.activeNode) {
				$tree.getFirstChild().setActive();
			}
		}
	});

	var $tree = $("#side-menu").fancytree("getTree");

	$("#lparsearch").on("submit", function(event) {
		event.preventDefault();
		var svol = $("#volsrch").is(':checked');
		var ssan = $("#sansrch").is(':checked');
		if (! (svol || ssan) ) {
			alert("Please select at least one search category!");
			return false;
		}
		var searchTitle;
		if (svol && ssan) {
			searchTitle = "Volume & SAN search results";
		} else if (svol) {
			searchTitle = "Volume search results";
		} else {
			searchTitle = "SAN search results";
		}

		if (timeoutHandle) {
			clearTimeout(timeoutHandle);
		}
		$('#content').empty();

		$('#content').append("<div style='width: 100%; height: 100%; text-align: center'><img src='css/images/sloading.gif' style='margin-top: 200px'></div>");
		$('#title').text(searchTitle);
		var postData = $(this).serialize();
		if (sysInfo.guidebug == 1) {
			copyToClipboard(postData);
		}
		$('#content').load(this.action, postData, function() {
			if (curNode.data.hash) {
				urlMenu = curNode.data.hash;
			} else {
				urlMenu = curNode.key.substring(1);
			}
			History.pushState({
				menu: curNode.key,
				tab: curTab,
				form: "lparsrch"
			}, prodName + " - " + searchTitle, '?menu=' + urlMenu + "&tab=" + curTab);
			imgPaths();
			myreadyFunc();
			saveData("lparsrch"); // save when page loads

		});
	});
	$("#lparsearch input:checkbox").on("click", function(event) {
		if ($(this).is(":checked")) {
			$.cookie(this.id, true, {
				expires: 365
			});
		} else {
			$.cookie(this.id, false, {
				expires: 365
			});
		}
	});

	/* BUTTONS */

	$("#collapseall").button({
		text: false,
		icons: {
			primary: "ui-icon-minus"
		}
	})
		.on("click", function() {
			$tree.visit(function(node) {
				node.setExpanded(false, {
					noAnimation: true,
					noEvents: true
				});
			});
		});
	$("#expandall").button({
		text: false,
		icons: {
			primary: "ui-icon-plus"
		}
	})
		.on("click", function() {
			$tree.visit(function(node) {
				node.setExpanded(true, {
					noAnimation: true,
					noEvents: true
				});
			});
		});
	$("#filter").button({
		text: false,
		icons: {
			primary: "ui-icon-search"
		}
	})
	.on("click", function() {
		// Pass text as filter string (will be matched as substring in the node title)
		var match = $("#menu-filter").val();
		if ($.trim(match) !== "") {
			var re = new RegExp(match, "i");
			var n = $tree.filterNodes(function(node) {
				var parentTitle = node.parent.title;
				var matched = re.test(node.data.str);
				if (matched) {
					node.setExpanded(true, true);
					if (parentTitle != "Removed") {
						if ((parentTitle != "Items") || ((parentTitle == "Items") && re.test(node.title))) {
							node.makeVisible({
								noAnimation: true,
								noEvents: true,
								scrollIntoView: false
							});
						}
					}
				}
				return matched;
			});
			// $("#expandall").trigger("click");
			$("#clrsrch").button("enable");
		}
	});

	$("#clrsrch").button({
		text: false,
		disabled: true,
		icons: {
			primary: "ui-icon-close"
		}
	})
		.on("click", function() {
			$("#menu-filter").val("");
			$tree.clearFilter();
			$(this).button("disable");
		});

	/*
	* Event handlers for menu filtering
	*/
	$("#menu-filter").on("keypress", function(event) {
		var match = $(this).val();
		if (event.which == 13) {
			event.preventDefault();
			if (match > "") {
				$("#filter").trigger("click");
			}
		}
		if (event.which == 27 || $.trim(match) === "") {
			$("#clrsrch").trigger("click");
		}
	}).trigger("focus");

	if (navigator.userAgent.indexOf('MSIE') >= 0) { // MSIE
		placeholder();
		$("input[type=text]").focusin(function() {
			var phvalue = $(this).attr("placeholder");
			if (phvalue == $(this).val()) {
				$(this).val("");
			}
		});
		$("input[type=text]").focusout(function() {
			var phvalue = $(this).attr("placeholder");
			if ($(this).val() === "") {
				$(this).val(phvalue);
			}
		});
		$("#menu-filter").blur();
	}

	$("#savecontent").on("submit", function(event) {
		var conf = confirm("This will generate file named <debug.txt> containing HTML code of main page. Please save it to disk and attach to the bugreport");
		if (conf === true) {
			var postDataObj = {
				html: "<!-- " + navigator.userAgent + "-->\n" + $("#content").html()
			};
			var postData = "<!-- " + navigator.userAgent + "-->\n" + $("#content").html();
			$("#tosave").val(postData);
			return;
		} else {
			event.preventDefault();
		}

	});
	$("#switchstyle").change(function() {
		if ($(this).is(":checked")) {
			$('#style[rel=stylesheet]').attr("href", "css/darkstyle.css");
		} else {
			$('#style[rel=stylesheet]').attr("href", "css/style.css");
		}
	});
	$("#ms1").checkboxradio({
		create: function( event, ui ) {
			$("#ms1").prop("checked", $.cookie('groupMenuByStorageType')).checkboxradio('refresh');
		}
	});

	$("#menusw").on("change", function() {
		$.cookie('groupMenuByStorageType', $("#ms1").is(":checked"), {
			expires: 360
		});
		if ($("#ms1").is(":checked")) {
			$("#side-menu").fancytree("getTree").reload({
				url: cgiPath + '/genjson.sh?jsontype=gmenu'
			});
		} else {
			$("#side-menu").fancytree("getTree").reload({
				url: cgiPath + '/genjson.sh?jsontype=menuh'
			});
		}
	});

	setInterval(function () {
		checkStatus();
		checkCopyServices();
		checkSnapshot();
	}, 600000);

	$("#pdf").on("click", function(event) {
		var tpm = img2pdf();
		var topost = {};
		var grcnt = 0;
		topost.sections = [];
		topost.graphs = [];
		var rnd = Math.random().toString(36).substring(7);
		$.each(tpm, function(index, value) {
			topost.sections.push(index + ":" + value.length);
			$.each(value, function(i, url) {
				topost.graphs.push(url);
				grcnt++;
			});
		});

		topost.title = prodName + "-report";
		topost.free = sysInfo.free;
		topost.id = rnd;
		topost.cmd= "gen";
		$.getJSON(cgiPath + "/genpdf.sh?cmd=test", function( data ) {
			if (data.success) {
				var ttt = "<div id='progressDialog'><div id='pdfprogressbar'><div class='progress-label'>Please wait...</div></div><input type='button' value='Cancel' id='terminate' data-id='" + rnd + "'></div>";
				progressDialog = $( ttt ).dialog({
					dialogClass: "no-close",
					minWidth: 400,
					height: 136,
					modal: true,
					title: "PDF export - processing graphs...",
					show: {
						effect: "fadeIn",
						duration: 500
					},
					hide: {
						effect: "fadeOut",
						duration: 200
					},
					open: function( event, ui ) {
						$( "#pdfprogressbar" ).progressbar({
							"max": grcnt
						});
						$( "#terminate" ).on("click", function(e) {
							$.getJSON(cgiPath + "/genpdf.sh?cmd=stop&id=" + this.dataset.id, function(data) {
								if(data.status=="terminated") {
								}
							});
						});
					}
				});
				$.ajax( {
					method: "POST" ,
					url: cgiPath + "/genpdf.sh",
					data: topost
				}).done( function( data ) {
				});
				setTimeout(function() {
					getPDFstatus(rnd);
				}, 100);
			} else {
				var info = "<p>Please install the <a href='http://www.stor2rrd.com/pdf-install.htm' target='_blank'>required pre-requisites</a>.</p>";
				info += "<p>Error message follows:</p>";
				$("<div></div>").dialog( {
					buttons: { "OK": function () { $(this).dialog("close"); } },
					close: function (event, ui) { $(this).remove(); },
					resizable: false,
					title: "PDF export failed",
					minWidth: 800,
					modal: true
				}).html(info + "<pre>" + data.log + "</pre>");
			}
		});
	});
	$("#resizer").draggable({
		// animate: true,
		axis: "x",
		cursor: "move",
		stop: function( event, ui ) {
			var newWidth = ui.position.left;
			lessVars.sideBarWidth = newWidth + 'px';
			less.modifyVars( lessVars );
			$.cookie('sideBarWidth', newWidth, {
				expires: 360
			});
		}
	});


});

function imgPaths() {
	$('#content img').each(function() {
		var imgsrc = $(this).attr("src");
		if (/loading\.gif$/.test(imgsrc)) {
			$(this).attr("src", 'css/images/sloading.gif');
		} else if (!/\//.test(imgsrc)) {
			var n = $('#side-menu').fancytree('getActiveNode');
			var url = n.data.href;

		$(this).attr("src", url.substr(0, url.lastIndexOf('/') + 1) + imgsrc);
		}
	});
}

function autoRefresh() {
	if (timeoutHandle) {
		clearTimeout(timeoutHandle);
	}
	if (curNode.title != "Alerting configuration") {
		timeoutHandle = setTimeout(function() {
			$("#side-menu").fancytree("getTree").reactivate();
			autoRefresh();
		}, 600000); /* 600000 = 10 minutes */
	}
}

/********* Execute after new content load */

function myreadyFunc() {

	if (sysInfo.demo == "1") {
		$("#demo-notice").removeClass("hidden");
	}

	loaded = 0;
	var dbHashes = $.cookie('dbHashes');
	$("div.zoom").uniqueId();
	$("#pdf").hide();

	if (!dbHashes) {
		dbHash = [];
	} else {
		dbHash = dbHashes.split(":");
		$.each(dbHash, function(index, value) {
			if (value.length == 9) {
				dbHash[index] = value.substr(0, 7) + "x" + value.substr(7);
			}
		});
	}

	$('#tabs').tabs({
		create: function( event, ui ) {
			var tabTitles = $( "#tabs li a" ).map(function(i, el) {
				return $(el).text();
			}).get();
			var tabPos = jQuery.inArray( lastTabName, tabTitles );
			if (tabPos !== -1) {
				curTab = tabPos;
			} else {
				// curTab = 0;
			}
			$( "#tabs" ).tabs( "option", "active", curTab );
		},
		beforeLoad: function( event, ui ) {
			ui.panel.html('<img src="css/images/sloading.gif" style="display: block; margin-left: auto; margin-right: auto; margin-top: 10em" />');
		},
		activate: function(event, ui) {
			curTab = ui.newTab.index();
			lastTabName = $('#tabs li.ui-tabs-active').text();
			var tabName = "";
			if ($("#tabs").length) {
				tabName = " [" + $('#tabs li.ui-tabs-active').text() + "]";
			}
			if (curNode) {
				if (curNode.data.hash) {
					urlMenu = curNode.data.hash;
				} else {
					urlMenu = curNode.key.substring(1);
				}
				History.pushState({
					menu: curNode.key,
					tab: curTab
				}, prodName + " - " + $("#title").text() + tabName, '?menu=' + urlMenu + "&tab=" + curTab);
			}
			setTitle(curNode);

			if ($("#emptydash").length) {
				$("ul.dashlist li").remove();
				genDashboard();
				autoRefresh();
			} else {
				autoRefresh();
				loadImages("#" + ui.newPanel.attr('id') + " img.lazy");
				hrefHandler();
				dataSource();
				showHideSwitch();
				sections();
			}
		},
		load: function(event, ui) {
			hrefHandler();
			var $t = ui.panel.find('table.tablesorter');
			if ($t.length) {
				tableSorter($t);
			}
			$t = ui.panel.find('#allpooltree');
			if ($t.length) {
				$("#allpooltree").fancytree({
					extensions: ["persist", "table"],
					persist: {
						cookiePrefix: "allpooltree-"
					},
					clickFolderMode: 3,
					selectMode: 1,
					/* init: function (){
					$(this).fancytree("option", "selectMode", 3);
					$(this).fancytree("getTree").getFirstChild().fixSelection3FromEndNodes();
					},
					*/
					icon: false,
					table: {
						indentation: 20,
						nodeColumnIdx: 2,
						checkboxColumnIdx: 0
					},
					create: function() {
						$.getJSON(cgiPath + "/heatmapcfg.sh?cmd=tiers", function(data) {
							tiersList = data;
						});
					},
					init: function () {
						$.getJSON(cgiPath + "/heatmapcfg.sh?cmd=poolstiers", function(data) {
							poolsTiers = data;
							var $tree = $("#allpooltree").fancytree("getTree");
							$tree.visit(function(node) {
								if ( node.getLevel() == 2 ) {
									storage = node.parent.title;
									node.data.tier = "tier1";
									if (poolsTiers[storage] && poolsTiers[storage][node.title]) {
										if ($.inArray(poolsTiers[storage][node.title], tiersList) >= 0) {
											node.data.tier = poolsTiers[storage][node.title];
										}
									}
								}
							});
						});
					},
					renderColumns: function(event, data) {
						var node = data.node,
						$select = $("<select class='tiersel' name='tier' />"),
						$tdList = $(node.tr).find(">td");
						if ( node.getLevel() == 2 ) {
							// (index #0 is rendered by fancytree by adding the checkbox)
							// (index #2 is rendered by fancytree)
							$.each(tiersList, function(i, val) {
								$("<option />", {text: val, value: val, selected: (node.data.tier == val)}).appendTo($select);
							});
							$tdList.eq(3).html($select);
						}
					},
					source: {
						url: cgiPath + '/genjson.sh?jsontype=pools'
					}
				});
				$( "#allpooltree" ).on('change', "select.tiersel", function(event, data) {
					$.ui.fancytree.getNode(event.target).data[event.target.name] = event.target.value;
				});
				$("#savehmcfg").on("click", function(event) {
					event.preventDefault();
					$("#aclfile").text("");
					var delimiter = "\\:";
					var acltxt = "Storage_name,Pool_name,Tier\n";
					$("#allpooltree").fancytree("getTree").visit(function(node) {
						if (node.getLevel() == 2) {
							var storage = node.parent.title.replace(/\:/g, delimiter);
							if (node.data.tier && node.data.tier != "tier1") {
								acltxt += storage + "," + node.title + "," + node.data.tier + "\n";
							}
						}
					});
					var postdata = {cmd: "save", 'acl': acltxt};
					$.post( cgiPath + "/heatmapcfg.sh?cmd=save", postdata, function( data ) {
						var returned = data;
						if ( returned.status == "success" ) {
							$("#aclfile").text(returned.cfg).show();
						}
						$(returned.msg).dialog({
							dialogClass: "info",
							title: "Heatmap configuration save - " + returned.status,
							minWidth: 600,
							modal: true,
							show: {
								effect: "fadeIn",
								duration: 500
							},
							hide: {
								effect: "fadeOut",
								duration: 200
							},
							buttons: {
								OK: function() {
									$(this).dialog("close");
								}
							}
						});
					});
				});
			}
			if ($("#aclgrptree").length) {
				if (timeoutHandle) {
					clearTimeout(timeoutHandle);
				}
				ACLcfg();
			}
			if ( $("#mirroring").length ) {
				copyServices();
			}
			if ( $("#snapshotting").length ) {
				snapshotting();
			}

		}
	});

	setTimeout(function() {
		if ($("#tabs").length) {
			loadImages("div[aria-hidden=false] img.lazy");
		} else {
			loadImages('#content img.lazy');
		}
		dataSource();
	}, 100);

	$("table.tablesorter").each(function() {
		tableSorter(this);
	});

	hrefHandler();

	$("#subheader fieldset").hide();

	$("#nmonsw").buttonset();

	$("#nmonsw").on("click", function() {
		sections();
		var newTabHref = '';
		var activeTab = $('#tabs li.ui-tabs-active.tabfrontend,#tabs li.ui-tabs-active.tabbackend').text();
		showHideSwitch();
		if (activeTab) {
			if ($("#nmr1").is(':checked')) {
				newTabHref = $('#tabs li.tabfrontend a:contains("' + activeTab + '")').attr("href");
			} else {
				newTabHref = $('#tabs li.tabbackend a:contains("' + activeTab + '")').attr("href");
			}
			$("[href='" + newTabHref + "']").trigger("click");
		}
	});

	if ( $("#histrep").length ) {
		var checkedBoxes = $.cookie('HistFormCheckBoxes');
		if ( !checkedBoxes ) {
			// Set basic set of output data if not defined
			checkedBoxes = ["io_rate", "read_io", "write_io", "data_rate", "read", "write"];
			$( "input:checkbox[value=san_data]" ).prop('checked', true);
			$( "input:checkbox[value=lan_data]" ).prop('checked', true);
		}
		$.each(checkedBoxes, function(index, value) {
			$( "input:checkbox[value=" + value + "]" ).prop('checked', true);
		});
	}

	$("#radio").buttonset();
	$("#radiosrc").buttonset();

	$("input[type=checkbox][name=lparset]").change(function() {
		if ($("#radios2").is(':checked')) {
			$("#lpartree").fancytree("getTree").reload({
				url: cgiPath + '/genjson.sh?jsontype=hmcsel'
			});
			$("#lparfieldset legend").text("HMC | Server | LPAR");
		} else {
			$("#lpartree").fancytree("getTree").reload({
				url: cgiPath + '/genjson.sh?jsontype=lparsel'
			});
			$("#lparfieldset legend").text("Server | LPAR");
		}
	});

	fancyBox();

	var now = new Date();
	var twoWeeksBefore = new Date();
	var yesterday = new Date();
	var nowPlusHour = new Date();
	yesterday.setDate(now.getDate() - 1);
	twoWeeksBefore.setDate(now.getDate() - 14);
	nowPlusHour.setHours(now.getHours() + 1);


	var startDateTextBox = $('#fromTime');
	var endDateTextBox = $('#toTime');

	$("#fromTime").datetimepicker({
		defaultDate: '-1d',
		dateFormat: "yy-mm-dd",
		timeFormat: "HH:00",
		maxDate: nowPlusHour,
		changeMonth: true,
		changeYear: true,
		showButtonPanel: true,
		showOtherMonths: true,
		selectOtherMonths: true,
		showMinute: false,
		onClose: function(dateText, inst) {
			if (endDateTextBox.val() !== '') {
				var testStartDate = startDateTextBox.datetimepicker('getDate');
				var testEndDate = endDateTextBox.datetimepicker('getDate');
				if (testStartDate > testEndDate) {
					endDateTextBox.datetimepicker('setDate', testStartDate);
				}
			} else {
				endDateTextBox.val(dateText);
			}
		},
		onSelect: function(selectedDateTime) {
			endDateTextBox.datetimepicker('option', 'minDate', startDateTextBox.datetimepicker('getDate'));
		}
	});
	if ($("#fromTime").length) {
		var fromTime = $.cookie('fromTimeField');
		if ( fromTime ) {
			$("#fromTime").datetimepicker("setDate", fromTime);
		} else {
			$("#fromTime").datetimepicker("setDate", yesterday);
		}
	}

	$("#toTime").datetimepicker({
		defaultDate: 0,
		dateFormat: "yy-mm-dd",
		timeFormat: "HH:00",
		maxDate: nowPlusHour,
		changeMonth: true,
		changeYear: true,
		showButtonPanel: true,
		showOtherMonths: true,
		selectOtherMonths: true,
		showMinute: false,
		onClose: function(dateText, inst) {
			if (startDateTextBox.val() !== '') {
				var testStartDate = startDateTextBox.datetimepicker('getDate');
				var testEndDate = endDateTextBox.datetimepicker('getDate');
				if (testStartDate > testEndDate) {
					startDateTextBox.datetimepicker('setDate', testEndDate);
				}
			} else {
				startDateTextBox.val(dateText);
			}
		},
		onSelect: function(selectedDateTime) {
			startDateTextBox.datetimepicker('option', 'maxDate', endDateTextBox.datetimepicker('getDate'));
		}
	});
	if ($("#toTime").length) {
		var toTime = $.cookie('toTimeField');
		if ( toTime ) {
			$("#toTime").datetimepicker("setDate", toTime);
		} else {
			$("#toTime").datetimepicker("setDate", now);
		}
	}

	// History reports form submit
	$("#histrep").on("submit", function(event) {
		var outputDataCount = $( "input:checked[name=output]" ).length;
		if (!outputDataCount) {
			alert("Please select at least one data output for report!");
			return false;
		}

		var $poolTree = $("#pooltree").fancytree("getTree");
		var $portTree = $("#porttree").fancytree("getTree");
		var $rankTree = $("#ranktree").fancytree("getTree");
		var $voluTree = $("#voltree").fancytree("getTree");
		var $hostTree = $("#hosttree").fancytree("getTree");

		var selCount = 0;
		var pota, prta, rata, vota, hota;

		if ($poolTree.length !== 0) {
			selCount += $poolTree.getSelectedNodes().length;
			$poolTree.generateFormElements(true, false, false);
			pota = 'ft_' + $poolTree._id + "[]";
		}
		if ($portTree.length !== 0) {
			selCount += $portTree.getSelectedNodes().length;
			$portTree.generateFormElements(true, false, { stopOnParents: false });
			prta = 'ft_' + $portTree._id + "[]";
		}
		if ($rankTree.length !== 0) {
			selCount += $rankTree.getSelectedNodes().length;
			$rankTree.generateFormElements(true, false, false);
			rata = 'ft_' + $rankTree._id + "[]";
		}
		if ($voluTree.length !== 0) {
			selCount += $voluTree.getSelectedNodes().length;
			$voluTree.generateFormElements(true, false, false);
			vota = 'ft_' + $voluTree._id + "[]";
		}
		if ($hostTree.length !== 0) {
			selCount += $hostTree.getSelectedNodes().length;
			$hostTree.generateFormElements(true, false, false);
			hota = 'ft_' + $hostTree._id + "[]";
		}

		if ( selCount === 0) {
			alert("Please select at least one item for report");
			return false;
		}

		var fromDate = $("#fromTime").datetimepicker("getDate");
		var toDate = $("#toTime").datetimepicker("getDate");

		$.cookie('fromTimeField', fromDate, {
			expires: 0.04
		});
		$.cookie('toTimeField', toDate, {
			expires: 0.04
		});

		$("#start-hour").val(fromDate.getHours());
		$("#start-day").val(fromDate.getDate());
		$("#start-mon").val(fromDate.getMonth() + 1);
		$("#start-yr").val(fromDate.getFullYear());

		$("#end-hour").val(toDate.getHours());
		$("#end-day").val(toDate.getDate());
		$("#end-mon").val(toDate.getMonth() + 1);
		$("#end-yr").val(toDate.getFullYear());

		// get HMC & server name from menu url
		// var serverPath = $("#side-menu").fancytree('getActiveNode').data.href.split('/');
		var storage = curNode.parent.title;
		$("#storage").val(storage);

		var checkedBoxes = $("input:checkbox:checked.allcheck, input:checkbox:checked[name=output]").map(function () {
			return this.value;
		}).get();
		$.cookie('HistFormCheckBoxes',checkedBoxes, {
			expires: 60
		});

		// exclude allcheck boxes
		$(this).find(":checkbox.allcheck").attr("disabled", true);

		// remove parent items if whole branch checked
		var postArray = $(this).serializeArray();
		for (var i = 0; i < postArray.length; i++) {
			if (postArray[i].value.indexOf('_') === 0) {
				postArray.splice(i, 1);
				i--;
			}
		}
		var portname = "PORT";
		if ( curNode.parent.data.type == "SAN" || (curNode.parent.parent && (curNode.parent.parent.title == "SAN SWITCH" || curNode.parent.parent.title == "SAN SWITCH BNA" ))) {
			portname = "SANPORT";
		}
		if ( curNode.parent.data.type == "LAN" || (curNode.parent.parent && (curNode.parent.parent.title == "LAN SWITCH" ))) {
			portname = "LANPORT";
		}
		// replace fancytree fieldnames ft_...
		$.each(postArray, function(index, value) {
			if (value.name == pota) {
				value.name = 'POOL';
			} else if (value.name == prta) {
				value.name = portname;
			} else if (value.name == rata) {
				value.name = 'RANK';
			} else if (value.name == vota) {
				value.name = 'VOLUME';
			} else if (value.name == hota) {
				value.name = 'HOST';
			}
		});
		var postData = $.param(postArray);

		if (sysInfo.guidebug == 1) {
			copyToClipboard(postData);
			// alert("POST data:\n" + postData);
		}

		$('#content').load(this.action, postArray, function() {
			if (curNode.data.hash) {
				urlMenu = curNode.data.hash;
			} else {
				urlMenu = curNode.key.substring(1);
			}
			History.pushState({
				menu: curNode.key,
				tab: curTab,
				form: "hrep"
			}, prodName + " - " + $('#title').text(), '?menu=' + urlMenu + "&tab=" + curTab + "&form=");
			imgPaths();
			myreadyFunc();
			$("#pdf").show();
			saveData("hrep"); // save when page loads
		});
		event.preventDefault();
		if (timeoutHandle) {
			clearTimeout(timeoutHandle);
		}
	});

	//*************** Remove unwanted parent classes
	$('#content table.tabsyscfg').has('table').removeClass('tabsyscfg');
	$('#content table.tabtop10').has('table').removeClass('tabtop10');

	showHideSwitch();

	if (navigator.userAgent.indexOf('MSIE 8.0') < 0) {
		$('#content a:not(.nowrap):contains("How it works")').wrap(function() {
			var url = this.href;
			return "<div id='hiw'><a href='" + url + "' target='_blank'><img src='css/images/help-browser.gif' alt='How it works?' title='How it works?'></a></div>";
		});
	}

	$("#datasrc").on("click", function() {
		$("#data-src-info").dialog("open");
	});

	$("#pooltree").fancytree({
		extensions: ["persist"],
		persist: {
			cookiePrefix: "pooltree-"
		},
		clickFolderMode: 2,
		checkbox: true,
		selectMode: 2,
		/* init: function (){
$(this).fancytree("option", "selectMode", 3);
$(this).fancytree("getTree").getFirstChild().fixSelection3FromEndNodes();
},
*/
		icon: false,
		autoCollapse: true,
		source: {
			url: cgiPath + '/genjson.sh?' + histRepQueryString('POOL')
		}
	});
	$("#srvlparfilter").keyup(function(e){
		var n,
			match = $(this).val();
		var $ltree = $("#voltree").fancytree("getTree");

		if (e && e.which === $.ui.keyCode.ESCAPE || $.trim(match) === "") {
			$ltree.clearFilter();
			return;
		}
		n = $ltree.filterNodes(function (node) {
			return new RegExp(match, "i").test(node.title);
		}, true);
		$ltree.visit(function(node){
			if (!$(node.span).hasClass("fancytree-hide")) {
				node.setExpanded(true);
			}
		});
	}).trigger("focus");
	$("#porttree").fancytree({
		extensions: ["persist"],
		persist: {
			cookiePrefix: "porttree-"
		},
		clickFolderMode: 2,
		checkbox: true,
		selectMode: 3,
		icon: false,
		autoCollapse: true,
		source: {
			url: cgiPath + '/genjson.sh?' + histRepQueryString('PORT')
		}
	});

	$("#ranktree").fancytree({
		extensions: ["persist"],
		persist: {
			cookiePrefix: "ranktree-"
		},
		clickFolderMode: 2,
		checkbox: true,
		selectMode: 2,
		icon: false,
		autoCollapse: true,
		source: {
			url: cgiPath + '/genjson.sh?' + histRepQueryString('RANK')
		}
	});

	$("#voltree").fancytree({
		extensions: ["persist", "filter"],
		persist: {
			cookiePrefix: "voltree-"
		},
		filter: {
			mode: "hide",
			autoApply: true
		},
		clickFolderMode: 2,
		checkbox: true,
		selectMode: 2,
		icon: false,
		autoCollapse: true,
		source: {
			url: cgiPath + '/genjson.sh?' + histRepQueryString('VOLUME')
		}
	});

	$("#hosttree").fancytree({
		extensions: ["persist", "filter"],
		persist: {
			cookiePrefix: "hosttree-"
		},
		filter: {
			mode: "hide",
			autoApply: true
		},
		clickFolderMode: 2,
		checkbox: true,
		selectMode: 2,
		icon: false,
		autoCollapse: true,
		source: {
			url: cgiPath + '/genjson.sh?' + histRepQueryString('HOST')
		}
	});
	$("#hostfilter").keyup(function(e){
		var n,
			match = $(this).val();
		var $ltree = $("#hosttree").fancytree("getTree");

		if (e && e.which === $.ui.keyCode.ESCAPE || $.trim(match) === "") {
			$ltree.clearFilter();
			return;
		}
		n = $ltree.filterNodes(function (node) {
			return new RegExp(match, "i").test(node.title);
		}, true);
		$ltree.visit(function(node){
			if (!$(node.span).hasClass("fancytree-hide")) {
				node.setExpanded(true);
			}
		});
	}).trigger("focus");
	$("div.favs").each(function() {
		var url = $(this).parent().siblings('a.detail').attr('href');
		var urlObj = itemDetails(url, true);
		var hash = "";
		if (urlObj.type == "NODE-CACHE") {
			urlObj.type = "CACHE";
		} else if (urlObj.type == "DIRECTOR") {
			urlObj.type = "NODE";
		} else if (urlObj.type == "STORAGE GROUP") {
			urlObj.type = "VOLUME";
		} else if (urlObj.type == "DISK GROUP") {
			urlObj.type = "DRIVE";
		}
		if (urlObj.host == "totals" && (urlObj.name == "totals" || urlObj.name == "totals-BNA")) {
			hash = curNode.data.hashstr;
		} else if (curNode.data.agg) {
			hash = urlObj.host + urlObj.type + curNode.data.altname + 'SubSys_SUM';
		} else if (urlObj.host == "custom-group") {
			hash = "nana" + curNode.title;
		} else if (/^[sl]an_/.test(urlObj.item)) {
			hash = urlObj.host + urlObj.type + (curNode.data.altname ? curNode.data.altname : curNode.title);
		} else {
			hash = urlObj.host + urlObj.type + curNode.data.altname;
		}

		hash = hex_md5(hash).substring(0, 7);
		hash = hash + urlObj.itemcode + urlObj.time;
		$(this).data("gid", hash);

		if ($.inArray(hash, dbHash) >= 0) {
			$(this).removeClass("favoff"); /* Add item */
			$(this).addClass("favon");
			$(this).attr("title", "Remove this graph from Dashboard");
		} else {
			$(this).removeClass("favon");
			$(this).addClass("favoff");
			$(this).attr("title", "Add this graph to Dashboard");
		}
	});

	$(".g_title").each(function() {
		var grtitle = this.data;
		$(this).html();
	});
	$("div.popdetail").each(function() {
		$(this).attr("title", "ZOOM reset");
	});

	$("div.popdetail").on("click", function() {
		resZoom(this);
	});

	$("div.favs").on("click", function() {
		var hash = $(this).data("gid");
		if ($(this).hasClass("favon")) { /* Remove item */
			$(this).removeClass("favon");
			$(this).addClass("favoff");
			$(this).attr("title", "Add this graph to Dashboard");
			var toRemove = $.inArray(hash, dbHash);
			if (toRemove >= 0) {
				dbHash.splice(toRemove, 1);
				saveCookies();
			}
		} else {
			$(this).removeClass("favoff"); /* Add item */
			$(this).addClass("favon");
			$(this).attr("title", "Remove this graph from Dashboard");
			dbHash.push(hash);
			saveCookies();
		}
	});


	if (!areCookiesEnabled()) {
		$("#nocookies").show();
	} else {
		$("#nocookies").hide();
		if (dbHash.length === 0) {
			$("#emptydash").show();
		} else {
			$("#emptydash").hide();
		}
	}

	if ($("#emptydash").length) {
		$( "#tabs > ul li" ).hide();
		genDashboard();
	}


	$("#dashfooter button").button();

	if ($.cookie('flatDB')) {
		$( "#dbstyle" ).button({ label: "Switch to Tabbed Style" });
	}

	$("#clrcookies").on("click", function() {
		var conf = confirm("Are you sure you want to remove all DashBoard items?");
		if (conf === true) {
			dbHash.length = 0;
			saveCookies();
			$("#side-menu").fancytree("getTree").reactivate();
		}
	});
	$("#wipecookies").button().on("click", function() {
		var conf = confirm("Are you sure you want to wipe all STOR2RRD cookies for this host.domain/path?");
		if (conf === true) {
			for (var it in $.cookie()) {
				$.removeCookie(it);
			}
		}
	});
	$("#envdump").button().on("click", function() {
		$.get(cgiPath + "/genjson.sh?jsontype=test", function(data) {
			alert(data);
		});
	});

	$("#filldash").on("click", function() {
		var conf = confirm("This will append predefined items: POOL IO R/W summary. Are you sure?");
		if (conf === true) {
			$.getJSON(cgiPath + "/genjson.sh?jsontype=pre", function(data) {
				$.each(data, function(key, val) {
					if ($.inArray(val, dbHash) < 0) {
						dbHash.push(val);
					}
				});
				saveCookies();
				$("#side-menu").fancytree("getTree").reactivate();
			});
		}
	});
	$("#filldashlink").on("click", function(event) {
		event.preventDefault();
		$("#filldash").trigger("click");
	});

	$( "#dbstyle" ).on("click", function() {
		if ($.cookie('flatDB')) {
			$.removeCookie('flatDB');
		} else {
			$.cookie('flatDB', true, {
				expires: 365
			});
		}
		$("#side-menu").fancytree("getTree").reactivate();
	});

	$("ul.ui-tabs-nav").on("mouseenter mouseleave", function() {
		if (!$("#emptydash").length) {
			$("#tabgroups").fadeIn(200);
		}
	}, function() {
		$("#tabgroups").fadeOut(100);
	});
	var accwr = cgiPath + "/acc-wrapper.sh";
	$('form[action="' + accwr + '"]').on("submit", function(event) {
		event.preventDefault();
		if (timeoutHandle) {
			clearTimeout(timeoutHandle);
		}
		$('#content').empty();

		$('#content').append("<div style='width: 100%; height: 100%; text-align: center'><img src='css/images/sloading.gif' style='margin-top: 200px'></div>");
		// $('#title').text("Accounting results");
		var postData = $(this).serialize() + "&Report=Generate+Report";
		if (sysInfo.guidebug == 1) {
			copyToClipboard(postData);
		}
		$('#content').load(this.action, postData, function() {
			imgPaths();
			myreadyFunc();
		});
	});

	$( "input.allcheck" ).on("click", function() {
		var isChecked = this.checked;
		if ( this.name == "outdata" ) {
			$( "input:checkbox[name=output]" ).prop('checked', isChecked);
		} else {
			$( "#" + this.name + "tree").fancytree("getTree").visit(function(node) {
			if (!node.hasChildren()) {
				if (!$(node.span).hasClass("fancytree-hide")) {
					node.setSelected(isChecked);
				}
			}
			});
		}
	});
	$("#alrttree").fancytree({
		icon: false,
		clickFolderMode: 1,
		autoCollapse: false,
		create: function () {
			if (timeoutHandle) {
				clearTimeout(timeoutHandle);
			}
			$.getJSON( cgiPath + "/genjson.sh?jsontype=alrtgrptree", function( data ) {
				mailGroups = data;
			});
			$.getJSON( cgiPath + "/genjson.sh?jsontype=fleet", function( data ) {
				fleet = data;
			});
		},
		init: function () {
			loaded += 1;
			if (loaded > 1) {
				$(".savealrtcfg").button().prop( "disabled", false);
				$("#testalrtcfg").button().prop( "disabled", false);
			}
		},
		extensions: ["persist", "edit", "table", "gridnav"],
		source: {
			url: cgiPath + '/genjson.sh?jsontype=alrttree'
		},
		renderColumns: function(event, data) {
			var node = data.node,
			$select = $("<select class='alrtcol' name='metric' />"),
			$tdList = $(node.tr).find(">td"),
			selItems = ['io_rate','read_io','write_io','data_rate','read','write'];
			if( node.getLevel() == 2 ) {
				$tdList.eq(3).html("<b>" + node.data.subsys + "</b>");
			}
			if( node.getLevel() == 3 ) {
				var storType = fleet[node.parent.parent.title] && fleet[node.parent.parent.title]['STORTYPE'];
				switch (storType) {
					case 'HUS':
					case 'VSPG':
					case 'SWIZ':
					case 'XIV':
					case 'DS8K':
					case 'VPLEX':
					case 'NIMBLE':
						selItems = ['io_rate','read_io','write_io','data_rate','read','write','resp_t_r','resp_t_w'];
					break;
					case '3PAR':
					case 'NETAPP':
					case 'COMPELLENT':
					case 'OCEANSTOR':
					case 'PURE':
					case 'DATADOMAIN':
					case 'ETERNUS':
					case 'INFINIBOX':
					case 'XTREMIO':
					case 'PUREBLADE':
						selItems = ['io_rate','read_io','write_io','data_rate','read','write','resp_t','resp_t_r','resp_t_w'];
					break;
					case "DS5K":
						selItems = ['io_rate','data_rate'];
					break;
					case "DS5K-v2":
						selItems = ['io_rate','data_rate', 'resp_t'];
					break;
					case "DATADOMAIN-V5":
						selItems = ['io_rate','data_rate', 'read','write', 'resp_t'];
					break;
					case "ISILON":
						selItems = ['data_rate', 'read','write'];
					break;
					case 'DATACORE':
					case 'STOREVIRTUAL':
						selItems = ['io_rate','read_io','write_io','data_rate','read','write','resp_t_r','resp_t_w'];
					break;
					case 'VNX':
					case 'VNXF':
					case 'VNXE':
					case 'UNITY':
					case 'VMAX':
						selItems = ['io_rate','read_io','write_io','data_rate','read','write','resp_t'];
					break;
					case 'SAN-BRCD':
					case 'SAN-BNA':
						selItems = ['data total', 'data in', 'data out', 'frames total', 'frames in', 'frames out', 'CRC errors', 'BBCredits', 'Enc out', 'Disc c3', 'Link fail', 'Loss sync'];
						if (node.parent.data.subsys == "SANSWITCH") {
							selItems.push("cpu");
						}
					break;
					case 'SAN-CISCO':
						selItems = ['data total', 'data in', 'data out', 'frames total', 'frames in', 'frames out', 'CRC errors', 'BBCredits'];
						if (node.parent.data.subsys == "SANSWITCH") {
							selItems.push("cpu");
						}
					break;
					case 'LAN-CISCO':
					case 'LAN-UNKNOWN':
						selItems = ['data total', 'data in', 'data out', 'Ucast pkts total', 'Ucast pkts in', 'Ucast pkts out', 'errors total', 'errors in', 'errors out'];
						if (node.parent.data.subsys == "LANSWITCH") {
							selItems.push("cpu");
						}
					break;
				}
				if (storType == 'XIV' && node.parent.data.subsys != "VOLUME") {
					selItems = ['io_rate','read_io','write_io','data_rate','read','write','resp_t','resp_t_r','resp_t_w'];
				}
				if (storType == 'VMAX' && node.parent.data.subsys == "HOST") {
					selItems = ['io_rate','read_io','write_io','data_rate','read','write','resp_t','resp_t_r','resp_t_w'];
				}
				if (storType == 'VPLEX' && node.parent.data.subsys == "VOLUME") {
					selItems = ['io_rate','data_rate','read','write','resp_t_r','resp_t_w'];
				}
				if (storType == 'VPLEX' && node.parent.data.subsys == "HOST") {
					selItems = ['io_rate','data_rate','read','write'];
				}
				if (storType == 'DATACORE' && node.parent.data.subsys == "HOST") {
					selItems = ['io_rate','read_io','write_io','data_rate','read','write'];
				}
				if (storType == 'DATACORE' && node.parent.data.subsys == "VOLUME") {
					selItems = ['io_rate','read_io','write_io','data_rate','read','write'];
				}
				if (storType == 'STOREONCE' && node.parent.data.subsys == "POOL") {
					selItems = ['data_rate','read','write'];
				}
				if (storType == 'DS8K' && node.parent.data.subsys == "VOLUME") {
					selItems = ['io_rate','read_io','write_io','data_rate','read','write','resp_t','resp_t_r','resp_t_w'];
				}
				if (! node.data.metric) {
					node.data.metric = selItems[0];
				}
				$.each(selItems, function(i, val) {
					$("<option />", {text: alrtMetrics[val], value: val, selected: (node.data.metric == val)}).appendTo($select);
				});
				// (index #0 is rendered by fancytree by adding the checkbox)
				// (index #2 is rendered by fancytree)
				$tdList.eq(3).html($select);
				var err = node.data.limit ? "" : " ui-state-error";
				$tdList.eq(4).html("<input type='text' size='5' class='alrtcol" +  err + "' name='limit' value='" + node.data.limit + "'>");
				$tdList.eq(5).html("<input type='text' size='5' class='alrtcol' name='peak' value='" + node.data.peak + "'>");
				$tdList.eq(6).html("<input type='text' size='5' class='alrtcol' name='repeat' value='" + node.data.repeat + "'>");
				$tdList.eq(7).html("<input type='text' size='5' class='alrtcol' name='iothold' value='" + node.data.iothold + "'>");
				if ( ! /^resp_*/.test(node.data.metric) ) {
					$tdList.eq(7).children("input").prop( "disabled", true );
				}
				$tdList.eq(8).html("<input type='text' size='5' class='alrtcol' name='exclude' value='" + node.data.exclude + "'>");
				$select = $("<select class='alrtcol' name='mailgrp' />"),
				$("<option />", {text: "---" , value: "", selected: true}).appendTo($select);
				$.each(mailGroups, function(i, val) {
					$("<option />", {text: val.title, value: val.title, selected: (node.data.mailgrp == val.title)}).appendTo($select);
				});
				$tdList.eq(9).html($select);
				$tdList.eq(10).html("<button class='removeme' title='Remove rule'>X</button>");
			}
		},
		table: {
			indentation: 20,
			nodeColumnIdx: 2,
			checkboxColumnIdx: 0
		},
		gridnav: {
			autofocusInput: false,
			handleCursorKeys: true
		}
	});

	// Set FT data to currently selected option
	$( "#alrttree" ).on('change', "select.alrtcol", function(event, data) {
		$.ui.fancytree.getNode(event.target).data[event.target.name] = event.target.value;
		if ( /^resp_*/.test(event.target.value) ) {
			$(event.target).parents("tr").find("input[name='iothold']").prop( "disabled", false );
		} else {
			$(event.target).parents("tr").find("input[name='iothold']").val("").prop( "disabled", true );
		}
	});
	$( "#alrttree" ).on('click', "select.alrtcol", function(event, data) {
		event.stopPropagation();
	});
	$( "#alrttree" ).on('blur', "input.alrtcol", function(event, data) {
		var valid = false;

		switch (event.target.name) {
			case "limit":
				var regexp = /^\d+(?:\.\d+)?$/;
				valid = event.target.value.match(/^[0-9]+$/);
				valid = regexp.test(event.target.value);
				// checkRegexp( event.target.value, /[0-9]*/, "This doesn't look like valid e-mail address" );
			break;
			case "iothold":
				valid = event.target.value.match(/^[0-9]*$/);
			break;
			case "peak":
				valid = event.target.value.match(/^[0-9]*$/);
				if (event.target.value && (event.target.value < 5)) {
					event.target.value = 5;
				}
				if (event.target.value && (event.target.value > 120)) {
					event.target.value = 120;
				}
			break;
			case "repeat":
				valid = event.target.value.match(/^[0-9]*$/);
				if (event.target.value && (event.target.value < 5)) {
					event.target.value = 5;
				}
				if (event.target.value && (event.target.value > 168)) {
					event.target.value = 168;
				}
			break;
			case "exclude":
				valid = (event.target.value == "") || event.target.value.match(/^([01]?[0-9]|^2[0-4])\-([01]?[0-9]|2[0-4])$/);
			break;
		}
		if (valid) {
			$.ui.fancytree.getNode(event.target).data[event.target.name] = event.target.value;
			$(event.target).removeClass( "ui-state-error" );
		} else {
			$(event.target).trigger("focus");
			$(event.target).addClass( "ui-state-error" );
		}
	});

	$( "#optform" ).on('blur', "input.alrtoption", function(event, data) {
		var valid = false;
		switch (event.target.name) {
			case "NAGIOS":
				valid = event.target.value.match(/^[01]$/);
				// checkRegexp( event.target.value, /[0-9]*/, "This doesn't look like valid e-mail address" );
			break;
			case "EXTERN_ALERT":
				valid = (event.target.value == "") || event.target.value.match(/^bin\/.+$/);
				// checkRegexp( event.target.value, /[0-9]*/, "This doesn't look like valid e-mail address" );
			break;
			case "EMAIL_GRAPH":
				valid = event.target.value.match(/^[0-9]*$/);
				if (event.target.value && (event.target.value > 256)) {
					event.target.value = 256;
				}
			break;
			case "REPEAT_DEFAULT":
				valid = event.target.value.match(/^[0-9]*$/);
				if (event.target.value && (event.target.value < 5)) {
					event.target.value = 5;
				}
				if (event.target.value && (event.target.value > 168)) {
					event.target.value = 168;
				}
			break;
			case "PEAK_TIME_DEFAULT":
				valid = event.target.value.match(/^[0-9]*$/);
				if (event.target.value && (event.target.value < 15)) {
					event.target.value = 15;
				}
				if (event.target.value && (event.target.value > 120)) {
					event.target.value = 120;
				}
			break;
			case "TRAP":
				valid = event.target.value.match(/^(([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z]|[A-Za-z][A-Za-z0-9\-]*[A-Za-z0-9])$/);
				valid = valid || event.target.value.match(/^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$/);
				valid = valid || (event.target.value == "");
			break;
		}
		if (valid) {
			$(event.target).removeClass( "ui-state-error" );
		} else {
			event.target.trigger("focus");
			$(event.target).addClass( "ui-state-error" );
		}
	});

	$( "#eventform" ).on('blur', "input.alrtoption", function(event, data) {
		var valid = false;
		switch (event.target.name) {
			case "NAGIOS_EVENT":
				valid = event.target.value.match(/^[01]$/);
				// checkRegexp( event.target.value, /[0-9]*/, "This doesn't look like valid e-mail address" );
			break;
			case "EXTERN_ALERT_EVENT":
				valid = (event.target.value == "") || event.target.value.match(/^bin\/.+$/);
				// checkRegexp( event.target.value, /[0-9]*/, "This doesn't look like valid e-mail address" );
			break;
			case "REPEAT_DEFAULT":
				valid = event.target.value.match(/^[0-9]*$/);
				if (event.target.value && (event.target.value < 5)) {
					event.target.value = 5;
				}
				if (event.target.value && (event.target.value > 168)) {
					event.target.value = 168;
				}
			break;
			case "EMAIL_EVENT":
				valid = (event.target.value == "") || event.target.value.length >3;
			break;
			case "TRAP_EVENT":
				valid = event.target.value.match(/^(([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z]|[A-Za-z][A-Za-z0-9\-]*[A-Za-z0-9])$/);
				valid = valid || event.target.value.match(/^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$/);
				valid = valid || (event.target.value == "");
			break;
		}
		if (valid) {
			$(event.target).removeClass( "ui-state-error" );
		} else {
			event.target.trigger("focus");
			$(event.target).addClass( "ui-state-error" );
		}
	});

	$( "#alrttree,#alrtgrptree" ).on('click', "button.removeme", function(event, data) {
		$.ui.fancytree.getNode(event.target).remove();
		mailGroups = $("#alrtgrptree").fancytree("getTree").toDict();
	});
	$( "#addnewalrt" ).on( "click", function() {
		// if (mailGroups) {
			var node = $( "#alrttree").fancytree("getTree").getActiveNode();
			if (! node) {
				var node = $( "#alrttree").fancytree("getTree").getRootNode();
			}
			params = {};
			if (node.getLevel() == 1) {
				params.storage = node.title;
			} else if (node.getLevel() == 2) {
				params.storage = node.parent.title;
				params.subsys = node.data.subsys;
				params.volume = node.title;
			} else if (node.getLevel() == 3) {
				params.storage = node.parent.parent.title;
				params.subsys = node.parent.data.subsys;
				params.volume = node.parent.title;
			}
			if (fleet[params.storage]) {
				params.type = fleet[params.storage].STORTYPE;
			}

			addNewAlrtForm("Create new alerting rule", params);
		// } else {
		// 	$.alert("You have no E-mail groups defined, please create some first!", "Add new alert rule result", false);
		// 	}
	});

	$("#alrtgrptree").fancytree({
		icon: false,
		clickFolderMode: 1,
		autoCollapse: false,
		extensions: ["persist", "edit", "table", "gridnav"],
		source: {
			url: cgiPath + '/genjson.sh?jsontype=alrtgrptree'
		},
		init: function () {
			loaded += 1;
			if (loaded > 1) {
				$(".savealrtcfg").button().prop( "disabled", false);
			}
		},
		renderColumns: function(event, data) {
			var node = data.node,
			$tdList = $(node.tr).find(">td");
			// (index #0 is rendered by fancytree by adding the checkbox)
			// (index #2 is rendered by fancytree)
			$tdList.eq(1).text(node.data.email);
			$tdList.eq(3).html("<button class='removeme' title='Remove line'>X</button>");
		},
		table: {
			indentation: 20,
			nodeColumnIdx: 2,
			checkboxColumnIdx: 0
		},
		gridnav: {
			autofocusInput: false,
			handleCursorKeys: true
		}
	});
	$( "#addalrtgrp" ).on( "click", function() {
		var node = $( "#alrtgrptree").fancytree("getTree").getActiveNode();
		if (! node) {
			var node = $( "#alrtgrptree").fancytree("getTree").getRootNode();
		}
		params = {};
		if (node.getLevel() == 1) {
			params.storage = node.title;
		} else if (node.getLevel() == 2) {
			params.storage = node.parent.title;
			params.volume = node.title;
		}
		addNewAgrpForm("Create new mail group", params);
	});
	$("#alrttimetree").fancytree({
		checkbox: false,
		icon: false,
		clickFolderMode: 2,
		selectMode: 3, // 1:single, 2:multi, 3:multi-hier
		autoCollapse: false,
		source: {
			url: cgiPath + '/genjson.sh?jsontype=alrttimetree'
		}
	});
	if ( $( "#optform" ).length ) {
		$.getJSON( cgiPath + "/genjson.sh?jsontype=alrtcfg", function( data ) {
			alrtCfg = data;
		});
	}
	$("#cgtree").fancytree({
		icon: false,
		// autoCollapse: true,
		clickFolderMode: 1,
		titlesTabbable: true,     // Add all node titles to TAB chain
		quicksearch: true,        // Jump to nodes when pressing first character
		source: {url: cgiPath + '/genjson.sh?jsontype=custgrps'},

		// extensions: ["edit", "table", "gridnav"],
		extensions: ["persist", "edit", "table", "gridnav"],

		create: function() {
			$.getJSON( cgiPath + "/genjson.sh?jsontype=fleet", function( data ) {
				fleet = data;
			});
			if (timeoutHandle) {
				clearTimeout(timeoutHandle);
			}
			$("#addcgrp").on("click", function () {
				var child = {
					"title": "",
					"folder": true,
					"expanded": true,
					"children": [{
						"expanded": true,
						"folder": true,
						"title": ".*",
						"children": [{
							"title": ".*"
						}]
					}]
				};
				if ($("#cgtree").fancytree("getRootNode").getFirstChild()) {
					$("#cgtree").fancytree("getRootNode").getFirstChild().editCreateNode("before", child);
				} else {
					$("#cgtree").fancytree("getRootNode").editCreateNode("child", child);
				}
			});

		},

		edit: {
			triggerStart: ["f2", "dblclick", "shift+click", "mac+enter"],
			edit: function(event, data) {
				var grpType;
				switch (data.node.getLevel()) {
				case 1:
					data.input.attr("placeholder", "Type group name");
					break;
				case 2:
					grpType = data.node.parent.data.type != "SANPORT" ? "storage" : "switch";
					data.input.attr("placeholder", "Type " + grpType + " name");
					break;
				case 3:
					grpType = data.node.parent.parent.data.type != "SANPORT" ? "storage" : "switch";
					data.input.attr("placeholder", "Type " + data.node.parent.parent.data.type + " name");
					break;
				default:
				}
				if (data.node.getLevel() == 2) {
					var acSAN = [];
					var acLAN = [];
					var acSTO = [];
					jQuery.each(fleet, function( n ) {
						if (fleet[n]["SANPORT"]) {
							acSAN.push(n);
						} else if (fleet[n]["LANPORT"]){
							acLAN.push(n);
						} else {
							acSTO.push(n);
						}
					});
					if (grpType == "storage") {
						acData = acSTO;
					} else {
						acData = acSAN;
					}
					// acData = Object.keys(acData);
					data.input.autocomplete({
						autoFocus: false,
						source: acData,
						select: function( event, ui ) {
							// data.input.value =
							window.console && console.log(ui);
						},
						focus: function( event, ui ) {
							data.input.val( ui.item.value );
						}
					});
				} else if (data.node.getLevel() == 3) {
					var acData = [];
					var type = data.node.parent.parent.data.type;
					jQuery.each(fleet, function(i, val) {
						var re = new RegExp("^" + data.node.parent.title + "$", "");
						if (re.test(i)) {
							if (fleet[i][type]) {
								$.merge(acData, fleet[i][type]);
							}
						}
					});

					// var acData = fleet[data.node.parent.title][data.node.parent.parent.data.type];
					acData = jQuery.uniqueSort( acData );
					data.input.autocomplete({
						autoFocus: false,
						source: acData,
						focus: function( event, ui ) {
							data.input.val( ui.item.value );
						}
					});
				}
			},
			beforeClose: function(event, data) {
				if (data.input.autocomplete("instance")) {
					data.input.autocomplete("close");
				}
				if (data.save) {
					try {
						var re = new RegExp(data.input.val(), "");
					} catch(exception) {
						return true;
					}
					if (data.isNew) {
						if (data.node.getLevel() == 1) {
							data.node.data.type = "VOLUME";
						}
					}
				}
			},
			close: function (event, data) {
					// Editor was removed.
					// data.node.render();
					if (data.node && data.node.getLevel() != 3) {
						data.node.folder = true;
					}
					data.node && $(data.node.tr).find("button").trigger("click");
				}
				// triggerStart: ["f2", "shift+click", "mac+enter"],
				// close: function(event, data) {
				//	if( data.save && data.isNew ){
				//	// Quick-enter: add new nodes until we hit [enter] on an empty title
				//	$("#cgtree").trigger("nodeCommand", {cmd: "addSibling"});
				//	}
				// }
		},
		table: {
			indentation: 20,
			nodeColumnIdx: 2,
			checkboxColumnIdx: 0
		},
		gridnav: {
			autofocusInput: false,
			handleCursorKeys: true
		},

		renderColumns: function(event, data) {
			var node = data.node,
				$select = $("<select class='grptypesel' />"),
				$tdList = $(node.tr).find(">td");

			// (Index #0 is rendered by fancytree by adding the checkbox)
			// $tdList.eq(1).text(node.getIndexHier()).addClass("alignRight");
			// Index #2 is rendered by fancytree, but we make the title cell
			// span the remaining columns if it is a folder:
			if( node.isTopLevel() ) {
				/*
				$tdList.eq(4)
				.prop("colspan", 3)
				.nextAll().remove();
				*/
				if (node.data.loaded) {
					$tdList.eq(3).text(node.data.type);
					// $select.prop('disabled', true);
					// $(data.node.tr).find("select").prop('disabled', true);
				} else {
					var isSAN = (node.data.type == 'SANPORT');
					$("<option />", {text: "VOLUME", value: "VOLUME", selected: !isSAN}).appendTo($select);
					$("<option />", {text: "SAN port", value: "SANPORT", selected: isSAN}).appendTo($select);
					$("<option />", {text: "HOST", value: "HOST", selected: isSAN}).appendTo($select);
					$("<option />", {text: "POOL", value: "POOL", selected: isSAN}).appendTo($select);
					$tdList.eq(3).html($select);
				}
				var collValue = "";
				if (node.data.collection) {
					collValue = node.data.collection;
				}
				$tdList.eq(4).html("<input type='text' placeholder='Set of goups' class='collname' value='" + collValue + "'>");
			}
			if( node.getLevel() == 3 ) {
				var isPool = (node.parent.parent.data.type == 'VOLUME');
				// if (isPool && node.title == "all_pools") {
				//	node.setTitle("CPU pool");
				//}
				// $tdList.eq(4).html("<input type='checkbox' value='" + "" + "'>");
				// $tdList.eq(5).html("<input type='input' size='5' value='" + "" + "'>");
			}
			$tdList.eq(5).html("<button class='grptestbtn'>S</button>");
		},
		activate: function(event, data) {
			var node = data.node;
			// var tree = $(this).fancytree("getTree");
			$(node.tr).find("button").trigger("click");
		}
	}).on("nodeCommand", function(event, data){
		// Custom event handler that is triggered by keydown-handler and
		// context menu:
		var refNode, moveMode,
		tree = $(this).fancytree("getTree"),
		node = tree.getActiveNode();

		switch( data.cmd ) {
		case "rename":
		node.editStart();
		break;
		case "remove":
		refNode = node.getNextSibling() || node.getPrevSibling() || node.getParent();
		node.remove();
		if( refNode ) {
			refNode.setActive();
		}
		break;
		case "addGroup":
		node.editCreateNode("after", "");
		break;
		case "addServer":
		var child = {"expanded": true,"folder": true,"title":".*","children": [{"title":".*"}]};
		if (node.isTopLevel()) {
			node.editCreateNode("child", child);
		} else {
			node.editCreateNode("after", child);
		}
		break;
		case "addRule":
		if (node.getLevel() == 2) {
			node.editCreateNode("child", "");
		} else {
			node.editCreateNode("after", "");
		}
		break;
		case "addSibling":
		node.editCreateNode("after", "");
		break;
		default:
		alert("Unhandled command: " + data.cmd);
		return;
		}

	// }).on("click dblclick", function(e){
	//   console.log( e, $.ui.fancytree.eventToString(e) );

	}).on("keydown", function(e){
		var cmd = null;

		// console.log(e.type, $.ui.fancytree.eventToString(e));
		switch( $.ui.fancytree.eventToString(e) ) {
		case "del":
		case "meta+backspace": // mac
		cmd = "remove";
		break;
		// case "f2":  // already triggered by ext-edit pluging
		//   cmd = "rename";
		//   break;
		}
		if( cmd ){
		$(this).trigger("nodeCommand", {cmd: cmd});
		// e.preventDefault();
		// e.stopPropagation();
		return false;
		}
	});

		/*
	* Context menu (https://github.com/mar10/jquery-ui-contextmenu)
	*/
	$("#cgtree").contextmenu({
		menu: [
		{title: "Edit <kbd>[F2]</kbd>", cmd: "rename"},
		{title: "Delete <kbd>[Del]</kbd>", cmd: "remove"},
		{title: "----"},
		/* {title: "New Group <kbd>[Ctrl+G]</kbd>", cmd: "addGroup", disabled: true}, */
		{title: "New Storage", cmd: "addServer", disabled: true},
		{title: "New Volume", cmd: "addRule", disabled: true}
		],
		beforeOpen: function(event, ui) {
			var node = $.ui.fancytree.getNode(ui.target);
			// $("#cgtree").contextmenu("enableEntry", "addGroup", node.isTopLevel());
			$("#cgtree").contextmenu("enableEntry", "addServer", node.getLevel() == 1);
			if (node.getParentList(false,true)[0].data.type  == "VOLUME") {
				$("#cgtree").contextmenu("setEntry", "addServer", {title: "New Storage"});
				$("#cgtree").contextmenu("setEntry", "addRule", {title: "New Volume"});
			} else if (node.getParentList(false,true)[0].data.type  == "HOST") {
				$("#cgtree").contextmenu("setEntry", "addServer", {title: "New Storage"});
				$("#cgtree").contextmenu("setEntry", "addRule", {title: "New Host"});
			} else if (node.getParentList(false,true)[0].data.type  == "POOL") {
				$("#cgtree").contextmenu("setEntry", "addServer", {title: "New Storage"});
				$("#cgtree").contextmenu("setEntry", "addRule", {title: "New Pool"});
			}
			else{
				$("#cgtree").contextmenu("setEntry", "addServer", {title: "New SAN switch"});
				$("#cgtree").contextmenu("setEntry", "addRule", {title: "New Port"});
			}
			$("#cgtree").contextmenu("enableEntry", "addRule", node.getLevel() != 1);
			node.setActive();
		},
		select: function(event, ui) {
			var that = this;
			// delay the event, so the menu can close and the click event does
			// not interfere with the edit control
			setTimeout(function(){
				$(that).trigger("nodeCommand", {cmd: ui.cmd});
			}, 100);
		}
	});

	$( "#cgtree" ).on('dblclick', "button.grptestbtn", function(event, data) {
		event.stopPropagation();
	});
	$( "#cgtree" ).on('click', "button.grptestbtn", function(event, data) {
		event.stopPropagation();
		var cgnode = $("#cgtree").fancytree("getActiveNode");
		var match = [];
		var gmatch = {};
		var vals = {};
		var count = 0;
		if( cgnode.getLevel() == 3 ) { // lowest level
			vals.lpar = cgnode.title;
			vals.srv = cgnode.parent.title;
			vals.type = cgnode.parent.parent.data.type;
			//if (vals.type == "POOL" && vals.lpar == "all_pools") {
			//	vals.lpar = "CPU pool";
			//}
			jQuery.each(fleet, function(i, val) {
				var re = new RegExp("^" + vals.srv + "$", "");
				if (re.test(i) || vals.srv == i) {
					if (fleet[i][vals.type]) {
						var grepped = [];
						if (fleet[i]['STORTYPE'] == "VMAX" && vals.type == "POOL"){
							grepped.push("Array_Total");
						} else {
							grepped = jQuery.grep(fleet[i][vals.type], function( a ) {
								var regex = new RegExp("^" + vals.lpar + "$", "");
								return (regex.test(a) || vals.lpar == a);
							});
						}
						if (grepped.length) {
							var newHTML = [];
							$.each(grepped, function(index, value) {
								newHTML.push('<span class="cgel">' + value + '</span>');
								count += 1;
							});
							if (!gmatch[i]) {
								gmatch[i] = [];
							}
							gmatch[i].push(newHTML.join(" "));
						}
					}
				}
			});
			$("#cgtest").html("<b>" + vals.type + " level rule live preview:</b> <span class='cgel'>" + cgnode.parent.parent.title + "</span><span class='rarrow'>&nbsp;&rArr;&nbsp;</span><span class='cgel'>" + cgnode.parent.title + "</span><span class='rarrow'>&nbsp;&rArr;&nbsp;</span><span class='cgel'>" + cgnode.title + "</span><hr><table>");
			if (count > 0) {
				$("#cgtest").append("<tr><th> Storage</th><th></th><th>" + vals.type + "</th></tr>");
				jQuery.each(gmatch, function(i,val) {
					$("#cgtest").append("<tr><td><span class='cgel'>" + i + "</span></td><td class='rarrow'>&nbsp;&rArr;&nbsp;</td><td>" + val.join(" ") + "</td></tr>");
				});
			} else {
				$("#cgtest").append("<tr><td>-- empty list --</td></tr>");
			}
			$("#cgtest").append("</table>").show();

		} else if( cgnode.isTopLevel() ) { // Top level
			vals.type = cgnode.data.type;
			cgnode.visit(function(tnode) {
				if( tnode.getLevel() == 3 ) { // lowest level
					vals.lpar = tnode.title;
					vals.srv = tnode.parent.title;
					if (vals.type == "POOL" && vals.lpar == "all_pools") {
						vals.lpar = "CPU pool";
					}
					jQuery.each(fleet, function(i, val) {
						var re = new RegExp("^" + vals.srv + "$", "");
						if (re.test(i) || vals.srv == i) {
							if (fleet[i][vals.type]) {
								var grepped = [];
								if (fleet[i]['STORTYPE'] == "VMAX" && vals.type == "POOL"){
									grepped.push("Array_Total");
								} else {
									grepped = jQuery.grep(fleet[i][vals.type], function( a ) {
										var regex = new RegExp("^" + vals.lpar + "$", "");
										return (regex.test(a) || vals.lpar == a);
									});
								}
								if (grepped.length) {
									var newHTML = [];
									$.each(grepped, function(index, value) {
										newHTML.push('<span class="cgel">' + value + '</span>');
										count += 1;
										if (!gmatch[i]) {
											gmatch[i] = {};
										}
										if (gmatch[i][value]) {
										gmatch[i][value] += 1;
										} else {
											gmatch[i][value] = 1;
										}
									});
								}
							}
						}
					});
				}
			});
			$("#cgtest").html("<b>" + vals.type + " group live preview:</b> <span class='cgel'>" + cgnode.title + "</span>&nbsp;&nbsp;<span style='display: none' class='cgel dupe' id='dupsfound'></span><hr><table>");
			if (count > 0) {
				$("#cgtest").append("<tr><th>Storage </th><th></th><th>" + vals.type + "</th></tr>");
				var dupsFound = 0;
				jQuery.each(gmatch, function(i,val) {
					var tItems = [];
					jQuery.each(val, function(ii,ival) {
						if (ival == 1) {
							tItems.push('<span class="cgel">' + ii + '</span>');
						} else {
							tItems.push('<span class="cgel dupe" title="occurrences found: ' + ival +'">' + ii + '</span>');
							dupsFound += 1;
						}
					});
					$("#cgtest").append("<tr><td><span class='cgel'>" + i + "</span></td><td class='rarrow'>&nbsp;&rArr;&nbsp;</td><td>" + tItems.join(" ") + "</td></tr>");
				});
			} else {
				$("#cgtest").append("<tr><td>-- empty list --</td></tr>");
			}
			$("#cgtest").append("</table>").show();
			if (dupsFound) {
				$("#dupsfound").text("some duplicates found").show();
			}
			if (sysInfo.free == 1 && vals.type == "VOLUME" && count > 10) {
				$("#cgtest").append( "<hr>Due to the limitation of free STOR2RRD edition only the first 10 volumes per group will be graphed. Unlimited number of volumes in one custom group is one of the benefits of enterprise edition which comes with support subscription. <a href='http://www.stor2rrd.com/support.htm#benefits'>More info...</a>");
			}
			if (sysInfo.free == 1 && vals.type == "POOL" && count > 4) {
				$("#cgtest").append( "<hr>Due to the limitation of free STOR2RRD edition only the first 4 pools per group will be graphed. Unlimited number of pools in one custom group is one of the benefits of enterprise edition which comes with support subscription. <a href='http://www.stor2rrd.com/support.htm#benefits'>More info...</a>");
			}
			if (sysInfo.free == 1 && /[SL]ANPORT/.test(vals.type) && count > 4) {
				$("#cgtest").append( "<hr>Due to the limitation of free STOR2RRD edition only the first 4 ports per group will be graphed. Unlimited number of ports in one custom group is one of the benefits of enterprise edition which comes with support subscription. <a href='http://www.stor2rrd.com/support.htm#benefits'>More info...</a>");
			}

		} else {  // server level
			vals.type = cgnode.parent.data.type;
			cgnode.visit(function(tnode) {
				if( tnode.getLevel() == 3 ) {
					vals.lpar = tnode.title;
					vals.srv = tnode.parent.title;
					jQuery.each(fleet, function(i, val) {
						var re = new RegExp("^" + vals.srv + "$", "");
						if (re.test(i) || vals.srv == i) {
							if (fleet[i][vals.type]) {
								var grepped = [];
								if (fleet[i]['STORTYPE'] == "VMAX" && vals.type == "POOL"){
									grepped.push("Array_Total");
								} else {
									grepped = jQuery.grep(fleet[i][vals.type], function( a ) {
										var regex = new RegExp("^" + vals.lpar + "$", "");
										return (regex.test(a) || vals.lpar == a);
									});
								}
								if (grepped.length) {
									var newHTML = [];
									$.each(grepped, function(index, value) {
										newHTML.push('<span class="cgel">' + value + '</span>');
										count += 1;
										if (!gmatch[i]) {
											gmatch[i] = {};
										}
										if (gmatch[i][value]) {
										gmatch[i][value] += 1;
										} else {
											gmatch[i][value] = 1;
										}
									});
								}
							}
						}
					});
				}
			});
			$("#cgtest").html("<b>Storage level rule live preview:</b> <span class='cgel'>" + cgnode.parent.title + "</span><span class='rarrow'>&nbsp;&rArr;&nbsp;</span><span class='cgel'>" + cgnode.title + "</span> <span style='display: none' class='cgel dupe' id='dupsfound'></span><hr><table>");
			if (count > 0) {
				$("#cgtest").append("<tr><th>Storage </th><th></th><th>" + vals.type + "</th></tr>");
				var dupsFound = 0;
				jQuery.each(gmatch, function(i,val) {
					var tItems = [];
					jQuery.each(val, function(ii,ival) {
						if (ival == 1) {
							tItems.push('<span class="cgel">' + ii + '</span>');
						} else {
							tItems.push('<span class="cgel dupe" title="occurrences found: ' + ival +'">' + ii + '</span>');
							dupsFound += 1;
						}
					});
					$("#cgtest").append("<tr><td><span class='cgel'>" + i + "</span></td><td class='rarrow'>&nbsp;&rArr;&nbsp;</td><td>" + tItems.join(" ") + "</td></tr>");
				});
			} else {
				$("#cgtest").append("<tr><td>-- empty list --</td></tr>");
			}
			$("#cgtest").append("</table>").show();
			if (dupsFound) {
				$("#dupsfound").text("some duplicates found").show();
			}
		}
	});

	// Set FT data to currently selected option
	$( "#cgtree" ).on('change', "select.grptypesel", function(event, data) {
		$.ui.fancytree.getNode(event.target).data.type = event.target.value;
		$( $.ui.fancytree.getNode(event.target).tr ).find("button").trigger("click");
	});
	$( "#cgtree" ).on('click', "select.grptypesel", function(event, data) {
		event.stopPropagation();
	});
	$( "#cgtree" ).on('change', "input.collname", function(event, data) {
		$.ui.fancytree.getNode(event.target).data.collection = event.target.value;
	});
	$( "#cgtree" ).on('click', "input.collname", function(event, data) {
		var acData = $('#cgtree td:nth-child(5) input').map(function(){
				return $(this).val();
			}).get();
		acData = unique(acData);
		var field = $(event.target);
		field.autocomplete({
			autoFocus: false,
			source: acData,
			select: function( event, ui ) {
				// data.input.value =
				window.console && console.log(ui);
			},
			focus: function( event, ui ) {
				field.val( ui.item.value );
				$.ui.fancytree.getNode(event.target).data.collection = ui.item.value;
			}
		});
	});

	$("#savegrp").on("click", function(event) {
		event.preventDefault();
		$("#aclfile").text("");
		var delimiter = "\\:";
		var acltxt = "# This file is GUI generated, modifying is not recommended!\n";
		var atxt = [];
		$("#cgtree").fancytree("getTree").visit(function(node) {
			if (node.getLevel() == 3) {
				var line = [];
				var type = node.parent.parent.data.type;
				var col = node.parent.parent.data.collection;
				var rule = unescapeHtml(node.title).replace(/\:/g, delimiter);
				var srv = unescapeHtml(node.parent.title).replace(/\:/g, delimiter);
				var grp = unescapeHtml(node.parent.parent.title).replace(/\:/g, delimiter);
											//if (type == "POOL" && rule == "CPU pool") {
											//	rule = "all_pools";
											//}
				line.push(type, srv, rule, grp);
											if (col) {
												line.push(col.replace(/\:/g, delimiter));
											}

											atxt.push(line.join(":"));
											acltxt += line.join(":") + "\n";
			}
		});

		var postdata = {acl: acltxt};

		$.post( cgiPath + "/cgrps-save-cgi.sh", postdata, function( data ) {
			var returned = JSON.parse(data);
			if ( returned.status == "success" ) {
				$("#aclfile").text(returned.cfg).show();
			}
			$(returned.msg).dialog({
				dialogClass: "info",
				title: "Custom group configuration save - " + returned.status,
				minWidth: 600,
				modal: true,
				show: {
					effect: "fadeIn",
					duration: 500
				},
				hide: {
					effect: "fadeOut",
					duration: 200
				},
				buttons: {
					OK: function() {
						$(this).dialog("destroy");
					}
				}
			});
		});
	});

	$("#savedash").on("click", function(event) {
		event.preventDefault();
		var ttmp = '<div id="dialog-form">' +
					'<p class="validateTips">File name is required.</p>' +
					'<form>' +
						'<div id="existing" style="display: none"><select name="name" id="dbfilecombo" class="text ui-widget-content ui-corner-all"></select><br></div>' +
						'<!--label for="name">File name</label>&nbsp;&nbsp;-->' +
						'<input type="text" name="name" id="dbfilename" placeholder="Type filename..." class="text ui-widget-content ui-corner-all">' +
						'<!-- Allow form submission with keyboard without duplicating the dialog button -->' +
						'<input type="submit" tabindex="-1" style="position:absolute; top:-1000px">' +
					'</form>' +
					'</div>';
		$.getJSON(cgiPath + "/dashboard.sh?list", function(jsonData){
			cb = '';
			$.each(jsonData.sort(), function(i,data){
				var woprefix = data.substring(3);
				cb += '<option value="' + woprefix + '">' + woprefix +'</option>';
			});
			$("#dbfilecombo").html('');
			$("#dbfilecombo").append(cb).show();
			if (jsonData.length) {
				$("#existing").show();
				$("#existing").on("click", function(e) {
					$("#dbfilename").val(e.target.value);
				});
			}
		});
		$( ttmp ).dialog({
			dialogClass: "info",
			title: "Save DashBoard status",
			minWidth: 600,
			modal: true,
			show: {
				effect: "fadeIn",
				duration: 500
			},
			hide: {
				effect: "fadeOut",
				duration: 200
			},
			create: function( e, ui ) {
				$( this ).find( "form" ).on( "submit", function( event ) {
					event.preventDefault();
					saveDbState();
				});
			},
			buttons: {
				Save: saveDbState,
				Cancel: function() {
					$( this ).dialog( "destroy" );
					return;
				}
			}
		});
	});
	$("#loaddash").on("click", function(event) {
		event.preventDefault();
		var ttmp = '<div id="dialog-form">' +
					'<p class="validateTips">Your current DashBoard items will be lost!</p>' +
					'<form>' +
						'<label for="name">Select saved state name</label>&nbsp;&nbsp;' +
						'<select name="name" id="dbfilename" class="text ui-widget-content ui-corner-all"></select>' +
						'<!-- Allow form submission with keyboard without duplicating the dialog button -->' +
						'<input type="submit" tabindex="-1" style="position:absolute; top:-1000px">' +
					'</form>' +
					'</div>';
		$.getJSON(cgiPath + "/dashboard.sh?list", function(jsonData){
			cb = '';
			$.each(jsonData.sort(), function(i,data){
				var woprefix = data.substring(3);
				cb += '<option value="' + woprefix + '">' + woprefix +'</option>';
			});
			$("#dbfilename").html('');
			$("#dbfilename").append(cb);
		});
		$( ttmp ).dialog({
			dialogClass: "info",
			title: "Restore DashBoard status",
			minWidth: 600,
			modal: true,
			show: {
				effect: "fadeIn",
				duration: 500
			},
			hide: {
				effect: "fadeOut",
				duration: 200
			},
			create: function( e, ui ) {
				$( this ).find( "form" ).on( "submit", function( event ) {
					event.preventDefault();
					restorDbState();
				});
			},
			buttons: {
				Restore: restoreDbState,
				Cancel: function() {
					$( this ).dialog( "destroy" );
					return;
				}
			}
		});
	});

	$(".savealrtcfg").button().prop( "disabled", true ).on("click", function(event) {
		event.preventDefault();
		if ($( "input.alrtcol.ui-state-error" ).length) {
			$.alert("Please correct all marked fields before saving!", "Configuration check result", false);
			return;
		}
		$("#aclfile").text("");
		var delimiter = "\\:";
		var alertext = "";
		var alrtxt = [];
		var line = [];

		$.each($('#optform').serializeArray(), function(i, field) {
			line = [field.name, field.value].join("=");
			alrtxt.push(line);
		});
		$.each($('#eventform').serializeArray(), function(i, field) {
			line = [field.name, field.value].join("=");
			alrtxt.push(line);
		});
		alrtxt.push("");
		$("#alrtgrptree").fancytree("getTree").visit(function(node) {
			if (node.getLevel() == 1) {
				var grp = node.title.replace(/\:/g, delimiter),
				emails = [];
				node.visit(function(tnode) {
					emails.push(tnode.title);
				});
				alrtxt.push( ['EMAIL', grp, emails.join(",")].join(":") );
			}
		});
		alrtxt.push("");
		$("#alrttree").fancytree("getTree").visit(function(node) {
			if (node.getLevel() == 2) {
				var subsys = node.data.subsys,
				storage = node.parent.title.replace(/\:/g, delimiter),
				match = [],
				gmatch = {},
				vals = {};
				node.visit(function(tnode) {
					title = tnode.parent.title;
					if (subsys == "POOL-ALL") {
						title = "";
					}
					line = [subsys, storage.replace(/:/g, "\\:"), title.replace(/:/g, "\\:"), tnode.data.metric, tnode.data.limit, tnode.data.peak, tnode.data.repeat, tnode.data.exclude, tnode.data.mailgrp, tnode.data.iothold].join(":");
					alrtxt.push(line);
				});
			}
		});
		alertext = alrtxt.join("\n");
		var postdata = {cmd: "save", acl: alertext};

		$.post( cgiPath + "/alcfg.sh", postdata, function( data ) {
			var returned = JSON.parse(data);
			if ( returned.status == "success" ) {
				$("#aclfile").text(returned.cfg).show();
				$("#alrttree").fancytree("getTree").reload();
			}
			$(returned.msg).dialog({
				dialogClass: "info",
				title: "Alerting configuration save - " + returned.status,
				minWidth: 600,
				modal: true,
				show: {
					effect: "fadeIn",
					duration: 500
				},
				hide: {
					effect: "fadeOut",
					duration: 200
				},
				buttons: {
					OK: function() {
						$(this).dialog("close");
					}
				}
			});
		});
		//if (! $("#aclfile").length ) {
		////	$(this).after("<br><pre><div id='aclfile' style='text-align: left; margin: auto; background: #fcfcfc; border: 1px solid #c0ccdf; border-radius: 10px; padding: 15px; display: none; overflow: auto'></div></pre>");
		////}
		////$("#aclfile").html(alertext).show();
	});

	$("#testalrtcfg").button().on("click", function(event) {
		event.preventDefault();  //stop the browser from following
		if (confirm ("Save configuration at first, only saved configuration will be tested!\n\nAlerting configuration will be tested.\nAll alerts will be raised even if no thresholds are reached.\n\nDo you want to continue?")) {
			document.body.style.cursor = 'wait';
			$.get(cgiPath + "/alert-test.sh", function(data) {
				if (data) {
					document.body.style.cursor = 'default';
					$("<div></div>").dialog( {
						close: function (event, ui) { $(this).remove(); },
						resizable: false,
						title: "Alerting test results",
						dialogClass: "testresult",
						height: "auto",
						width: "auto",
						position: {
							my: "left top",
							at: "left+100 top+50",
						},
						open: function(event, ui) {
							$(this).css({'max-height': $(document).height()-200, 'max-width': $(document).width()-200, 'overflow': 'auto'});
						},
						modal: true
					}).html("<pre>" + data + "</pre>");
				}
			});
		}
	});
	$("#testevents").button().on("click", function(event) {
		event.preventDefault();  //stop the browser from following
		document.body.style.cursor = 'wait';
		if (confirm ("Save configuration at first, only saved configuration will be tested!\n\nAlerting notification will be sent to all recipients.\n\nDo you want to continue?")) {
			$.get(cgiPath + "/alert-test-events.sh", function(data) {
				if (data) {
					document.body.style.cursor = 'default';
					$("<div></div>").dialog( {
						close: function (event, ui) { $(this).remove(); },
						resizable: false,
						title: "Alerting test results",
						dialogClass: "testresult",
						height: "auto",
						width: "auto",
						position: {
							my: "left top",
							at: "left+100 top+50",
						},
						open: function(event, ui) {
							$(this).css({'max-height': $(document).height()-200, 'max-width': $(document).width()-200, 'overflow': 'auto'});
						},
						modal: true
					}).html("<pre>" + data + "</pre>");
				}
			});
		}
	});

	var bar = $('.bar');
	var percent = $('.percent');
	var status = $('#status');
	$(status).hide();

	$( '#upgrade-form' ).ajaxForm({
		beforeSend: function() {
			status.empty();
			var percentVal = '0%';
			bar.width(percentVal);
			percent.html(percentVal);
			document.body.style.cursor = 'wait';
		},
		uploadProgress: function(event, position, total, percentComplete) {
			var percentVal = percentComplete + '%';
			bar.width(percentVal);
			percent.html(percentVal);
		},
		success: function(data, textStatus, jqXHR) {
			var percentVal = '100%';
			bar.width(percentVal);
			percent.html(percentVal);
			status.html("<b>Please wait, your file is being processed...</b>");
			$(status).show(200);
		},
		complete: function(xhr) {
			document.body.style.cursor = 'auto';
			status.html(xhr.responseJSON.log);
			$.alert(xhr.responseJSON.message, "Upgrade install result", xhr.responseJSON.success);
			$( "#run-data-load" ).button().on( "click", function() {
				params = { cmd: "load" };
				$.post(cgiPath + "/upgrade.sh", params, function(jsonData) {
					$.alert(jsonData.message, "Data load launched", jsonData.success);
				}, 'json');
			});
			if (xhr.responseJSON.success) {
				$("#side-menu").fancytree("getTree").reload();
				$("#side-menu").fancytree("getTree").reactivate();
			}
		}
	});

	$( "#collect-logs" ).button().on( "click", function(e) {
		e.preventDefault();  //stop the browser from following
		window.location.href = cgiPath + "/collect_logs.sh?cmd=logs";
	});

/*
 *    $( "<button>" )
 *      .text( "Show help" )
 *      .button()
 *      .on("click", function() {
 *        tooltips.tooltip( "open" );
 *      })
 *      .insertAfter( "#savealcfg" );
 *
 */
	var tooltips = $( ".optform [title]" ).tooltip ({
		position: {
			my: "left top",
			at: "right+5 top-5"
		},
		open: function(event, ui) {
			if (typeof(event.originalEvent) === 'undefined') {
				return false;
			}
			var $id = $(ui.tooltip).attr('id');
			// close any lingering tooltips
			$('div.ui-tooltip').not('#' + $id).remove();
			// ajax function to pull in data and add it to the tooltip goes here
		},
		close: function(event, ui) {
			ui.tooltip.hover(function() {
				$(this).stop(true).fadeTo(400, 1);
			},
			function() {
				$(this).fadeOut('400', function() {
					$(this).remove();
				});
			});
		},
		content: function () {
			return $(this).prop('title');
		}
	});

	$( "#volcustomform" ).on("submit", function(event) {
		// $ENV{WEB_CGI_PATH}/detail-graph.sh?host=IBM-Storwize&type=VOLUME&name=top&item=avrg&time=w&detail=0&none=1473792347
		var postData = [];
		if (curNode.getLevel() == 1) {
			postData.push ({name: "host", value: "none"});
		} else {
			postData.push ({name: "host", value: curNode.parent.parent.title});
		}
		postData.push ({name: "type", value: "VOLUME"});
		if (curNode.getLevel() == 1) {
			postData.push ({name: "name", value: "topglobal"});
		} else {
			postData.push ({name: "name", value: "top"});
		}
		postData.push ({name: "item", value: $(this).children("select").val().toLowerCase()});
		postData.push ({name: "time", value: "d"});
		postData.push ({name: "detail", value: 0});

		postData.push ({name: "sunix", value: $("#fromTime").datetimepicker("getDate").getTime() / 1000});
		postData.push ({name: "eunix", value: $("#toTime").datetimepicker("getDate").getTime() / 1000});

		$.cookie('fromTimeField', $("#fromTime").datetimepicker("getDate"), {
			expires: 0.04
		});
		$.cookie('toTimeField', $("#toTime").datetimepicker("getDate"), {
			expires: 0.04
		});

		event.preventDefault();
		if (timeoutHandle) {
			clearTimeout(timeoutHandle);
		}

		$('#volresults').empty();

		$('#volresults').append("<div style='width: 100%; height: 100%; text-align: center'><img src='css/images/sloading.gif' style='margin-top: 200px'></div>");
		// $('#title').text("Accounting results");
		// var postData = $(this).serialize();
		if (sysInfo.guidebug == 1) {
			copyToClipboard(postData);
		}
		$('#volresults').load(this.action, $.param(postData), function() {
			imgPaths();
			var $t = $(this).find('table.tablesorter');
			if ($t.length) {
				tableSorter($t);
			}
			hrefHandler();
		});

	});

	if ( $("#usertable").length ) {
		$.getJSON(cgiPath + '/users.sh?cmd=json', function(data) {
			usercfg = data;
			var isAdmin = false;
			if (usercfg.users[sysInfo.uid]) {
				isAdmin = $.inArray(aclAdminGroup, usercfg.users[sysInfo.uid].groups) > -1;
			}
			if (!isAdmin) {
				$("#adduser").prop('disabled', 'disabled');
			}
			$.each(Object.keys(usercfg.users).sort(), function(x, i) {
				var val = usercfg.users[i];
				var row = "<tr>";
				var adminRow = $.inArray(aclAdminGroup, val.groups) > -1;
				var isInMyGroups = false;
				//uncomment 'each' cycle if you want to show group members to non-admin users
				//$.each(val.groups, function (gx, gr) {
				//	if ($.inArray(gr, usercfg.users[sysInfo.uid].groups) > -1) {
				//		isInMyGroups = true;
				//	};
				//});
				if (isAdmin || sysInfo.uid == i || isInMyGroups) {
					if (isAdmin || sysInfo.uid == i) {
						if (adminRow) {
							row += "<td><b><a href='#' class='userlink'>" + i + "</a></b></td>";
						} else {
							row += "<td><a href='#' class='userlink'>" + i + "</a></td>";
						}
					} else {
						row += "<td>" + i + "</td>";
					}
					row += "<td>" + val.name + "</td>";
					row += "<td><a href='mailto:" + val.email + "'>" + val.email + "</a></td>";
					if ((isAdmin && !adminRow ) || sysInfo.uid == i) {
						row += "<td style='text-align: center;'><a href='#' class='passlink'>change</a></td>";
					} else {
						row += "<td style='text-align: center;'></td>";
					}
					row += "<td>" + ShowDate(val.created) + "</td>";
					row += "<td>" + ShowDate(val.changed) + "</td>";
					if (val.groups) {
						row += "<td>" + val.groups.join( ', ') + "</td>";
					} else {
						row += "<td></td>";
					}
					if (i != sysInfo.uid && isAdmin) {
						row += "<td><div class='delete' title='Delete user'></div></td>";
					} else {
						row += "<td></td>";
					}
					row += "</tr>";
					$("#usertable tbody").append(row);
				}
			});
			$("#usertable a.userlink").on("click", function(event) {
				var curUser = $(event.target).text();
				userDetailForm(curUser);
			});

			$("#adduser").button().on("click", function() {
				userDetailForm(false);
			});

			$("#usertable a.passlink").on("click", function(event) {
				var user = $(event.target).parent().parent().find(".userlink").text();
				var notMe = (sysInfo.uid != user);
				changePasswordForm(user, notMe);
			});

			$("#usertable .delete").on("click", function(event) {
				$.confirm(
					"Are you sure you want to remove this user?",
					"User delete confirmation",
					function() { /* Ok action here*/
						var user = $(event.target).parent().parent().find(".userlink").text();
						$(event.target).parent().parent().remove();
						delete usercfg.users[user];
						SaveUsrCfg();
					}
				);
			});
		});
	}
	if ( $("#grptable").length ) {
		$.getJSON(cgiPath + '/users.sh?cmd=json', function(data) {
			usercfg = data;
			var isAdmin = false;
			if (usercfg.users[sysInfo.uid]) {
				isAdmin = $.inArray(aclAdminGroup, usercfg.users[sysInfo.uid].groups) > -1;
			}
			if (!isAdmin) {
				$("#addgrp").prop('disabled', 'disabled');
			}
			$.each(usercfg.groups, function(i, val) {
				var row = "<tr>";
				if (isAdmin || sysInfo.uid == i) {
					row += "<td><a href='#' class='grplink'>" + i + "</a></td>";
				} else {
					row += "<td>" + i + "</td>";
				}
				row += "<td>" + val.description + "</td>";
				if (isAdmin && i != aclAdminGroup) {
					row += "<td><div class='delete'></div></td>";
				} else {
					row += "<td></td>";
				}
				row += "</tr>";
				$("#grptable tbody").append(row);
			});
			$("#grptable a.grplink").on("click", function() {
				var curUser = $(event.target).text();
				grpDetailForm();
			});

			$("#addgrp").button().on("click", function() {
				newGroupForm(false);
			});

			$("#grptable a.passlink").on("click", function() {
				var user = $(event.target).parent().parent().find(".userlink").text();
				var notMe = (sysInfo.uid != user);
				changePasswordForm(usercfg.users[user], notMe);
			});

			$("#grptable .delete").on("click", function(event) {
				$.confirm(
					"Are you sure you want to remove this group?",
					"Group delete confirmation",
					function() { /* Ok action here*/
						var grp = $(event.target).parent().parent().find(".grplink").text();
						$(event.target).parent().parent().remove();
						delete usercfg.groups[grp];
						SaveUsrCfg();
					}
				);
			});
		});
	}
	if ( $("#perf_logs").length ) {
		$.get(cgiPath + '/alcfg.sh?cmd=plog&count=100', function(data) {
			$("#perf_logs").html(data);
			tableSorter($("#perf_logs table"));
			$.get(cgiPath + '/alcfg.sh?cmd=hlog&count=100', function(data) {
				$("#hw_logs").html(data);
				tableSorter($("#hw_logs table"));
				hrefHandler();
			});
		});
	}

	// ################################################################################
	// Reporter start

	if ( $("#reptable").length || $("#repgrptable").length) {
		if (timeoutHandle) {
			clearTimeout(timeoutHandle);
		}
		$.getJSON(cgiPath + '/genpdf.sh?cmd=test', function(data) {
			if (data.success) {
				backendSupportsPDF = true;
			} else {
				var info = "<p style='font-style: italic'><span style='color: red'>Warning:</span> You cannot use PDF format for reporting, please install the <a href='http://www.stor2rrd.com/pdf-install.htm' target='_blank'>required pre-requisites</a>.";
				info += "&nbsp;&nbsp;&nbsp;<a href='#' id='dbgpdf' title='" + data.log + "'>Debug info...</a>";
				$("#moderr").append(info);
				$("#dbgpdf").on("click", function() {
					var dlg = "<p>Error message follows:</p>";
					$("<div></div>").dialog( {
						buttons: { "OK": function () { $(this).dialog("close"); } },
						close: function (event, ui) { $(this).remove(); },
						resizable: false,
						title: "PDF test failed",
						minWidth: 800,
						modal: true
					}).html(dlg + "<pre>" + data.log + "</pre>");
				});
			}
		});
		$.getJSON(cgiPath + '/reporter.sh?cmd=modtest', function(data) {
			if (data.success) {
				backendSupportsZIP = true;
			} else {
				var info = "<p style='font-style: italic'><span style='color: red'>Warning:</span> You cannot use ZIP reports, your host system cannot find required Perl module: IO::Compress::Zip. Please install the <a href='http://www.stor2rrd.com/zip-install.htm' target='_blank'>required pre-requisites</a>.";
				info += "&nbsp;&nbsp;&nbsp;<a href='#' id='dbgzip' title='" + data.log + "'>Debug info...</a>";
				$("#moderr").append(info);
				$("#dbgzip").on("click", function() {
					var dlg = "<p>Error message follows:</p>";
					$("<div></div>").dialog( {
						buttons: { "OK": function () { $(this).dialog("close"); } },
						close: function (event, ui) { $(this).remove(); },
						resizable: false,
						title: "ZIP module test failed",
						minWidth: 800,
						modal: true
					}).html(dlg + "<pre>" + data.log + "</pre>");
				});
			}
		});
		$.getJSON(cgiPath + '/reporter.sh?cmd=json', function(data) {
			repcfg = data;
			$.getJSON( cgiPath + "/genjson.sh?jsontype=fleet", function( data ) {
				fleet = data;
			});
			$.getJSON( cgiPath + "/genjson.sh?jsontype=metrics", function( data ) {
				metrics = data;
			});
			$.getJSON( cgiPath + "/genjson.sh?jsontype=custgrps", function( data ) {
				cgroups = data;
			});
			if (! repcfg.users) {
				repcfg.users = {};
				repcfg.users.admin = {};
				repcfg.users.admin.reports = repcfg.reports;
				repcfg.users.admin.groups = repcfg.groups;
				delete repcfg.reports;
				delete repcfg.groups;
			}
			var isAdmin = sysInfo.isAdmin;
			userName = sysInfo.uid;
			if (! userName) {
				userName = "admin";
				isAdmin = true;
			}
			if (! repcfg.users[userName]) {
				repcfg.users[userName] = {};
				repcfg.users[userName].reports = {}
				repcfg.users[userName].groups = {}
			}

			repcfgusr = repcfg.users[userName];
			$.each(Object.keys(repcfgusr.reports).sort(), function(x, i) {
				var val = repcfgusr.reports[i];
				var row = "<tr>";
				if (val.disabled) {
					row = "<tr class='disabled'>";
				}
				row += "<td><b><a href='#' class='replink'>" + i + "</a></b></td>";
				row += "<td>" + val.format + "</td>";
				row += "<td>" + rrToText(val.rrule) + "</td>";
				row += "<td>" + (sysInfo.basename ? "N/A" : val.disabled ? "disabled" : ShowDate(nextRuleRun(val.rrule), true)) + "</td>";
				row += "<td>" + ShowDate(val.created) + "</td>";
				row += "<td>" + ShowDate(val.updated) + "</td>";
				row += "<td>" + val.recipients.join( ', ') + "</td>";
				row += "<td style='text-align: center'><button class='testrep' title='Test report' /></td>";
				row += "<td style='text-align: center'><div class='delete' title='Delete report'></div></td>";
				row += "</tr>";
				$("#reptable tbody").append(row);
			});
			$("#reptable a.replink").on("click", function(event) {
				var curID = $(event.target).text();
				repDetailForm(curID);                      // create new fn
			});
			$("#reptable .testrep").button({
				icon: 'ui-icon-play'
			}).on("click", function(event) {
				document.body.style.cursor = 'wait';
				var repName = $(event.target).parents("tr").find(".replink").text();
				$.getJSON(cgiPath + '/reporter.sh?cmd=test', {repname: repName, user: userName }, function(data) {
					document.body.style.cursor = 'default';
					var dlg = "<p>Error message follows:</p>";
					var title = "";
					var log = "";
					if (data.status) {
						dlg = "<p>Report log follows:</p>";
						title = "Report test succeed";
						log = "<h3>Your report has been generated.</h3>";
						if (data.emails) {
							log += "<p>It has been sent to the defined mail groups</p>";
						}
						log += "<p>You can find it on the host running this tool:</p>";
						log += "<pre>" + data.stored + "</pre>";
						log += "<p>Download it from the following link:</p>";
						log += "<p><a href='" + cgiPath + "/reporter.sh?cmd=get&filename=" + encodeURIComponent(data.dnld) + "' target='_blank'>" + data.filename + "</a></p>";
						// backendSupportsPDF = true;
					} else {
						title = "Report test failed";
						log = dlg + "<pre>" + data.error + "</pre>";
					}
					$("<div></div>").dialog( {
						buttons: { "OK": function () { $(this).dialog("close"); } },
						close: function (event, ui) {
							$(this).remove();
						},
						open: function() {
							$('.ui-widget-overlay').addClass('custom-overlay');
						},
						resizable: false,
						position: { my: "top", at: "top+20", of: window },
						title: title,
						minWidth: 800,
						modal: true
					}).html(log);
				});
			});

			$("#addrep").button().on("click", function() {
				repDetailForm(false);                      // create new fn
			});

			$("#reptable .delete").on("click", function(event) {
				$.confirm(
					"Are you sure you want to delete this report?",
					"Report delete confirmation",
					function() { /* Ok action here*/
						var rep = $(event.target).parent().parent().find(".replink").text();
						$(event.target).parent().parent().remove();
						delete repcfgusr.reports[rep];
						SaveRepCfg();                      // create new fn
						if (sysInfo.basename && $.isEmptyObject(repcfgusr.reports)) {
							$("#addrep").button("enable");
						}
					}
				);
			});
			if (sysInfo.basename && ! $.isEmptyObject(repcfgusr.reports)) {
				$("#addrep").button("disable");
			}
			$.each(Object.keys(repcfgusr.groups).sort(), function(i, j) {
				var val = repcfgusr.groups[j];
				var row = "<tr>";
				if (isAdmin || sysInfo.uid == i) {
					row += "<td><a href='#' class='grplink'>" + j + "</a></td>";
				} else {
					row += "<td>" + j + "</td>";
				}
				row += "<td>" + val.description + "</td>";
				if (!val.emails) {
					val.emails = [];
				}
				row += "<td>" + val.emails.join( ', ') + "</td>";
				if (isAdmin) {
					row += "<td><div class='delete'></div></td>";
				} else {
					row += "<td></td>";
				}
				row += "</tr>";
				$("#repgrptable tbody").append(row);
			});
			$("#repgrptable a.grplink").on("click", function(event) {
				var curGrp = $(event.target).text();
				newRepGroupForm(curGrp);
			});

			$("#addgrp").button().on("click", function() {
				newRepGroupForm(false);
			});
			$("#repgrptable .delete").on("click", function(event) {
				$.confirm(
					"Are you sure you want to remove this group?",
					"Group delete confirmation",
					function() { /* Ok action here*/
						var grp = $(event.target).parent().parent().find(".grplink").text();
						$(event.target).parent().parent().remove();
						delete repcfgusr.groups[grp];
						SaveRepCfg();
					}
				);
			});
		});
		$(".saverepcfg").button().on("click", function(event) {
			if ($("#csv_delim").val()) {
				repcfgusr.csvDelimiter = $("#csv_delim").val();
			} else {
				delete repcfgusr.csvDelimiter;
			}
			SaveRepCfg(true);
		});
		if (sysInfo.free == 1) {
			$("#freeinfo").show();
		}
		if (sysInfo.demo == 1) {
			$("#repexamples").show();
		}
	}
	//  Reporter end
	/// ##########################################################################################

	if ( $("div.hsdiv").length ) {
		$("#hs_storages").tablesorter({
			theme: "ice",
			ignoreCase: false,
			sortList: [[0,0]],
			textExtraction : function(node, table, cellIndex) {
				n = $(node);
				return n.attr('data-sortValue') || n.text();
			}
		});
		$("#hs_switches").tablesorter({
			theme: "ice",
			ignoreCase: false,
			sortList: [[0,0]],
			textExtraction : function(node, table, cellIndex) {
				n = $(node);
				return n.attr('data-sortValue') || n.text();
			}
		});
	}
}

function fancyBox() {
	$('a.detail').colorbox({
		photo: true,
		live: false,
		speedIn: 300,
		fadeOut: 100,
		scalePhotos: true, // images won't be scaled to fit to browser's height
		maxWidth: "95%",
		initialWidth: 1200,
		opacity: 0.4,
		hideOnContentClick: true,
		onOpen: function(obj) {
			if (storedUrl) {
				obj.href = zoomedUrl;
			} else {
				var tUrl = obj.href;
				tUrl += "&nonefb=" + Math.floor(new Date().getTime() / 1000);
				obj.href = tUrl;
			}
			return true;
		},
		onComplete: function() {
			$('.cboxPhoto').off().on("click", $.colorbox.close);
		},
		onClosed: function() {
			if (storedUrl) {
				$(storedObj).attr("href", storedUrl);
				storedUrl = "";
				storedObj = {};
			}
		}
	});
}

function saveCookies() {
	var hashes = dbHash.join(":");
	$.cookie('dbHashes', hashes, {
		expires: 60
	});
}

function genDashboard() {
	if (sysInfo.vmImage) {
		$( "#lpar2rrd" ).attr("onclick", "window.location.href = '/lpar2rrd'");
	}
	if (prodName == "STOR2RRD") {
		$( "#lpar2rrd" ).show()
	}
	$("ul.dashlist li").remove();
	if ($.cookie('flatDB')) {
		$( "#tabs" ).tabs( "destroy" );
		$( "#tabs > ul" ).hide();
		$( "#tabs div" ).hide();
		$( ".dashlist p" ).show();
	}
	if (dbHash.length) {
		$.each(dbHash, function(i, val) {
			var dbItem = hashRestore(val);
			if (jQuery.isEmptyObject(dbItem) || ! dbItem.item) {
				return true;
			}
			var isSAN = (dbItem.item.substring(0, 4) == "san_");
			var isLAN = (dbItem.item.substring(0, 4) == "lan_");
			if (dbItem.server == 'CACHE') {
				dbItem.server = "NODE-CACHE";
			}

			if (dbItem.lpar == 'sum' && ! isSAN && ! isLAN) {
				dbItem.lpar = dbItem.item;
				dbItem.item = 'sum';
			} else if (isSAN || isLAN) {

				if (dbItem.host == "Totals-BNA" && (dbItem.item == "san_cpu_tot" || dbItem.item == "san_mem_tot")) {
					dbItem.host = "totals";
					dbItem.lpar = "totals-BNA";
				} else if (/Totals|Totals-BNA|LAN-Totals/.test(dbItem.host)) {
					dbItem.host = "totals";
					dbItem.lpar = "totals";
				}
			}

			var complHref = urlQstring(dbItem, 1) + "&none=" + Math.floor(new Date().getTime() / 1000);
			var complUrl = urlQstring(dbItem, 2) + "&none=" + Math.floor(new Date().getTime() / 1000);
			var title = dbItem.host + ": ";
			if (dbItem.item == "sum") {
				if (dbItem.longname) {
					dbItem.host = dbItem.longname;
				}
				title += urlItems[dbItem.lpar][0] + " | ";
			} else {
				if (dbItem.longname) {
					dbItem.lpar = dbItem.longname;
				}
				var lparstr = dbItem.lpar;
				if (lparstr) {
					title += lparstr + ": " + urlItems[dbItem.item][0] + " | ";
				}
			}

			title += intervals[dbItem.time];

			var topTitle = dbItem.host;

			if (dbItem.host == "custom-group") {
				topTitle = dbItem.lpar;
			}

			var flat = $.cookie('flatDB');

			if (dbItem.item) {
				if (dbItem.item.indexOf("custom") >= 0) {
					$( "#tabs > ul li:eq( 0 )" ).show();
					if (flat) {
						$( "#tabs-1" ).show();
					}
					$("#dashboard-cust").append("<li><a href='" + complHref + "' class='detail'><span class='dbitemtitle'>" + topTitle + "</span></br><img class='lazy' src='css/images/sloading.gif' data-src='" + complUrl + "' title='" + title + "' alt='" + val + "'></a><div class='dash' title='Remove this item from DashBoard'></div></li>");
				} else if (isSAN) {
					$( "#tabs > ul li:eq( 8 )" ).show();
					if (flat) {
						$( "#tabs-9" ).show();
					}
					$("#dashboard-san").append("<li><a href='" + complHref + "' class='detail'><span class='dbitemtitle'>" + topTitle + "</span></br><img class='lazy' src='css/images/sloading.gif' data-src='" + complUrl + "' title='" + title + "' alt='" + val + "'></a><div class='dash' title='Remove this item from DashBoard'></div></li>");
				} else if (dbItem.server == 'POOL' || dbItem.server == 'NAS POOL') {
					$( "#tabs > ul li:eq( 1 )" ).show();
					if (flat) {
						$( "#tabs-2" ).show();
					}
					$("#dashboard-pool").append("<li><a href='" + complHref + "' class='detail'><span class='dbitemtitle'>" + topTitle + "</span></br><img class='lazy' src='css/images/sloading.gif' data-src='" + complUrl + "' title='" + title + "' alt='" + val + "'></a><div class='dash' title='Remove this item from DashBoard'></div></li>");
				} else if (dbItem.server == "RANK" || dbItem.server == "Managed disk") {
					$( "#tabs > ul li:eq( 2 )" ).show();
					if (flat) {
						$( "#tabs-3" ).show();
					}
					$("#dashboard-rank").append("<li><a href='" + complHref + "' class='detail'><span class='dbitemtitle'>" + topTitle + "</span></br><img class='lazy' src='css/images/sloading.gif' data-src='" + complUrl + "' title='" + title + "' alt='" + val + "'></a><div class='dash' title='Remove this item from DashBoard'></div></li>");
				} else if (dbItem.server == "VOLUME") {
					$( "#tabs > ul li:eq( 3 )" ).show();
					if (flat) {
						$( "#tabs-4" ).show();
					}
					$("#dashboard-volume").append("<li><a href='" + complHref + "' class='detail'><span class='dbitemtitle'>" + topTitle + "</span></br><img class='lazy' src='css/images/sloading.gif' data-src='" + complUrl + "' title='" + title + "' alt='" + val + "'></a><div class='dash' title='Remove this item from DashBoard'></div></li>");
				} else if (dbItem.server == "DRIVE") {
					$( "#tabs > ul li:eq( 4 )" ).show();
					if (flat) {
						$( "#tabs-5" ).show();
					}
					$("#dashboard-drive").append("<li><a href='" + complHref + "' class='detail'><span class='dbitemtitle'>" + topTitle + "</span></br><img class='lazy' src='css/images/sloading.gif' data-src='" + complUrl + "' title='" + title + "' alt='" + val + "'></a><div class='dash' title='Remove this item from DashBoard'></div></li>");
				} else if (dbItem.server == "PORT") {
					$( "#tabs > ul li:eq( 5 )" ).show();
					if (flat) {
						$( "#tabs-6" ).show();
					}
					$("#dashboard-port").append("<li><a href='" + complHref + "' class='detail'><span class='dbitemtitle'>" + topTitle + "</span></br><img class='lazy' src='css/images/sloading.gif' data-src='" + complUrl + "' title='" + title + "' alt='" + val + "'></a><div class='dash' title='Remove this item from DashBoard'></div></li>");
				} else if (dbItem.server == "CPU-NODE" || dbItem.server == "CPU-CORE" || dbItem.server == "CPU") {
					$( "#tabs > ul li:eq( 6 )" ).show();
					if (flat) {
						$( "#tabs-7" ).show();
					}
					$("#dashboard-cpu").append("<li><a href='" + complHref + "' class='detail'><span class='dbitemtitle'>" + topTitle + "</span></br><img class='lazy' src='css/images/sloading.gif' data-src='" + complUrl + "' title='" + title + "' alt='" + val + "'></a><div class='dash' title='Remove this item from DashBoard'></div></li>");
				} else if (dbItem.server == "HOST") {
					$( "#tabs > ul li:eq( 7 )" ).show();
					if (flat) {
						$( "#tabs-8" ).show();
					}
					$("#dashboard-host").append("<li><a href='" + complHref + "' class='detail'><span class='dbitemtitle'>" + topTitle + "</span></br><img class='lazy' src='css/images/sloading.gif' data-src='" + complUrl + "' title='" + title + "' alt='" + val + "'></a><div class='dash' title='Remove this item from DashBoard'></div></li>");
				} else if (dbItem.server == "SAN") {
					$( "#tabs > ul li:eq( 8 )" ).show();
					if (flat) {
						$( "#tabs-9" ).show();
					}
					$("#dashboard-san").append("<li><a href='" + complHref + "' class='detail'><span class='dbitemtitle'>" + topTitle + "</span></br><img class='lazy' src='css/images/sloading.gif' data-src='" + complUrl + "' title='" + title + "' alt='" + val + "'></a><div class='dash' title='Remove this item from DashBoard'></div></li>");
				} else if (isLAN) {
					$( "#tabs > ul li:eq( 9 )" ).show();
					if (flat) {
						$( "#tabs-10" ).show();
					}
					$("#dashboard-lan").append("<li><a href='" + complHref + "' class='detail'><span class='dbitemtitle'>" + topTitle + "</span></br><img class='lazy' src='css/images/sloading.gif' data-src='" + complUrl + "' title='" + title + "' alt='" + val + "'></a><div class='dash' title='Remove this item from DashBoard'></div></li>");
				} else if (dbItem.server == "NODE-CACHE") {
					$( "#tabs > ul li:eq( 10 )" ).show();
					if (flat) {
						$( "#tabs-11" ).show();
					}
					$("#dashboard-cache").append("<li><a href='" + complHref + "' class='detail'><span class='dbitemtitle'>" + topTitle + "</span></br><img class='lazy' src='css/images/sloading.gif' data-src='" + complUrl + "' title='" + title + "' alt='" + val + "'></a><div class='dash' title='Remove this item from DashBoard'></div></li>");
				} else if (dbItem.server == "NODE") {
					$( "#tabs > ul li:eq( 11 )" ).show();
					if (flat) {
						$( "#tabs-12" ).show();
					}
					$("#dashboard-node").append("<li><a href='" + complHref + "' class='detail'><span class='dbitemtitle'>" + topTitle + "</span></br><img class='lazy' src='css/images/sloading.gif' data-src='" + complUrl + "' title='" + title + "' alt='" + val + "'></a><div class='dash' title='Remove this item from DashBoard'></div></li>");
				} else if (dbItem.server == "LUN") {
					$( "#tabs > ul li:eq( 12 )" ).show();
					if (flat) {
						$( "#tabs-13" ).show();
					}
					$("#dashboard-lun").append("<li><a href='" + complHref + "' class='detail'><span class='dbitemtitle'>" + topTitle + "</span></br><img class='lazy' src='css/images/sloading.gif' data-src='" + complUrl + "' title='" + title + "' alt='" + val + "'></a><div class='dash' title='Remove this item from DashBoard'></div></li>");
				} else if (dbItem.server == "NAS") {
					$( "#tabs > ul li:eq( 13 )" ).show();
					if (flat) {
						$( "#tabs-14" ).show();
					}
					$("#dashboard-nas").append("<li><a href='" + complHref + "' class='detail'><span class='dbitemtitle'>" + topTitle + "</span></br><img class='lazy' src='css/images/sloading.gif' data-src='" + complUrl + "' title='" + title + "' alt='" + val + "'></a><div class='dash' title='Remove this item from DashBoard'></div></li>");
				} else if (dbItem.server == "FS") {
					$( "#tabs > ul li:eq( 14 )" ).show();
					if (flat) {
						$( "#tabs-15" ).show();
					}
					$("#dashboard-fs").append("<li><a href='" + complHref + "' class='detail'><span class='dbitemtitle'>" + topTitle + "</span></br><img class='lazy' src='css/images/sloading.gif' data-src='" + complUrl + "' title='" + title + "' alt='" + val + "'></a><div class='dash' title='Remove this item from DashBoard'></div></li>");
				} else {
					$( "#tabs > ul li:eq( 15 )" ).show();
					if (flat) {
						$( "#tabs-16" ).show();
					}
					$("#dashboard-other").append("<li><a href='" + complHref + "' class='detail'><span class='dbitemtitle'>" + topTitle + "</span></br><img class='lazy' src='css/images/sloading.gif' data-src='" + complUrl + "' title='" + title + "' alt='" + val + "'></a><div class='dash' title='Remove this item from DashBoard'></div></li>");
				}
			}
		});

		if ( $("#tabs > ul li:visible").length == 1) {
			$("#tabs > ul li:visible a").trigger("click");
		}

		$(".dashlist li").css({
			"width": Number(sysInfo.dashb_rrdwidth) + 75 + "px",
			"height": Number(sysInfo.dashb_rrdheight) + 60 + "px"
			//	"line-height": Number(sysInfo.dashb_rrdheight) + 60 + "px"
		});
		loadImages('#content img.lazy');
		fancyBox();

		$("div.dash").on("click", function() {
			var hash = $(this).parent().find('img').attr('alt');
			var toRemove = $.inArray(hash, dbHash);
			if (toRemove >= 0) {
				dbHash.splice(toRemove, 1);
				saveCookies();
				$(this).parent().hide("slow");
			}
		});
		$("ul.dashlist").sortable({
			dropOnEmpty: false
		});

		$("ul.dashlist").on("sortupdate", function(event, ui) {
			dbHash.length = 0;
			$("ul.dashlist li").find('img').each(function() {
				var hash = $(this).attr('alt');
				dbHash.push(hash);
			});
			saveCookies();
		});
	}
}

function saveDbState() {
	var valid = true;
	dbfilename = $("#dbfilename");
	dbfilename.removeClass( "ui-state-error" );

	valid = valid && checkLength( dbfilename, "filename", 1, 160 )
	valid = valid && checkRegexp( dbfilename, /^([0-9a-zA-Z_\s])+$/i, "File name may consist of A-Z, a-z, 0-9, underscores and spaces." );
	if ( $('#dbfilecombo option[value="' + dbfilename.val() + '"]').length ) {
		valid = valid && confirm ("File '" + dbfilename.val() + "' already exists, do you want to overwrite");
	}

	if ( valid ) {
		// var postdata = { "save": "db_websave", "cookie" : $.cookie('dbHashes')};
		var postdata = "save=db_" + dbfilename.val() + "&cookie=" + $.cookie('dbHashes');

		$.ajax( { method: "GET" , url: cgiPath + "/dashboard.sh", data: postdata} ).done( function( data ) {
			$(data.msg).dialog({
				dialogClass: "info",
				title: "DashBoard save - " + data.status,
				minWidth: 600,
				modal: true,
				show: {
					effect: "fadeIn",
					duration: 500
				},
				hide: {
					effect: "fadeOut",
					duration: 200
				},
				buttons: {
					OK: function() {
						$(this).dialog("destroy");
					}
				}
			});
		});
		$("#dialog-form").dialog("destroy")
	}
	return valid;
}

function restoreDbState() {
	dbfilename = $("#dbfilename");
	dbfilename.removeClass( "ui-state-error" );

	// var postdata = { "save": "db_websave", "cookie" : $.cookie('dbHashes')};
	var postdata = "load=db_" + dbfilename.val();

	$.get( cgiPath + "/dashboard.sh?" + postdata, function( data ) {
		if ( data.status == "success" && data.cookie) {
			$.cookie('dbHashes', data.cookie, {
				expires: 60
			});
			$("#side-menu").fancytree("getTree").reactivate();
			$("<p>DashBoard has been succesfuly restored from " + data.filename + "</p>").dialog({
				dialogClass: "info",
				title: "DashBoard restore - " + data.status,
				minWidth: 600,
				modal: true,
				show: {
					effect: "fadeIn",
					duration: 500
				},
				hide: {
					effect: "fadeOut",
					duration: 200
				},
				buttons: {
					OK: function() {
						$(this).dialog("destroy");
					}
				}
			});
		}
	});
	$("#dialog-form").dialog("destroy");
	//		genDashboard;
	return true;
}

function itemDetails(pURL, decode) {
	var host = getUrlParameters("host", pURL, decode);
	var type = getUrlParameters("type", pURL, decode);
	var vname = getUrlParameters("name", pURL, decode);
	var item = getUrlParameters("item", pURL, false);
	var time = getUrlParameters("time", pURL, false);
	if (item == 'sum') {
		item = vname;
		vname = 'sum';
	}
	// var itemcode = String.fromCharCode(97 + $.inArray(item, urlItems));
	var itemcode = "";
	try {
		itemcode = urlItems[item][1];
	} catch (exception) {
		window.console && console.log("Unknown URL item type: " + item);
	}
//	var menutext = tabHead[item];
	return {
		"host": host,
		"type": type,
		"name": vname,
		"item": item,
		"time": time,
		"itemcode": itemcode,
//		'menutext': menutext
	};
}

function hashRestore(hash) {
	var params = {};
	var i = hashTable[hash.substring(0, 7)];
	if (i) {
		var indexChars = hash.substring(7, 9);
		var itemIndex = jQuery.map(urlItems, function (item, index) {
			return item[1] == indexChars ? index : null;
		});
		// var itemIndex = hash.substring(7, 8).charCodeAt(0) - 97;
		var item = itemIndex[0];
		if ((i.hmc + i.srv) == "nana") {
			i.hmc = "custom-group";
			i.srv = i.type;
		}
		var time = hash.substring(9, 10);
		var lpar = i.lpar;
		params = {
			"host": i.hmc,
			"server": i.srv,
			"lpar": lpar,
			"item": item,
			"time": time,
			longname: i.longname
		};
	}
	return params;
}

function urlQstring(p, det, tot) {
	var qstring = [];
	qstring.push({
		name: "host",
		value: p.host
	});
	qstring.push({
		name: "type",
		value: p.server
	});
	qstring.push({
		name: "name",
		value: p.lpar
	});
	qstring.push({
		name: "item",
		value: p.item
	});
	qstring.push({
		name: "time",
		value: p.time
	});
	qstring.push({
		name: "detail",
		value: det
	});

	return cgiPath + "/detail-graph.sh?" + $.param(qstring);
}


function loadImages(selector) {
	$(selector).lazy({
		bind: 'event',
		/*        delay: 0, */
		effect: 'fadeIn',
		effectTime: 400,
		threshold: 100,
		appendScroll: $("div#econtent"),
		beforeLoad: function(element) {
			getImageData(element);
			if (! $(element).data("revert_url")) {
				$(element).data("revert_url", element.attr("data-src"));
			}
			element.parents("td").css("vertical-align", "middle");
		},
		afterLoad: function(element) {
			$(element).removeClass('load');
			$(element).parents("td.relpos").css("vertical-align", "top");
			$(element).parents("td.relpos").css("text-align", "left");
			$(element).parents("td.relpos").find("div.favs").show();
			$(element).parents("td.relpos").find("div.dash").show();
			// $(element).parents("td.relpos").find("div.popdetail").show();
		}
	});
}

function getImageData(element) {
	var dataSrc = getParams(element.attr("data-src"));
	if (dataSrc.detail == 8 || dataSrc.detail == 9) {
		var title = "<span class='tt_subsys'>" + dataSrc.type;
		if (dataSrc.item == 'sum') {
			dataSrc.item = dataSrc.name;
		}
		var itemTitle = "";
		try {
			itemTitle = urlItems[dataSrc.item][0];
		} catch (exception) {
			window.console && console.log("Unknown URL item type: " + dataSrc.item);
			itemTitle = "<span style='color:red;font-weight:bold'>" + dataSrc.item + "</span>";
		}
		if (dataSrc.item == "sum") {
			title += " aggregated</span> <span class='tt_item'>" + itemTitle + "</span>:";
		} else {
			title += "</span> <span class='tt_item'>" + itemTitle + "</span>:";
		}
		$(element).data("title", title);
		var period;
		switch (dataSrc.time) {
			case 'd':
				period = "last day";
			break;
			case 'w':
				period = "last week";
			break;
			case 'm':
				period = "last 4 weeks";
			break;
			case 'y':
				period = "last year";
			break;
		}
		period = " <span class='tt_range'>" + period + "</span>";
		$(element).data("period", period);
		var alink = $(element).parents("a.detail");
		$(alink).parent().find("span.tt_span").html(title + period).attr("title", $(title + period).text());
	}
	if ( $(element).hasClass("nolegend") ) {
		$.getJSON(element.attr("data-src"), function(data, textStatus, jqXHR) {
			var header = jqXHR.getResponseHeader('X-RRDGraph-Properties');
			if (header) {
				if (sysInfo.guidebug == 1) {
					$(element).parent().attr("title", header);
				}
				var h = header.split(":");
				var frame = $(element).siblings("div.zoom");
				if (frame.length) {
					$(frame).imgAreaSelect({
						remove: true
					});
					$(frame).data("graph_start", h[4]);
					$(frame).data("graph_end", h[5]);
					$(frame).data("title", title);
					$(frame).css("left", h[0] + "px");
					$(frame).css("top", h[1] + "px");
					$(frame).css("width", h[2] + "px");
					$(frame).css("height", h[3] + "px");
					if (h[2] && h[3]) {
						betterZoom($(frame).attr("id"), h[2], h[3]);
					}
					frame.show();
					// console.log(h);
				}
			}
			element.attr("src", data.img);
			legendTable(element, data.table);
			// loadImages(curImg);

		});
	} else {
		jQuery.ajax({
			// url: $(element).attr("data-src") + "&none=" + new Date().getTime(),
			url: $(element).attr("data-src"),
			//   complete: function (jqXHR, textStatus) {
			success: function(data, textStatus, jqXHR) {
				var header = jqXHR.getResponseHeader('X-RRDGraph-Properties');
				if (header) {
					if (sysInfo.guidebug == 1) {
						$(element).parent().attr("title", header);
					}
					var h = header.split(":");
					var frame = $(element).siblings("div.zoom");
					if (frame.length) {
						$(frame).imgAreaSelect({
							remove: true
						});
						$(frame).data("graph_start", h[4]);
						$(frame).data("graph_end", h[5]);
						$(frame).css("left", h[0] + "px");
						$(frame).css("top", h[1] + "px");
						$(frame).css("width", h[2] + "px");
						$(frame).css("height", h[3] + "px");
						if (h[2] && h[3]) {
							betterZoom($(frame).attr("id"), h[2], h[3]);
						}
						frame.show();
						// console.log(h);
					}
				}
			}
		});
	}
}

function setTitle(menuitem) {
	var item = '';
	var path = '';
	var parents = menuitem.getParentList(false, true);
	var delimiter = '<span class="delimiter">&nbsp;&nbsp;|&nbsp;&nbsp;</span>';

	$.each(parents, function(key, part) {
		item = part.title;
		if (item.indexOf(prodName + " <span") >= 0) {
			item = prodName;
		}
		if (item != 'Items' && item != 'Totals' && item != "STORAGE") {
			if (path === '') {
				path = item;
			} else {
				path += delimiter + item;
			}
		}
	});

	if ((curNode.key != "_1") && (curNode.title != "Historical reports") && ($('#tabs').length)) {
		var tabText = $('#tabs li.ui-tabs-active').text();
		/*
		*if ( tabHead.tabText ) {
		*    path += delimiter + tabHead.tabText;
		*} else {
		*    path += delimiter + tabText;
		*}
		*/
	}

	$('#title').html(path);
	$('#title').show();

	if ($( "#alrttree" ).length) {
		$( "#title" ).append("<div id='hiw'><a href='http://www.stor2rrd.com/alerting.html' target='_blank'><img src='css/images/help-browser.gif' alt='More info about alerting...' title='More info about the alerting...'></a></div>");
	};
}

function hrefHandler() {
	$('#content a:not(.ui-tabs-anchor, .detail)').on("click", function() {
		var url = $(this).attr('href');
		if ((url.substring(0, 7) != "http://") && (!/\.csv$/.test(url)) && (!/lpar-list-rep\.sh/.test(url)) && ($(this).attr("title") != "CSV")) {
			backLink(url, this);
			return false;
		}
	});
}

function backLink(pURL, sender) {
	if (pURL == "#") {
		return false;
	}
	if (pURL.indexOf("?") >= 0) {
		if ($(sender).parent().hasClass("regroup")) {
			$('#content').load(pURL, function() {
				imgPaths();
				myreadyFunc();
				return false;
			});
		}
		var itemType = getUrlParameters("type", pURL, true);
		var typeList = ["POOL", "RANK", "PORT", "DRIVE", "VOLUME", "LDEV", "HOST", "HOST-ADAPTER", "NODE", "LUN", "NAS", "TIER", "NODE-CACHE", "SLO", "FS", "VOLUME-FOLDER", "HOST-GROUP", "IO-GROUP", "DDBOOST", "MTREE", "VTL", "CATALYST", "CLUSTER", "NFS", "SMB", "S3", "LANPORT"];
		if (jQuery.inArray(itemType, typeList) >= 0) {
			host = getUrlParameters("host", pURL, true);
			lpar = getUrlParameters("name", pURL, true);
			stortype = getUrlParameters("storage", pURL, true);
			/*
			if (itemType == "NAS" && stortype == "NETAPP") {
				itemType = "SVM";
			}
			if (stortype == "VMAX") {
				if (itemType == "VOLUME") {
					itemType = "STORAGE GROUP";
				}
				if (itemType == "NODE") {
					itemType = "DIRECTOR";
				}
				if (itemType == "DRIVE") {
					itemType = "DISK GROUP";
				}
				if (itemType == "NODE-CACHE") {
					itemType = "CACHE";
				}
			}
			if (stortype == "3PAR") {
				if (itemType == "NODE") {
					itemType = "CACHE";
				}
			}
			*/
			$tree = $("#side-menu").fancytree("getTree");
			$tree.visit(function(node) {
				if (node.data.altname == lpar || node.title == lpar) {
					var par1 = node.getParent(); // skip Items level
					// if (lpar != "cap" && lpar != "cap_pool" && lpar != "data" && lpar != "io" || (itemType == "HOST" && par1.getParent().title == "Items") ) {
					if (host == "custom-group") {
						if (par1.title == "CUSTOM GROUPS" || par1.getParent().title == "CUSTOM GROUPS") {
							node.setExpanded(true);
							node.setActive();
							return false;
						}
					}
					if (par1.title == "Items" || itemType == "SANPORT" || itemType == "LANPORT") {
						par1 = par1.getParent();    // get class level
					}
					if ( (lpar == "cap_pool" && par1.title == host) || (itemType == "SANPORT" && par1.title == host) || (itemType == "LANPORT" && par1.title == host)) {
						node.setExpanded(true);
						node.setActive();
						return false;
					}
					if (par1.data.bl && par1.data.bl == itemType) {
						par1 = par1.getParent();
						if (par1.title == host) {
							node.setExpanded(true);
							node.setActive();
							return false;
						}
					}
				}
			});
		} else if (itemType == "Data" || itemType == "Frame" || itemType == "Packet") {
			host = getUrlParameters("host", pURL, true);
			$tree = $("#side-menu").fancytree("getTree");
			$tree.visit(function(node) {
				if (node.title == itemType) {
					var par1 = node.getParent(); // skip Items level
					if (par1.data.altname == host || par1.title == host) {
						node.setExpanded(true);
						node.setActive();
						return false;
					}
				}
			});
		} else if (itemType == "SANPORT") {
			host = getUrlParameters("host", pURL, true);
			lpar = getUrlParameters("name", pURL, true);
			$tree = $("#side-menu").fancytree("getTree");
			$tree.visit(function(node) {
				if (node.data.altname == lpar || node.title == lpar) {
					var par1 = node.getParent(); // skip Items level
					par1 = par1.getParent();     // get class level
					var bna = (par1.data.obj == "W" && /-BNA$/.test(par1.data.altname));
					if (( bna && par1.data.altname == host) || (!bna && par1.title == host)) {
						node.setExpanded(true);
						node.setActive();
						return false;
					}
				}
			});
		}
	} else if (pURL.indexOf("gui-cpu.html") >= 0) {
		splitted = pURL.split("/");
		server = splitted[1];
		$tree = $("#side-menu").fancytree("getTree");
		$tree.visit(function(node) {
			if (node.title == "Totally for all CPU pools" || node.title == "CPU pool") {
				var par1 = node.getParent(); // skip LPARs level
				if (par1.title == server) {
					node.setExpanded(true);
					node.setActive();
					return false;
				}
			}
		});
	} else if (pURL.indexOf("health_status.html") >= 0) {
		splitted = pURL.split("/");
		server = splitted[0];
		$tree = $("#side-menu").fancytree("getTree");
		$tree.visit(function(node) {
			if (node.title == "Health status") {
				var par1 = node.getParent(); // skip LPARs level
				var bna = (par1.data.obj == "W" && /-BNA$/.test(par1.data.altname));
				if (( bna && par1.data.altname == server) || (!bna && par1.title == server)) {
					node.setExpanded(true);
					node.setActive();
					return false;
				}
			}
		});
	} else if (pURL.indexOf("config.html") >= 0  && curNode.title != "Configuration") {
		splitted = pURL.split("/");
		server = splitted[0];
		$tree = $("#side-menu").fancytree("getTree");
		$tree.visit(function(node) {
			if (node.title == "Configuration") {
				var par1 = node.getParent(); // skip LPARs level
				if (par1.title == server) {
					node.setExpanded(true);
					node.setActive();
					return false;
				}
			}
		});
	} else {
		var splitted = pURL.split("#");
		if (splitted[1]) {
			jumpTo = splitted[1];
		} else {
			jumpTo = "";
		}

		$('#content').load(pURL, function() {
			if (jumpTo) {
				jumpTo = decodeURI(jumpTo);
				location.hash = jumpTo;
			}
			imgPaths();
			myreadyFunc();
		});
	}
}

function getUrlParameters(parameter, url, decode) {
	var parArr = url.split("?")[1].split("&"),
		returnBool = true;

	for (var i = 0; i < parArr.length; i++) {
		parr = parArr[i].split("=");
		if (parr[0] == parameter) {
			return (decode) ? decodeURIComponent(parr[1].replace(/\+/g, " ")) : parr[1];
		} else {
			returnBool = false;
		}
	}
	if (!returnBool) {
		return false;
	}
}

function areCookiesEnabled() {
	var cookieEnabled = (navigator.cookieEnabled) ? true : false;

	if (typeof navigator.cookieEnabled == "undefined" && !cookieEnabled) {
		document.cookie = "testcookie";
		cookieEnabled = (document.cookie.indexOf("testcookie") != -1) ? true : false;
	}
	return (cookieEnabled);
}

function copyToClipboard(text) {
	window.prompt("GUI DEBUG: Please copy following content to the clipboard (Ctrl+C), then paste it to the bugreport (Ctrl-V)", text);
}

/*
function download(filename, text) {
	var pom = document.createElement('a');
	pom.setAttribute('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent(text));
	pom.setAttribute('download', filename);
	pom.trigger("click");
}

function arrayBytes(arr) {
	var g = JSON.stringify(arr).replace(/[\[\]\,\"]/g, ''); //stringify and remove all "stringification" extra data
	return (g.length); //this will be your length.
}
*/

function dataSource() {
	$("#datasrc").removeClass();
	$("#datasrc").hide();
	if ($('li.tabfrontend, li.tabbackend').length > 0) {
		var activeTab = $('#tabs li.ui-tabs-active');
		var title = "Data source: ";
		var cls = "";
		if (activeTab.hasClass("tabfrontend")) {
			title += "Frontend data";
			cls = "agent";
		} else if (activeTab.hasClass("tabbackend")) {
			title += "Backend data";
			cls = "nmon";
		} else if ($('li.tabfrontend').length > 0) {
			title += "Frontend data";
			cls = "agent";
		} else {
			title += "Backend data";
			cls = "nmon";
		}
		$("#datasrc").attr("title", title);
		$("#datasrc").addClass(cls);
		$("#datasrc").show();
	} else {
		$("#datasrc").addClass("none");
	}
}

function showHideSwitch() {
	if (curNode.parent.title == "Items" && curNode.parent.parent.title == "VOLUME") {
		var dataSources = "";
		if ($("ul.ui-tabs-nav").has("li.tabfrontend").length) {
			dataSources = "frontend";
		}
		if ($("ul.ui-tabs-nav").has("li.tabbackend").length) {
			if (dataSources == "frontend") {
				dataSources = "all"; // both OS agent and NMON data present
			} else {
				dataSources = "backend"; // just NMON data present
			}
		}
		if (dataSources == "all") {
			var activeTab = $('#tabs li.ui-tabs-active.tabfrontend,#tabs li.ui-tabs-active.tabbackend').text();
			if (activeTab) {
				$("#nmonsw").show();
			} else {
				$("#nmonsw").hide();
			}
		} else {
			$("#nmonsw").hide();
		}
		agentNmonToggle(dataSources);
	} else {
		$("#nmonsw").hide();
	}
}

//*************** Toggle agent/nmon data

function agentNmonToggle(src) {
	if (src == 'all') {
		if (($("#nmr1").is(':checked')) || src == "agent") {
			$("ul.ui-tabs-nav li.tabbackend").css("display", "none");
			$("ul.ui-tabs-nav li.tabfrontend").css("display", "inline-block");
		}

		if (($("#nmr2").is(':checked')) || src == "nmon") {
			$("ul.ui-tabs-nav li.tabbackend").css("display", "inline-block");
			$("ul.ui-tabs-nav li.tabfrontend").css("display", "none");
		}
	}
}

function histRepQueryString(managedName) {
	// get HMC & server name from menu url
	// var serverPath = $("#side-menu").fancytree('getActiveNode').data.href.split('/');
	var storage = curNode.parent.title;
	var queryArr = [{
		name: 'jsontype',
		value: 'histrep'
	}, {
		name: 'hmc',
		value: storage
	}, {
		name: 'managedname',
		value: managedName
	}];
	if ( curNode.parent.data.type == "SAN" || (curNode.parent.parent && (curNode.parent.parent.title == "SAN SWITCH" || curNode.parent.parent.title == "SAN SWITCH BNA"))) {
		queryArr.push({ name: 'class', value: "san" });
	}
	if ( curNode.parent.data.type == "LAN" || (curNode.parent.parent && (curNode.parent.parent.title == "LAN SWITCH"))) {
		queryArr.push({ name: 'class', value: "lan" });
	}
	return $.param(queryArr);
}

function sections() {
	// return;
	if (sysInfo.demo == "1") {
		var allSources = $("ul.ui-tabs-nav").has("li.tabbackend", "li.tabfrontend").length;
		if ($("li.tabhmc").length > 0) {
			$("#fsh").width(function() {
				var sectWidth = 0;
				$("li.tabhmc").each(function() {
					sectWidth += $(this).outerWidth() + 1;
				});
				return sectWidth - 1;
			});
			$("#fsh").show();
		} else {
			$("#fsh").hide();
		}

		if ($("li.tabfrontend").length > 0) {
			$("#fsa").width(function() {
				var sectWidth = 0;
				$("li.tabfrontend").each(function() {
					sectWidth += $(this).outerWidth() + 1;
				});
				return sectWidth - 1;
			});
			if (allSources === 0) {
				$("#fsa").show();
			} else if ($("#nmr1").is(':checked')) {
				$("#fsa").show();
			} else {
				$("#fsa").hide();
			}
		} else {
			$("#fsa").hide();
		}

		if ($("li.tabbackend").length > 0) {
			$("#fsn").width(function() {
				var sectWidth = 0;
				$("li.tabbackend").each(function() {
					sectWidth += $(this).outerWidth() + 1;
				});
				return sectWidth - 1;
			});
			if (allSources === 0) {
				$("#fsn").show();
			} else if ($("#nmr2").is(':checked')) {
				$("#fsn").show();
			} else {
				$("#fsn").hide();
			}
		} else {
			$("#fsn").hide();
		}
	} else {
		$("#subheader fieldset").hide();
	}
}

function tableSorter(tabletosort) {
	var sortList = {};
	$(tabletosort).find("th").each(function(i, header) {
		// $(this).addClass("group-false");
		if (!$(header).hasClass('sortable')) {
			sortList[i] = {
				"sorter": false
			};
		} else if ( $(header).text().match( /^av.?g|^max/i ) ) {
			sortList[i] = {
				"sorter": "digit"
			};
		}
	});
	sortArray = [];
	if ($(tabletosort).data().sortby) {
		var sortcols = $(tabletosort).data().sortby.toString();
		var arr = sortcols.split(" ");
		$.each(arr, function( index, value ) {
			sortArray.push([value - 1, 1]);
		});
	}
	$(tabletosort).tablesorter({
		sortInitialOrder: 'desc',
		widgets : [ "filter" ],
		sortList: sortArray,
		stringTo: 'bottom',
		"headers": sortList,
		theme: "ice",
		widgetOptions : {
			// filter_anyMatch options was removed in v2.15; it has been replaced by the filter_external option

			// If there are child rows in the table (rows with class name from "cssChildRow" option)
			// and this option is true and a match is found anywhere in the child row, then it will make that row
			// visible; default is false
			filter_childRows : false,

			// if true, filter child row content by column; filter_childRows must also be true
			filter_childByColumn : false,

			// if true, include matching child row siblings
			filter_childWithSibs : true,

			// if true, a filter will be added to the top of each table column;
			// disabled by using -> headers: { 1: { filter: false } } OR add class="filter-false"
			// if you set this to false, make sure you perform a search using the second method below
			filter_columnFilters : true,

			// if true, allows using "#:{query}" in AnyMatch searches (column:query; added v2.20.0)
			filter_columnAnyMatch: true,

			// extra css class name (string or array) added to the filter element (input or select)
			filter_cellFilter : '',

			// extra css class name(s) applied to the table row containing the filters & the inputs within that row
			// this option can either be a string (class applied to all filters) or an array (class applied to indexed filter)
			filter_cssFilter : '', // or []

			// add a default column filter type "~{query}" to make fuzzy searches default;
			// "{q1} AND {q2}" to make all searches use a logical AND.
			filter_defaultFilter : {},

			// filters to exclude, per column
			filter_excludeFilter : {},

			// jQuery selector (or object) pointing to an input to be used to match the contents of any column
			// please refer to the filter-any-match demo for limitations - new in v2.15
			filter_external : '',

			// class added to filtered rows (rows that are not showing); needed by pager plugin
			filter_filteredRow : 'filtered',

			// add custom filter elements to the filter row
			// see the filter formatter demos for more specifics
			filter_formatter : null,

			// add custom filter functions using this option
			// see the filter widget custom demo for more specifics on how to use this option
			filter_functions : null,

			// hide filter row when table is empty
			filter_hideEmpty : true,

			// if true, filters are collapsed initially, but can be revealed by hovering over the grey bar immediately
			// below the header row. Additionally, tabbing through the document will open the filter row when an input gets focus
			filter_hideFilters : true,

			// Set this option to false to make the searches case sensitive
			filter_ignoreCase : true,

			// if true, search column content while the user types (with a delay)
			filter_liveSearch : true,

			// a header with a select dropdown & this class name will only show available (visible) options within that drop down.
			filter_onlyAvail : 'filter-onlyAvail',

			// default placeholder text (overridden by any header "data-placeholder" setting)
			filter_placeholder : { search : '', select : '' },

			// jQuery selector string of an element used to reset the filters
			filter_reset : 'button.reset',

			// Reset filter input when the user presses escape - normalized across browsers
			filter_resetOnEsc : true,

			// Use the $.tablesorter.storage utility to save the most recent filters (default setting is false)
			filter_saveFilters : true,

			// Delay in milliseconds before the filter widget starts searching; This option prevents searching for
			// every character while typing and should make searching large tables faster.
			filter_searchDelay : 300,

			// allow searching through already filtered rows in special circumstances; will speed up searching in large tables if true
			filter_searchFiltered: true,

			// include a function to return an array of values to be added to the column filter select
			filter_selectSource  : null,

			// if true, server-side filtering should be performed because client-side filtering will be disabled, but
			// the ui and events will still be used.
			filter_serversideFiltering : false,

			// Set this option to true to use the filter to find text from the start of the column
			// So typing in "a" will find "albert" but not "frank", both have a's; default is false
			filter_startsWith : false,

			// Filter using parsed content for ALL columns
			// be careful on using this on date columns as the date is parsed and stored as time in seconds
			filter_useParsedData : false,

			// data attribute in the header cell that contains the default filter value
			filter_defaultAttrib : 'data-value',

			// filter_selectSource array text left of the separator is added to the option value, right into the option text
			filter_selectSourceSeparator : '|'
		}
	});
}

/*
function queryStringToHash(query) {
	var query_string = {},
		vars = query.split("&");

	for (var i = 0; i < vars.length; i++) {
		var pair = vars[i].split("=");
		pair[0] = decodeURIComponent(pair[0]);
		pair[1] = decodeURIComponent(pair[1]);
		// If first entry with this name
		if (typeof query_string[pair[0]] === "undefined") {
			query_string[pair[0]] = pair[1];
			// If second entry with this name
		} else if (typeof query_string[pair[0]] === "string") {
			var arr = [query_string[pair[0]], pair[1]];
			query_string[pair[0]] = arr;
			// If third or later entry with this name
		} else {
			query_string[pair[0]].push(pair[1]);
		}
	}
	return query_string;
}

/*
 * Returns a map of querystring parameters
 *
 * Keys of type <fieldName>[] will automatically be added to an array
 *
 * @param String url
 * @return Object parameters
 */
function getParams(url, decode) {
	var regex = /([^=&?]+)=([^&#]*)/g,
		params = {},
		parts, key, value;

	while ((parts = regex.exec(url)) != null) {

		key = parts[1];
		value = parts[2];
		if (decode) {
			value = decodeURIComponent(value);
		}
		var isArray = /\[\]$/.test(key);

		if (isArray) {
			params[key] = params[key] || [];
			params[key].push(value);
		} else {
			params[key] = value;
		}
	}

	return params;
}

function ShowDate(ts, short) {
	var then = "never";
	if (ts) {
		ts = new Date(ts);
		function pad(n) {return n<10 ? '0'+n : n};
		var then = pad(ts.getFullYear()) + '-' + pad((ts.getMonth() + 1)) + '-' + pad(ts.getDate());
		if ( short ) {
			var days = ["Sun","Mon","Tue","Wed","Thu","Fri","Sat"];
			then = days[ts.getDay()] + ", " + then;
		} else {
			then += ' ' + pad(ts.getHours()) + ':' + pad(ts.getMinutes());
		}
	}
	return (then);
}

function TimeStamp() {
	ts = new Date($.now());
	function pad(n) {return n<10 ? '0'+n : n}
	var then = pad(ts.getUTCFullYear()) + '-' + pad((ts.getUTCMonth() + 1)) + '-' + pad(ts.getUTCDate());
	then += 'T' + pad(ts.getUTCHours()) + ':' + pad(ts.getUTCMinutes()) + ':' + pad(ts.getUTCSeconds()) + "Z";
	return (then);
}

function betterZoom(zoomID, width, height) {
	$("#" + zoomID).imgAreaSelect({
		handles: false,
		maxHeight: height,
		minHeight: height,
		maxWidth: width,
		parent: "#content",
		// parent: $("#" + zoomID).parent(),
		fadeSpeed: 500,
		autoHide: true,
		onSelectEnd: function(img, selection) {
			selectEnd(img, selection, null, function() {
				if ($(img).parents().hasClass("regrp")) {
					$(img).parents(".regrp").find(".zoom").each(function(i, zoom) {
						if (zoom.id != img.id) {
							var deferredObject = $.Deferred();
							selectEnd(zoom, selection, img, function() {
								deferredObject.resolve();
							});
							// return deferredObject.promise();
						}
					});
				}
			});
		}
	});
}

function selectEnd(img, selection, sync, callback) {
	if (selection.width) {
		$(img).addClass("wait");
		var imgEl = $(img).parent().children("img"),
			selFrom, selTo;
		if (sync) {
			selFrom = new Date($(sync).data().graph_start * 1000);
			selTo = new Date($(sync).data().graph_end * 1000);
		} else {
			var from = new Date($(img).data().graph_start * 1000);
			var to = new Date($(img).data().graph_end * 1000);
			var timePerPixel = (to - from) / $(img).width();
			selFrom = new Date(+from + selection.x1 * timePerPixel);
			selTo = new Date(+selFrom + selection.width * timePerPixel);
		}
		// console.log("From: " + from + " To: " + to);
		var zoomTitle = "<b>" + $.format.date(selFrom, 'H:mm') + "</b> " + $.format.date(selFrom, 'd-MMM-yyyy')
		+ " &xrarr; " + "<b>" + $.format.date(selTo, 'H:mm') + "</b> " + $.format.date(selTo, 'd-MMM-yyyy'); // + "&nbsp;&nbsp;&nbsp; Název půjde z headeru";
		if (imgEl.width() > 600) {
			zoomTitle = imgEl.data("title") + "&nbsp;&nbsp;" + zoomTitle;
		}
		var alink = $(img).parents("a.detail");
		$(alink).parent().find("span.tt_span").html(zoomTitle);
		var ahref = ($(imgEl).data("revert_url")) ? $(imgEl).data("revert_url") : ahref = $(imgEl).data("src");
		if (! $(alink).parent().find("div.popdetail").length) {
			$("<div class='popdetail'></div>").insertBefore( $(alink) );
			$(alink).parent().find("div.popdetail").on("click", function() {
				resZoom(this);
			});
		}
		$(alink).parent().find("div.popdetail").show();
		if (!$(alink).data("basehref")) {
			$(alink).data("basehref", $(alink).attr("href"));
		}
		nonePos = ahref.indexOf('?');
		params = getParams(ahref, 1);
		paramsDetail = getParams($(alink).data("basehref"), 1);

		delete params.none;
		delete paramsDetail.none;
		zUrl = ahref.slice(0, nonePos);
		params.sunix = parseInt(selFrom.getTime() / 1000);
		params.eunix = parseInt(selTo.getTime() / 1000);
		paramsDetail.sunix = params.sunix;
		paramsDetail.eunix = params.eunix;
		var zoomedUrl = zUrl + "?" + jQuery.param(params).replace(/\+/g, "%20");
		zoomedUrlDetail = zUrl + "?" + jQuery.param(paramsDetail).replace(/\+/g, "%20");
		dt = 'binary';
		$(alink).attr("href", zoomedUrlDetail);
		if ($(imgEl).hasClass('nolegend')) {
			dt = 'json';
		}
		jQuery.ajax({
			// url: $(element).attr("data-src") + "&nonelazy=" + new Date().getTime(),
			url: zoomedUrl,
			cache: true,
			dataType: dt,
			// responseType: 'blob',
			processData: false,
			//   complete: function (jqXHR, textStatus) {
			success: function(data, textStatus, jqXHR) {
				// console.log("Title: " + zoomedUrl);
				// console.log(imgEl);
				header = jqXHR.getResponseHeader('X-RRDGraph-Properties');
				if (header) {
					if (sysInfo.guidebug == 1) {
						$(element).parent().attr("title", header);
					}
					$(img).removeClass("wait");
					//var image = new Image();
					//image.src = URL.createObjectURL(data);

					if ($(imgEl).hasClass('nolegend')) {
						$(imgEl).attr("src", data.img);
						legendTable(imgEl, data.table);
					} else {
						$(imgEl).attr("src", URL.createObjectURL(data));
					}
					var h = header.split(":");
					$(img).imgAreaSelect({
						remove: true
					});
					$(img).data("graph_start", h[4]);
					$(img).data("graph_end", h[5]);
					$(img).css("left", h[0] + "px");
					$(img).css("top", h[1] + "px");
					$(img).css("width", h[2] + "px");
					$(img).css("height", h[3] + "px");
					if (h[2] && h[3]) {
						betterZoom($(img).attr("id"), h[2], h[3]);
					}
					if(callback) callback();
					// frame.show();
					// console.log(h);
				}
			}
		});
		// $(storedObj).trigger("click");
	}
}

function resZoom(resButton) {
	if ($(resButton).parents().hasClass("regrp")) {
		$(resButton).parents(".regrp").find("div.popdetail").each(function() {
			resetZoom(this);
		});
	} else {
		resetZoom(resButton);
	}
}

function resetZoom(resButton) {
	var alink = $(resButton).parents().siblings("a.detail");
	var imgEl = $(alink).parent().find("img");
	var frame = $(alink).find("div.zoom");
	$(frame).addClass("wait");
	var title = $(imgEl).data("title");
	var period = $(imgEl).data("period");

	$(alink).parent().find("span.tt_span").html(title + period);

	if ($(alink).data("basehref")) {
		$(alink).attr("href", $(alink).data("basehref"));
		$(alink).parents(".relpos").find("div.popdetail").hide();
	}
	var dt = 'binary';
	if ($(imgEl).hasClass('nolegend')) {
		dt = 'json';
	}
	jQuery.ajax({
		// url: $(element).attr("data-src") + "&nonelazy=" + new Date().getTime(),
		url: $(imgEl).data("revert_url"),
		dataType: dt,
		cache: true,
		// responseType: 'blob',
		processData: false,
		//   complete: function (jqXHR, textStatus) {
		success: function(data, textStatus, jqXHR) {
			$(frame).removeClass("wait");
			var header = jqXHR.getResponseHeader('X-RRDGraph-Properties');
			if (header) {
				if (sysInfo.guidebug == 1) {
					$(element).parent().attr("title", header);
				}

				if ($(imgEl).hasClass('nolegend')) {
					$(imgEl).attr("src", data.img);
					legendTable(imgEl, data.table);
				} else {
					$(imgEl).attr("src", URL.createObjectURL(data));
				}
				var h = header.split(":");
				$(frame).imgAreaSelect({
					remove: true
				});
				$(imgEl).data("graph_start", h[4]);
				$(imgEl).data("graph_end", h[5]);
				$(frame).data("graph_start", h[4]);
				$(frame).data("graph_end", h[5]);
				$(frame).css("left", h[0] + "px");
				$(frame).css("top", h[1] + "px");
				$(frame).css("width", h[2] + "px");
				$(frame).css("height", h[3] + "px");
				if (h[2] && h[3]) {
					betterZoom(frame.attr("id"), h[2], h[3]);
				}
				frame.show();
				// console.log(h);
			}
		}
	});
	// $(storedObj).trigger("click");
}

/* placeholder for input fields */
function placeholder() {
	$("input[type=text]").each(function() {
		var phvalue = $(this).attr("placeholder");
		$(this).val(phvalue);
	});
}

function CheckExtension(file) {
	/*global document: false */
	var validFilesTypes = ["nmon", "csv"];
	var filePath = file.value;
	var ext = filePath.substring(filePath.lastIndexOf('.') + 1).toLowerCase();
	var isValidFile = false;

	for (var i = 0; i < validFilesTypes.length; i++) {
		if (ext == validFilesTypes[i]) {
			isValidFile = true;
			break;
		}
	}

	if (!isValidFile) {
		file.value = null;
		alert("Invalid File. Valid extensions are:\n\n" + validFilesTypes.join(", "));
	}

	return isValidFile;
}

function getUrlParameter(sParam)
{
	var sPageURL = window.location.search.substring(1);
	var sURLVariables = sPageURL.split('&');
	for (var i = 0; i < sURLVariables.length; i++)
	{
		var sParameterName = sURLVariables[i].split('=');
		if (sParameterName[0] == sParam)
		{
			return sParameterName[1];
		}
	}
}

function saveData (id) {
	if (!sessionStorage) {
		return;
	}
	var data = {
		id: id,
		scroll: $("#content").scrollTop(),
		title: $("#title").html(),
		html: $("#content").html()
	};
	sessionStorage.setItem(id,JSON.stringify(data));
}
function restoreData (id) {
	if (!sessionStorage) {
		return;
	}
	var data = sessionStorage.getItem(id);
	if (!data) {
		return null;
	}
	return JSON.parse(data);
}

function detectIE() {
	var ua = window.navigator.userAgent;
	var msie = ua.indexOf('MSIE ');
	var trident = ua.indexOf('Trident/');

	if (msie > 0) {
		// IE 10 or older => return version number
		return parseInt(ua.substring(msie + 5, ua.indexOf('.', msie)), 10);
	}

	if (trident > 0) {
		// IE 11 (or newer) => return version number
		var rv = ua.indexOf('rv:');
		return parseInt(ua.substring(rv + 3, ua.indexOf('.', rv)), 10);
	}

	// other browser
	return false;
}

// Create Base64 Object
var Base64={_keyStr:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",encode:function(e){var t="";var n,r,i,s,o,u,a;var f=0;e=Base64._utf8_encode(e);while(f<e.length){n=e.charCodeAt(f++);r=e.charCodeAt(f++);i=e.charCodeAt(f++);s=n>>2;o=(n&3)<<4|r>>4;u=(r&15)<<2|i>>6;a=i&63;if(isNaN(r)){u=a=64}else if(isNaN(i)){a=64}t=t+this._keyStr.charAt(s)+this._keyStr.charAt(o)+this._keyStr.charAt(u)+this._keyStr.charAt(a)}return t},decode:function(e){var t="";var n,r,i;var s,o,u,a;var f=0;e=e.replace(/[^A-Za-z0-9\+\/\=]/g,"");while(f<e.length){s=this._keyStr.indexOf(e.charAt(f++));o=this._keyStr.indexOf(e.charAt(f++));u=this._keyStr.indexOf(e.charAt(f++));a=this._keyStr.indexOf(e.charAt(f++));n=s<<2|o>>4;r=(o&15)<<4|u>>2;i=(u&3)<<6|a;t=t+String.fromCharCode(n);if(u!=64){t=t+String.fromCharCode(r)}if(a!=64){t=t+String.fromCharCode(i)}}t=Base64._utf8_decode(t);return t},_utf8_encode:function(e){e=e.replace(/\r\n/g,"\n");var t="";for(var n=0;n<e.length;n++){var r=e.charCodeAt(n);if(r<128){t+=String.fromCharCode(r)}else if(r>127&&r<2048){t+=String.fromCharCode(r>>6|192);t+=String.fromCharCode(r&63|128)}else{t+=String.fromCharCode(r>>12|224);t+=String.fromCharCode(r>>6&63|128);t+=String.fromCharCode(r&63|128)}}return t},_utf8_decode:function(e){var t="";var n=0;var r=c1=c2=0;while(n<e.length){r=e.charCodeAt(n);if(r<128){t+=String.fromCharCode(r);n++}else if(r>191&&r<224){c2=e.charCodeAt(n+1);t+=String.fromCharCode((r&31)<<6|c2&63);n+=2}else{c2=e.charCodeAt(n+1);c3=e.charCodeAt(n+2);t+=String.fromCharCode((r&15)<<12|(c2&63)<<6|c3&63);n+=3}}return t}}

function groupTable($rows, startIndex, total) {
	if (total === 0) {
		return;
	}
	var i , currentIndex = startIndex, count=1, lst=[];
	var tds = $rows.find('td:eq('+ currentIndex +')');
	var ctrl = $(tds[0]);
	lst.push($rows[0]);
	for (i=1;i<=tds.length;i++) {
		if (ctrl.text() ==  $(tds[i]).text()) {
			count++;
			$(tds[i]).addClass('deleted');
			lst.push($rows[i]);
		} else {
			if (count>1) {
				ctrl.attr('rowspan',count);
				groupTable($(lst),startIndex+1,total-1)
			}
			count=1;
			lst = [];
			ctrl=$(tds[i]);
			lst.push($rows[i]);
		}
	}
}

function unique(array) {
	return $.grep(array, function(el, index) {
		return index === $.inArray(el, array);
	});
}

function checkLength( o, n, min, max ) {
	if ( o.val().length > max || o.val().length < min ) {
		o.addClass( "ui-state-error" );
		updateTips( "Length of " + n + " must be between " + min + " and " + max + "." );
		return false;
	} else {
		return true;
	}
}

function checkRegexp( o, regexp, n ) {
	if ( !( regexp.test( o.val() ) ) ) {
		o.addClass( "ui-state-error" );
		updateTips( n );
		return false;
	} else {
		o.removeClass( "ui-state-error" );
		return true;
	}
}

function updateTips( t ) {
	tips = $( ".validateTips" );
	tips
	.text( t )
	.addClass( "ui-state-highlight" );
	setTimeout(function() {
		tips.removeClass( "ui-state-highlight", 1500 );
	}, 500 );
}

RegExp.escape = function(text) {
	return text.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
};

function checkStatus () {
	if (true || !sysInfo.demo) {
		$.getJSON(cgiPath + "/genjson.sh?jsontype=isok", function(data) {
			if (data.status == "NOK") {
				$tree = $("#side-menu").fancytree("getTree");
				if ($("#redpoint").length == 0) {
					var redPoint = '<img src="css/images/wrench-red-icon.png" id="redpoint" style="margin-left: 2px; margin-top: -1px;" title="Problem detected on some device...">';
					$($tree.rootNode.children[1].span).append(redPoint);
				}
			} else {
				if ($("#redpoint").length) {
					$("#redpoint").remove();
				}
			}
		});
	}
}

function checkCopyServices () {
	if (true || !sysInfo.demo) {
		$.getJSON(cgiPath + "/genjson.sh?jsontype=copystate", function(data) {
			if (data.error) {
				$tree = $("#side-menu").fancytree("getTree");
				if ($("#copyamber").length) {
					$("#copyamber").remove();
				}
				if ($("#copyred").length == 0) {
					var copyRed = '<img src="css/images/lightning-red-icon.png" id="copyred" class="copy" style="margin-left: 2px; margin-top: -1px;" title="Error status reported from Mirror service...">';
					$($tree.rootNode.children[1].span).append(copyRed);
				}
			} else {
				if ($("#copyred").hasClass("copy")) {
					$("#copyred").remove();
				}
				if (data.warning && $("#copyred").length == 0) {
					$tree = $("#side-menu").fancytree("getTree");
					if ($("#copyamber").length == 0) {
						var copyAmber = '<img src="css/images/lightning-orange-icon.png" id="copyamber" class="copy" style="margin-left: 2px; margin-top: -1px;" title="Warning status reported from Mirror service...">';
						$($tree.rootNode.children[1].span).append(copyAmber);
					}
				} else {
					if ($("#copyamber").hasClass("copy")) {
						$("#copyamber").remove();
					}
				}
			}
		});
	}
}
function checkSnapshot () {
	if (true || !sysInfo.demo) {
		$.getJSON(cgiPath + "/genjson.sh?jsontype=snapstate", function(data) {
			if (data.error) {
				$tree = $("#side-menu").fancytree("getTree");
				if ($("#copyamber").length) {
					$("#copyamber").remove();
				}
				if ($("#copyred").length == 0) {
					var copyRed = '<img src="css/images/lightning-red-icon.png" id="copyred" class="snap" style="margin-left: 2px; margin-top: -1px;" title="Error status reported from Snapshot service...">';
					$($tree.rootNode.children[1].span).append(copyRed);
				}
			} else {
				if ($("#copyred").hasClass("snap")) {
					$("#copyred").remove();
				}
				if (data.warning && $("#copyred").length == 0) {
					$tree = $("#side-menu").fancytree("getTree");
					if ($("#copyamber").length == 0) {
						var copyAmber = '<img src="css/images/lightning-orange-icon.png" id="copyamber" class="snap" style="margin-left: 2px; margin-top: -1px;" title="Warning status reported from Snapshot service...">';
						$($tree.rootNode.children[1].span).append(copyAmber);
					}
				} else {
					if ($("#copyamber").hasClass("snap")) {
						$("#copyamber").remove();
					}
				}
			}
		});
	}
}

function genCapacity () {
	var content = $('#content');
	$('#title').html("Capacity").show();
	$.getJSON(cgiPath + "/genjson.sh?jsontype=caps", function(data) {
		if (data) {
			content.empty();
			var re = /\s*([\d|\.]+)/gi;
			content.append ("<center><br><table class='captab tabconfig tablesorter'><thead><tr><th class='sortable'>Storage</th><th class='sortable'>Type</th><th class='sortable'>Total</th><th class='sortable'>Used</th><th class='sortable'>Free</th><th class='sortable'>Percentage</th></tr></thead><tbody></tbody></table>");
			content.append ("<a class='csvfloat' href='" + cgiPath + "/detail-graph.sh?host=ALL&type=ALL&name=cap_total&item=sum&time=d::::' title='CSV'><img src='css/images/csv.gif'></a>");
			content.append("<div id='caps'></div>");

			var deferreds = [],
			rowclass = "",
			childclass = "",
			dataLines = [];
			$.each(data, function(key, val) {
				// val.url = "/sgui/cap2.txt";  // debug line
				deferreds.push(
					$.get(val.url, function (capdata) {
						dataLines.push(capdata);
						var clines = capdata.replace(/print\[\d+\] = /g, "");
						clines = clines.replace(/"/g, "");
						clines = clines.replace(/^\s*\n/gm, "");
						clines = clines.split("\n");
						capline = {};
						$.each(clines, function(i, txt) {
							if (txt) {
								$.trim(txt);
								// var pair = txt.split(/\s+/, 2);
								var pair = txt.split(/\s(.+)?/);
								var tier = pair[0].split(/(total|free|used|time)/g);
								if (tier[2] == "") {
									tier[2] = "Total";
								}
								if (!capline[tier[2]]) {
									capline[tier[2]] = {};
								}
								capline[tier[2]][tier[1]] = pair[1];
							}
						});
						$.each(capline, function(i, line) {
							if (i == "Total" || line.total >0) {
								var perc = round(line.used / line.total*100, 0),
								total = roundUnit(line.total, 1),
								free = roundUnit(line.free, 1),
								used = roundUnit(line.used, 1),
								tdclass = "",
								scurl = cgiPath + "/detail.sh?host=" + val.storage + "&type=" + val.subsys + "&name=cap_pool";
								if (i != "Total") {
									i = "<span class='tier'>" + i + "</span>";
									tdclass = " tier";
									shref = "<a class='hidden' href='" + scurl + "' style='width:100%; display:block;'>" + val.storage + "</a>";
									childclass = " tablesorter-childRow";
								} else {
									shref = "<a href='" + scurl + "' style='width:100%; display:block;'>" + val.storage + "</a>";
									childclass = "";
								}
								if(key & 1) {
									rowclass = " class='" + childclass + tdclass + "'";
								} else {
									rowclass = " class='" + childclass + tdclass + "'";
								}
								// meter = "<meter value='" + used + "' min='0' max='" + total + "' optimum='0' low='" + total*0.8 + "' high='" + total*0.97 + "' title='" + perc + "% of storage capacity used'>" + perc + "</meter>",
								meter = "<meter value='" + perc + "' min='0' max='100' optimum='0' low='80' high='95' title='" + perc + "% of storage capacity used (" + capline.Total.time + ")'>" + perc + "</meter>",
								row = "<tr" + rowclass + "><td><b>" + shref + "</b></td><td>" + i + "</td><td class='tdr'>" + total + "</td><td class='tdr'>" + used + "</td><td class='tdr'>" + free + "</td><td>" + meter + "</td></tr>";
								content.find('tbody').append(row);
							}
						});
					})
				);
			});
			$.when.apply($, deferreds).done(function() {
				var sortArray = [[0, 0]];
				$(content.find('table')).tablesorter({
					sortInitialOrder: 'desc',
					stringTo: 'bottom',
					theme: "ice",
					widgets: [ 'zebra' ],
					sortList: sortArray,
					headers: {
						2: {
							sorter: 'metric'
						},
						3: {
							sorter: 'metric'
						},
						4: {
							sorter: 'metric'
						},
					},
					widgetOptions: {
						group_collapsible    : true,
						group_collapsed      : false,
						group_count          : false
					}
				});
				hrefHandler();
				$('meter').html5jpMeterPolyfill();
			});

		}
	});
}

function genPoolCapacity (storage, capURL) {
	var content = $('#content'),
	stype = curNode.parent.data.type;
	// $('#title').html(storage + " | Pool Capacity").show();
	$.get(capURL, function(data) {
		if (data) {
			content.empty();
			var re = /\s*([\d|\.]+)/gi;

			rowclass = "",
			dataLines = [];
			var capData = [],
			rows = "";
			capData = data.split("\n");
			$.each(capData, function(key, val) {
				// val.url = "/sgui/cap2.txt";  // debug line
				dataLines.push(val);
				var clines = val.replace(/print\[\d+\] = /g, "");
				clines = clines.replace(/"/g, "");
				clines = clines.replace(/^\s*\n/gm, "");
				clines = clines.split("\n");
				var line = clines[0].split(",");
				capline = {};
				if (line.length>1) {
					var perc = round(line[3] / line[1]*100, 0),
					total = roundUnit(line[1], 1),
					free = roundUnit(line[2], 1),
					used = roundUnit(line[3], 1);

					if (stype == "SWIZ") {
						var virt = roundUnit(line[4], 1),
						//real = roundUnit(line[5], 1),
						oversub = roundUnit(line[5], 1);
					}
					if (stype == "VMAX" && line.length > 5) {
						stype = "VMAX+";
					}
					if (stype == "DATACORE") {
						var virt = roundUnit(line[4], 1),
						oversub = roundUnit(line[5], 1);
					}
					scurl = cgiPath + "/detail.sh?host=" + storage + "&type=POOL&name=" + line[0];
					// host=IBM-Storwize&type=POOL&name=SAS-15k&storage=SWIZ&item=SAS-15k&gui=1&none=none
					shref = "<a href='" + scurl + "' style='width:100%; display:block;'>" + line[0] + "</a>";
					if(key & 1) {
						rowclass = " class='even'";
					} else {
						rowclass = "";
					}
					var meter = "<meter value='" + perc + "' min='0' max='100' optimum='0' low='80' high='95' title='" + perc + "% of storage capacity used (" + line[4] + ")'>" + perc + "</meter>",
					row = "";
					if (stype == "SWIZ") {
						meter = "<meter value='" + perc + "' min='0' max='100' optimum='0' low='80' high='95' title='" + perc + "% of storage capacity used (" + line[7] + ")'>" + perc + "</meter>";
						row = "<tr" + rowclass + "><td><b>" + shref + "</b></td><td class='tdr'>" + total + "</td><td class='tdr'>" + used + "</td><td class='tdr'>" + free + "</td><td class='tdr'>" + virt + "</td><td class='tdr'>" + oversub + "</td><td>" + meter + "</td></tr>";
					} else if (stype == "VMAX+") {
						meter = "<meter value='" + perc + "' min='0' max='100' optimum='0' low='80' high='95' title='" + perc + "% of storage capacity used (" + line[5] + ")'>" + perc + "</meter>";
						var subscr = "";
						if (line[4] != "-") {
						  subscr = Math.round(line[4]) + "%";
						}
						row = "<tr" + rowclass + "><td><b>" + shref + "</b></td><td class='tdr'>" + total + "</td><td class='tdr'>" + used + "</td><td class='tdr'>" + free + "</td><td>" + meter + "</td><td class='tdr'>" + subscr + "</td></tr>";

					} else if (stype == "DATACORE") {
						meter = "<meter value='" + perc + "' min='0' max='100' optimum='0' low='80' high='95' title='" + perc + "% of storage capacity used (" + line[6] + ")'>" + perc + "</meter>";
						row = "<tr" + rowclass + "><td><b>" + shref + "</b></td><td class='tdr'>" + total + "</td><td class='tdr'>" + used + "</td><td class='tdr'>" + free + "</td><td class='tdr'>" + virt + "</td><td class='tdr'>" + oversub + "</td><td>" + meter + "</td></tr>";
					} else {
						row = "<tr" + rowclass + "><td><b>" + shref + "</b></td><td class='tdr'>" + total + "</td><td class='tdr'>" + used + "</td><td class='tdr'>" + free + "</td><td>" + meter + "</td></tr>";
					}
					rows += row;
				}
			});
			if (stype == "SWIZ") {
				content.append ("<center><br><table class='captab tabconfig tablesorter'><thead><tr><th class='sortable'>Pool</th><th class='sortable'>Total</th><th class='sortable'>Used</th><th class='sortable'>Free</th><th class='sortable'>Virtual</th><th class='sortable'>Oversubscr</th><th class='sortable'>Percentage</th></tr></thead><tbody></tbody></table>");
			} else if (stype == "VMAX+") {
				content.append ("<center><br><table class='captab tabconfig tablesorter'><thead><tr><th class='sortable'>Pool</th><th class='sortable'>Total</th><th class='sortable'>Used</th><th class='sortable'>Free</th><th class='sortable'>Percentage</th><th class='sortable'>Subscription</th></tr></thead><tbody></tbody></table>");
			} else if (stype == "3PAR") {
				content.append ("<center><br><table class='captab tabconfig tablesorter'><thead><tr><th class='sortable'>Tier</th><th class='sortable'>Total</th><th class='sortable'>Used</th><th class='sortable'>Free</th><th class='sortable'>Percentage</th></tr></thead><tbody></tbody></table>");
			} else if (stype == "DATACORE") {
				content.append ("<center><br><table class='captab tabconfig tablesorter'><thead><tr><th class='sortable'>Pool</th><th class='sortable'>Total</th><th class='sortable'>Used</th><th class='sortable'>Free</th><th class='sortable'>Virtual</th><th class='sortable'>Oversubscr</th><th class='sortable'>Percentage</th></tr></thead><tbody></tbody></table>");
			} else {
				content.append ("<center><br><table class='captab tabconfig tablesorter'><thead><tr><th class='sortable'>Pool</th><th class='sortable'>Total</th><th class='sortable'>Used</th><th class='sortable'>Free</th><th class='sortable'>Percentage</th></tr></thead><tbody></tbody></table>");
			}
			content.find('tbody').append(rows);
			content.append("<div id='caps'></div>");
			var sortArray = [[0, 0]];
			$(content.find('table')).tablesorter({
				sortInitialOrder: 'desc',
				stringTo: 'bottom',
				theme: "ice",
				widgets: [ 'zebra' ],
				sortList: sortArray,
				headers: {
					1: {
						sorter: 'metric'
					},
					2: {
						sorter: 'metric'
					},
					3: {
						sorter: 'metric'
					},
				}
			});
			hrefHandler();
			$('meter').html5jpMeterPolyfill();
		}
	});
}
function fastSG (storage, capURL) {
	var content = $('#content'),
	stype = curNode.parent.data.type;
	// $('#title').html(storage + " | Pool Capacity").show();
	$.get(capURL, function(data) {
		if (data) {
			content.empty();
			var re = /\s*([\d|\.]+)/gi;
			content.append ("<center><br><table class='captab tabconfig fastsg'><thead><tr><th>Storage group</th><th><span id='tiers' class='stacked-bar-graph header'></span></th></thead><tbody></tbody></table>");

			$.each(data.split("\n"), function(key, val) {
				if (!val.length) {
					return;
				}
				if (key == 0) {
					headers = val.split(",");
					$.each(headers, function(idx, val) {
						if (idx > 0) {
							var span = "<span class='bar-" + idx + "'>" + val + "</span>";
							$("#tiers").append(span);
						}
					});
				} else {
					var line = val.split(",");
					var n = line.length,
					sum = 0,
					span = "";
					while(n--) {
						sum += parseFloat(line[n]) || 0;
					}
					sum = parseInt(sum*100) / 100;
					sumr = 0;
					$.each(line, function(key1, val1) {
						var percent = val1/sum * 100;
						if (key1 > 0 && (percent > .4)) {
							var percstr = (percent >= 4) ? Math.round(percent) + "%" : "&nbsp;";
							if (key1 < (line.length - 1)) {
								rounded = Math.round(percent*100)/100;
								sumr += rounded;
							} else {
								rounded = 100 - sumr;
							}
							span += "<span style='width: " + rounded + "%' class='bar-" + key1 +"' title='"+ headers[key1] + " (" + roundUnitGB(val1,1) + ")'>" + percstr + "</span>";
						}
					});
					var tr = "<tr><td>" + line[0] + " (" + roundUnitGB(sum, 1) + ")</td><td class='stacked-bar-graph'>" + span + "</td></tr>";
					content.find('tbody').append(tr);
				}
			});
			hrefHandler();
		}
	});
}

function round(value, decimals) {
	return Number(Math.round(value+'e'+decimals)+'e-'+decimals);
}

function roundUnit(value, decimals) {
	var unit = " TiB";
	if (value > 1048576) {
		value /= 1048576;
		unit = " EiB";
	} else if (value > 1024) {
		value /= 1024;
		unit = " PiB";
	} else if (value < 1) {
		value *= 1024;
		unit = " GiB";
	}
	if (value > 10) {
		return Math.round(value) + unit;
	} else {
		return Number(Math.round(value+'e'+decimals)+'e-'+decimals) + unit;
	}
}
function roundUnitGB(value, decimals) {
	var unit = " GiB";
	if (value > 1073741824) {
		value /= 1073741824;
		unit = " EiB";
	} else if (value > 1048576) {
		value /= 1048576;
		unit = " PiB";
	} else if (value > 1024) {
		value /= 1024;
		unit = " TiB";
	} else if (value < 1) {
		value *= 1024;
		unit = " MiB";
	}
	if (value > 10) {
		return Math.round(value) + unit;
	} else {
		return Number(Math.round(value+'e'+decimals)+'e-'+decimals) + unit;
	}
}

// add parser through the tablesorter addParser method
$.tablesorter.addParser({
	// set a unique id
	id: 'metric',
	is: function(s) {
		// return false so this parser is not auto detected
		return false;
	},
	format: function(s) {
		var prefixes = {
			E: Math.pow(1024, 6), // 1024^6
			P: Math.pow(1024, 5), // 1024^5
			T: Math.pow(1024, 4), // 1024^4
			G: Math.pow(1024, 3), // 1024^3
			M: Math.pow(1024, 2), // 1024^2
		}
		regAbbr = /([\d\.]+)(\s+)?(E|P|T|G|M)/i;
		re = s.match(regAbbr);
		val = re[1];
		unit = re[3];
		// format your data for normalization
		return val * prefixes[unit];
	},
	// set type, either numeric or text
	type: 'numeric'
});
function unescapeHtml(safe) {
	return $('<div />').html(safe).text();
}
var addNewAlertDiv = '<div id="alert-dialog-form"> \
<p class="validateTips">All form fields are required.</p> \
<form autocomplete="off"> \
<fieldset> \
<legend>Choose object to be alerted</legend> \
<div id="radioctrl"> \
<input type="radio" name="typesel" id="typesel1" value="storage" checked> \
<label for="typesel1">Storage subsystem</label> \
<input type="radio" name="typesel" id="typesel2" value="cgroup"> \
<label for="typesel2">Custom group</label> \
<input type="radio" name="typesel" id="typesel3" value="switch"> \
<label for="typesel3">Switch</label> \
</div> \
<label id="storlabel" for="storagesel" style="margin-top: 8px">Storage</label> \
<select class="alrtcol" name="storage" id="storagesel" /><br> \
<label id="sslabel" for="subsyssel" style="margin-top: 4px">Subsystem</label> \
<select class="alrtcol" id="subsyssel" name="subsys" style="margin-top: 4px"> \
<option value="">--- choose one ---</option> \
</select><br> \
<label id="varlabel" for="volumesel" style="margin-top: 4px; display: none">Volume</label> \
<select class="alrtcol" style="margin-top: 4px; display: none" name="volume" id="volumesel" /> \
<!-- Allow form submission with keyboard without duplicating the dialog button --> \
<input type="submit" tabindex="-1" style="position:absolute; top:-1000px"> \
</fieldset> \
</form> \
</div>';

function addNewAlrtForm (title, oParams) {
	$( addNewAlertDiv ).dialog({
		height: 320,
		width: 500,
		position: {
			my: "top",
			at: "top",
			of: $("#content")
		},
		modal: true,
		title: title,
		buttons: {
			"Add new alerting rule": addNewAlert,
			Cancel: function() {
				$(this).dialog("close");
			}
		},
		create: function() {
			alertForm = $(this).find( "form" ).on( "submit", function( event ) {
				event.preventDefault();
				addNewAlert();
			});

			$( "#radioctrl input" ).checkboxradio({
				icon: true
			});
			$( "[name='typesel']").on( "change", function(e) {
				var target = $( e.target );
				if (target.val() == "cgroup") {
					$( "#storlabel" ).text("Custom group");
					$( "#storagesel").empty();
					$("<option />", {text: "--- choose one ---" , value: ""}).appendTo($( "#storagesel"));
					$.getJSON( cgiPath + "/genjson.sh?jsontype=custgrps", function( data ) {
						$.each(data, function(i, val) {
							// if (val.type == "VOLUME") {
							$("<option />", {text: val.title, value: val.title, type: val.type}).appendTo($( "#storagesel"));
							// }
						});
					});
					$( "#sslabel" ).hide();
					$( "#subsyssel" ).hide();
					$( "#varlabel" ).hide();
					$( "#volumesel" ).hide();
				} else if (target.val() == "switch") {
					$( "#storlabel" ).text("Switch");
					$( "#storagesel").empty();
					$( "#subsyssel" ).empty();
					$( "#volumesel" ).empty();
					$( '#subsyssel' ).prop('disabled', 'disabled');
					$('<option value="">--- choose one ---</option>').appendTo($( "#subsyssel"));
					$("<option />", {text: "--- choose one ---" , value: ""}).appendTo($( "#storagesel"));
					$("<option />", {text: "--- choose one ---" , value: ""}).appendTo($( "#volumesel"));
					$.each(fleet, function(i, val) {
						if (val.SANPORT || val.LANPORT) {
							// $("<option />", {text: val , value: val, selected: (oParams.storage == val)}).appendTo($( "#storagesel"));
							$("<option />", {text: i , value: i, type: val.STORTYPE}).appendTo($( "#storagesel"));
						}
					});
					$( "#sslabel" ).show();
					$( "#subsyssel" ).show();
				} else {
					$( "#storlabel" ).text("Storage");
					$( "#storagesel").empty();
					$( "#subsyssel" ).empty();
					$( "#volumesel" ).empty();
					$( '#subsyssel' ).prop('disabled', 'disabled');
					$('<option value="">--- choose one ---</option>').appendTo($( "#subsyssel"));
					$("<option />", {text: "--- choose one ---" , value: ""}).appendTo($( "#storagesel"));
					$("<option />", {text: "--- choose one ---" , value: ""}).appendTo($( "#volumesel"));
					$.each(fleet, function(i, val) {
						if (val.VOLUME || val.POOL) {
							// $("<option />", {text: val , value: val, selected: (oParams.storage == val)}).appendTo($( "#storagesel"));
							$("<option />", {text: i , value: i, type: val.STORTYPE}).appendTo($( "#storagesel"));
						}
					});
					$( "#sslabel" ).show();
					$( "#subsyssel" ).show();
				}
			});
			$("<option />", {text: "--- choose one ---" , value: ""}).appendTo($( "#storagesel"));
			$("<option />", {text: "--- choose one ---" , value: ""}).appendTo($( "#volumesel"));
			$.each(fleet, function(i, val) {
				if (val.VOLUME || val.POOL) {
					// $("<option />", {text: val , value: val, selected: (oParams.storage == val)}).appendTo($( "#storagesel"));
					$("<option />", {text: i , value: i, type: val.STORTYPE}).appendTo($( "#storagesel"));
				}
			});
			$( "#storagesel" ).change(function(event, data) {
				$( "#volumesel").empty();
				$("<option />", {text: "--- choose one ---" , value: "", selected: true}).appendTo($( "#volumesel"));
				if ($(event.target.value) && $("#subsyssel").val() && $("#subsyssel").val() != "POOL-ALL") {
					$.each(fleet[event.target.value][$("#subsyssel").val()], function(i, val) {
						$("<option />", {text: val , value: val}).appendTo($( "#volumesel"));
					});
				}
				if ($("#storagesel").val()) {
					var element = $(this).find('option:selected');
					$( "#subsyssel" ).empty();
					$('<option value="">--- choose one ---</option>').appendTo($( "#subsyssel"));
					if ( /^SAN-|^LAN-/.test(element.attr("type")) ) {
						var lansan = ( /^SAN-/.test(element.attr("type")) ) ? "SAN" : "LAN";
						$("<option />", {text: "Total" , value: lansan + "SWITCH"}).appendTo($( "#subsyssel"));
						$("<option />", {text: "Port" , value: lansan + "PORT"}).appendTo($( "#subsyssel"));
					} else {
						$('<option value="VOLUME">Volume</option>').appendTo($( "#subsyssel"));
						if (element.attr("type") != "3PAR" && element.attr("type") != "VMAX") {
							$('<option value="POOL">Pool</option>').appendTo($( "#subsyssel"));
						}
						if (element.attr("type") != "VMAX") {
							$('<option value="POOL-ALL">All Pools</option>').appendTo($( "#subsyssel"));
						}
						$('<option value="HOST">Host</option>').appendTo($( "#subsyssel"));
					}
					$('#subsyssel').prop('disabled', false);
				}
				else {
					$('#subsyssel').prop('disabled', 'disabled');
				}
				if ($("#storagesel").val() && $("#subsyssel").val()) {
					$('#volumesel').prop('disabled', false);
				}
				else {
					$('#volumesel').prop('disabled', 'disabled');
				}
			});
			$( "#subsyssel" ).change(function(event, data) {
				if (event.target.value == "VOLUME") {
					$( "#varlabel" ).text("Volume");
					$( "#varlabel" ).show();
					$( "#volumesel" ).show();
				} else if (event.target.value == "POOL") {
					$( "#varlabel" ).text("Pool");
					$( "#varlabel" ).show();
					$( "#volumesel" ).show();
				} else if (event.target.value == "HOST") {
					$( "#varlabel" ).text("Host");
					$( "#varlabel" ).show();
					$( "#volumesel" ).show();
				} else if ( /[SL]ANPORT/.test(event.target.value) ) {
					$( "#varlabel" ).text("Port");
					$( "#varlabel" ).show();
					$( "#volumesel" ).show();
				} else {
					$( "#varlabel" ).hide();
					$( "#volumesel" ).hide();
				}
				$( "#volumesel").empty();
				$("<option />", {text: "--- choose one ---" , value: "", selected: true}).appendTo($( "#volumesel"));
				if ($("#subsyssel").val() && $("#subsyssel").val() != "POOL-ALL") {
					$.each(fleet[$( "#storagesel" ).val()][$("#subsyssel").val()], function(i, val) {
						$("<option />", {text: val , value: val}).appendTo($( "#volumesel"));
					});
				}
				if ($("#subsyssel").val()) {
					$('#volumesel').prop('disabled', false);
				}
				else {
					$('#volumesel').prop('disabled', 'disabled');
				}
			});
			if (oParams.storage) {
				$( "#volumesel").empty();
				$("<option />", {text: "--- select volume ---" , value: "", selected: true}).appendTo($( "#volumesel"));
				if (fleet[oParams.storage]) {
					$( "#storagesel" ).val(oParams.storage);
					$.each(fleet[oParams.storage]['VOLUME'], function(i, val) {
						$("<option />", {text: val , value: val}).appendTo($( "#volumesel"));
					});
					// if (fleet[oParams.storage]["VOLUME"][oParams.volume] ) {
					$( "#volumesel" ).val(oParams.volume);
					// }
				}
			}
			if ($("#storagesel").val()) {
				var element = $(this).find('option:selected');
				$( "#subsyssel" ).empty();
				$('<option value="">--- choose one ---</option>').appendTo($( "#subsyssel"));
				$('<option value="VOLUME">Volume</option>').appendTo($( "#subsyssel"));
				if (element.attr("type") != "3PAR" && element.attr("type") != "VMAX") {
					$('<option value="POOL">Pool</option>').appendTo($( "#subsyssel"));
				}
				if (element.attr("type") != "VMAX") {
					$('<option value="POOL-ALL">All Pools</option>').appendTo($( "#subsyssel"));
				}
				$('<option value="HOST">Host</option>').appendTo($( "#subsyssel"));
				$('#subsyssel').prop('disabled', false);
			}
			else {
				$('#subsyssel').prop('disabled', 'disabled');
			}
			if ($("#subsyssel").val()) {
				$('#volumesel').prop('disabled', false);
			}
			else {
				$('#volumesel').prop('disabled', 'disabled');
			}
		},
		close: function() {
			$(this).find( "form" ).trigger('reset');
			var storage = $( "#storage" ),
			volume = $( "#volume" );
			allFields = $( [] ).add( storage ).add( volume );
			allFields.removeClass( "ui-state-error" );
			$(this).dialog("destroy");
		}
	});
}

function addNewAlert(title, oParams) {
	var valid= true,
	stor = $( "#storagesel" ).val(),
	subsys = $( "#subsyssel" ).val(),
	vol = $( "#volumesel" ).val();
	if (! stor) {
		valid = false;
		updateTips("Storage, switch or custom group has to be selected!");
	} else if ($("[name='typesel']:checked").val() == "cgroup") {
		subsys = $( "#storagesel :selected" ).attr("type");
		vol = stor;
		stor = "CUSTOM GROUP";
	} else {
		if (! subsys) {
			valid = false;
			updateTips("Subsystem has to be selected!");
		} else if (subsys != "POOL-ALL" && subsys != "SANSWITCH" && subsys != "LANSWITCH" && ! vol) {
			valid = false;
			updateTips($( "#varlabel" ).text() + " has to be selected!");
		}
		if (subsys == "POOL-ALL") {
			vol = "All pools";
		}
	}

	if (valid) {
		$( "#alert-dialog-form" ).dialog( "close" );
		var $tree = $("#alrttree").fancytree("getTree");
		var newStore = {
			"title": stor,
			"folder": true,
			"expanded": true
		}
		var newVolume = {
			"title": vol,
			"folder": true,
			"expanded": true,
			"subsys" : subsys
		}
		var child = {
			title: "",
			metric: "",
			limit: "",
			peak: "",
			repeat: "",
			exclude: "",
			mailgrp: "",
			iothold: ""
		};
		var rootNode = $tree.getRootNode();
		var storNode, volNode;
		// storNode = rootNode.findFirst(stor);
		$tree.visit(function(node) {
			if (node.getLevel() == 1 && node.title == stor) {
				storNode = node;
				return false;
			}
		});

		if (storNode) {
			storNode.visit(function(node) {
				if (node.getLevel() == 2) {
					if (node.title == vol) {
						if (node.data.subsys == subsys) {
							volNode = node;
							return false;
						}
					}
				}
			});
		} else {
			storNode = rootNode.addNode(newStore, "child");
		}
		// var volNode = storNode.findFirst(vol);
		if (! volNode) {
			volNode = storNode.addNode(newVolume, "child");
		}
		var newChild = volNode.addNode(child, "child");
		newChild.setActive();
	}
	return valid;
}

var addNewAgrpDiv = '<div id="algrp-dialog-form"> \
<p class="validateTips">All form fields are required.</p> \
<form> \
<fieldset> \
<label for="mailgrpinp">E-mail group</label> \
<input type="text" class="alrtcol" name="mailgrpinp" id="mailgrpinp" /><br> \
<label for="mailinp" style="margin-top: 4px">E-mail</label> \
<input type="text" class="alrtcol" name="mailinp" id="mailinp" style="margin-top: 4px" /> \
<!-- Allow form submission with keyboard without duplicating the dialog button --> \
<input type="submit" tabindex="-1" style="position:absolute; top:-1000px"> \
</fieldset> \
</form> \
</div>';

function addNewAgrpForm (title, oParams) {
	$( addNewAgrpDiv ).dialog({
		height: 280,
		width: 420,
		modal: true,
		title: title,
		buttons: {
			"Add new e-mail": addNewAlertMail,
			Cancel: function() {
				$(this).dialog("close");
			}
		},
		create: function() {
			alertForm = $(this).find( "form" ).on( "submit", function( event ) {
				event.preventDefault();
				addNewAlertMail();
			});
			if (oParams.storage) {
				$( "#mailgrpinp" ).val(oParams.storage);
			}
		},
		close: function() {
			$(this).find( "form" ).trigger('reset');
			var storage = $( "#mailgrpinp" ),
			volume = $( "#mailinp" );
			allFields = $( [] ).add( storage ).add( volume );
			allFields.removeClass( "ui-state-error" );
			$(this).dialog("destroy");
		}
	});
}

function addNewAlertMail(title, oParams) {
	var valid= true,
	mgrp = $( "#mailgrpinp" ),
	mgrpval = $( mgrp ).val(),
	mail = $( "#mailinp" ),
	mailval = $( mail ).val(),

	valid = valid && checkLength( mgrp, "E-mail group", 1, 32 );
	valid = valid && checkLength( mail, "mail", 3, 80 );

	valid = valid && checkRegexp( mgrp, /^[0-9a-z_\-]+$/i, "E-mail group name may consist of a-z, 0-9, dashes and underscores." );
	valid = valid && checkRegexp( mail, emailRegex, "This doesn't look like valid e-mail address" );

	if (valid) {
		$( "#algrp-dialog-form" ).dialog( "close" );
		var $tree = $("#alrtgrptree").fancytree("getTree");
		var newGrp = {
			"title": mgrpval,
			"folder": true,
			"expanded": true
		};
		var rootNode = $tree.getRootNode(),
		grpNode = rootNode.findFirst(mgrpval);
		if (! grpNode) {
			grpNode = rootNode.addNode(newGrp, "child");
		}
		var mailNode = grpNode.findFirst(mailval);
		if (! mailNode) {
			mailNode = grpNode.addChildren({ title: mailval });
			mailNode.setActive();
			mailGroups = $tree.toDict();
			$("#alrttree").fancytree("getTree").reload();
		}
	}
	return valid;
}

function getPDFstatus(id){
	$.getJSON(cgiPath + "/genpdf.sh?cmd=status&id=" + id, function(data) {
		$('#statusmessage').html(data.message);
		if(data.status=="pending") {
			$( "#pdfprogressbar" ).progressbar( "value", data.done )
			.children(".progress-label").text(data.done + " of " + data.total);
			setTimeout(function() {
				getPDFstatus(id);
			}, 500);
		} else if (data.status=="done") {
			window.location = cgiPath + "/genpdf.sh?cmd=get&id=" + id;
			$( "#progressDialog" ).dialog( "destroy" );
		} else if (data.status=="terminated") {
			$( "#progressDialog" ).dialog( "destroy" );
		} else {
			setTimeout(function() {
				getPDFstatus(id);
			}, 500);
		}
	});
}

// use this transport for "binary" data type
$.ajaxTransport("+binary", function(options, originalOptions, jqXHR){
	// check for conditions and support for blob / arraybuffer response type
	if (window.FormData && ((options.dataType && (options.dataType == 'binary')) || (options.data && ((window.ArrayBuffer && options.data instanceof ArrayBuffer) || (window.Blob && options.data instanceof Blob)))))
		{
			return {
				// create new XMLHttpRequest
				send: function(headers, callback){
					// setup all variables
					var xhr = new XMLHttpRequest(),
					url = options.url,
					type = options.type,
					async = options.async || true,
					// blob or arraybuffer. Default is blob
					dataType = options.responseType || "blob",
					data = options.data || null,
					username = options.username || null,
					password = options.password || null;

					xhr.addEventListener('load', function(){
						var data = {};
						data[options.dataType] = xhr.response;
						// make callback and send data
						callback(xhr.status, xhr.statusText, data, xhr.getAllResponseHeaders());
					});

					xhr.open(type, url, async);

					// setup custom headers
					for (var i in headers ) {
						xhr.setRequestHeader(i, headers[i] );
					}

					xhr.responseType = dataType;
					xhr.send(data);
				},
				abort: function(){
					jqXHR.abort();
				}
			};
		}
});

function saveUser(user, pass) {
	var form = $("#user-dialog-form form");
	var valid= true;

	if (pass) {
		if ($("input.ui-state-error").length) {
			valid = false;
		}
	} else {
		var login = $( "#login" ),
		mail = $( "#mailinp" ),
		fullname = $( "#fullname" ),
		groupmem = $( "#groupmem" );

		valid = valid && checkLength( login, "login", 2, 40 );
		valid = valid && checkLength( mail, "mailinp", 3, 80 );
		valid = valid && checkLength( fullname, "fullname", 2, 80 );
		valid = valid && checkRegexp( mail, emailRegex, "This doesn't look like valid e-mail address" );
	}

	if (valid) {
		if (!user) {
			user = $( "#login" ).val();
			usercfg.users[user] = {};
			usercfg.users[user].name = $( "#fullname" ).val();
			usercfg.users[user].email = $( "#mailinp" ).val();
			usercfg.users[user].htpassword = htpasswd($("#pass1").val());
			usercfg.users[user].groups = $( "#groupmem" ).val();
			usercfg.users[user].created = TimeStamp();
			usercfg.users[user].active = true;
		} else {
			if (pass) {
				usercfg.users[user].htpassword = htpasswd($("#pass1").val());
			} else {
				usercfg.users[user].name = fullname.val();
				usercfg.users[user].email = mail.val();
				usercfg.users[user].groups = groupmem.val();
			}
			usercfg.users[user].changed = TimeStamp();
		}
		$( "#user-dialog-form" ).dialog( "close" );
		var postdata = {cmd: "saveuser", user: user, acl: JSON.stringify(usercfg.users[user], null, 2)};
		// usercfg = "";

		$.post( cgiPath + "/users.sh", postdata, function( data ) {
			var returned = JSON.parse(data);
			if ( returned.status == "success" ) {
				$( "#side-menu" ).fancytree( "getTree" ).reactivate();
				// $("#aclfile").text(returned.cfg).show();
			}
			$(returned.msg).dialog({
				dialogClass: "info",
				title: "User configuration save - " + returned.status,
				minWidth: 600,
				modal: true,
				show: {
					effect: "fadeIn",
					duration: 500
				},
				hide: {
					effect: "fadeOut",
					duration: 200
				},
				buttons: {
					OK: function() {
						$(this).dialog("close");
					}
				}
			});
		});
	}
}
function SaveUsrCfg (showResult) {
	var postdata = {cmd: "saveall", acl: JSON.stringify(usercfg, null, 2)};
	$.post( cgiPath + "/users.sh", postdata, function( data ) {
		if (showResult) {
		var returned = JSON.parse(data);
		if ( returned.status == "success" ) {
			// $("#aclfile").text(returned.cfg).show();
		}
		$(returned.msg).dialog({
			dialogClass: "info",
			title: "Configuration saved - " + returned.status,
			minWidth: 600,
			modal: true,
			show: {
				effect: "fadeIn",
				duration: 500
			},
			hide: {
				effect: "fadeOut",
				duration: 200
			},
			buttons: {
				OK: function() {
					$(this).dialog("close");
				}
			}
		});
		}
	});
}

function SaveRepCfg (showResult) {
	var o = repcfgusr.reports;
	var $repname = $("#repname");
	if ($repname.val() != $repname.data("oldvalue")) {
		o[$repname.val()] =  o[$repname.data("oldvalue")];
		delete o[$repname.data("oldvalue")];
	}
	var postdata = {cmd: "saveall", acl: JSON.stringify(repcfg, null, 2), user: userName};
	$.post( cgiPath + "/reporter.sh", postdata, function( data ) {
		var returned = JSON.parse(data);
		if (showResult || returned.status == "fail") {
			$(returned.msg).dialog({
				dialogClass: "info",
				title: "Configuration save - " + returned.status,
				minWidth: 600,
				modal: true,
				show: {
					effect: "fadeIn",
					duration: 500
				},
				hide: {
					effect: "fadeOut",
					duration: 200
				},
				buttons: {
					OK: function() {
						$(this).dialog("close");
					}
				}
			});
		}
	});
}

function userDetailForm (user) {
	var userFormDiv = '<div id="user-dialog-form"> \
	<form autocomplete="off"> \
	<fieldset> \
	<label for="login">Login</label> \
	<input type="text" name="login" id="login" title="User already exists!" /><br> \
	<label for="fullname">Full name</label> \
	<input name="fullname" id="fullname" /><br> \
	<label for="mailinp">E-mail</label> \
	<input type="text" class="alrtcol" name="mailinp" id="mailinp" title="This doesn\'t look like valid e-mail address"/><br> \
	<label for="groupmem">Group</label> \
	<select class="multisel" name="groupmem" id="groupmem" multiple></select><br> \
	</fieldset> \
	<!-- Allow form submission with keyboard without duplicating the dialog button --> \
	<input type="submit" tabindex="-1" style="position:absolute; top:-1000px"> \
	</form> \
	</div>';

	$( userFormDiv ).dialog({
		height: 440,
		width: 440,
		modal: true,
		title: "User details",
		buttons: {
			"Save user": function() {
				saveUser(user)
			},
			Cancel: function() {
				$(this).dialog("close");
			}
		},
		create: function() {
			var isAdmin = false;
			if (usercfg.users[sysInfo.uid]) {
				isAdmin = $.inArray(aclAdminGroup, usercfg.users[sysInfo.uid].groups) > -1;
			}
			alertForm = $(this).find( "form" ).on( "submit", function( event ) {
				event.preventDefault();
				saveUser(user);
			});
			$.each(usercfg.groups, function(grp, val) {
				var isIn = (usercfg.users[user] !== undefined && ($.inArray(grp, usercfg.users[user].groups) >= 0));
				$("<option />", {text: grp, value: grp, selected: isIn}).appendTo($("#groupmem"));
			});
			if (user) {
				$("#login").val(user).prop('disabled', 'disabled');
				$("#fullname").val(usercfg.users[user].name);
				$("#mailinp").val(usercfg.users[user].email);
			} else {
				var passfields = '<br><fieldset><label for="pass1">Password</label> \
				<input type="password" name="pass1" id="pass1" title="Passwords don\'t match!" autocomplete="off" /><br> \
				<label for="pass2">Confirm</label> \
				<input type="password" name="pass2" id="pass2" title="Passwords don\'t match!" autocomplete="off" /></fieldset>';
				$(this).find("fieldset").after(passfields);
				$("#pass1, #pass2").tooltipster({
					trigger: 'custom',
					position: 'right',
				});

				$("#pass1,#pass2").on("blur", function( event ) {
					var pass1 = $("#pass1").val();
					var pass2 = $("#pass2").val();
					if (pass1 == "" || pass2 == "" || pass1 == pass2) {
						$(this).tooltipster("close");
						$(event.target).removeClass( "ui-state-error" );
						if (pass1 && (pass1 == pass2)) {
							$(".ui-dialog-buttonpane button:contains('password')").prop("disabled", false).css("cursor" , "pointer");
						} else {
							$(".ui-dialog-buttonpane button:contains('password')").prop("disabled", 'disabled').css("cursor" , "auto");
						}
					} else {
						$(this).tooltipster("open");
						event.target.trigger("focus");
						$(event.target).addClass( "ui-state-error" );
					}
				});

				$("#pass1, #pass2").tooltipster({
					trigger: 'custom',
					position: 'right',
					//	theme: 'tooltipster-punk'
				});
			}
			$("#login").tooltipster({
				trigger: 'custom',
				position: 'right',
			});
			$("#login").on("blur", function( event ) {
				if ($("#login")) {
					if ((usercfg.users[$("#login").val()] !== undefined)) {
						$(this).tooltipster("open");
					}
				}
			});
			$("#mailinp").tooltipster({
				trigger: 'custom',
				position: 'right',
			});
			$("#mailinp").on("blur", function( event ) {
				if(event.relatedTarget && event.relatedTarget.textContent != "Cancel") {
					if (emailRegex.test( $("#mailinp").val())) {
						$(this).tooltipster("close");
						$(event.target).removeClass( "ui-state-error" );
					} else {
						$(this).tooltipster("open");
						$(event.target).trigger("focus");
						$(event.target).addClass( "ui-state-error" );
					}
				}
			});

			if (isAdmin) {
				$('select.multisel').multipleSelect();
			} else {
				$('select.multisel').multipleSelect("disable");
			}
		},
		close: function() {
			$(this).find( "form" ).trigger('reset');
			$("#oldpass, #pass1, #pass2").tooltipster("destroy");
			$(this).dialog("destroy");
		}
	});
}

function changePasswordForm (user, notMe) {
	var changePasswordFormDiv = '<div id="user-dialog-form"> \
	<form autocomplete="off"> \
	<fieldset>';
	if (!notMe) {
		changePasswordFormDiv += '<label for="oldpass">Old password</label> \
		<input type="password" name="oldpass" id="oldpass" title="Invalid password" autocomplete="off" /><br>';
	}
	changePasswordFormDiv += '<label for="pass1">New password</label> \
	<input type="password" name="pass1" id="pass1" title="Passwords don\'t match!" autocomplete="off" /><br> \
	<label for="pass2">Confirm</label> \
	<input type="password" name="pass2" id="pass2" title="Passwords don\'t match!" autocomplete="off" /> \
	</fieldset> \
	<!-- Allow form submission with keyboard without duplicating the dialog button --> \
	<input type="submit" tabindex="-1" style="position:absolute; top:-1000px"> \
	</form> \
	</div>';

	$( changePasswordFormDiv ).dialog({
		height: 250,
		width: 440,
		modal: true,
		title: "Change password",
		buttons: {
			"Save new password": function() {
				saveUser(user, true)
			},
			Cancel: function() {
				$(this).dialog("close");
			}
		},
		create: function() {
			$("#oldpass, #pass1, #pass2").tooltipster({
				trigger: 'custom',
				position: 'right',
			});
			alertForm = $(this).find( "form" ).on( "submit", function( event ) {
				event.preventDefault();
				saveUser(user, true);
			});
			if (!notMe) {
				// $("#pass1,#pass2").prop('disabled', 'disabled');
			}
			if (user) {
				$("#login").prop('disabled', 'disabled');
			}
			$(".ui-dialog-buttonpane button:contains('password')").prop("disabled", 'disabled').css("cursor" , "auto");
			$("#oldpass").on("blur", function( event ) {
				if(event.relatedTarget && event.relatedTarget.textContent != "Cancel"){
					var passTest = htpasswd(event.target.value, usercfg.users[user].htpassword);
					if (passTest != usercfg.users[user].htpassword) {
						event.preventDefault();
						event.stopPropagation();
						$("#oldpass").tooltipster("open");
						event.target.trigger("focus");
						$(event.target).addClass( "ui-state-error" );
						return false;
						// $("#pass1,#pass2").prop('disabled', 'disabled');
					} else {
						$("#oldpass").tooltipster('close');
						$(event.target).removeClass( "ui-state-error" );
						// $("#pass1,#pass2").prop('disabled', false);
						$("#pass1").trigger("focus");
					}
				}
			});
			$("#pass1,#pass2").on("blur", function( event ) {
				var pass1 = $("#pass1").val();
				var pass2 = $("#pass2").val();
				if (pass1 == "" || pass2 == "" || pass1 == pass2) {
					$(this).tooltipster("close");
					$(event.target).removeClass( "ui-state-error" );
					if (pass1 && (pass1 == pass2)) {
						$(".ui-dialog-buttonpane button:contains('password')").prop("disabled", false).css("cursor" , "pointer");
					} else {
						$(".ui-dialog-buttonpane button:contains('password')").prop("disabled", 'disabled').css("cursor" , "auto");
					}
				} else {
					$(this).tooltipster("open");
					event.target.trigger("focus");
					$(event.target).addClass( "ui-state-error" );
				}
			});
		},
		close: function() {
			$(this).find( "form" ).trigger('reset');
			$("#mailinp, #oldpass, #pass1, #pass2").tooltipster("destroy");
			$(this).dialog("destroy");
		}
	});
}

function repDetailForm (report) {
	var isNewRep = false,
	oldRepCfg = JSON.parse(JSON.stringify(repcfg));
	repFormDiv = '<div id="rep-dialog-form" class="repform"> \
	<form autocomplete="off"> \
	<fieldset> \
	<legend>Properties</legend> \
	<label for="repname">Report name</label> \
	<input type="text" name="repname" id="repname" style="width: 24em" title="Report already exists!" /> \
	<select class="multisel fr" name="format" id="format" style="width: 14em; float: right"> \
	<option value="IMG">Image (PNG)</option> \
	<option value="PDF">Portable document (PDF)</option> \
	<option value="CSV">Comma separated values (CSV)</option> \
	<!-- option value="XLS">Excel sheet (XLS)</option --> \
	</select> \
	<label for="format" style="width: 8em; float: right">Output format</label><br style="clear: left;"> \
	<label for="groupmem">Recipient groups</label> \
	<select class="multisel" name="groupmem" id="groupmem" multiple style="width: 10em"></select> \
	<label for="disabled" class="cb">Disabled</label> \
	<input type="checkbox" name="disabled" id="disabled" class="cb" title="Don\'t run this report periodically"> \
	<label for="zipattach" class="cb">ZIP&nbsp;attachments</label> \
	<input type="checkbox" name="zipattach" id="zipattach" class="cb" "Send one ZIP instead of many single files"><br style="clear: left;"> \
	<label for="repfreq">Recurrence</label> \
	<input type="text" name="repfreq" id="repfreq" style="width: 28em" disabled> \
	<button id="rruleset" style="float: left" title="Configure when to run this report">...</button> \
	<select class="multisel fr" name="reprange" id="reprange" style="width: 9em; float: right"> \
	<option value="prev" selected>Previous month</option> \
	<option value="last">Last 31 days</option> \
	</select> \
	<label for="reprange" style="margin-left: 2em; width: unset; float: right">Range</label> \
	</fieldset> \
	<fieldset style="height: 17em; margin-top: 4px"> \
	<legend>Items <button id="addrepitem" /></legend> \
	<div id="itemtablediv"></div> \
	</fieldset> \
	<!-- Allow form submission with keyboard without duplicating the dialog button --> \
	<input type="submit" tabindex="-1" style="position:absolute; top:-1000px"> \
	</form> \
	</div>';

	$( repFormDiv ).dialog({
		height: 560,
		width: 824,
		modal: true,
		title: "Report details",
		dialogClass: "no-close-dialog",
		buttons: [
			{
				id: "button-save",
				text: "Save definition",
				click: function() {
					if (!isNewRep) {
						var d = new Date();
						repcfgusr.reports[report].updated = d.toISOString();
					}
					SaveRepCfg(true);
					$(this).dialog("close");
					$( "#side-menu" ).fancytree( "getTree" ).reactivate();
				}
			},
			{
				id: "button-saverun",
				text: "Save definition & Run",
				click: function() {
					if (!isNewRep) {
						var d = new Date();
						repcfgusr.reports[report].updated = d.toISOString();
					}
					var o = repcfgusr.reports;
					var $repname = $("#repname");
					if ($repname.val() != $repname.data("oldvalue")) {
						report = $repname.val();
						o[report] =  o[$repname.data("oldvalue")];
						delete o[$repname.data("oldvalue")];
					}
					var postdata = {cmd: "saveall", acl: JSON.stringify(repcfg, null, 2), user: userName};
					$.post( cgiPath + "/reporter.sh", postdata, function( data ) {
						var returned = JSON.parse(data);
						if (returned.status == "fail") {
							$(returned.msg).dialog({
								dialogClass: "info",
								title: "Configuration save - " + returned.status,
								minWidth: 600,
								modal: true,
								show: {
									effect: "fadeIn",
									duration: 500
								},
								hide: {
									effect: "fadeOut",
									duration: 200
								},
								open: function() {
									$('.ui-widget-overlay').addClass('custom-overlay');
								},
								buttons: {
									OK: function() {
										$(this).dialog("close");
									}
								}
							});
						} else {
							document.body.style.cursor = 'wait';
							$.getJSON(cgiPath + '/reporter.sh?cmd=test', {repname: report, user: userName}, function(data) {
								document.body.style.cursor = 'default';
								var dlg = "<p>Error message follows:</p>";
								var title = "";
								var log = "";
								if (data.status) {
									dlg = "<p>Report log follows:</p>";
									title = "Report test succeed";
									log = "<h3>Your report has been generated.</h3>";
									if (data.emails) {
										log += "<p>It has been sent to the defined mail groups</p>";
									}
									log += "<p>You can find it on the host running this tool:</p>";
									log += "<pre>" + data.stored + "</pre>";
									log += "<p>Download it from the following link:</p>";
									log += "<p><a href='" + cgiPath + "/reporter.sh?cmd=get&filename=" + encodeURIComponent(data.dnld) + "' target='_blank'>" + data.filename + "</a></p>";
									// backendSupportsPDF = true;
								} else {
									title = "Report test failed";
									log = dlg + "<pre>" + data.error + "</pre>";
								}
								$("<div></div>").dialog( {
									buttons: { "OK": function () { $(this).dialog("close"); } },
									open: function() {
										$('.ui-widget-overlay').addClass('custom-overlay');
									},
									close: function (event, ui) {
										$(this).remove();
									},
									resizable: false,
									position: { my: "top", at: "top+20", of: window },
									title: title,
									minWidth: 800,
									modal: true
								}).html(log);
							});
						}
					});
					$(this).dialog("close");
					$( "#side-menu" ).fancytree( "getTree" ).reactivate();
				}
			},
			{
				id: "button-cancel",
				text: "Cancel",
				click: function() {
					repcfg = JSON.parse(JSON.stringify(oldRepCfg));
					$(this).dialog("close");
					$( "#side-menu" ).fancytree( "getTree" ).reactivate();
				}
			}
		],
		create: function() {
			var isAdmin = false;
			var repForm = $(this).find( "form" ).on( "submit", function( event ) {
				event.preventDefault();
			//	SaveRepCfg();
			});
			$("#addrepitem").button({
				icon: 'ui-icon-plus'
			}).on("click", function(event) {
				repItemForm();
			}).button("disable");

			if (! backendSupportsPDF) {
				$('#format option:eq(1)').prop("disabled", true);
			}
			$('#format').multipleSelect({
				placeholder: "Select format to define items!",
				single: true,
				onClick: function(view) {
					$("#button-save,#button-saverun").button("enable");
					repcfgusr.reports[report].format = view.value;
					$("#addrepitem").button("enable");
					if (view.value == "PDF") {
						repcfgusr.reports[report].zipattach = false;
						$('#zipattach').prop("checked", false).checkboxradio("disable");
					} else {
						$('#zipattach').checkboxradio("enable");
					}
				},
				onBlur: function(event) {
					if ( ( !$("#format").val() ) && event.relatedTarget && event.relatedTarget.textContent != "Cancel" && event.relatedTarget.dataset.name != "selectItemformat") {
						$('#format').multipleSelect('focus');
						//$('#format').multipleSelect({
						//	isOpen: true,
						//	keepOpen: true
						//});
						$('#format').multipleSelect('open');
					}
				}
			});
			$('#format').multipleSelect('uncheckAll');
			$('#reprange').multipleSelect({
				onClick: function(view) {
					repcfgusr.reports[report].range = view.value;
				},
				single: true
			});
			$.each(repcfgusr.groups, function(grp, val) {
				var isIn = (repcfgusr.reports[report] !== undefined && ($.inArray(grp, repcfgusr.reports[report].recipients) >= 0));
				$("<option />", {text: grp, value: grp, selected: isIn}).appendTo($("#groupmem"));
			});
			$('#groupmem').multipleSelect({
				onClick: function(view) {
					repcfgusr.reports[report].recipients = $('#groupmem').multipleSelect('getSelects');
				},
				onCheckAll: function(view) {
					repcfgusr.reports[report].recipients = $('#groupmem').multipleSelect('getSelects');
				},
				onUncheckAll: function(view) {
					repcfgusr.reports[report].recipients = $('#groupmem').multipleSelect('getSelects');
				}
			});
			$('#zipattach, #keepfiles, #disabled').checkboxradio().on("change", function () {
				repcfgusr.reports[report][this.id] = this.checked;
			});
			if (! backendSupportsZIP) {
				$('#zipattach').checkboxradio("disable");
			}
			if (report) {
				// $("#repname").val(report).prop('disabled', 'disabled');
				if (repcfgusr.reports[report].items.length) {
					$('#format').multipleSelect('disable');
				}
				$("#repname").val(report);
				if (repcfgusr.reports[report].format) {
					$('#format').multipleSelect('setSelects', [repcfgusr.reports[report].format]);
					$("#addrepitem").button("enable");
				}
				$("#repfreq").val(rrToText(repcfgusr.reports[report].rrule));
				var rrange = repcfgusr.reports[report].freq;
				switch (rrange) {
					case "yearly":
						$("#reprange option:first").text("Previous year");
						$("#reprange option:last").text("Last 365 days");
						break;
					case "monthly":
						$("#reprange option:first").text("Previous month");
						$("#reprange option:last").text("Last 31 days");
						break;
					case "weekly":
						$("#reprange option:first").text("Previous week");
						$("#reprange option:last").text("Last 7 days");
						break;
					case "daily":
						$("#reprange option:first").text("Yesterday");
						$("#reprange option:last").text("Last 24 hours");
						break;
				}
				if (! repcfgusr.reports[report].range) {
					repcfgusr.reports[report].range = "prev";
				}
				$("#reprange").multipleSelect("setSelects", [repcfgusr.reports[report].range]);
				$("#reprange").multipleSelect("refresh");
				if ( repcfgusr.reports[report].format == "PDF" ) {
					$('#zipattach').prop( "disabled", true );
				}
				$('#zipattach').prop('checked', repcfgusr.reports[report].zipattach).checkboxradio( "refresh" );
				$('#keepfiles').prop('checked', repcfgusr.reports[report].keepfiles).checkboxradio( "refresh" );
				$('#disabled').prop('checked', repcfgusr.reports[report].disabled).checkboxradio( "refresh" );
			} else {
				// report = "New Report #" + Math.floor((Math.random() * 899) + 100);
				var d = new Date();
				report = "New Report " + d.toLocaleTimeString();
				if (report.match(/[^a-zA-Z0-9 #:]/g)) {
					report = report.replace(/[^a-zA-Z0-9 #:]/g, '');
				};
				isNewRep = true;
				if (repcfgusr.reports[report] == undefined) {
					// repRuleStr = "FREQ=MONTHLY;BYMONTHDAY=" + d.getDate();
					repRuleStr = "FREQ=MONTHLY;BYMONTHDAY=1";
					repRuleObj = RRule.fromString(repRuleStr);
					$("#repfreq").val(rrToText(repRuleStr));
					repcfgusr.reports[report] = {format: "", rrule: repRuleStr, freq: "monthly", range: "prev", recipients: [], items: [], zipattach: false, keepfiles: false};
					repcfgusr.reports[report].created = d.toISOString();
				}
				$("#repname").val(report);
			}
			$("#repname").tooltipster({
				trigger: 'custom',
				position: 'right',
			});
			$("#repname").on("focus", function( event ) {
				if ( $(this).data("oldvalue") == undefined ) {
					$(this).data("oldvalue", $(this).val());
				}
			});
			$("#repname").on("blur", function( event ) {
				if(!event.relatedTarget || event.relatedTarget && event.relatedTarget.textContent != "Cancel") {
					if ($("#repname") && $(this).val() !== $(this).data("oldvalue") ) {
						var o = repcfgusr.reports;
						if (o[$(this).val()] !== undefined) {
							$(this).tooltipster("open");
							$(event.target).trigger("focus");
						} else {
							$(this).tooltipster("close");
						}
					}
				}
			}).on("change", function() {
				this.value = $.trim(this.value);
				if (this.value.match(/[^a-zA-Z0-9 #:]/g)) {
					this.value = this.value.replace(/[^a-zA-Z0-9 #:]/g, '');
				};
			});

			itemList = repcfgusr.reports[report].items;

			if (itemList.length) {
				renderItemsTable(itemList);
			}

			$("#rruleset").button().on("click", function( event ) {
				rruleDialog(report);
			});

		},
		open: function() {
			$('.ui-widget-overlay').addClass('custom-overlay');
			if ( !$("#format").val() ) {
				$("#button-save,#button-saverun").button("disable");
				$('#format').multipleSelect('focus');
				setTimeout(function() {
					$('#format').multipleSelect('open');
				}, 100);
			}
		},
		close: function() {
			$(this).find( "form" ).trigger('reset');
			$(this).dialog("destroy");
		}
	});
}

function rruleDialog(repid) {
	var rruleFormDiv = '<div id="rrule-form" class="repform"> \
	<form> \
	<fieldset style="float: left;"> \
		<legend>Definition</legend> \
		<label for="rrfreq">Frequency</label> \
		<select class="multisel" name="rrfreq" id="rrfreq"> \
			<option value="3">Daily</option> \
			<option value="2">Weekly</option> \
			<option value="1">Monthly</option> \
			<option value="0">Yearly</option> \
		</select><div class="descr" title="YEARLY, MONTHLY, WEEKLY, DAILY<br> \
		– type of recurrence to use (i.e. is the event every year, every month, weekly, or daily)"></div><br> \
		<label for="byweekday">By weekday</label> \
		<select class="multisel" name="byweekday" id="byweekday" multiple> \
			<option value="0">Monday</option> \
			<option value="1">Tuesday</option> \
			<option value="2">Wednesday</option> \
			<option value="3">Thursday</option> \
			<option value="4">Friday</option> \
			<option value="5">Saturday</option> \
			<option value="6">Sunday</option> \
		</select><div class="descr" title="When given, these variables will define the weekdays where the \
			recurrence will be applied."></div> \
		<br> \
		<label for="bymonth">By month</label> \
		<select class="multisel" name="bymonth" id="bymonth" multiple> \
			<option value="1">January</option> \
			<option value="2">February</option> \
			<option value="3">March</option> \
			<option value="4">April</option> \
			<option value="5">May</option> \
			<option value="6">June</option> \
			<option value="7">July</option> \
			<option value="8">August</option> \
			<option value="9">September</option> \
			<option value="10">October</option> \
			<option value="11">November</option> \
			<option value="12">December</option> \
		</select><div class="descr" title="Meaning the months to apply the recurrence to."></div> \
		<br> \
		<label for="bysetpos">By setpos</label> \
		<input id="bysetpos" class="rrcan" /><div class="descr" title="= 1-366 or (-1)-(-366)<br> \
		Comma-separated list of values. Each BYSETPOS value can include a positive (+n) or negative (-n) integer.  If present, \
		this indicates the nth occurrence of the specific occurrence within the set of occurrences \
		specified by the rule."></div> \
		<br> \
		<label for="bymonthday">By month day</label> \
		<input id="bymonthday" class="rrcan" /><div class="descr" title="Comma-separated list of days \
		of the month. Valid values are 1 to 31 or -31 to -1. For example, -10 represents the tenth to the last day of the month."></div> \
		<br> \
		<label for="byyearday">By year day</label> \
		<input id="byyearday" class="rrcan" /><div class="descr" title="Comma-separated list of days \
		of the year. Valid values are 1 to 366 or -366 to -1. For \
		example, -1 represents the last day of the year (December 31st) \
		and -306 represents the 306th to the last day of the year (March 1st)."></div> \
		<br> \
		<label for="byweekno">By week number</label> \
		<input id="byweekno" class="rrcan" /><div class="descr" title="Comma-separated list of \
		ordinals specifying weeks of the year. Valid values are 1 to 53 \
		or -53 to -1. This corresponds to weeks according to week \
		numbering as defined in [ISO.8601.2004]."></div> \
		<br style="clear: left;"> \
	</fieldset> \
	<fieldset style="float: right;"> \
		<legend>Nearest future occurrences</legend> \
		<div id="nearfuture"></div> \
	</fieldset> \
	<div id="rrstring"></div> \
</form> \
</div>';
	$( rruleFormDiv ).dialog({
		height: 490,
		width: 820,
		modal: true,
		title: "Recurrence rule",
		dialogClass: "no-close-dialog",
		buttons: {
			"Use this rule": function() {
				repcfgusr.reports[repid].freq = $('#rrfreq option:selected').text().toLowerCase();
				repcfgusr.reports[repid].rrule = rrToString(repRuleObj);
				$("#repfreq").val(rrToText(repcfgusr.reports[repid].rrule));
				var rrange = $('#rrfreq').val();
				switch (rrange) {
					case "0":
						$("#reprange option:first").text("Previous year");
						$("#reprange option:last").text("Last 365 days");
						break;
					case "1":
						$("#reprange option:first").text("Previous month");
						$("#reprange option:last").text("Last 31 days");
						break;
					case "2":
						$("#reprange option:first").text("Previous week");
						$("#reprange option:last").text("Last 7 days");
						break;
					case "3":
						$("#reprange option:first").text("Yesterday");
						$("#reprange option:last").text("Last 24 hours");
						break;
				}
				$("#reprange").multipleSelect("refresh");
				$(this).dialog("close");
			},
			Cancel: function() {
				$(this).dialog("close");
			}
		},
		create: function() {
			$('#byweekday, #bymonth').multipleSelect();
			$('#rrfreq').multipleSelect({
				single: true,
				onClick: function(view) {
					if (view.value == 3 || view.value == 2) {
						$('#bymonthday').val("");
					}
					if (view.value == 3) {
						$('input.rrcan').val("").prop("disabled", true);
						$('#byweekday, #bymonth').multipleSelect("uncheckAll");
						$('#byweekday, #bymonth').multipleSelect("disable");
					} else {
						$('input.rrcan').prop("disabled", false);
						$('#byweekday, #bymonth').multipleSelect("enable");
					}
				}
			});
			$( "#rrule-form [title]" ).tooltip ({
				position: {
					my: "left top",
					at: "right+5 top-5"
				},
				open: function(event, ui) {
					if (typeof(event.originalEvent) === 'undefined') {
						return false;
					}
					var $id = $(ui.tooltip).attr('id');
					// close any lingering tooltips
					$('div.ui-tooltip').not('#' + $id).remove();
					// ajax function to pull in data and add it to the tooltip goes here
				},
				close: function(event, ui) {
					ui.tooltip.hover(function() {
						$(this).stop(true).fadeTo(400, 1);
					},
					function() {
						$(this).fadeOut('400', function() {
							$(this).remove();
						});
					});
				},
				content: function () {
					return $(this).prop('title');
				}
			});
			if (repid) {
				repRuleStr = repcfgusr.reports[repid].rrule;
			}
			repRuleObj = RRule.fromString(repRuleStr);
			$('#rrfreq').multipleSelect('setSelects', [repRuleObj.options.freq]);
			$('#byweekday').multipleSelect('setSelects', repRuleObj.options.byweekday);
			$('#bymonth').multipleSelect('setSelects', repRuleObj.options.bymonth);
			$('#bysetpos').val(repRuleObj.origOptions.bysetpos);
			$('#bymonthday').val(repRuleObj.origOptions.bymonthday );
			$('#byyearday').val(repRuleObj.origOptions.byyearday);
			$('#byweekno').val(repRuleObj.origOptions.byweekno);
			$( "#nearfuture" ).empty().append(listRRuleOccurs(repRuleObj));
			var rstr = rrToString(repRuleObj);
			$( "#rrstring" ).html("RRULE: " + rstr + "<br>Human: " + rrToText(rstr));

			$('#rrule-form input, #rrule-form select').on("change", function(event, data) {
				repRuleObj = rrCreate();
				$( "#nearfuture" ).empty().append(listRRuleOccurs(repRuleObj));
				var rstr = rrToString(repRuleObj);
				$( "#rrstring" ).html("RRULE: " + rstr + "<br>Human: " + rrToText(rstr));
			});
			if (repRuleObj.options.freq == 3) {
				$('input.rrcan').val("").prop("disabled", true);
				$('#byweekday, #bymonth').multipleSelect("disable");
			}
		},
		open: function() {
			$('.ui-widget-overlay').addClass('custom-overlay');
		},
		close: function() {
			$(this).find( "form" ).trigger('reset');
			$( "#rrule-form label[title]" ).tooltip( "destroy" );
			$(this).dialog( "destroy" );
		}
	});
}

function repItemForm (repItem) {
	var isNewItem = false,
	repItemIdx = repItem,
	report = $("#repname").val(),
	reptype = $("#format").val(),
	repItemFormDiv = '<div id="rep-item-form" class="repform"> \
	<form autocomplete="off"> \
	<fieldset style="float: left;"> \
	<div id="repitemtype" style="margin-left: 12px;"> \
	<input type="radio" id="radio1" name="radio" value="storage" checked /><label for="radio1">Storage</label> \
	<input type="radio" id="radio2" name="radio" value="san" /><label for="radio2">Switch</label> \
	<input type="radio" id="radio3" name="radio" value="cgroup" /><label for="radio3">Custom group</label> \
	<input type="radio" id="radio4" name="radio" value="capacity" /><label for="radio4">Capacity</label> \
	</div><br> \
	<label for="rephost">Name</label> \
	<select class="multisel" type="text" name="rephost" id="rephost"> \
	</select><br style="clear: left;"> \
	<label for="repsubsys">Subsystem</label> \
	<select class="multisel" type="text" name="repsubsys" id="repsubsys"> \
	</select><br style="clear: left;"> \
	<label for="repitem">Item name</label> \
	<select class="multisel" name="repitem" id="repitem"> \
	</select><br style="clear: left;"> \
	<label for="repmetric">Metric</label> \
	<select class="multisel" name="repmetric" id="repmetric"> \
	</select><br style="clear: left;"> \
	</fieldset> \
	<!-- Allow form submission with keyboard without duplicating the dialog button --> \
	<input type="submit" tabindex="-1" style="position:absolute; top:-1000px; left: -1000px;"> \
	</form> \
	</div>';
	if (reptype != "CSV") {
		reptype = "IMG";
	}

	$( repItemFormDiv ).dialog({
		height: 480,
		width: 424,
		modal: true,
		title: "Reported item selection",
		dialogClass: "no-close-dialog",
		buttons: [
			{
				id: "button-ok",
				text: "Use this definition",
				click: function() {
					$(this).dialog("close");
					if (repItem.name == "") {
						repItem.aggregate = true;
						delete repItem.name;
					}
					if (isNewItem) {
						itemList.push(repItem);
					} else {
						itemList[repItemIdx] = repItem;
					}
					$('#format').multipleSelect('disable');
					renderItemsTable(itemList);
				}
			},
			{
				id: "button-cancel",
				text: "Cancel",
				click: function() {
					$(this).dialog("close");
				}
			},
		],
		create: function() {
			var isAdmin = false;
			var repForm = $(this).find( "form" ).on( "submit", function( event ) {
				event.preventDefault();
			//	SaveRepCfg();
			});
			if (reptype == "CSV") {
				$("#radio3").prop("disabled", true)
			}
			$("#button-ok").button("disable");
			$('#repitem').multipleSelect({
				filter: true,
				single: true,
				selectAll: false,
				allSelected: false,
				onClick: function(view) {
					repItem.name = view.value;
					if (view.value.length) {
						repItem.aggregate = false;
					} else {
						repItem.aggregate = true;
					}
					if (reptype == "CSV") {
						$("#button-ok").button("enable");
						$('#repmetric').empty().multipleSelect("disable");
					} else {
						$("#button-ok").button("disable");
						$('#repmetric').empty().multipleSelect("enable");
						var itype = $("#rephost option:selected").data("stortype");
						if (itype == "SAN-BRCD" && /-BNA$/.test(repItem.host)) {
							itype = "SAN-BNA";
						}
						var ssys = $("#repsubsys option:selected").val();
						var metricGroup = view.value ? "ITEMS" : "AGGREGATES";
						var metricCategory = ($("#repitemtype input:checked").val() == "capacity") ? "CAPACITY" : "PERFORMANCE";
						try {
							if (metrics[itype][ssys][metricCategory][reptype][metricGroup].length) {
								$.each(metrics[itype][ssys][metricCategory][reptype][metricGroup], function(idx, val0) {
									var ttext = (metricGroup == "AGGREGATES" && urlItems[val0][2]) ? urlItems[val0][2] : urlItems[val0][0];
									$opt = $("<option />", {
										value: val0,
										text: ttext
									});
									$('#repmetric').append($opt);
								});
							}
						}
						catch(e) { }
						$('#repmetric').multipleSelect('refresh');
						$('#repmetric').multipleSelect('uncheckAll');
					}
				},
				onCheckAll: function(view) {
					repItem.aggregate = true;
				},
				onUncheckAll: function(view) {
					repItem.aggregate = false;
				}
			}, "disable");
			$('#repsubsys').multipleSelect({
				filter: true,
				single: true,
				selectAll: false,
				allSelected: false,
				onClick: function(view) {
					repItem.subsys = view.value;
					$('#repmetric').empty().multipleSelect("disable").multipleSelect("refresh");
					if (reptype == "CSV" && $("#radio2").is(":checked") && /^[SL]ANSWITCH/.test(view.value)) {
						repItem.name = "";
						repItem.metrics = [];
						$("#button-ok").button("enable");
					} else {
						$('#repitem').empty().multipleSelect("enable");
						$("#button-ok").button("disable");
						var itype = $("#rephost option:selected").data("stortype");
						if (itype == "SAN-BRCD" && /-BNA$/.test(repItem.host)) {
							itype = "SAN-BNA";
						}
						var ssys = view.value;
						var metricCategory = ($("#repitemtype input:checked").val() == "capacity") ? "CAPACITY" : "PERFORMANCE";
						try {
							if ( reptype != "CSV" && metrics[itype][ssys][metricCategory][reptype]["AGGREGATES"].length) {
								$opt = $("<option />", { value: "", text: "[all aggregated]" });
								$('#repitem').append($opt);
							}
						}
						catch (e) {}
						$.each(fleet[$('#rephost').val()][view.value], function(key1, val1) {
							if (key1 != "STORTYPE") {
								$opt = $("<option />", {
									value: val1,
									text: val1
								});
								$('#repitem').append($opt);
							}
						});
						$('#repitem').multipleSelect('uncheckAll');
						$('#repitem').multipleSelect('refresh');
					}
				}
			}, "disable");
			$('#rephost').multipleSelect({
				filter: true,
				single: true,
				selectAll: false,
				allSelected: false,
				onClick: function(view) {
					repItem.host = view.value;
					var metricCategory = ($("#repitemtype input:checked").val() == "capacity") ? "CAPACITY" : "PERFORMANCE";
					var metricGroup = view.value ? "ITEMS" : "AGGREGATES";
					$('#repsubsys').empty();
					$('#repitem').empty().multipleSelect("disable").multipleSelect("refresh");
					$('#repmetric').empty().multipleSelect("disable").multipleSelect("refresh");
					$("#button-ok").button("disable");
					if ($("#radio3").is(":checked")) {
						$opt = $("<option />", {
							value: $('#rephost :selected').data("stortype"),
							text: $('#rephost :selected').data("stortype")
						});
						$('#repsubsys').append($opt);
						$('#repsubsys').multipleSelect('refresh');
						$('#repsubsys').multipleSelect('checkAll');
						$('#repmetric').empty().multipleSelect("enable");
						var itype = "CUSTOM-GROUP";
						var ssys = $("#repsubsys option:selected").val();
						repItem.type = itype;
						if (itype == "SAN-BRCD" && /-BNA$/.test(repItem.host)) {
							itype = "SAN-BNA";
						}
						repItem.subsys = ssys;
						try {
							if (metrics[itype][ssys][metricCategory][reptype][metricGroup].length) {
								$.each(metrics[itype][ssys][metricCategory][reptype][metricGroup], function(idx, val0) {
									var ttext = (metricGroup == "AGGREGATES" && urlItems[val0][2]) ? urlItems[val0][2] : urlItems[val0][0];
									$opt = $("<option />", {
										value: val0,
										text: ttext
									});
									$('#repmetric').append($opt);
								});
							}
						}
						catch (e) {}
						$('#repmetric').multipleSelect('refresh');
						$('#repmetric').multipleSelect('uncheckAll');
					} else if ($("#radio5").is(":checked")) {
						$opt = $("<option />", {
							value: $('#rephost :selected').data("stortype"),
							text: $('#rephost :selected').data("stortype")
						});
						$('#repsubsys').append($opt);
						$('#repsubsys').multipleSelect('refresh');
						$('#repsubsys').multipleSelect('checkAll');
						$('#repmetric').empty().multipleSelect("enable");
						var itype = "CUSTOM-GROUP";
						var ssys = $("#repsubsys option:selected").val();
						repItem.type = itype;
						if (itype == "SAN-BRCD" && /-BNA$/.test(repItem.host)) {
							itype = "SAN-BNA";
						}
						repItem.subsys = ssys;
						if (! jQuery.isEmptyObject(metrics[itype][ssys][metricCategory][reptype][metricGroup])) {
							$.each(metrics[itype][ssys][metricCategory][reptype][metricGroup], function(idx, val0) {
								var ttext = (metricGroup == "AGGREGATES" && urlItems[val0][2])? urlItems[val0][2] : urlItems[val0][0];
								$opt = $("<option />", {
									value: val0,
									text: ttext
								});
								$('#repmetric').append($opt);
							});
						}
						$('#repmetric').multipleSelect('refresh');
						$('#repmetric').multipleSelect('uncheckAll');
					} else {
						if (fleet[view.value] && fleet[view.value].STORTYPE) {
							repItem.type = fleet[view.value].STORTYPE;
						}
						$.each(fleet[view.value], function(key2, val2) {
							if (key2 != "STORTYPE") {
								try {
									if (reptype == "CSV" || metrics[repItem.type][key2][metricCategory][reptype][metricGroup].length) {
										$opt = $("<option />", {
											value: key2,
											text: key2,
										});
										$('#repsubsys').append($opt);
									}
								}
								catch (e) {}
							}
						});
						if (reptype == "CSV" && $("#radio2").is(":checked")) {
							if (/^SAN-/.test(repItem.type)) {
								$opt = $("<option />", { value: "SANSWITCH", text: "SANSWITCH" });
								$('#repsubsys').append($opt);
							}
							if (/^LAN-/.test(repItem.type)) {
								$opt = $("<option />", { value: "LANSWITCH", text: "LANSWITCH" });
								$('#repsubsys').append($opt);
							}
						}
						$('#repsubsys').multipleSelect("enable");
						$('#repsubsys').multipleSelect('uncheckAll');
					}
					$('#repsubsys').multipleSelect('refresh');
				}
			});
			$( "#repitemtype" ).controlgroup({
				create: function(event, ui) {
					$('#rephost').empty();
					$.each(fleet, function(key3, val3) {
						if (!/^[SL]AN-/.test(val3.STORTYPE)) {
							$opt = $("<option />", {
								value: key3,
								text: key3,
								"data-stortype": val3.STORTYPE
							});
							$('#rephost').append($opt);
						}
					});
					$('#rephost').multipleSelect('uncheckAll');
					$('#rephost').multipleSelect('refresh');
				}
			}, "disable");

			$("#repitemtype input").checkboxradio();
			$("#repitemtype").on("change", function(ev, line) {
				if ( ev.target.value ) {
					repItem.group = ev.target.value;
				}
				$("#button-ok").button("disable");
				$('#repsubsys').empty().multipleSelect("disable").multipleSelect("refresh");
				$('#repitem').empty().multipleSelect("disable").multipleSelect("refresh");
				$('#repmetric').empty().multipleSelect("disable").multipleSelect("refresh");
				var issan = ($("#radio2").is(":checked"));
				$('#rephost').empty();
				if (ev.target.value == "cgroup") {
					$("label[for='rephost']").text("Group name");
					$.each(cgroups, function(key, val) {
						$opt = $("<option />", {
							value: val.title,
							text: val.title,
							"data-stortype": val.type
						});
						$('#rephost').append($opt);
					});
				} else if (reptype == "CSV" && ev.target.value == "capacity") {
					$("label[for='rephost']").text("Usage");
					$opt = $("<option />", {
						value: "ALL",
						text: "all storages"
					});
					$('#rephost').append($opt);
					$('#rephost').multipleSelect('refresh');
					$('#rephost').multipleSelect('setSelects', ["ALL"]);
					repItem.subsys = "CAPACITY";
					$("#button-ok").button("enable");
				} else {
					if (ev.target.value == "capacity") {
						$("label[for='rephost']").text("Storage");
					} else {
						$("label[for='rephost']").text("Name");
					}
					$.each(fleet, function(key3, val3) {
						if ( /^[SL]AN-/.test(val3.STORTYPE) && issan || !/^[SL]AN-/.test(val3.STORTYPE) && !issan) {
							$opt = $("<option />", {
								value: key3,
								text: key3,
								"data-stortype": val3.STORTYPE
							});
							$('#rephost').append($opt);
						}
					});
				}
				if (line !== undefined) {
					if (line.type == "CUSTOM-GROUP") {
						$('#rephost').empty();
						$.each(cgroups, function(key, val) {
							$opt = $("<option />", {
								value: val.title,
								text: val.title,
								"data-stortype": val.type
							});
							$('#rephost').append($opt);
						});
						$('#rephost').multipleSelect('refresh');
						$('#rephost').multipleSelect('setSelects', [line.host]);
					} else {
						var itype = line.type;
						if (itype == "SAN-BRCD" && /-BNA$/.test(line.host)) {
							itype = "SAN-BNA";
						}
						var ssys = line.subsys;
						var metricGroup = line.aggregate ? "AGGREGATES" : "ITEMS";
						var metricCategory = (line.group == "capacity") ? "CAPACITY" : "PERFORMANCE";
						$('#rephost').multipleSelect('refresh');
						$('#rephost').multipleSelect('setSelects', [line.host]);
						$('#repsubsys').multipleSelect("enable");
						$.each(fleet[line.host], function(key2, val2) {
							if (key2 == "STORTYPE") {
								// repItem.type = val2;
							} else {
								$opt = $("<option />", {
									value: key2,
									text: key2,
								});
								$('#repsubsys').append($opt);
							}
						});
						$('#repsubsys').multipleSelect('refresh');
						$('#repsubsys').multipleSelect('setSelects', [line.subsys]);

						$('#repitem').multipleSelect("enable");
						try {
							if ( reptype != "CSV" && metrics[itype][ssys][metricCategory][reptype]["AGGREGATES"].length) {
								$opt = $("<option />", { value: "", text: "[all aggregated]" });
								$('#repitem').append($opt);
							}
						}
						catch (e) {}
						if (fleet[line.host]) {
							$.each(fleet[line.host][line.subsys], function(key1, val1) {
								if (key1 != "STORTYPE") {
									$opt = $("<option />", {
										value: val1,
										text: val1
									});
									$('#repitem').append($opt);
								}
							});
						}
						$('#repitem').multipleSelect('refresh');
						$('#repitem').multipleSelect('setSelects', [line.aggregate ? "" : line.name]);
						$('#repitem').multipleSelect('refresh');
					}
					if (reptype != "CSV") {
						$('#repmetric').multipleSelect("enable");
						try {
							if (metrics[itype][ssys][metricCategory][reptype][metricGroup].length) {
								$.each(metrics[itype][ssys][metricCategory][reptype][metricGroup], function(idx, val0) {
									var ttext = (metricGroup == "AGGREGATES" && urlItems[val0][2]) ? urlItems[val0][2] : urlItems[val0][0];
									$opt = $("<option />", {
										value: val0,
										text: ttext
									});
									$('#repmetric').append($opt);
								});
							}
						}
						catch (e) {}

						$('#repmetric').multipleSelect('refresh');
						$('#repmetric').multipleSelect('setSelects', line.metrics);
					}
				} else {
					if (! (reptype == "CSV" && ev.target.value == "capacity")) {
						$('#rephost').multipleSelect('uncheckAll');
						$('#rephost').multipleSelect('refresh');
					}
				}
			});

			$('#repmetric').multipleSelect({
				disabled: true,
				onClick: function(view) {
					repItem.metrics = $('#repmetric').multipleSelect('getSelects');
					if (repItem.metrics.length) {
						$("#button-ok").button("enable");
					} else {
						$("#button-ok").button("disable");
					}
				},
				onCheckAll: function(view) {
					repItem.metrics = $('#repmetric').multipleSelect('getSelects');
					$("#button-ok").button("enable");
				},
				onUncheckAll: function(view) {
					repItem.metrics = $('#repmetric').multipleSelect('getSelects');
					$("#button-ok").button("disable");
				}
			}, "disable");

			if (repItem !== undefined) {
				repItem = repcfgusr.reports[report].items[repItem];

				if ( repItem.group ) {
					$("#repitemtype input[value='" + repItem.group + "']").prop("checked", true);
				} else if ( /^[SL]AN-/.test(repItem.type) ) {
					$("#radio2").prop("checked", true);
				} else if ( repItem.type == "CUSTOM-GROUP" ) {
					$("#radio3").prop("checked", true);
				} else {
					$("#radio1").prop("checked", true);
				}
				$( "#repitemtype" ).controlgroup("refresh");

				$('#repitemtype').trigger('change', repItem);

				if (reptype == "CSV" && repItem.type.indexOf("SAN-") == 0) {
					$opt = $("<option />", { value: "SANSWITCH", text: "SANSWITCH", selected: 'selected' });
					$('#repsubsys').append($opt);
					$('#repsubsys').multipleSelect("refresh");
					$('#repsubsys').multipleSelect('setSelects', [repItem.subsys]);
					if (repItem.subsys == "SANSWITCH") {
						$('#repmetric').multipleSelect("disable");
						$('#repitem').multipleSelect("disable");
					}
				}
				if (reptype == "CSV" && repItem.type.indexOf("LAN-") == 0) {
					$opt = $("<option />", { value: "LANSWITCH", text: "LANSWITCH", selected: 'selected' });
					$('#repsubsys').append($opt);
					$('#repsubsys').multipleSelect("refresh");
					$('#repsubsys').multipleSelect('setSelects', [repItem.subsys]);
					if (repItem.subsys == "LANSWITCH") {
						$('#repmetric').multipleSelect("disable");
						$('#repitem').multipleSelect("disable");
					}
				}

			} else {
				isNewItem = true;
				repItem = {host: "", type: "", subsys: "", name: "", metrics: [], group: "storage"};
			}
		},
		open: function() {
			$('.ui-widget-overlay').addClass('custom-overlay');
		},
		close: function() {
			$(this).find( "form" ).trigger('reset');
			$(this).dialog("destroy");
		}
	});
}

function rrCreate () {
	var v = {},
	list,
	da = new Date();
	da.setHours(0,0,0,0);
	da.setDate(da.getDate() + 1);
	v.freq = Number($('#rrfreq').val()),
	v.dtstart = da;

	list = $('#byweekday').multipleSelect('getSelects');
	if (list.length) {
		v.byweekday = list.map(Number);
	}
	list = $('#bymonth').multipleSelect('getSelects');
	if (list.length) {
		v.bymonth = list.map(Number);
	}
	list = $('#bysetpos').val();
	if (list) {
		v.bysetpos = list.split(',').map(Number);
	}
	list = $('#bymonthday').val();
	if (list) {
		v.bymonthday = list.split(',').map(Number);
	}
	list = $('#byyearday').val();
	if (list) {
		v.byyearday = list.split(',').map(Number);
	}
	list = $('#byweekno').val();
	if (list) {
		v.byweekno = list.split(',').map(Number);
	}
	var rule = new RRule( v );
	return rule;
}

function rrToText (rrule) {
	var rr = RRule.fromString(rrule);
	return rr.toText();
}

function rrToString(rule) {
	var str = RRule.optionsToString({
		freq: rule.options.freq,
		bymonth: rule.options.bymonth,
		bymonthday: rule.options.bymonthday.concat(rule.options.bynmonthday),
		bysetpos: rule.options.bysetpos,
		byweekday: rule.options.byweekday,
		byweekno: rule.options.byweekno,
		byyearday: rule.options.byyearday
	})
	return str;
}

function listRRuleOccurs(rule) {
	var html = "",
	maxlines = 20;
	da = new Date();
	da.setHours(0,0,0,0);
	da.setDate(da.getDate() + 1);
	rule.timeset[0].constructor(0,0,0,0);
	rule.options.byhour = [0];
	rule.options.byminute = [0];
	rule.options.bysecond = [0];
	var lines = rule.all(function (date, i){return i < maxlines});
	$.each(lines, function (i, node) {
		html += node + "<br>";
	});
	return html;
}
function nextRuleRun(rrule) {
	var rr = RRule.fromString(rrule);
	var maxlines = 1;
	da = new Date();
	da.setHours(0,0,0,0);
	da.setDate(da.getDate() + 1);
	rr.timeset[0].constructor(0,0,0,0);
	rr.options.byhour = [0];
	rr.options.byminute = [0];
	rr.options.bysecond = [0];
	var lines = rr.all(function (date, i){return i < maxlines});
	return lines[0];
}

function renderItemsTable(items) {
	var html = "<table id='itemtable' class='cfgtree'><thead><tr><th>Host</th><th>Type</th><th>Subsystem</th><th>Name</th><th>Metrics</th><th style='width: 11px;'></th></tr></thead>";
	$.each(items, function (i, node) {
		html += "<tr><td><a href='#' class='itemlink'>" + node.host + "</a></td><td>" + node.type + "</td><td>" + node.subsys + "</td><td>" + (node.aggregate ? "ALL" : node.name) + "</td><td>" + node.metrics.join(", ") + "</td>";
		html += "<td><div class='delete' title='Delete item'></div></td></tr>";
	});
	html += "</table>";
	$("#itemtablediv").html(html);
	$("#itemtablediv div.delete").on("click", function(event) {
		var index = $(this).parents("tr").index();
		$.confirm(
			"Are you sure you want to remove this item?",
			"Item remove confirmation",
			function() { /* Ok action here*/
				// var grp = $(event.target).parent().parent().find(".grplink").text();
				// $(event.target).parent().parent().remove();
				// delete usercfg.groups[grp];
				itemList.splice(index, 1);
				renderItemsTable(itemList);
				if (! itemList.length) {
					$('#format').multipleSelect('enable');
				}
				// SaveRepCfg();
			}
		);
	});
	$("#itemtable a.itemlink").on("click", function(event) {
		var index = $(this).parents("tr").index();
		repItemForm(index, function() {
			renderItemsTable(itemList);
		});
	});
}

function newGroupForm () {
	var newGroupFormDiv = '<div id="new-group-form"> \
	<form autocomplete="off"> \
	<fieldset> \
	<label for="grpname">Group name</label> \
	<input type="text" name="grpname" id="grpname" autocomplete="off" /><br> \
	<label for="descr">Description</label> \
	<input type="text" name="descr" id="descr" autocomplete="off" /> \
	</fieldset> \
	<!-- Allow form submission with keyboard without duplicating the dialog button --> \
	<input type="submit" tabindex="-1" style="position:absolute; top:-1000px"> \
	</form> \
	</div>';
	$( newGroupFormDiv ).dialog({
		height: 250,
		width: 440,
		modal: true,
		title: "Edit mail group",
		buttons: {
			"Save group": function() {
				var grp = $("#grpname").val(),
					dsc = $("#descr").val();
				usercfg.groups[grp] = {description: dsc};
				SaveUsrCfg();
				$(this).dialog("close");
				$( "#side-menu" ).fancytree( "getTree" ).reactivate();
			},
			Cancel: function() {
				$(this).dialog("close");
			}
		},
		create: function() {
			$("#grpname").tooltipster({
				trigger: 'custom',
				position: 'right',
			});
			alertForm = $(this).find( "form" ).on( "submit", function( event ) {
				event.preventDefault();
				saveUser(user, true);
			});
			$("#grpname").on("blur", function( event ) {
				if (!event.relatedTarget || event.relatedTarget && event.relatedTarget.textContent != "Cancel") {
					if (! this.value) {
						$("#grpname").tooltipster('content', 'Group name is required').tooltipster('open');
						$(event.target).addClass( "ui-state-error" );
						$(event.target).trigger("focus");
					} else if (usercfg.groups[this.value]) {
						$("#grpname").tooltipster('content', 'Group already exists!').tooltipster('open');
						$(event.target).addClass( "ui-state-error" );
						$(event.target).trigger("focus");
					} else {
						$("#grpname").tooltipster("close");
						$(event.target).removeClass( "ui-state-error" );
					}
				}
			});
		},
		close: function() {
			$(this).find( "form" ).trigger('reset');
			$("#grpname").tooltipster("destroy");
			$(this).dialog("destroy");
		}
	});
}

function newRepGroupForm (grpToEdit) {
	var newRepGroupFormDiv = '<div id="new-rep-group-form"> \
	<form autocomplete="off"> \
	<fieldset> \
	<label for="grpname">Group name</label> \
	<input type="text" name="grpname" id="grpname" autocomplete="off" /><br> \
	<label for="descr">Description</label> \
	<input type="text" name="descr" id="descr" autocomplete="off" /><br> \
	<label for="emails">E-mails</label> \
	<input type="text" name="emails" id="emails" autocomplete="off" title="Space separated list of recepient e-mail addresses" /> \
	<label for="mailfrom">Mail from</label> \
	<input type="text" name="mailfrom" id="mailfrom" autocomplete="off" title="E-mail adddress to be used as a sender" /> \
	</fieldset> \
	<!-- Allow form submission with keyboard without duplicating the dialog button --> \
	<input type="submit" tabindex="-1" style="position:absolute; top:-1000px"> \
	</form> \
	</div>';
	$( newRepGroupFormDiv ).dialog({
		height: 290,
		width: 440,
		modal: true,
		title: "Edit group",
		buttons: {
			"Send test message": {
				click: function() {
					var postdata = {cmd: "mailtest", group: $("#grpname").val()};
					$.post( cgiPath + "/reporter.sh", postdata, function( data ) {
						$("<div>" + data.message + "</div>").dialog({
							dialogClass: "info",
							title: "Send test message - " + data.success ? "succeed" : "fail",
							minWidth: 600,
							modal: true,
							show: {
								effect: "fadeIn",
								duration: 500
							},
							hide: {
								effect: "fadeOut",
								duration: 200
							},
							open: function() {
								$('.ui-widget-overlay').addClass('custom-overlay');
							},
							buttons: {
								OK: function() {
									$(this).dialog("close");
								}
							}
						});
					});
				},
				text: "Send test message",
				class: 'savecontrol'
			},
			"Save group": {
				click: function() {
					var grp = $("#grpname").val(),
					dsc = $("#descr").val(),
					emails = $("#emails").val().split(" "),
					mailfrom = $("#mailfrom").val();
					if (grpToEdit) {
						delete repcfgusr.groups[grpToEdit];
						if (grpToEdit != grp) {
							$.each(repcfgusr.reports, function(i1, rep) {
								var changeGrp = $.inArray(grpToEdit, rep.recipients);
								if (changeGrp > -1) {
									rep.recipients[changeGrp] = grp;
								}
							});
						}
					}
					repcfgusr.groups[grp] = {description: dsc, emails: emails, mailfrom: mailfrom};
					SaveRepCfg(true);
					$(this).dialog("close");
					$( "#side-menu" ).fancytree( "getTree" ).reactivate();
				},
				text: "Save group",
				class: 'savecontrol'
			},
			Cancel: function() {
				$(this).dialog("close");
			}
		},
		create: function() {
			if (!grpToEdit) {
				$("button.savecontrol").button("disable");
			}
			$("#grpname").tooltipster({
				trigger: 'custom',
				position: 'right',
			});
			$("#mailfrom, #emails").tooltipster({
				trigger: 'custom',
				position: 'right',
			});
			$("#mailfrom").on("blur", function( event ) {
				if(!event.relatedTarget || event.relatedTarget && event.relatedTarget.textContent != "Cancel") {
					if (!$("#mailfrom").val() || emailRegex.test( $("#mailfrom").val())) {
						$(this).tooltipster("close");
						$(event.target).removeClass( "ui-state-error" );
						$("button.savecontrol").button("enable");
					} else {
						$(this).tooltipster("open");
						$(event.target).trigger("focus");
						$(event.target).addClass( "ui-state-error" );
						$("button.savecontrol").button("disable");
					}
				}
			});
			$("#emails").on("blur", function( event ) {
				if(!event.relatedTarget || event.relatedTarget && event.relatedTarget.textContent != "Cancel") {
					var emails = $("#emails").val().split(" ");
					var valid = true;
					for (var i = 0; i < emails.length; i++) {
						if( emails[i] == "" || ! emailRegex.test(emails[i])){
							valid = false;
						}
					}
					if (!$("#emails").val() || valid) {
						$(this).tooltipster("close");
						$(event.target).removeClass( "ui-state-error" );
						$("button.savecontrol").button("enable");
					} else {
						$(this).tooltipster("open");
						$(event.target).trigger("focus");
						$(event.target).addClass( "ui-state-error" );
						$("button.savecontrol").button("disable");
					}
				}
			});
			$("#grpname").on("blur", function( event ) {
				if (!event.relatedTarget || event.relatedTarget && event.relatedTarget.textContent != "Cancel") {
					if (! this.value) {
						$("#grpname").tooltipster('content', 'Group name is required').tooltipster('open');
						$(event.target).addClass( "ui-state-error" );
						$(event.target).trigger("focus");
						$("button.savecontrol").button("disable");
					} else if (this.value != grpToEdit && repcfgusr.groups[this.value]) {
						$("#grpname").tooltipster('content', 'Group already exists!').tooltipster('open');
						$(event.target).addClass( "ui-state-error" );
						$(event.target).trigger("focus");
						$("button.savecontrol").button("disable");
					} else {
						$("#grpname").tooltipster("close");
						$(event.target).removeClass( "ui-state-error" );
						$("button.savecontrol").button("enable");
					}
				}
			});
			if (grpToEdit) {
				$("#grpname").val(grpToEdit);
				$("#descr").val(repcfgusr.groups[grpToEdit].description);
				$("#emails").val(repcfgusr.groups[grpToEdit].emails.join(" "));
				$("#mailfrom").val(repcfgusr.groups[grpToEdit].mailfrom);
			}
		},
		open: function() {
			$('.ui-widget-overlay').addClass('custom-overlay');
		},
		close: function() {
			$(this).find( "form" ).trigger('reset');
			$("#grpname").tooltipster("destroy");
			$(this).dialog("destroy");
		}
	});
}

$.fn.sort_select_box = function() {
	// Get options from select box
	var my_options = $("#" + this.attr('id') + ' option');
	// sort alphabetically
	my_options.sort(function(a,b) {
		if (a.text > b.text) return 1;
		else if (a.text < b.text) return -1;
		else return 0
	})
	//replace with sorted my_options;
	(this).empty().append( my_options );

	// clearing any selections
	("#"+this.attr('id')+" option").attr('selected', false);
}

function ACLcfg () {
	$("#aclgrptree").fancytree({
		checkbox: false,
		clickFolderMode: 2,
		icon: false,
		autoCollapse: true,
		source: {
			url: cgiPath + '/users.sh?cmd=grptree'
		},
		activate: function (event, data) {
			$("#aclitemstree").fancytree("enable");
			$("#aclcustgrptre").fancytree("enable");
			var node = data.node;
			var cgroups = {},
			all_cgroups = false,
			storages = {},
			all_storages = false,
			san = false,
			sanswitches = {},
			lan = false,
			lanswitches = {};
			if (usercfg.groups[node.title].ACL) {
				custgrps = usercfg.groups[node.title].ACL.cgroups;
				all_cgroups = usercfg.groups[node.title].ACL.all_cgroups;
				storages = usercfg.groups[node.title].ACL.storages;
				all_storages = usercfg.groups[node.title].ACL.all_storages;
				san = usercfg.groups[node.title].ACL.san;
				sanswitches = usercfg.groups[node.title].ACL.sanswitches;
				lan = usercfg.groups[node.title].ACL.lan;
				lanswitches = usercfg.groups[node.title].ACL.lanswitches;
				if (!cgroups) {
					cgroups = [];
				}
				if (!all_cgroups) {
					all_cgroups = false;
				}
				if (!storages) {
					storages = [];
				}
				if (!all_storages) {
					all_storages = false;
				}
				if (!san) {
					san = false;
				}
				if (!sanswitches) {
					sanswitches = [];
				}
				if (!lan) {
					lan = false;
				}
				if (!lanswitches) {
					lanswitches = [];
				}
			} else {
				usercfg.groups[node.title].ACL = {};
				usercfg.groups[node.title].ACL.cgroups = [];
				usercfg.groups[node.title].ACL.all_cgroups = false;
				usercfg.groups[node.title].ACL.storages = [];
				usercfg.groups[node.title].ACL.all_storages = false;
				usercfg.groups[node.title].ACL.san = false;
				usercfg.groups[node.title].ACL.sanswitches = [];
				usercfg.groups[node.title].ACL.lan = false;
				usercfg.groups[node.title].ACL.lanswitches = [];
			}
			$(".acd").empty();
			$(".aclh4").hide();
			var atree = $("#aclitemstree").fancytree("getTree");

			$("#aclitemstree").fancytree("getTree").getNodeByKey("storage").setSelected(all_storages);
			if (all_storages) {
				$("#acl_st").append("All granted");
				$(".ast").show();
			} else {
				atree.getNodeByKey("storage").visit(function(node) {
					node.setSelected($.inArray(node.title, storages) !== -1);
					if (node.isSelected()) {
						$("#acl_st").append(node.title + "<br>");
						$(".ast").show();
					}
				});
			}
			$("#aclitemstree").fancytree("getTree").getNodeByKey("san").setSelected(san);
			if (san) {
				$("#acl_san").append("All granted");
				$(".asan").show();
			} else {
				atree.getNodeByKey("san").visit(function(node) {
					node.setSelected($.inArray(node.title, sanswitches) !== -1);
					if (node.isSelected()) {
						$("#acl_san").append(node.title + "<br>");
						$(".asan").show();
					}
				});
			}
			$("#aclitemstree").fancytree("getTree").getNodeByKey("lan").setSelected(lan);
			if (lan) {
				$("#acl_lan").append("All granted");
				$(".alan").show();
			} else {
				atree.getNodeByKey("lan").visit(function(node) {
					node.setSelected($.inArray(node.title, lanswitches) !== -1);
					if (node.isSelected()) {
						$("#acl_lan").append(node.title + "<br>");
						$(".alan").show();
					}
				});
			}
			$("#aclitemstree").fancytree("getTree").getNodeByKey("cgroup").setSelected(all_cgroups);
			if (all_cgroups) {
				$("#acl_cg").append("All granted");
				$(".acg").show();
			} else {
				$("#aclitemstree").fancytree("getTree").getNodeByKey("cgroup").visit(function(node) {
					node.setSelected($.inArray(node.title, custgrps) !== -1);
					if (node.isSelected()) {
						$("#acl_cg").append(node.title + "<br>");
						$(".acg").show();
					}
				});
			}
		}
	});
	$("#aclcustgrptre").fancytree({
		checkbox: true,
		icon: false,
		clickFolderMode: 2,
		autoCollapse: false,
		source: {
			url: cgiPath + '/genjson.sh?jsontype=cust'
		},
		disabled: true,
		select: function (event, data) {
			var node = data.node;
			selNodes = $(this).fancytree("getTree").getSelectedNodes();
			var group = $("#aclgrptree").fancytree("getActiveNode").title;
			usercfg.groups[group].ACL.cgroups = [];

			$("#acl_cg").empty();
			$(".acg").hide();
			$.each(selNodes, function (i, node) {
				$("#acl_cg").append(node.title + "<br>");
				$(".acg").show();
				usercfg.groups[group].ACL.cgroups.push(node.title);
			});
		}
	});

	$("#aclitemstree").fancytree({
		checkbox: true,
		selectMode: 3,
		icon: false,
		clickFolderMode: 2,
		autoCollapse: false,
		source: [
			{title: "Storage", key: "storage", folder: true},
			{title: "Custom group", key: "cgroup", folder: true},
			{title: "SAN", key: "san", folder: false},
			{title: "LAN", key: "lan", folder: false}
		],
		/*
		[
				{title: "Cluster", key: "cluster", myOwnAttr: "abc"},
				{title: "Datastore", key: "datastore", myOwnAttr: "abc"},
				{title: "Resource pool", key: "respool"}
		]
		*/

		init: function (event, data) {
			var mtree = $('#side-menu').fancytree("getTree");
			var atree = $(this).fancytree("getTree");
			var stree = atree.getNodeByKey("storage");
			var wtree = atree.getNodeByKey("san");
			var ltree = atree.getNodeByKey("lan");
			var ctree = atree.getNodeByKey("cgroup");
			var newParent = {
				"title": "",
				"folder": true,
			}
			var newChild = {
				"title": "",
			}
			mtree.visit(function(node) {
				if (node.data.obj) {
					newParent.obj = node.data.obj;
					newChild.obj = node.data.obj;
					switch (node.data.obj) {
						case "S":
							var parent = stree.findFirst(node.title, true);
							if (! parent) {
								newChild.title = node.title;
								parent = stree.addNode(newChild, "child");
							}
							break;
						case "W":
							var parent = wtree.findFirst(node.title, true);
							if (! parent) {
								newChild.title = node.title;
								parent = wtree.addNode(newChild, "child");
							}
							break;
						case "L":
							var parent = ltree.findFirst(node.title, true);
							if (! parent) {
								newChild.title = node.title;
								parent = ltree.addNode(newChild, "child");
							}
							break;
						case "C":
							newChild.title = node.title;
							ctree.addNode(newChild, "child");
							break;
					};
				};
			});
		},
		/*
		*{
		*    url: '/lpar2rrd-cgi/genjson.sh?jsontype=aclitems'
		*},
		*/
		disabled: true,
		select: function (event, data) {
			if (data.targetType == "checkbox") {
			var node = data.node;
			$(".aclh4").hide();
			$(".acd").empty();
			selNodes = $(this).fancytree("getTree").getSelectedNodes(true);
			var group = $("#aclgrptree").fancytree("getActiveNode").title;
			usercfg.groups[group].ACL.all_storages = false;
			usercfg.groups[group].ACL.storages = [];
			usercfg.groups[group].ACL.san = false;
			usercfg.groups[group].ACL.sanswitches = [];
			usercfg.groups[group].ACL.lan = false;
			usercfg.groups[group].ACL.lanswitches = [];
			usercfg.groups[group].ACL.all_cgroups = false;
			usercfg.groups[group].ACL.cgroups = [];
			$(this).fancytree("getTree").visit(function (node) {
				if (node.getLevel() == 1) {
					switch (node.key) {
						case "storage":
							if (node.isSelected()) {
								$("#acl_st").append("All granted<br>");
								$(".ast").show();
								usercfg.groups[group].ACL.all_storages = true;
							} else {
								$.each(node.getChildren(), function(x, subnode) {
									if (subnode.isSelected()) {
										$("#acl_st").append(subnode.title + "<br>");
										$(".ast").show();
										usercfg.groups[group].ACL.storages.push(subnode.title);
									}
								});
							}
						break;
						case "san":
							if (node.isSelected()) {
								$("#acl_san").append("All granted<br>");
								$(".asan").show();
								usercfg.groups[group].ACL.san = true;
							} else {
								$.each(node.getChildren(), function(x, subnode) {
									if (subnode.isSelected()) {
										$("#acl_san").append(subnode.title + "<br>");
										$(".asan").show();
										usercfg.groups[group].ACL.sanswitches.push(subnode.title);
									}
								});
							}
						break;
						case "lan":
							if (node.isSelected()) {
								$("#acl_lan").append("All granted<br>");
								$(".alan").show();
								usercfg.groups[group].ACL.lan = true;
							} else {
								$.each(node.getChildren(), function(x, subnode) {
									if (subnode.isSelected()) {
										$("#acl_lan").append(subnode.title + "<br>");
										$(".alan").show();
										usercfg.groups[group].ACL.lanswitches.push(subnode.title);
									}
								});
							}

						break;
						case "cgroup":
							if (node.isSelected()) {
								$("#acl_cg").append("All granted<br>");
								$(".acg").show();
								usercfg.groups[group].ACL.all_cgroups = true;
							} else {
								$.each(node.getChildren(), function(x, subnode) {
									if (subnode.isSelected()) {
										$("#acl_cg").append(subnode.title + "<br>");
										$(".acg").show();
										usercfg.groups[group].ACL.cgroups.push(subnode.title);
									}
								});
							}
						break;

					}
				}
			});
			//var joined = selNodes.map (function(elem) { return elem.title; }).join();
			//$("#acltable tr.highlight td:eq(3)").text(JSON.stringify(olpars));
			}
		}
	});
	// $("#aclitemstree").fancytree('getTree').getSelectedNodes();

	// $("#aclitemstree").fancytree("disable");
	// $("#aclcustgrptree").fancytree("disable");

	$("#saveacl").button().on("click", function(event) {
		SaveUsrCfg(true);
	});
}

function legendTable(element, table_data) {
	var legdiv = $(element).parents(".relpos").find("div.legend");
	/*
	var pane = $(legdiv).data('jsp');
	if (pane) {
		pane.destroy();
	}
	*/
	$(legdiv).html(Base64.decode(table_data));
	var $t = element.parents(".relpos").find('table.tablesorter');
	if ($t.length) {
		var updated = $t.find(".tdupdated");
		if (updated) {
			element.parents(".detail").siblings(".updated").text(updated.text());
			updated.parent().remove();
		}
		tableSorter($t);
		$t.find("a").on("click", function() {
			var url = $(this).attr('href');
			if ((url.substring(0, 7) != "http://") && (!/\.csv$/.test(url)) && (!/lpar-list-rep\.sh/.test(url)) && ($(this).attr("title") != "CSV")) {
				backLink(url);
			return false;
			}
		});
		$t.find("td.legsq").each(function() {
			$(this).next().attr("title", $(this).next().text()); // set tooltip (to see very long names)
			var bgcolor = $(this).text();
			if (bgcolor) {
				var parLink = $(this).parents(".relpos").find("a.detail").attr("href");
				var parParams = getParams(parLink);
				// var trTime = trTime.match(/&time=([dwmy])/)[1];
				trItem = parParams.item;
				if (trItem == "sum") {
					trItem = parParams.name;
				}
				var trTime = parParams.time;
				var trLink = $(this).parent().find(".clickabletd a").last().attr("href");
				var trParams = getParams(trLink);
				if (trParams.item == "pool") {
					if (trParams.lpar == "pool") {
						trItem = "pool"
					} else {
						trItem = "shpool"
					}
				}
				if (trParams.square_item) {
					trItem = trParams.square_item;
				}
				trLink = cgiPath + "/detail-graph.sh?host=" + trParams.host + "&type=" + trParams.type + "&name=" + trParams.name +
					"&item=" + trItem + "&time=" + trTime + "&detail=1&none=";
				if (trParams.name) {
					$(this).html("<a href='" + trLink + "' title='Click to get [" + decodeURIComponent(trParams.name.replace(/\+/g, " ")) + "] detail in a pop-up view' class='detail'><div class='innersq' style='background:" + bgcolor + ";'></div></a>");
					$(this).find('a.detail').colorbox({
						photo: true,
						// transition: 'none',
						live: false,
						speed: 300,
						fadeOut: 100,
						scalePhotos: true, // images won't be scaled to fit to browser's height
						initialWidth: 1200,
						maxWidth: "95%",
						opacity: 0.4,
						hideOnContentClick: true,
						onOpen: function(obj) {
							if (storedUrl) {
								obj.href = zoomedUrl;
							} else {
								var tUrl = obj.href;
								tUrl += "&nonefb=" + Math.floor(new Date().getTime() / 1000);
								obj.href = tUrl;
							}
							return true;
						},
						onComplete: function() {
							$('.cboxPhoto').off().on("click", $.colorbox.close);
						},
						onClosed: function() {
							if (storedUrl) {
								$(storedObj).attr("href", storedUrl);
								storedUrl = "";
								storedObj = {};
							}
						}
					});
				} else {
					$(this).html("<div class='innersq' style='background:" + bgcolor + ";'></div>");
				}
			}
		});
		if ($t.find("a.detail").length) {
			$t.find("tr").find("th").first().addClass("popup").attr("title", "Click on the color square below to get item detail in a pop-up view");
		}
		if (sysInfo.legend_height) {
			$t.parent().css("max-height", sysInfo.legend_height + "px");
		}
		// $(legdiv).jScrollPane (
		//	{
		//	showArrows: false,
		//	horizontalGutter: 30,
		//	verticalGutter: 30
		//});
	}
	$(element).parents("td.relpos").css("vertical-align", "top");
	$(element).parents("td.relpos").css("text-align", "left");
	$(element).parents(".relpos").find("div.favs").show();
	$(element).parents(".relpos").find("div.dash").show();
	// $(element).parents(".relpos").find("div.popdetail").show();
}

function getLenIfExists(obj) {
	try { return (obj.length) }
	catch(e) { return undefined }
}

function copyServices () {
	$("#title").text("Mirror");
	$.getJSON(cgiPath + '/mirroring.sh?cmd=json', function(data) {
		var mirrorData = data;
		var isAdmin = sysInfo.isAdmin;
		$.each(Object.keys(mirrorData).sort(), function(grpid, j) {
			var val = mirrorData[j];
			if (j == "") {
				return true;
			}
			var newGroup = 0;
			$.each(Object.keys(val).sort(), function(i, ss) {
				var sstor = val[ss];
				$.each(Object.keys(sstor).sort(), function(i, sv) {
					var svol = sstor[sv];
					$.each(Object.keys(svol).sort(), function(i, ds) {
						var dstor = svol[ds];
						$.each(Object.keys(dstor).sort(), function(i, dv) {
							var dvol = dstor[dv];
							var row = "<tr data-severity='" + dvol.severity + "'>";
							// if (newGroup == 0) {
								row += "<td>" + j + "</td>";
							// }
							newGroup++;
							row += "<td>" + ss + "</td>";
							row += "<td>" + sv + "</td>";
							// var type = dvol.mtype == "metro" ? "&rArr;" : dvol.mtype == "global" ? "&rarr;" : dvol.mtype == "active" ? ! "&rarr;" : "";
							var typeTitle = dvol.mtype + " / " + dvol.mstate;
							if (dvol.reason) {
								typeTitle += " / " + dvol.reason;
							}
							row += "<td data-sortValue='" + dvol.mstate + "' class='mirror " + dvol.class + "' style='text-align: center' title='" + typeTitle + "'></td>";
							// row += "<td class='mirror " + dvol.mstate + " " + dvol.mtype + "' style='text-align: center' title='" + dvol.mtype + "'></td>";
							// row += "<td style='text-align: center' title='" + dvol.mtype + "'><p>" + type + "</p></td>";
							row += "<td>" + ds + "</td>";
							row += "<td>" + dv + "</td>";
							// row += "<td class='mirror " + dvol.mstate + "'>" + dvol.mstate + "</td>";
							//row += "<td>" + val. + "</td>";
							row += "</tr>";
							$("#mirroring tbody").append(row);
						});
					});
				});
			});
			// $("#mgr-" + grpid).attr('rowspan', newGroup);
		});
		if (mirrorData[""]) {
			$.each(Object.keys(mirrorData[""]).sort(), function(i, ss) {
				var sstor = mirrorData[""][ss];
				$.each(Object.keys(sstor).sort(), function(i, sv) {
					var svol = sstor[sv];
					$.each(Object.keys(svol).sort(), function(i, ds) {
						var dstor = svol[ds];
						$.each(Object.keys(dstor).sort(), function(i, dv) {
							var dvol = dstor[dv];
							var row = "<tr data-severity='" + dvol.severity + "'><td></td>";
							row += "<td>" + ss + "</td>";
							row += "<td>" + sv + "</td>";
							var typeTitle = dvol.mtype + " / " + dvol.mstate;
							if (dvol.reason) {
								typeTitle += " / " + dvol.reason;
							}
							row += "<td data-sortValue='" + dvol.mstate + "' class='mirror " + dvol.class + "' style='text-align: center' title='" + typeTitle + "'></td>";
							row += "<td>" + ds + "</td>";
							row += "<td>" + dv + "</td>";
							// row += "<td class='mirror " + dvol.mstate + "'>" + dvol.mstate + "</td>";
							//row += "<td>" + val. + "</td>";
							row += "</tr>";
							$("#mirroring tbody").append(row);
						});
					});
				});
			});
		}
		$("#mirroring").tablesorter({
			widgets : [ "group", "filter" ],
			theme: "ice",
			ignoreCase: false,
			sortList: [[0,0]],
			// initialized: function(table) {
			//	$("#mirroring").find(".group-name:empty()").parents("tr").trigger('toggleGroup');
			//},
			widgetOptions : {
				filter_hideEmpty : true,
				filter_hideFilters : true,
				filter_ignoreCase : true,
				filter_liveSearch : true,
				// group_collapsed: true,
				group_saveGroups: false,
				// group_forceColumn: [0],
				group_complete: "openEmptyGroup",
				group_callback : function($cell, $rows, column, table) {
					var severity = 1;
					$.each($rows, function(id, val) {
						if ($(val).data("severity") > severity) {
							severity = $(val).data("severity");
						}
					});
					if (severity == 3) {
						// var copyRed = '<button class="ui-button ui-widget ui-corner-all ui-button-icon-only" title="Button with icon only"> \
						//     <span class="ui-icon ui-icon-transferthick-e-w"></span> Button with icon only</button>';
						var copyRed = '<img src="css/images/lightning-red-icon.png" style="vertical-align: bottom; padding-right: 1em">';
						$cell.find('.group-name').before(copyRed);
					}
					if (severity == 2) {
						var copyAmber = '<img src="css/images/lightning-orange-icon.png" style="vertical-align: bottom; padding-right: 1em">';
						$cell.find('.group-name').before(copyAmber);
					}
				}
			},
			textExtraction : function(node, table, cellIndex) {
				n = $(node);
				return n.attr('data-sortValue') || n.text();
			}

		});
	});
}
function snapshotting () {
	$("#title").text("Snapshot");
	$.getJSON(cgiPath + '/mirroring.sh?cmd=jsonsnap', function(data) {
		var isAdmin = sysInfo.isAdmin;
		$.each(Object.keys(data).sort(), function(i, j) {
			var val = data[j];
			$.each(Object.keys(val).sort(), function(i, ss) {
				var sstor = val[ss];
				$.each(Object.keys(sstor).sort(), function(i, sv) {
					var svol = sstor[sv];
					$.each(Object.keys(svol).sort(), function(i, ds) {
						var dvol = svol[ds];
						var row = "<tr data-severity='" + dvol.severity + "'>";
						// if (newGroup == 0) {
						row += "<td>" + j + "</td>";
						// }
						row += "<td>" + ss + "</td>";
						row += "<td>" + sv + "</td>";
						// var type = dvol.mtype == "metro" ? "&rArr;" : dvol.mtype == "global" ? "&rarr;" : dvol.mtype == "active" ? ! "&rarr;" : "";
						var typeTitle = dvol.state;
						row += "<td data-sortValue='" + typeTitle + "' class='snapshot " + dvol.class + "' style='text-align: center' title='" + typeTitle + "'></td>";
						// row += "<td class='mirror " + dvol.mstate + " " + dvol.mtype + "' style='text-align: center' title='" + dvol.mtype + "'></td>";
						// row += "<td style='text-align: center' title='" + dvol.mtype + "'><p>" + type + "</p></td>";
						row += "<td>" + ds + "</td>";
						row += "<td>" + dvol.group + "</td>";
						if (dvol.progress.length) {
							row += "<td data-sortValue='" + dvol.progress + "%' title='" +  dvol.progress + "%'><progress value='" + dvol.progress + "' max='100'></progress></td>";
						} else {
							row += "<td></td>";
						}
						row += "<td>" + ShowDate(dvol.started * 1000) + "</td>";
						// row += "<td class='mirror " + dvol.mstate + "'>" + dvol.mstate + "</td>";
						//row += "<td>" + val. + "</td>";
						row += "</tr>";
						$("#snapshotting tbody").append(row);
					});
				});
			});
			// $("#mgr-" + grpid).attr('rowspan', newGroup);
		});
		$("#snapshotting").tablesorter({
			widgets : [ "group", "filter" ],
			theme: "ice",
			ignoreCase: false,
			sortList: [[0,0]],
			// initialized: function(table) {
			// 	$("#mirroring").find(".group-name:empty()").parents("tr").trigger('toggleGroup');
			// },
			widgetOptions : {
				filter_hideEmpty : true,
				filter_hideFilters : true,
				filter_ignoreCase : true,
				filter_liveSearch : true,
				//group_collapsed: true,
				group_saveGroups: false,
				group_complete: "openEmptyGroup",
				group_callback : function($cell, $rows, column, table) {
					var severity = 1;
					$.each($rows, function(id, val) {
						if ($(val).data("severity") > severity) {
							severity = $(val).data("severity");
						}
					});
					if (severity == 3) {
						// var copyRed = '<button class="ui-button ui-widget ui-corner-all ui-button-icon-only" title="Button with icon only"> \
						//     <span class="ui-icon ui-icon-transferthick-e-w"></span> Button with icon only</button>';
						var copyRed = '<img src="css/images/lightning-red-icon.png" style="vertical-align: bottom; padding-right: 1em">';
						$cell.find('.group-name').before(copyRed);
					}
					if (severity == 2) {
						var copyAmber = '<img src="css/images/lightning-orange-icon.png" style="vertical-align: bottom; padding-right: 1em">';
						$cell.find('.group-name').before(copyAmber);
					}
				}
			},
			textExtraction : function(node, table, cellIndex) {
				n = $(node);
				return n.attr('data-sortValue') || n.text();
			}
		});
	});
}

function img2pdf(){list={};if($("a.ui-tabs-anchor").length){$.each($("li.ui-state-default:visible a.ui-tabs-anchor"),function(index,value){name=this.text;tabimg=$(this.attributes.href.value+" img.lazy");count=$(tabimg).length;imgarr=$(tabimg).map(function(){src="";if($(this).is("[src]")){if($(this).attr("src")=="css/images/sloading.gif"||$(this).hasClass("nolegend")&&$(this).is("[data-src]")){src=$(this).attr("data-src")}else{src=$(this).attr("src")}}if($(this).hasClass("nolegend")){src=src.replace("detail=0","detail=1")}if(!sysInfo.basename||$(this).hasClass("loaded")){return src}}).get();list[name]=imgarr})}else{name="CPU";tabimg=$("#content img.lazy");count=$(tabimg).length;imgarr=$(tabimg).map(function(){src="";if($(this).is("[src]")){if($(this).attr("src")=="css/images/sloading.gif"||$(this).hasClass("nolegend")&&$(this).is("[data-src]")){src=$(this).attr("data-src")}else{src=$(this).attr("src")}}if($(this).hasClass("nolegend")){src=src.replace("detail=0","detail=1")}if(!sysInfo.basename||$(this).hasClass("loaded")){return src}}).get();list[name]=imgarr}return list}
// vim: set ts=4 sw=4 tw=0 noet :
